/***************** run backwards, compute pre-images ************/

#include "edecfunc.h"

/*** mark each state on grid, 1/2 bits (or more)=y, 1/2 bits (or less)=x ***/
void show_statespace_matrix(char *thisstate){
 signed short z,zz,yL,xL,
	      tempx,tempy,
	      mright,mbot,mleft,mtop,   /*  0_______   plot the string*/
	      mwidth,mheight;           /* 0|       |  (8)7654-3210   */
					/*  |       |  on 2-d grid    */
 double	sx,/*x pos of state on grid*/   /*  |       |                 */
	sy,/*y poss "     "        */   /*  |       |3210             */
	sq;/*size of square block  */   /*  |       |                 */
 unsigned long thisx=0,/*x value   */	/*  |_______|                 */
	       thisy=0;/*y value   */
					/*   (8)7654                  */
   tempx=getx;
   tempy=gety;


   if (show_ss_matrixF){
      mright=Maxx-vgax(136);
      mbot=Maxy-2;
   }
   else{
      mright=Maxx-2;
      mbot=Maxy-vgay(31);
   }
   mwidth=vgax(msize);
   mheight=vgay(msize);

   if (lineL%2==0) mtop=mbot-mheight;
   else mtop=mbot-mheight/2;
   mleft=mright-mwidth;
   if (lineL>=32) yL=xL=16;
   else{
      if (lineL%2==0) yL=xL=lineL/2-1;
      else{
	 yL=lineL/2-1;
	 xL=lineL/2;
      }
   }
   /*set up the window for grid*/
   if (thisstate==NULL){
      if (show_ss_matrixF) matrixcolor=yellow;
      draw_box(-1,mleft-1,mtop-1,mright,mbot,1,0);
      matrixx=matrixy=0; /*max x,y axis*/

      zz=0;
      for (z=lineL/2-1;z>=0;z--){
	 matrixy+=(unsigned long)pow(2,(double)(yL-zz));
	 zz++;
	 if (zz>16) break;
      }
      zz=0;
      for (z=lineL-1;z>=lineL/2;z--){
	 matrixx+=(unsigned long)pow(2,(double)(xL-zz));
	 zz++;
	 if (zz>16) break;
      }
   }
   else{
      zz=0;
      for (z=lineL/2-1;z>=0;z--){
	 thisy+=(unsigned long)get_bit(thisstate,z)*
			      pow(2,(double)(yL-zz));
	 zz++;
	 if (zz>16) break;
      }
      zz=0;
      for (z=lineL-1;z>=lineL/2;z--){
	 thisx+=(unsigned long)get_bit(thisstate,z)*
				    pow(2,(double)(xL-zz));
	 zz++;
	 if (zz>16) break;
      }
      sy=mtop+(double)(thisy*(mbot-mtop))/(matrixy+1);
      sx=mleft+(double)(thisx*(mright-mleft))/(matrixx+1);
      /*space for single pixels only*/
      if (matrixx>=mwidth) putpixel(sx,sy,matrixcolor);
      /*space for square bars*/
      else{
	 sq=(double)mwidth/(matrixx+1)-1;
	 setfillstyle(SOLID_FILL,matrixcolor);
	 bar(sx,sy,sx+sq,sy+sq);

	 if (lineL<=6){
	    moveto(sx+2,sy+2);
	    sprintf(textb[0],"%lu",dec_equiv(thisstate,L));
	    outtext(textb[0]);
	 }
      }
   }
   moveto(tempx,tempy);
}

/******************* run backwards from seed, May 93 ***********/
void run_backward(void){
 unsigned short zu,zu1,count1s;
 unsigned long maxsubtreefan=0;
 signed short  z,zz,temp,
      xbox,stpwidth,
      tempx,tempy,
      tablesize,tablebytes,
      barlen,  /*progress bar*/
      pre_equiv_no=0, /*no of rotation equivalent states*/
      thisbasinno,
      segsize;
 unsigned short z0,z1,cm_d,actual_fansize=0;
 float gofEdensity;
 unsigned char tempcolor;
 /*char issegstate;*/

  #define free_rest { free(preim1);\
		      free(preim0);\
		      free(xx0);   \
		      free(yy0);   \
		      free(xx1);   \
		      free(yy1);   \
		      if (exhaustive_testing==0 && nonlocal==0){\
			    free(arule);\
			    free(arule1);\
			    free(arule2);\
			    free(p);  \
			    free(B);  \
		      }\
  }

  #define show_ss_state(ss_state) {\
	       if (show_ss_matrix){\
		  if (ss_m_att_only){\
		     if (precount==0) show_statespace_matrix(ss_state);\
		  }\
		  else if (!basinfield || successive_basins){\
		      if (precount==0) matrixcolor=lightred;\
		      else matrixcolor=green;\
		      show_statespace_matrix(ss_state);\
		  }\
		  else show_statespace_matrix(ss_state);\
	       }\
  }

  /*draw box for to show partial pre-image stack size*/
  if (nonlocal==0 && !nhood_mixed){
     if (see_ppstack){  /*decrease bar showing pp stack*/
       setcolor(white);
       
#      if __BORC__||__UNIX__
	 rectangle(vgax(125),Maxy-vgay(41),vgax(125)+vgax(150),Maxy-vgay(33));
#      elif __WATCOM__
	 rectangle(vgax(140),Maxy-vgay(41),vgax(140)+vgax(150),Maxy-vgay(33));
#      endif
     }
  }
  pretested=precount=totalprecount=gofEno=totalgofE=0;
  level=0;     /*current level*/
  /*adjust level for segfan*/
  if (startsegfan==1){
	level=1;
	if (justonepreimage==1) level=2;
  }
  thisindex=0; /*index in current level*/
  nextindex=0; /*index in next level*/
  thismax=0;   /*no of states in current level, level 0 has 1 seed state*/
  nextmax=0;   /*   "     "       next    "   */
  thisstart=0; /*total count of first state in current level*/
  pretog=0;    /*toggle fo 2 arrays this<-->next*/
  segfan=0;
  if (scale>vgax(3)) sep=2;
  else sep=1;
  /*size of rule table in bits*/
  tablesize=(signed short)pow(2,(double)nhood);
  /*size of rule table in in bytes*/
  tablebytes=tablesize/8;
  if (tablebytes==0) tablebytes=1;

  sprintf(textb[0],"run backwards arrays");
  if (exhaustive_testing==0 && nonlocal==0 ){
     /*3 arrays to hold rule/s*/
     if ((arule=(char *)calloc(tablebytes,sizeof(char)))
				 ==NULL) outof_memory(textb[0]);
     if ((arule1=(char *)calloc(tablebytes,sizeof(char)))
				 ==NULL) outof_memory(textb[0]);
     if ((arule2=(char *)calloc(tablebytes,sizeof(char)))
				 ==NULL) outof_memory(textb[0]);
     if (nhood==1) temp=1;
     else temp=nhood-1;
     if ((p=(char*)calloc(temp,sizeof(char)))
				 ==NULL) outof_memory(textb[0]);
     if ((B=(char*)calloc(bytesL+2,sizeof(char)))
				 ==NULL) outof_memory(textb[0]);
  }
  if ((preim0=(char**)calloc(1,sizeof(char*)))
				     ==NULL) outof_memory(textb[0]);
  if ((preim1=(char**)calloc(1,sizeof(char*)))
				     ==NULL) outof_memory(textb[0]);
  if ((xx0=(signed short*)calloc(1,sizeof(signed short)))
				     ==NULL) outof_memory(textb[0]);
  if ((yy0=(signed short*)calloc(1,sizeof(signed short)))
				     ==NULL) outof_memory(textb[0]);
  if ((xx1=(signed short*)calloc(1,sizeof(signed short)))
				     ==NULL) outof_memory(textb[0]);
  if ((yy1=(signed short*)calloc(1,sizeof(signed short)))
				     ==NULL) outof_memory(textb[0]);
  isrepeat=0;
  precount=0;

 startback:
  nextbefore=nextindex;
  if (precount>0){
     if (pretog){
	memcpy(A,preim1[thisindex],bytesL);
	free(preim1[thisindex-1]);/*deallocate previous*/
	}
     else{
	memcpy(A,preim0[thisindex],bytesL);
	free(preim0[thisindex-1]);/*deallocate previous*/
     }
  }
  else memcpy(A,firstseed,bytesL);
  if (stp){
     end_page(scale);
     print_current_state(A,white);
  }
  /*to show up exceptions in Raja's rule*/
  if (show_maj>=0){
     count1s=0;
     for (zu=0;zu<=L;zu++) count1s+=get_bit(A,zu);
     if (show_maj==0) count1s=lineL-count1s;
  }
  /*if drawing basin field, tick off used states*/
  /*tickspace=31^2) (watcom), 18^2-1 (boorland)*/
  if (basinfield || show_ss_matrix){
     if ((nonlocal==0 || compress_1d_local==1 || regular2d)
	    && !dontcompress && !rulemix && exhaustive_testing!=2){
	memcpy(tempState,A,bytesL);
	/*count segmented states*/
	/*issegstate=0;*/
	if (regular2d){
	   /*if (repseg_2d[0]<lineL || repseg_2d[1]<lineL) issegstate=1;*/
	   if (insegloop){
	      for (z=1;z<=seg_2d_h[segindex];z++){
		 for (zz=1;zz<=seg_2d_v[segindex];zz++){
		    if (basinfield && dec_equiv(tempState,L)<=tickspace)
		       set_bitlong(tickoff,dec_equiv(tempState,L),1);
		    show_ss_state(tempState);
		    progbar+=1;
		    rotate_array_2d(tempState,'u',1);
		 }
		 rotate_array_2d(tempState,'l',1);
	      }
	   }
	   else if (attperiod==0){
	      show_ss_state(tempState);
	   }
	   else {
	      if (cyclematch_2d_diag[0]>1 || cyclematch_2d_diag[1]>1){
		 if (cyclematch_2d_diag[0]>1)
			      cm_d=cyclematch_2d_diag[0];
		 else if (cyclematch_2d_diag[1]>1)
			      cm_d=cyclematch_2d_diag[1];
		 for (z=1;z<=basinno;z++){
		    for (z0=1;z0<=cm_d;z0++){
		       if (basinfield && dec_equiv(tempState,L)<=tickspace)
			  set_bitlong(tickoff,dec_equiv(tempState,L),1);
		       show_ss_state(tempState);
		       progbar+=1;
		       if (cyclematch_2d_diag[0]>1)
			   rotate_array_2d(tempState,'r',1);
		       else rotate_array_2d(tempState,'l',1);
		       rotate_array_2d(tempState,'u',1);
		    }
		    rotate_array_2d(tempState,'l',1);
		 }
	      }
	      else{
		 for (zu=1;zu<=cyclematch_2d[0];zu++){
		    /*if (issegstate) segstates+=1;*/
		    for (zu1=1;zu1<=cyclematch_2d[1];zu1++){
		       if (basinfield && dec_equiv(tempState,L)<=tickspace)
			   set_bitlong(tickoff,dec_equiv(tempState,L),1);
		       show_ss_state(tempState);
		       memcpy(tempState2,tempState,bytesL);

		       for (z0=1;z0<=basinno_2d_h;z0++){
			  /*if (issegstate) segstates+=1;*/
			  for (z1=1;z1<=basinno_2d_v;z1++){
			     if (z0==1 && z1==1) continue;
			     /*if (issegstate) segstates+=1;*/
			     rotate_array_2d(tempState2,'u',1);
			     if (basinfield &&
				dec_equiv(tempState2,L)<=tickspace)
			       set_bitlong(tickoff,dec_equiv(tempState2,L),1);
			     show_ss_state(tempState2);
			     progbar+=1;
			  }
			  rotate_array_2d(tempState2,'l',1);
		       }

		       progbar+=1;
		       rotate_array_2d(tempState,'u',basinno_2d_v);
		    }
		    rotate_array_2d(tempState,'l',basinno_2d_h);
		 }
	      }
	   }
	}
	else{
	   /*if (repeating_seg(tempState)<lineL) issegstate=1;*/
	   if (insegloop){
	      for (z=1;z<=seg[segindex];z++){
		 /*if (issegstate) segstates+=1;*/
		 rotate_array(nhood,tempState,'l',0,1);
		 if (basinfield && dec_equiv(tempState,L)<=tickspace)
			   set_bitlong(tickoff,dec_equiv(tempState,L),1);
		 show_ss_state(tempState);
		 progbar+=1;
	      }
	   }
	   else if (attperiod==0){
	      show_ss_state(tempState);
	   }
	   else {
	      for (zu=1;zu<=cyclematch;zu++){
		 /*if (issegstate) segstates+=1;*/
		 rotate_array(nhood,tempState,'l',0,basinno);
		 if (basinfield && dec_equiv(tempState,L)<=tickspace)
			   set_bitlong(tickoff,dec_equiv(tempState,L),1);
		 show_ss_state(tempState);
		 memcpy(tempState2,tempState,bytesL);

		 for (zz=1;zz<=basinno-1;zz++){
		    /*if (issegstate) segstates+=1;*/
		    rotate_array(nhood,tempState2,'l',0,1);
		    if (basinfield && dec_equiv(tempState2,L)<=tickspace)
			    set_bitlong(tickoff,dec_equiv(tempState2,L),1);
		    show_ss_state(tempState2);
		    progbar+=1;
		 }
		 progbar+=1;
	      }
	   }
	}
     }
     else {
	if (basinfield && dec_equiv(A,L)<=tickspace)
			  set_bitlong(tickoff,dec_equiv(A,L),1);
	show_ss_state(A);
	progbar+=1;
     }
     if (basinfield){
		setfillstyle(SOLID_FILL,green);
		barlen=(signed short)((float)(barxr-barxl-2)*
					  ((float)progbar/(statespace+1)));
		bar(barxl+1,baryt+2,barxl+barlen,baryb-2);
     }
  }
  else show_ss_state(A);

  /*if showing pre-image frequency histogram,
    count no of equivalent states*/
  if (pre_fansize_freq_hist){
     if ((nonlocal==0 || compress_1d_local==1 || regular2d)
           && !dontcompress && !rulemix && exhaustive_testing!=2){
	if (!basinfield) thisbasinno=1;
	else thisbasinno=basinno;
	if (regular2d){
	   if (insegloop) pre_equiv_no=
			     seg_2d_h[segindex]*seg_2d_v[segindex];
	   else if (direction=='f') pre_equiv_no=cyclematch*thisbasinno;
	   else pre_equiv_no=1;
	}
	else{
	   if (insegloop) pre_equiv_no=seg[segindex];
	   else if (direction=='f') pre_equiv_no=cyclematch*thisbasinno;
	   else pre_equiv_no=1;
	}
     }
     else pre_equiv_no=1;
  }
  if (stp) end_page(scale);
  /*chech if backwards seed is all 0s or 1s*/
  if ((nonlocal==0 || compress_1d_local==1 || regular2d)
	  && !dontcompress && !rulemix && exhaustive_testing!=2){
     if (memcmp(all_0s,A,bytesL)==0||memcmp(all_1s,A,bytesL)==0)
							 allbitssame=1;
     else allbitssame=0;
  }
  else allbitssame=0;

  /*interupt - only at new firstseed*/

  if (event_ready()){
   tempcolor=getcolor();
   switch(is[0]){
     /*partial pre-image histogram: start pause*/
     case 'p':
	if (see_ppstack==1 && nonlocal){
	   erase_prompt_box(1);
	   see_ppstack=2;
	}
	break;
     /*toggle state space matrix*/
     case 'm':
	if (show_ss_matrix==1){
	   draw_box(-1,Maxx-2-vgax(msize)-1,
		    Maxy-vgay(31)-vgay(msize)-1,Maxx-2,Maxy-vgay(31),0,0);
	   show_ss_matrix=0;
	}
	else{
	   show_ss_matrix=1;
	   show_statespace_matrix(NULL);;
	}
	break;
     /*expand space-time pattern scale*/
     case 'e':
	if (stp || shownumbers==3){
           /*first turn off scrolling __BORC__||__WATCOM__ */
           if (scrolling==1){
	      if (nowscrolling==1){
#         	  if __BORC__||__WATCOM__
		      freeimage(stpimage);
#                 endif
                  nowscrolling=0;
	       }
	   }     
	   scale+=1;
#          if __UNIX__
	      pixmap_width=lineL*scale;
#          endif
	   /*sep=2->1 pix div, sep=1-> no div*/
	   if (scale>vgax(3)) sep=2;
	   else sep=1;
	}
	break;
     /*contract space-time pattern scale*/
     case 'c':
	if (stp || shownumbers==3){
	   /*first turn off scrolling __BORC__||__WATCOM__ */
           if (scrolling==1){
	      if (nowscrolling==1){
#         	  if __BORC__||__WATCOM__
		      freeimage(stpimage);
#                 endif
                  nowscrolling=0;
	       }
	   }           
	   stpwidth=lineL*scale;
	   scale-=1;
	   if (scale<=0){
	      scale=1;
	      break;
	   }
	   if (stp){
	      setfillstyle(SOLID_FILL,black);
	      bar(lineL*scale,0,stpwidth,Maxy);
	   }
#          if __UNIX__
	      pixmap_width=lineL*scale;
#          endif
	   /*sep=2->1 pix div, sep=1-> no div*/
	   if (scale>vgax(3)) sep=2;
	   else sep=1;
	}
	break;
	
     case'#':/*toggle scrolling*/
	if (stp){
	   if (scrolling==1){
	      scrolling=0;
              if (nowscrolling==1){
#                if __BORC__||__WATCOM__
		    freeimage(stpimage);
#                endif
              }
	      stpwidth=lineL*scale;
#             if __UNIX__
		 pixmap_width=lineL*scale;
#             endif
	      /*clear area of screen*/
	      setviewport(0,0,stpwidth,Maxy,1);
	      clearviewport();
	      setviewport(0, 0, Maxx, Maxy, 1);
	   }
	   else scrolling=1;
           nowscrolling=0;
	}
	break;
     case 's':
	if (stp==1){
	   stp=0;
           if (scrolling==1){
	      scrolling=0;
              if (nowscrolling==1){
#                if __BORC__||__WATCOM__
		    freeimage(stpimage);
#                endif
              }
	      stpwidth=lineL*scale;
#             if __UNIX__
		 pixmap_width=lineL*scale;
#             endif
	      /*clear area of screen*/
	      setviewport(0,0,stpwidth,Maxy,1);
	      clearviewport();
	      setviewport(0, 0, Maxx, Maxy, 1);
	   }
           nowscrolling=0;
	}
	else if (stp==0) stp=1;
	break;

     case'q':
	tempx=getx;
	tempy=gety;
       startinterrupt:
	if (basinfield) sprintf(textb[0],
	   "next tree/basin-n, options-o, stop field-q, cont-ret:");
	else if (direction!='b') sprintf(textb[0],
	   "next tree-n, options-o, stop basin-q, cont-ret:");
	else if (direction=='b')sprintf(textb[0],
	   "options-o, stop subtree-q, cont-ret:");

	draw_prompt_box(1);
	if (pre_fansize_freq_hist) myouttext("inhist-h, ");
	myouttext(textb[0]);
	input_string(1,0);
	if (is[0]=='o'){
	   finish_options(1);
	   goto startinterrupt;
	}
	if (is[0]=='h' && pre_fansize_freq_hist){
	   show_pre_fansize_freq_hist();
	   goto startinterrupt;
	}
	if (is[0]=='q' || is[0]=='n'){
	   if (pretog){
	      for (zu=thisindex;zu<=thismax;zu++) free(preim1[zu]);
	      for (zu=1;zu<=nextmax;zu++) free(preim0[zu]);
	   }
	   else{
	      for (zu=thisindex;zu<=thismax;zu++) free(preim0[zu]);
	      for (zu=1;zu<=nextmax;zu++) free(preim1[zu]);
	   }
	   free_rest;
	   treesize=precount+1;
	   thisindex=nextindex=pretested=precount=0;
	   /*next tree space-time pattern from the top*/
	   if (stp){
	      setviewport(0, 0, (L+1)*scale+2, Maxy, 1);
	      clearviewport();
	      setviewport(0, 0, Maxx, Maxy, 1);
	      moveto(0,0);
	   }
	   earlyexit=1;
	   memory_box(1);
	   return;
	}

	if (stp) end_page(scale);
	if (basinfield) progress_bar(); /*redraw progbar box*/
	moveto(tempx,tempy);
   }
   setcolor(tempcolor);
  }
  is[0]=0;
  /*no of segments in pre-image fan from all 0s and 1s*/
  if (insegloop==0) segno=0;

  /*if exhaustive testing*/
  if (exhaustive_testing) pre_exhaustive();
  else{
     /*if local 1d, assumed start strings for pre-image fan*/
     if (nonlocal==0 && !nhood_mixed){
	for (zz=0;zz<=(signed short)pow(2,(double)nhood-1)-1;zz++){
	   for (z=nhood-2;z>=0;z--) p[z] = get_bit(nm[z],zz);
	   pre_images();
	}
     }
     /*if nonlocal wiring or 2d*/
     else pre_images_rand();
  }

  if (is[0]=='q' || is[0]=='n'){
     if (pretog){
	for (zu=thisindex;zu<=thismax;zu++) free(preim1[zu]);
	for (zu=1;zu<=nextindex;zu++) free(preim0[zu]);
     }
     else{
	for (zu=thisindex;zu<=thismax;zu++) free(preim0[zu]);
	for (zu=1;zu<=nextindex;zu++) free(preim1[zu]);
     }
     free_rest;
     treesize=precount+1;
     thisindex=nextindex=pretested=precount=0;
     if (direction=='b') segfan=0;
     memory_box(0);
     return;
  }

  /*if just one pre-image*/
  if (segfan &&
       (!nonlocal || compress_1d_local==1 || regular2d)
	     && !dontcompress && !rulemix && exhaustive_testing!=2){
     if (regular2d && segno==1 && seg_2d_h[1]==1 && seg_2d_v[1]==1){
	seg_2d_h[1]=seg_2d_v[1]=0;
        sprintf(textb[0],"realloc-seg_2d,segseed");
	if( (seg_2d_h=(signed short*)realloc
	   (seg_2d_h, sizeof(signed short)))
	       ==NULL) outof_memory(textb[0]);
	if( (seg_2d_v=(signed short*)realloc
	   (seg_2d_v, sizeof(signed short)))
	       ==NULL) outof_memory(textb[0]);
	free(segseed[1]);
	if( (segseed = (char**) realloc(segseed,sizeof(char*)*2))
				    ==NULL) outof_memory(textb[0]);
	segfan=0;
	justonepreimage=1;
     }
     else if (segno==1 && seg[1]==1){
	seg[1]=0;
	sprintf(textb[0],"realloc-seg,segseed");
	if( (seg = (signed short*)realloc(seg, sizeof(signed short)))
				       ==NULL) outof_memory(textb[0]);
	free(segseed[1]);
	if( (segseed = (char**) realloc(segseed,sizeof(char*)*2))
				       ==NULL) outof_memory(textb[0]);
	segfan=0;
	justonepreimage=1;
     }
  }
  fansize=nextindex-nextbefore;
  /*nextbefore=precount before state tested*/
  if (segfan &&
       (!nonlocal || compress_1d_local==1 || regular2d)
	     && !dontcompress && !rulemix && exhaustive_testing!=2){
     totalsegfan=0;
     if (regular2d){
	for (zu=1;zu<=segno;zu++) totalsegfan+=(seg_2d_h[zu]*seg_2d_v[zu]);
     }
     else{
	for (zu=1;zu<=segno;zu++) totalsegfan+=seg[zu];
     }
     if (maxtreefan<totalsegfan) maxtreefan=totalsegfan;
     if (!justonepreimage) maxtreefan+=1;
  }
  /*if showing pre-image frequency histogram,
    count no of equivalent states*/
  if (pre_fansize_freq_hist){
     actual_fansize=0;
     if (segfan &&
	  (!nonlocal || compress_1d_local==1 || regular2d)
		&& !dontcompress && !rulemix && exhaustive_testing!=2){
	actual_fansize=totalsegfan;
	if (!justonepreimage) actual_fansize+=1;
	if (actual_fansize<maxinhist) pre_fan_freq[actual_fansize]+=1;
	else pre_fan_freq[maxinhist]+=1;
     }
     else{
	actual_fansize=fansize;
	if (level==0 && direction=='f') actual_fansize+=1;
	if (fansize<maxinhist) pre_fan_freq[actual_fansize]+=pre_equiv_no;
	else pre_fan_freq[maxinhist]+=pre_equiv_no;
     }
     if (show_maj>=0){
	if (count1s>lineL/2) isexception+=pre_equiv_no;
     }
  }
  if (maxtreefan<fansize){
     maxtreefan=fansize;/*max pre-imaging in tree*/
     if (level==0) maxtreefan+=1; /* +pre-image on attractor*/
  }
  if (maxsubtreefan<fansize){
     maxsubtreefan=fansize;/*max pre-imaging in tree*/
     if (level==0) maxsubtreefan+=1; /* +pre-image on attractor*/
  }

  tempx=getx;
  tempy=gety;

# if __BORC__
	 draw_fan();
# elif __WATCOM__||__UNIX__
     if (!gd_z_graph) draw_fan();
     else{
	/*rectangle to contain basins*/
	if (stp) setviewport(lineL*scale+vgax(12),vgay(46),Maxx-3,vgay(157),1);
	else  setviewport(3,vgay(46),Maxx-3,vgay(157),1);
	draw_fan();
	setviewport(0, 0, Maxx, Maxy, 0);
     }
# endif

  moveto(tempx,tempy);
  /*if segmented fan from all 0s or 1s*/
  if (segfan &&
       (!nonlocal || compress_1d_local==1 || regular2d)
	    && !dontcompress && !rulemix  && exhaustive_testing!=2){
     sprintf(textb[0],"xseg");
     if ((segx=(signed short*)calloc(segno+1,sizeof(signed short)))
					 ==NULL) outof_memory(textb[0]);
     sprintf(textb[0],"yseg");
     if ((segy=(signed short*)calloc(segno+1,sizeof(signed short)))
					 ==NULL) outof_memory(textb[0]);
     /*copy co-ords of segseed nodes*/
     if (pretog){
	memcpy(segx,xx0,sizeof(signed short)*(segno+1));
	memcpy(segy,yy0,sizeof(signed short)*(segno+1));
     }
     else {
	memcpy(segx,xx1,sizeof(signed short)*(segno+1));
	memcpy(segy,yy1,sizeof(signed short)*(segno+1));
     }
     if (pretog){
	for (zu=thisindex;zu<=thismax;zu++) free(preim1[zu]);
	for (zu=1;zu<=nextindex;zu++) free(preim0[zu]);
     }
     else{
	for (zu=thisindex;zu<=thismax;zu++) free(preim0[zu]);
	for (zu=1;zu<=nextindex;zu++) free(preim1[zu]);
     }
     free_rest;
     thisindex=nextindex=pretested=precount=0;
     return;
  }
    /*
	 subtree structure

	 level.. 0    1    this              next               last level
								  :
		      |	   |<-this           |<-next
		      |       max               max
  initial	 |         |                 |                    |
     seed -->o   |    |    |<-this           |               . .  |
		 |    |    |  index
		      |                      |                    |
			   |                 |<-next              |
			   |                 |  index             |
					     |

    pretog. . .  0    1    0                 1     */

  nextmax=nextindex;
  if (fansize==0) gofEno+=1; /*count of garden of Eden states*/
  fansize=0;
  if (thisindex==thismax){ /*this level test complete*/
     /*move to next level*/
     level++;
     if (pretog) free(preim1[thisindex]);
     else free(preim0[thisindex]);
     /*toggle 2 arrays this<-->next*/
     pretog=abs(pretog-1);
     thismax=nextmax;
     thisindex=nextindex=nextmax=0;
  }
  /*end of subtree, all garden of Eden states have been reached*/
  if (pretested == precount){
     level-=1;
     if (maxtreelevel<level) maxtreelevel=level;
     tempx=getx;
     tempy=gety;

     if (direction=='b'){   /*if backward*/
	gofEdensity=(float)gofEno/(precount+1);
	treesize=precount+1;
	if (datapause==2 && insegloop){  /*pause to show tree data*/
	   xbox=draw_prompt_box(2);

	   if (regular2d) segsize=seg_2d_h[segindex]*seg_2d_v[segindex];
	   else segsize=seg[segindex];
	   sprintf(textb[0],
		"seg-fan=%lu (%d segs) seg-tree %d. no=%d size=%lu ",
			     totalsegfan,segno,segindex,segsize,treesize);
	   myouttext(textb[0]);
	   moveto(xbox,gety+CHeight);
	   sprintf(textb[0],"seg-root(hex)=");
	   myouttext(textb[0]);
	   tempx=getx;
	   print_current_bitstring_hexbytes(0,firstseed,0,Maxx,white,0);
	   moveto(tempx+(vgax(4)*bytesL/2)+(CWidth*2*bytesL),gety);
	   sprintf(textb[0]," g=%lu gd=%.3g ml=%d mp=%lu\n",
		    gofEno,gofEdensity,level,maxsubtreefan);
	   outtext(textb[0]);

	   xbox=memory_box(0);
	   moveto(xbox+vgax(3),vgay(3));
	   myouttext("options-o cont-ret:");
	   input_string(1,0);
	   if (is[0]=='o') finish_options(1);
	   erase_prompt_box(2);
	}
	/*print and/or save tree data*/
	if ((pdata==2 || filedata==2) && insegloop){
	   if (regular2d) segsize=seg_2d_h[segindex]*seg_2d_v[segindex];
	   else segsize=seg[segindex];
	   if (segindex==1){
		 sprintf(textb[0],
		  "   seg-fan=%lu (%d segs) \n",totalsegfan,segno);
		 if (pdata==2) print_out(textb[0]);
		 if (filedata==2) save_data(textb[0]);
	   }
	   sprintf(textb[0],"      %d. ",segindex);
	   if (pdata==2) print_out(textb[0]);
	   if (filedata==2) save_data(textb[0]);
	   print_current_bitstring_hexbytes (0,firstseed,0,Maxx,white,3);
	   sprintf(textb[0]," %d %lu ",segsize,treesize);
	   if (pdata==2) print_out(textb[0]);
	   if (filedata==2) save_data(textb[0]);
	   sprintf(textb[0]," %lu %.3g %d %lu\n",
		    gofEno,gofEdensity,level,maxsubtreefan);
	   if (pdata==2) print_out(textb[0]);
	   if (filedata==2) save_data(textb[0]);
	}
     }
     else{  /*if forward, tree from cycle state*/
	if (precount==0){
	   if (insegloop) gofEno=1;
	   else gofEno=0;  /*att state without tree*/
	}
	gofEdensity=(float)(gofEno)/(precount+1);
	treesize=precount+1;

	if (datapause==2){  /*pause to show tree data*/
	   xbox=draw_prompt_box(2);
	   if (insegloop){
	      if (regular2d) segsize=seg_2d_h[segindex]*seg_2d_v[segindex];
	      else segsize=seg[segindex];
	      sprintf(textb[0],
		"seg-fan=%lu (%d segs) seg-tree %d. no=%d size=%lu ",
			     totalsegfan,segno,segindex,segsize,treesize);
	      outtext(textb[0]);
	   }
	   else{
	      sprintf(textb[0],"tree %d. no=%d size=%lu ",
		  (signed short)attperiod-(attindex-1),cyclematch,treesize);
	      myouttext(textb[0]);
	      if (treesize!=precount+1){
		 sprintf(textb[0],"ERROR count=%lu",precount+1);
		 myouttext(textb[0]);
	      }
	      sprintf(textb[0],"(tree types=%d att=%lu)",
		       (signed short)attperiod/cyclematch,attperiod);
	      outtext(textb[0]);
	   }
	   moveto(xbox,gety+CHeight);
	   if (insegloop) sprintf(textb[0],"seg-root(hex)=");
	   else sprintf(textb[0],"root(hex)=");
	   myouttext(textb[0]);
	   tempx=getx;
	   print_current_bitstring_hexbytes(0,firstseed,0,Maxx,white,0);
	   moveto(tempx+(vgax(4)*bytesL/2)+(CWidth*2*bytesL),gety);
	   sprintf(textb[0]," g=%lu gd=%.3g ml=%d mp=%lu\n",
		    gofEno,gofEdensity,level,maxsubtreefan);
	   outtext(textb[0]);

	   xbox=memory_box(0);
	   moveto(xbox+vgax(3),vgay(3));
	   myouttext("options-o cont-ret:");
	   input_string(1,0);
	   if (is[0]=='o') finish_options(1);
	   erase_prompt_box(2);
	}
	if (pdata==2 || filedata==2){  /*pause to show tree data*/
	   if (insegloop){
	      if (regular2d) segsize=seg_2d_h[segindex]*seg_2d_v[segindex];
	      else segsize=seg[segindex];
	      if (segindex==1){
		 sprintf(textb[0],
		  "      seg-fan=%lu (%d segs) \n",totalsegfan,segno);
		 if (pdata==2) print_out(textb[0]);
		 if (filedata==2) save_data(textb[0]);
	      }
	      sprintf(textb[0],"      %d. ",segindex);
	      if (pdata==2) print_out(textb[0]);
	      if (filedata==2) save_data(textb[0]);
	      print_current_bitstring_hexbytes (0,firstseed,0,Maxx,white,3);
	      sprintf(textb[0]," %d %lu ",segsize,treesize);
	      if (pdata==2) print_out(textb[0]);
	      if (filedata==2) save_data(textb[0]);

	   }
	   else{
	      sprintf(textb[0],
		   "   %d. ",(signed short)attperiod-(attindex-1));
	      if (pdata==2) print_out(textb[0]);
	      if (filedata==2) save_data(textb[0]);
	      print_current_bitstring_hexbytes (0,firstseed,0,Maxx,white,3);
	      sprintf(textb[0]," %d %lu ",cyclematch,treesize);
	      if (pdata==2) print_out(textb[0]);
	      if (filedata==2) save_data(textb[0]);
	      if (treesize!=precount+1){
		 sprintf(textb[0],"ERROR count=%lu ",precount+1);
		 if (pdata==2) print_out(textb[0]);
		 if (filedata==2) save_data(textb[0]);
	      }
	   }
	   sprintf(textb[0]," %lu %.3g %d %lu\n",
		    gofEno,gofEdensity,level,maxsubtreefan);
	   if (pdata==2) print_out(textb[0]);
	   if (filedata==2) save_data(textb[0]);
	}
     }
     moveto(tempx,tempy);
     if (pretog) free(preim1[thisindex]);
     else free(preim0[thisindex]);
     free_rest;
     return;
  }
  pretested++;
  thisindex++;
  goto startback;
}

/*** setup state-successor pair array by exhaustive testing, Sept 94 ****/
void prestate_successor_pairs(void){

 char i,save_exh=0,load_exh=0;
 signed short u, /*index into rule table*/
	      tempx,tempy,xbox,barlen;
 unsigned short n,*pnhood; /*memory for pseudo-nhood*/
 unsigned long state_space,prestate,memreq,tickoffbytes;

 unsigned short Ham,bitno,zu1;
 char Ham_bias;

# define exhau_box draw_box(-1,Maxx/2,vgay(46),Maxx-vgax(2),vgay(60),1,0);\
		     moveto(Maxx/2+vgax(2),vgay(46));

   /*memory for pseudo-nhood*/
   sprintf(textb[0],"pnhood");
   if ((pnhood=(unsigned short *)calloc(nhood,sizeof(unsigned short)))
			      ==NULL) outof_memory(textb[0]);

   state_space=(unsigned long)(pow(2,(double)lineL));
   memory_box(1);
   memreq=state_space*bytesL*sizeof(char);

   draw_box(15,Maxx/2,vgay(46),Maxx-vgax(2),vgay(60),0,0);/*save box area*/

#  if __BORC__
      if (farcoreleft()<memreq || memreq>0xffff){ /*2^16=65535*/
	 exhau_box;
	 if (memreq>0xffff-1)
	   sprintf(textb[0],
	     "mem req %lu*%d=%lu larger than max=%lu, cont-ret:",
			   state_space,bytesL*sizeof(char),memreq,
				      (unsigned long)0xffff);
	 outtext(textb[0]);
	 exhaustive_testing=0;
	 input_string(1,0);
	 putimage(Maxx/2,vgay(46),boximage[15],COPY_PUT);
	 freeimage(boximage[15]);
	 free(pnhood);
	 return;
      }
#  elif __WATCOM__
      /*watcom: no 2^16=65535 limit*/
      if ((long)_memavl()+get_memory()<memreq){
	 exhau_box;
	 if (memreq>0xffff-1)
	   sprintf(textb[0],
	     "mem req %lu*%d=%lu larger than avail=%lu, cont-ret:",
			   state_space,bytesL*sizeof(char),memreq,
				       (long)_memavl()+get_memory());
	 outtext(textb[0]);
	 exhaustive_testing=0;
	 input_string(1,0);
	 putimage(Maxx/2,vgay(46),boximage[15],COPY_PUT);
	 freeimage(boximage[15]);
	 free(pnhood);
	 return;
      }

#  endif

   /*memory for exhaustive pairs, index=prestate,
                             char array=successor state*/
   sprintf(textb[0],"exh_pairs");
   if ((exh_pairs=(char*)calloc(state_space*bytesL,sizeof(char)))
				      ==NULL) outof_memory(textb[0]);

   /*memory for state-space tickoff (already done for field)*/
   if (!basinfield && !(direction=='f' && limitcheck==0)){

      tickspace=(unsigned long)(pow(2,(double)lineL)-1);

      tickoffbytes=(unsigned long)ceil( (double) (tickspace+1)/8 );
      sprintf(textb[0],"tickoff"); /*state-space index set to 0*/
      if ((tickoff=(char *)calloc(tickoffbytes,sizeof(char)))
					==NULL) outof_memory(textb[0]);
   }

   save_exh=load_exh=0;
   if (!rangeL && !screensavedemo && !mutantdontpause){
      exhau_box;
      if (exhaustive_testing==2){
	 myouttext(
	 "random map: load-l, random-ret, and save-s:");
	 show_rule_bottom(nhood,1,carule[0],0);
      }
      else myouttext(
	  "exhaustive pairs: load-l, compute-ret, and save-s:");

      input_string(1,0);
      if (is[0]=='q'){
	 /*erase boxes*/
	 putimage(Maxx/2,vgay(46),boximage[15],COPY_PUT);
	 free(exh_pairs);
	 freeimage(boximage[15]);
	 free(pnhood);
	 return;
      }
      if (is[0]=='s'){
	 save_exh=1;
	 dontcompress=1;
      }
      if (is[0]=='l'){
	 load_exh=1;
	 load_save_exhaustive('l');
	 if (is[0]=='q'){
	    /*erase boxes*/
	    putimage(Maxx/2,vgay(46),boximage[15],COPY_PUT);
	    free(exh_pairs);
	    freeimage(boximage[15]);
	    free(pnhood);
	    return;
	 }
      }
      if (exhaustive_testing==2){
	 Ham=Ham_bias=0;
	 exhau_box;
	 sprintf(textb[0],
	      "random map: rand-def, or set Hamming distance (0-%d):",
						     lineL);
	 outtext(textb[0]);
	 input_string(2,0);
	 if (is[0]!=13 && atof(is)>=0 && atof(is)<=lineL){
	    Ham=atof(is);
	    Ham_bias=1;
	 }
      }
   }
   if (load_exh==0){
      if (!screensavedemo){
	 exhau_box;
	 outtext("setting up exhaustive pairs");
      }
      /*set all bits to 0*/
      memcpy(A,all_0s,bytesL);
      memcpy(F,all_0s,bytesL);

      if (!screensavedemo) progress_bar(); /*draw progbar box*/
      moveto(0,0);


      for (prestate=0;prestate<=state_space-1;prestate++){
	 /*show progress with bar in 32 steps*/
	 if (!screensavedemo){
	    if ((prestate+1)%(unsigned long)ceil((double)state_space/32)==0){
	       setfillstyle(SOLID_FILL,red);
	       barlen=(signed short)((double)(barxr-barxl-2)*
				  ((double)(prestate+1)/(state_space)));
	       bar(barxl+1,baryt+2,barxl+barlen,baryb-2);
	    }
	 }
	 if (event_ready()){   /*to interrupt, early exit*/
	  if (is[0]=='q'){
	    tempx=getx;
	    tempy=gety;

	   startinterrupt:
	    sprintf(textb[0],
	      "exhaustive pairs %d%% complete; stop-q, options-o, cont-ret:",
		   (signed short)(100*((double)prestate/state_space)));
	    exhau_box;
	    myouttext(textb[0]);
	    input_string(1,0);

	    if (is[0]=='o'){
	       finish_options(1);
	       goto startinterrupt;
	    }
	    if (is[0]=='q'){
	       putimage(Maxx/2,vgay(46),boximage[15],COPY_PUT);
	       freeimage(boximage[15]);
	       free(pnhood);
	       moveto(tempx,tempy);
	       return;
	    }
	    is[0]=0;
	    exhau_box;
	    outtext("setting up exhaustive pairs, interrupt-q");
	    moveto(tempx,tempy);
	  }
         }
	 /*translate state to char array*/
	 dec_to_bit_line(A,prestate,lineL);
	 if (exhaustive_testing==1) {
	    /*run forward one step*/
	    for (n=L; n!=Maxu; n--){
	       /*local nhood with periodic boundary conditions*/
	       if (nonlocal==0){
		  for (i=0;i<=nhoodm[n]-1;i++)
			    pnhood[i]=(lineL+n-(nhoodm[n]/2)+i)%lineL;
	       }
	       /*nonlocal=1, get psuedo-nhood from wiring scheme*/
	       else {
		  for (i=0;i<=nhoodm[n]-1;i++) pnhood[i]=wiring[n][i];
	       }
	       u=0; /*find dec value of actual or pseudo-nhood*/
	       for (i=nhoodm[n]-1;i>=0;i--)
	       u+=get_bit(A,pnhood[i])*(signed short)pow(2,(double)i);
	       /*set cell next line according to rule look-up table*/
	       if (!rulemix){
		  set_bit(F,n,get_bit(carule[0],u));
	       }
	       else set_bit(F,n,get_bit(carule[n],u));
	    }
	 }
	 /*set exhaustive pairs at random*/
	 else if (exhaustive_testing==2){
	    if (Ham_bias==1){
	       dec_to_bit_line(tempState,prestate,lineL);
	       memcpy(F,tempState,bytesL);
	       /*flip bits if Ham <= lineL/2*/
	       if (Ham<=lineL/2){
		  bitno=0;
		  while(1){
		     bitno+=1;
		     zu1=myrand()%lineL;
		     /*flip a bit at random position*/
		     set_bit(F,zu1,abs(get_bit(F,zu1)-1));
		     /*restore flip if not different*/
		     if (get_bit(F,zu1)==get_bit(tempState,zu1)){
			     set_bit(F,zu1,abs(get_bit(F,zu1)-1));
			     bitno-=1;
		     }
		     if (bitno==Ham) break;
		  }
	       }
	       else if (Ham>=lineL/2+1){
		  /*restore bits in compliment if Ham >= lineL/2 + 1*/
		  for (zu1=L;zu1!=Maxu;zu1--)
		    set_bit(tempState2,zu1,abs(get_bit(tempState,zu1)-1));

		  bitno=0;
		  while(1){
		     if (Ham==lineL) break;
		     bitno+=1;
		     zu1=myrand()%lineL;
		     /*flip a bit at random position in compliment*/
		     set_bit(tempState2,zu1,abs(get_bit(tempState2,zu1)-1))
		     /*restore flip*/
		     if (get_bit(tempState2,zu1)!=get_bit(tempState,zu1)){
			set_bit(tempState2,zu1,abs(get_bit(tempState2,zu1)-1));
				bitno-=1;
		     }
		     if (bitno==lineL-Ham) break;
		  }
		  memcpy(F,tempState2,bytesL);
	       }
	    }
	    else{
	       for (n=L;n!=Maxu;n--) set_bit(F,n,( (rand() % 100)/50) );
	    }
	 }
	 memcpy(exh_pairs+prestate*bytesL,F,bytesL);
	 /*
	 if (stp){
	    print_current_state(A,white);
	    end_page(scale);
	    print_current_state(F,lightred);
	    end_page(scale);
	 }
	 */
      }
   }
   if (save_exh==1){
      exhau_box;
      outtext("SAVE exhaustive pairs-s:");
      input_string(1,0);
      if (is[0]=='s') load_save_exhaustive('s');
   }

   /*erase boxes*/
   putimage(Maxx/2,vgay(46),boximage[15],COPY_PUT);
   freeimage(boximage[15]);
   free(pnhood);
   xbox=(signed short)((float)Maxx)/2;
   erase_box(xbox,vgay(30),Maxx-2,vgay(30)+vgay(9)+vgay(3));
}

/***** compute pre-images by exhaustive testing, Sept 94 **********/
void pre_exhaustive(void){

 unsigned long state_space,prestate;
 
   attrepeat=0;
   state_space=(unsigned long)(pow(2,(double)lineL));

   for (prestate=0;prestate<=state_space-1;prestate++){
      if (get_bitlong(tickoff,prestate)) continue;
      if (memcmp(A,exh_pairs+prestate*bytesL,bytesL)==0){
	 /*pre-image found*/
	 dec_to_bit_line(F,prestate,lineL);
	 /*check for cycle repeat, rotation (from all 0s or 1s),
						if ok add, print*/
	 if (check_pre_image(F)==0){
	    accept_pre_image(F);
	    /*if interrupt*/
	    interrupt_pre_fan();
	    if (is[0]=='q' || is[0]=='n') return;
	 }
      }
   }
}

/**** prepair for pre-images, - random Boolean networks, Oct 94 *****/
void prepair_pre_rand(void){
 signed short
     Tcell,    /*target cell index*/
     Rtable,   /*rule table index*/
     tablemax, /*highest index in rule table*/
     tablebytes,/*no of bytes  "   "     "  */
     z;

 char tempbit,
      *samebits; /*for cheking same n-tupules*/

      /*global variables:
      **nhoodE, reduced effective nhood
      **skiptable; skip rule table entry because nhood reduced*/

  tablemax=(signed short)pow(2,(double)nhood)-1;
  tablebytes=(signed short)ceil(((double)tablemax+1)/8);

  sprintf(textb[0],"prepair pre-rand");
  if ((arule=(char *)calloc(tablebytes,sizeof(char)))
				 ==NULL) outof_memory(textb[0]);


  if ((PS=(char ***)calloc(2,sizeof(char**)))==NULL) outof_memory(textb[0]);
  if ((PSflag=(char ***)calloc(2,sizeof(char**)))
					==NULL) outof_memory(textb[0]);
  /*allocate initial mem PS[1],PSflag[1]*/
  if ((PS[1]=(char **)calloc(1,sizeof(char*)))==NULL) outof_memory(textb[0]);
  if ((PSflag[1]=(char **)calloc(1,sizeof(char*)))
					==NULL) outof_memory(textb[0]);
  /*allocate initial mem PS[0],PSflag[0]*/
  if ((PS[0]=(char **)calloc(2,sizeof(char*)))
					==NULL) outof_memory(textb[0]);
  if ((PSflag[0]=(char **)calloc(2,sizeof(char*)))
					==NULL) outof_memory(textb[0]);
  if ((PStemp=(char *)calloc(bytesL,sizeof(char)))
					==NULL) outof_memory(textb[0]);
  if ((flagtemp=(char *)calloc(bytesL,sizeof(char)))
					==NULL) outof_memory(textb[0]);
  if ((PScount=(unsigned short*)calloc(2,sizeof(unsigned short)))
					==NULL) outof_memory(textb[0]);
  if ((nhoodE=(char**)calloc(lineL,sizeof(char*)))
					==NULL) outof_memory(textb[0]);
  if ((skiptable=(char**)calloc(lineL,sizeof(char*)))
					==NULL) outof_memory(textb[0]);
  for (z=lineL-1;z>=0;z--){
     if (nhood_mixed){
	tablemax=(signed short)pow(2,(double)nhoodm[z])-1;
	tablebytes=(signed short)ceil(((double)tablemax+1)/8);
     }
     if ((nhoodE[z]=(char*)calloc(tablemax+1,sizeof(char)))
					==NULL) outof_memory(textb[0]);
     if ((skiptable[z]=(char*)calloc(tablebytes,sizeof(char)))
					==NULL) outof_memory(textb[0]);
  }
  memory_box(1);
  if (!rulemix) memcpy(arule,carule[0],tablebytes);

  for (Tcell=lineL-1;Tcell>=0;Tcell--){   /*for each target cell*/
     if (nhood_mixed){
	tablemax=(signed short)pow(2,(double)nhoodm[Tcell])-1;
	tablebytes=(signed short)ceil(((double)tablemax+1)/8);
     }
     if (rulemix) memcpy(arule,carule[Tcell],tablebytes);
     /*each rule table entry*/
     for (Rtable=tablemax;Rtable>=0;Rtable--){
	/*skip redundant rule table entries*/
	if (get_bit(skiptable[Tcell],Rtable)==1) continue;
	/*check if effective nhood smaller than actual                    */
	/*	    left->right                                           */
	/*	  7  6  5  4  3  2  1  0   rule table index= dec nhoods   */
	/*	  :  :  :  :  :  :  :  :                                  */
	/*                                                                */
	/*	  1  1  1  1  0  0  0  0 ..2  nhood index                 */
	/*	  1  1  0  0  1  1  0  0 ..1                              */
	/*	  1  0  1  0  1  0  1  0 ..0                              */
	/*                                                                */
	/*	  *  *  *  *  *  *  *  * ..outputs                        */
	/*	  ____                   ..equal tupule, reduce nhood by 1*/
	/*	  __________             ..equal 4-tupule, ..2            */
	/*	  ______________________ ..equal 8-tupule, ..3  etc..     */


	if ((Rtable+1)%2==0){
	   tempbit=get_bit(arule,Rtable); /*compare 2 bits */
	   if (tempbit==get_bit(arule,Rtable-1)){
	      /*reduce effective nhood by 1 wiring ..87654321* */
	      nhoodE[Tcell][Rtable]=1;
	      set_bit1(skiptable[Tcell],Rtable-1);
	      if ((Rtable+1)%4==0 &&
		  tempbit==get_bit(arule,Rtable-2) &&
			 tempbit==get_bit(arule,Rtable-3)){/*compare 4 bits*/
		 /*reduce effective nhood by 2 wiring ..8765432**  */
		 nhoodE[Tcell][Rtable]=2;
		 for (z=Rtable-1;z>=Rtable-3;z--)
		       set_bit1(skiptable[Tcell],z);
		 if ((Rtable+1)%8==0){  /*compare 8 bits, 1 byte  */
		  if (tempbit) samebits=rule_all_1s;
		  else samebits=rule_all_0s;
		  if (memcmp(arule+Rtable/8,samebits,1)==0){
		    /*reduce effective nhood by 3 wiring ..876543*** */
		    nhoodE[Tcell][Rtable]=3;
		    for (z=Rtable-1;z>=Rtable-7;z--)
		       set_bit1(skiptable[Tcell],z);
		    if ((Rtable+1)%16==0 && /*2 bytes*/
		      memcmp(arule+(Rtable/8)-1,samebits,2)==0){
		      /*reduce effective nhood by 4 wiring ..87654**** */
		      nhoodE[Tcell][Rtable]=4;
		      for (z=Rtable-1;z>=Rtable-15;z--)
		       set_bit1(skiptable[Tcell],z);
		      if ((Rtable+1)%32==0 && /*4 bytes*/
			memcmp(arule+(Rtable/8)-3,samebits,4)==0){
			/*reduce effective nhood by 5 wiring..8765***** */
			nhoodE[Tcell][Rtable]=5;
			for (z=Rtable-1;z>=Rtable-31;z--)
			  set_bit1(skiptable[Tcell],z);
			if ((Rtable+1)%64==0 && /*8 bytes*/
			  memcmp(arule+(Rtable/8)-7,samebits,8)==0){
			  /*reduce effective nhood by 6 wiring..876****** */
			  nhoodE[Tcell][Rtable]=6;
			  for (z=Rtable-1;z>=Rtable-63;z--)
			   set_bit1(skiptable[Tcell],z);
			  if ((Rtable+1)%128==0 && /*16 bytes*/
			    memcmp(arule+(Rtable/8)-15,samebits,16)==0){
			    /*reduce effective nhood by 7 wiring..87******* */
			    nhoodE[Tcell][Rtable]=7;
			    for (z=Rtable-1;z>=Rtable-127;z--)
			     set_bit1(skiptable[Tcell],z);
			    if ((Rtable+1)%256==0 && /*32 bytes*/
			      memcmp(arule+(Rtable/8)-31,samebits,32)==0){
			      /*reduce effective nhood by 8 wiring..8******** */
			      nhoodE[Tcell][Rtable]=8;
			      for (z=Rtable-1;z>=Rtable-255;z--)
			       set_bit1(skiptable[Tcell],z);
			    }
			  }
			}
		      }
		    }
		  }
		}
	      }
	   }
	}
     }
  }
}

/** free initial mem for pre-images, - random Boolean networks, Oct 94 ***/
void free_pre_rand(void){
   char z;

   for (z=0;z<=1;z++){
      free(PS[z]);
      free(PSflag[z]);
   }

   free(PS);
   free(PSflag);
   free(PStemp);
   free(flagtemp);
   free(PScount);

   free(arule);

   for (z=lineL-1;z>=0;z--){
      free(nhoodE[z]);
      free(skiptable[z]);
   }
   free(nhoodE);
   free(skiptable);
}

/***** compute pre-images, - random Boolean networks, Nov 93 *****/
void pre_images_rand(void){
 char tog,    /*toggle id of two latest partial pre-image stacks*/

      newbit, /*new bit fron pseudo-nhood*/
      PSbit,  /*bit at wire coupling in partial pre-image*/
      existbit, /*bit flags if above has been set=1, or is empty=0*/
      conflict=0;
      /*global variables:*/
      /*
      **nhoodE,    reduced effective nhood
      **skiptable; skip rule table entry because nhood reduced
      */

 unsigned short zu,
	  ppstack,   /*partial pre-image index*/
	  wildpre; /*to deal pre-image with wildcards*/
	  /*globalvariable:
	  *PScount,  count of partial pre-images in toggled stacks*/
 signed short
     Tcell,    /*target cell index*/
     z,zz,
     Rtable,   /*rule table index*/
     tablemax, /*highest index in rule table*/
     tablebytes,/*no of bytes  "   "     "  */
     byteno,
     tempx,tempy,
     possofw,  /*to deal pre-image with wildcards*/
     pp_temp;


  attrepeat=0; /*1 if pre_image on attractor cycle*/
  sprintf(textb[0],"PS..& PSflag..");
  if ((PS[1][0]=(char *)calloc(1,sizeof(char)))
					==NULL) outof_memory(textb[0]);
  if ((PSflag[1][0]=(char *)calloc(1,sizeof(char)))
					==NULL) outof_memory(textb[0]);
  for (z=0;z<=1;z++){
     if (z==1) byteno=bytesL;
     else byteno=1;
     if ((PS[0][z]=(char *)calloc(byteno,sizeof(char)))
					==NULL) outof_memory(textb[0]);
     if ((PSflag[0][z]=(char *)calloc(byteno,sizeof(char)))
					==NULL) outof_memory(textb[0]);
  }

  tog=0;
  tablemax=(signed short)pow(2,(double)nhood)-1;
  tablebytes=(signed short)ceil(((double)tablemax+1)/8);
  PScount[0]=1;   /*notional initial pp stack=1*/
  memset(PS[0][1],0,bytesL);
  memset(PSflag[0][1],0,bytesL);
  PScount[1]=0;
  if (!rulemix) memcpy(arule,carule[0],tablebytes);

  if (see_ppstack){
     pp_histcount+=1;/*to find average histogram*/
     /*rescale y axis smaller*/
     if (ppL==lineL && pp_hist_max < pp_ymax/6){
	pp_ymax=pp_ymax*.75;
	if (pp_ymax<10) pp_ymax=10;
	ppL=0;
     }
     pp_hist_max=0;
     setup_ppstack_hist();
  }

  for (Tcell=lineL-1;Tcell>=0;Tcell--){   /*for each target cell*/
    if (nhood_mixed){
       tablemax=(signed short)pow(2,(double)nhoodm[Tcell])-1;
       tablebytes=(signed short)ceil(((double)tablemax+1)/8);
    }
    if (rulemix) memcpy(arule,carule[Tcell],tablebytes);
    tog=abs(tog-1); /*toggle 0-1 for even-odd, first tog=1*/
    /*de-allocate mem in current stack*/
    if (PScount[tog]>0){
	for (zu=1;zu<=PScount[tog];zu++){
	      free(PS[tog][zu]);
	      free(PSflag[tog][zu]);
	}
	/*realloc mem for new pp stack stack PS[tog][set count to 0]*/
	sprintf(textb[0],"PS..PSflag..[%d]",tog);
	if ((PS[tog]=(char**)realloc(PS[tog],sizeof(char*)))
				  ==NULL) outof_memory(textb[0]);
	if ((PSflag[tog]=(char**)realloc(PSflag[tog],sizeof(char*)))
				  ==NULL) outof_memory(textb[0]);
    }
    PScount[tog]=0;  /*set new pre-image count to 0*/
    /*for each item in previous partial pre-image stack*/
    for (ppstack=1;ppstack<= PScount[abs(tog-1)];ppstack++){
       /*each rule table entry*/
       for (Rtable=tablemax;Rtable>=0;Rtable--){
	  /*reject rule table entries that dont match target cell*/
	  if (get_bit(A,Tcell)!=get_bit(arule,Rtable)) continue;
	  /*skip redundant rule table entries*/
	  if (get_bit(skiptable[Tcell],Rtable)==1) continue;
	  /*copy partial pre-image from stack to temp bitstring*/
	  memcpy(PStemp,PS[abs(tog-1)][ppstack],bytesL);
	  /*copy parrallel flag array from flag stack to temp bitstring*/
	  memcpy(flagtemp,PSflag[abs(tog-1)][ppstack],bytesL);

	  for (z=nhoodm[Tcell]-1;z>=nhoodE[Tcell][Rtable];z--){
	     /*get new bit fron pseudo-nhood*/
	     newbit = get_bit(nm[z],Rtable);
	     /*get value at wire coupling, 0 or 1*/
	     PSbit =  get_bit(PStemp,wiring[Tcell][z]);
	     existbit=get_bit(flagtemp,wiring[Tcell][z]);
	     /*ERROR - if bits conflict and  bit set reject psuedo-nhood*/
	     if (PSbit==1 && existbit==0){
		tempx=getx;
		tempy=gety;
		draw_prompt_box(1);
		sprintf(textb[0],
		  "ERROR - PSbit=%d so existbit should=1 (=%d)",
						       PSbit,existbit);
		outtext(textb[0]);
		finish_options(1);
		moveto(tempx,tempy);
	     }
	     /*if bits conflict and  bit set reject psedo-nhood*/
	     if (newbit!=PSbit && existbit==1){
		conflict=1;
		break;
	     }
	     /*if bit empty insert a new bit, set flag*/
	     if (newbit!=PSbit) set_bit(PStemp,wiring[Tcell][z],newbit);
	     /*flag the new bit as existing*/
	     if (existbit!=1) set_bit1(flagtemp,wiring[Tcell][z]);
	  }
	  if (conflict==1){
		conflict=0;
		continue;
	  }
	  PScount[tog]+=1;
	  /*realloc mem for new pp stack stack PS[tog][PScount[tog]]*/
	  sprintf(textb[0],"bigger pp stack=%d",PScount[tog]);
	  if ((PS[tog]=(char**)realloc(PS[tog],(PScount[tog]+1)*
			sizeof(char*)))==NULL) outof_memory(textb[0]);
	  if ((PSflag[tog]=(char**)realloc(PSflag[tog],(PScount[tog]+1)*
			sizeof(char*)))==NULL) outof_memory(textb[0]);
	  if ((PS[tog][PScount[tog]]=(char*)calloc(bytesL,sizeof(char)))
					  ==NULL) outof_memory(textb[0]);
	  if ((PSflag[tog][PScount[tog]]=(char*)calloc(bytesL,sizeof(char)))
					  ==NULL) outof_memory(textb[0]);
	  /*copy partial pre-image to next pp stack*/
	  memcpy(PS[tog][PScount[tog]],PStemp,bytesL);
	  /*copy parrallel flag array to next flag stack*/
	  memcpy(PSflag[tog][PScount[tog]],flagtemp,bytesL);
       }/*next Rtable*/
    }/*next ppstack*/

    if (PScount[tog]==0) break;
    /*show partial pre-image histogram*/
    if (see_ppstack){
       pp_hist_total[Tcell]+=PScount[tog];/*to find average histogram*/
       pp_hist[Tcell]=PScount[tog];
       /*rescale y axis bigger*/
       if (PScount[tog]>pp_ymax){
	  pp_ymax=PScount[tog]*1.2;
	  ppL=0;
	  setup_ppstack_hist();
	  for (z=lineL-1;z>=Tcell;z--){
	     pp_heighty=(signed short)(vgax(120)*(float)pp_hist[z]/pp_ymax);
	     bar(pp_startx,pp_starty-pp_heighty,
				   pp_startx+pp_barwidth,pp_starty);
	     pp_startx+=pp_bartotw;
	  }
       }
       else{
	  pp_heighty=(signed short)(vgax(120)*(float)PScount[tog]/pp_ymax);
	  bar(pp_startx,pp_starty-pp_heighty,
				   pp_startx+pp_barwidth,pp_starty);
	  pp_startx+=pp_bartotw;
       }
    }
    if (pp_hist_max < pp_hist[Tcell]) pp_hist_max=pp_hist[Tcell];

  }
  if (PScount[tog]>0){
      wildpre=0;
      while (wildpre<PScount[tog]){
	 wildpre+=1;
	 while(1){
	    possofw=-1;
	    for (z=lineL-1;z>=0;z--){
	       if (get_bit(PSflag[tog][wildpre],z)==0){
		  possofw=z;
		  break;
	       }
	    }
	    /*wildcard not found*/
	    if (possofw==-1) break;
	    /*wildcard found - undo wildcard in PSflag*/
	    set_bit1(PSflag[tog][wildpre],possofw);
	    /*copy pre-image to PStemp*/
	    memcpy(PStemp,PS[tog][wildpre],bytesL);
	    /*copy parrallel flag array to flagtemp*/
	    memcpy(flagtemp,PSflag[tog][wildpre],bytesL);
	    /*set 1 at wildcard poss in temp array*/
	    set_bit1(PStemp,possofw);
	    PScount[tog]+=1;
	    /*realloc mem for new pp stack stack PS[tog][PScount[tog]]*/
	    sprintf(textb[0],"wildpre, pp stack=PScount[tog]");

	    if ((PS[tog]=(char**)realloc(PS[tog],(PScount[tog]+1)*
			sizeof(char*)))==NULL) outof_memory(textb[0]);
	    if ((PSflag[tog]=(char**)realloc(PSflag[tog],(PScount[tog]+1)*
			 sizeof(char*)))==NULL) outof_memory(textb[0]);
	    if ((PS[tog][PScount[tog]]=(char*)calloc(bytesL,sizeof(char)))
				      ==NULL) outof_memory(textb[0]);
	    if ((PSflag[tog][PScount[tog]]=(char*)calloc(bytesL,
			       sizeof(char)))==NULL) outof_memory(textb[0]);
	    /*copy temp arrays to top of pre-image stack*/
	    memcpy(PS[tog][PScount[tog]],PStemp,bytesL);
	    memcpy(PSflag[tog][PScount[tog]],flagtemp,bytesL);
	 }
      }
      /*count pre-images due to wildcards*/
      if (see_ppstack && PScount[tog]-pp_hist[0]>0){
	 pp_wild=PScount[tog]-pp_hist[0];
	 pp_wild_tot+=pp_wild;

	 pp_startx-=pp_bartotw;
	 setfillstyle(INTERLEAVE_FILL,red);
	 pp_temp=pp_starty-pp_heighty-1
	    -(signed short)vgax(120)*(float)pp_wild/pp_ymax;
	 if (pp_temp < pp_starty0-pp_depthy+1)
			       pp_temp=pp_starty0-pp_depthy+1;
	 bar(pp_startx,pp_temp,
		 pp_startx+pp_barwidth,pp_starty-pp_heighty-1);
      }
      if (see_ppstack==2){
	 tempx=getx;
	 tempy=gety;
	 sprintf(textb[0],"abandon pause-p, see next-default:");
	 draw_prompt_box(1);
	 myouttext(textb[0]);
	 input_string(1,0);
	 if (is[0]=='p'){
	    sprintf(textb[0],"partial pre-image histogram: start pause-p");
	    draw_prompt_box(1);
	    outtext(textb[0]);
	    see_ppstack=1;
	 }
	 moveto(tempx,tempy);
      }
      for (zu=1;zu<=PScount[tog];zu++){
	 /*check for cycle repeat, rotation (from all 0s or 1s),
						if ok add, print*/
	 if (check_pre_image(PS[tog][zu])==1) continue;
	 accept_pre_image(PS[tog][zu]);
      }
  }
  for (zz=0;zz<=1;zz++){
     for (zu=0;zu<=PScount[zz];zu++){
	free(PS[zz][zu]);
	free(PSflag[zz][zu]);
     }
  }
  return;
}

/** compute pre-images 1D local, 1 rule or mixed May 93 - rev Dec 93 ****/
void pre_images(void){
  signed short 
      ppindex,     /*continue pp from ppindex....*/
      *ppend,            /*holds index reached by pp*/
      z,bytereached,  /*pos of index in countdown of bytes in B*/
      n,m,
      u,u1,ur,i, 		/*n'hood value*/
      tablebytes;  /*no of bytes  "   "     "  */
  char **pp,       /*array of pointers to partial pre-images pointers*/
       trypp=0,failpcheck=0,
       nrad,oddrad=0,ppcomplete,tu1;
  unsigned long ppcount=0,  /*count of partial pre-images in queue*/
		maxppcount=0;

    attrepeat=0; /*1 if pre_image on attractor cycle*/

    sprintf(textb[0],"pp");
    if ((pp=(char**)calloc(1,sizeof(char*)))==NULL) outof_memory(textb[0]);
    sprintf(textb[0],"ppend");
    if ((ppend=(signed short*)calloc(1,sizeof(signed short)))
				 ==NULL) outof_memory(textb[0]);
	/*	nhood=3     nhood=4     asymmetric nhood is
		o o *       o o o *     wider on the right
		\ | /       \ | / /
		  T           T         */
    nrad=nhood/2;
    if (nhood%2==0){
	nrad-=1;
	oddrad=1;
    }
    /* bitstrings A,B and pp:

	       L        n             0
	       |        |             |
	     --------|--------|--------      .........A
		   2        1        0

	      L+8       m m-nrad      8        0
	      |	 |      | |           |        |
    --------|--------|--------|--------|--------  ....B
	  4        3        2        1        0

		   set to 1  0
			  |  |
    --------|--------|--------     ...................pp
	  2        1        0
    */
    memset(B,0,bytesL+2); /*set all bits in B to 0*/
    for (z=nhood-2+oddrad;z>=0;z--) set_bit(B,8 +L +z-(nrad+oddrad-1),p[z]);
    /*		 L(+8)
		 |
	 =1      --------
	 =2 	 x-------
	 =3	xx-------
	 =4     xxx------       assumed start strings for
	 =5    xxxxx-----       different size nhoods
	 =6    xxxxxx----
	 =7   xxxxxxx----
	 =8   xxxxxxxx---
	 =9  xxxxxxxxx---    */
    ppindex=L;
    tablebytes=(signed short)ceil(pow(2,(double)nhood)/8);
    /*homogenious rule*/
    if (!rulemix){
	memcpy(arule,carule[0],tablebytes);
	memcpy(arule1,carule[0],tablebytes);
	memcpy(arule2,carule[0],tablebytes);
    }
 pre1:
    for ( n=ppindex;n>=0;n--){      /* from right to left ----->*/
	if (rulemix){
	   memcpy(arule,carule[n],tablebytes);                 /*rule at n*/
	   memcpy(arule1,carule[(lineL+n-1)%lineL],tablebytes);/*rule at n-1*/
	   memcpy(arule2,carule[(lineL+n+1)%lineL],tablebytes);/*rule at n+1*/
	}
	/*backwards logic*/
	m=n+8;
	/*excluded permutation left->right, 21*->T,321*->T
	  nhood ending with 0*/
	u=0; i=nhood;
	for (z=nrad;z>=1-nrad-oddrad;z--){
		i--;
		u += get_bit(B, m+z) * (signed short)pow(2,(double)i);
	}
	if (get_bit(arule,u)==get_bit(arule,u+1)
				     && get_bit(A,n)!=get_bit(arule,u)){
		trypp=1;
		break;
	}
	/*excluded permutation right->left,T<-*10, T<-*3210
	  nhood starting with 0*/
	ur=0;i=nhood-1;
	for (z=nrad;z>=1-nrad-oddrad;z--){
		i--;
		ur = ur + get_bit(B, m+z) * (signed short)pow(2,(double)i);
	}
	if (get_bit(arule2,ur)
	     ==get_bit(arule2,ur+(signed short)pow(2,(double)nhood)/2)
			&& get_bit(A,(lineL+n+1)%lineL)!=get_bit(arule2,ur)){
		trypp=1;
		break;
	}
	/*deterministic permutation  left->right*/
	if (get_bit(arule,u)!=get_bit(arule,u+1)){
		if (get_bit(A,n)==get_bit(arule,u))
			set_bit0(B,m-nrad-oddrad);/*right end of nhood=0*/
		else set_bit1(B,m-nrad-oddrad);/*right end of nhood=1*/
		/*check boundary conditions*/
		if (n<=nhood-2 && p[n]!=get_bit(B,m-nrad-oddrad)){
			trypp=1;
			break;
		}
		continue;
	}
	/* else if ambiguous permutation*/
	set_bit0(B,m-nrad-oddrad);/*next cell could be both 1 and 0, assume 0*/
	/*shift right nhood ending with 0*/
	u1=0;i=nhood;
	for (z=nrad-1;z>=-nrad-oddrad;z--){
		i--;
		u1 += get_bit(B, m+z) * pow(2,(double)i);
	}
	if (get_bit(arule1,u1)==get_bit(arule1,u1+1)){
	   /*check for deterministic permutation 2-tuples pairs unequal
			   A *  B *
			     |    |
			    -2    2    */
	   if (u1%4==0) tu1=2;
	   else tu1=-2;
	   if (get_bit(arule1,u1)!=get_bit(arule1,u1+tu1) &&
			    get_bit(arule1,u1+tu1)==get_bit(arule1,u1+tu1+1)){
		if (get_bit(A,(lineL+n-1)%lineL)==get_bit(arule1,u1)){
			    if (tu1==2) set_bit0(B,m-nrad-oddrad);
			    else set_bit1(B,m-nrad-oddrad);
		}
		else{
			    if (tu1==2) set_bit1(B,m-nrad-oddrad);
			    else set_bit0(B,m-nrad-oddrad);
		}
		/*check boundary conditions*/
		if (n<=nhood-2 && p[n]!=get_bit(B,m-nrad-oddrad)){
			trypp=1;
			break;
		}
		continue;
	   }
	   /*
	   shift ppindex->right,
	   check for excluded permutation 21*->T, 4321*->T
	   if excluded change assumed next cell from 0 to 1
	   */
	   if (get_bit(A,(lineL+n-1)%lineL) !=get_bit(arule1,u1)){
		set_bit1(B,m-nrad-oddrad);
		/*check  if 1 is compatible with boundary conditions*/
		if (n<=nhood-2 && p[n]!=1){
			trypp=1;
			break;
		}
		continue;
	   }
	}
	/* end backwards logic*/
	if (n<=nhood-2 && p[n]!=1){/*check boundary for*/
		continue;         /*alternative ending in 1*/
	}                         /*to be added to pp stack*/
	ppcount ++;    /*ppcount=partial preimage no*/
	if (maxppcount<ppcount){
	   maxppcount=ppcount;
	   sprintf(textb[0],"pp");
	   if( (pp=(char**) realloc(pp,sizeof(char*)*(ppcount+1)))
					==NULL) outof_memory(textb[0]);
	   sprintf(textb[0],"ppend");
	   if((ppend=(signed short*)realloc
		(ppend,sizeof(signed short)*(ppcount+1)))
					==NULL) outof_memory(textb[0]);
	}
	if (see_ppstack  && ppcount<150){  /*increace bar showing pp stack*/
	   setcolor(magenta);

#          if __BORC__||__UNIX__
	      line(vgax(125)+vgax(ppcount),Maxy-vgay(40),
				   vgax(125)+vgax(ppcount),Maxy-vgay(34));
#          elif __WATCOM__
	      line(vgax(140)+vgax(ppcount),Maxy-vgay(40),
				   vgax(140)+vgax(ppcount),Maxy-vgay(34));
#          endif

	   setcolor(white);
	}
	/*in B*/
	bytereached=(m-nrad-oddrad)/8;    /* countdown*/
	/*alloc required bytes*/
	sprintf(textb[0],"pp[%lu]",ppcount);
	if ((pp[ppcount]=(char *)malloc(bytesL+2-bytereached))
				      ==NULL) outof_memory(textb[0]);
	memset(pp[ppcount], 0, bytesL+2-bytereached);
	/*signed short array holding ppend index - to be continued from this*/
	ppend[ppcount]=n;
	memcpy(pp[ppcount],B+bytereached,bytesL+2-bytereached);
	set_bit1(pp[ppcount],(m-nrad-oddrad)%8);   /*set last bit to 1*/
    }  /*** next n ***/
    if (trypp==1){
	trypp=0;
	goto pre3;
    }
 pre2:
    failpcheck=0;         /*periodic boundary check*/
    for (z=nhood-2;z>=0;z--){
       if(p[z]!=get_bit(B,8+z-nrad-oddrad)){
	  failpcheck=1;
	  break;
       }
    }
    if (failpcheck==1) goto pre3;
    /*pp line is now complete and valid*/
    /*set_bits in B beyond L to 0, allows bytes to be compared*/
    for (z=(bytesL+1)*8-1;z>=L+1;z--) set_bit0(B,z+8);

    /*check for cycle repeat, rotation (from all 0s or 1s, if ok add, print*/
    if (check_pre_image(B+1)==1) goto pre3;
    accept_pre_image(B+1);
    /*if interrupt*/
    interrupt_pre_fan();
    if (is[0]=='q' || is[0]=='n'){
       for (z=1;z<=ppcount;z++) free(pp[z]);
       free(pp);
       free(ppend);
       ppcount=0;
       return;
    }
 pre3:
    if (ppcount==0){
       free(pp);
       free(ppend);
       return;  /*preim stack empty*/
    }
    ppcomplete=0;
    if (ppend[ppcount] == 0) ppcomplete=1;
    memset(B,0,bytesL+2); /*set all bits in B to 0*/
    bytereached=(8+ppend[ppcount]-nrad-oddrad)/8; /* countdown*/
    memcpy(B+bytereached,pp[ppcount],bytesL+2-bytereached);
    ppindex=ppend[ppcount]-1;
    free(pp[ppcount]);
    ppcount--;
    if (see_ppstack && ppcount+1<150){  /*decrease bar showing pp stack*/
       setcolor(black);
#      if __BORC__||__UNIX__
	  line(vgax(125)+vgax(ppcount+1),Maxy-vgay(40),
		     vgax(125)+vgax(ppcount+1),Maxy-vgay(34));
#      elif __WATCOM__
	  line(vgax(140)+vgax(ppcount+1),Maxy-vgay(40),
		     vgax(140)+vgax(ppcount+1),Maxy-vgay(34));
#      endif

       setcolor(white);
    }
    if (ppcomplete==1) goto pre2;
    goto pre1;
}

/**** check pre-image for repeat, (if pre-im of all 0s or 1s) rotation,
		accept and print if ok **********************************/
char check_pre_image(char *pre_state){
  unsigned short
      repseg=0, /*lenth of segment repeating segment in circular ca-array*/
      tempx,tempy,z,zz;
  signed short z0,z1;
  char rotrepeat, /*for rotation equivalent repeats*/
       reject=0;

    /*check for pre-image on cycle*/
    if (level==0 && attperiod>0 && attrepeat==0){
       isrepeat=1;
       if (attindex>1){
	  if (memcmp(att[attindex-1],pre_state,bytesL)==0){ /*if same*/
	     attrepeat=1;
	     reject=1;
	     goto pre3;
	  }
       }
       else{
	  if (memcmp(att[attperiod],pre_state,bytesL)==0){ /*if same*/
	     attrepeat=1;
	     reject=1;
	     goto pre3;
	  }
       }
    }
    /*check for repeat with firstseed, subtree only*/
    /*if not endless repeat of att cycle*/
    if (isrepeat==0 && attperiod==0){
       /* can only occur once */
       if (memcmp(firstseed,pre_state,bytesL)==0){ /*if same*/
	  isrepeat=1;
	  tempx=getx;
	  tempy=gety;
	  draw_prompt_box(1);
	  sprintf(textb[0],"repeat of seed");
	  outtext(textb[0]);
	  totatt_states=level+1;
	  moveto(tempx,tempy);
	  reject=1;
	  goto pre3;
       }
    }

    /*if seed was all 0s or all 1s*/
    if (allbitssame==1 && insegloop==0  && !rulemix && !dontcompress
       && exhaustive_testing!=2 &&
	     (!nonlocal || compress_1d_local==1 || regular2d)){

	  segfan=1; /*indicates condition above*/
	  memcpy(tempState, pre_state, bytesL);
	  if (regular2d){
	     repeating_seg_2d(tempState);
	     if (repseg_2d[0]>1 && repseg_2d[1]>1)
					    trans_sym_2d(tempState);
	  }
	  else repseg=repeating_seg(tempState);
	  /*check for repeat with fan so far*/
	  rotrepeat=0;
	  if (segno>0){
	     /*check for repeats in previous segments*/
	     for (zz=1;zz<=segno;zz++){
		/*if rotation symmetry is different, dont bother*/
		if (regular2d){
		   if (seg_2d_h[zz]!=repseg_2d[0] ||
			     seg_2d_v[zz]!=repseg_2d[1]) continue;

		   for (z0=1;z0<=repseg_2d[0];z0++){
		      for (z1=1;z1<=repseg_2d[1];z1++){
			 if (memcmp(segseed[zz],tempState,bytesL)==0){
			    rotrepeat=1;
			    break;
			 }
			 rotate_array_2d(tempState,'u',1);
		      }
		      if (rotrepeat==1) break;
		      rotate_array_2d(tempState,'l',1);
		   }
		}
		else{
		   if (seg[zz]!=(signed short)repseg) continue;
		   for (z=1;z<=repseg;z++){
		      if (memcmp(segseed[zz],
			    rotate_array(nhood,
			             tempState,'l',0,1),bytesL)==0){
			 rotrepeat=1;
			 break;
		      }
		   }
		}
		if (rotrepeat==1) break;
	     }
	     /*reject*/
	     if (rotrepeat==1){
		reject=1;
		goto pre3;
	     }
	  }
	  segno+=1;    /*number rototation equivelent groups*/

	  sprintf(textb[0],"checking seg etc");
	  if (regular2d){
	     if( (seg_2d_h=(signed short*)realloc
		    (seg_2d_h, sizeof(signed short)*(segno+1)))
				    ==NULL) outof_memory(textb[0]);
	     if( (seg_2d_v=(signed short*)realloc
		    (seg_2d_v, sizeof(signed short)*(segno+1)))
				    ==NULL) outof_memory(textb[0]);

	     seg_2d_h[segno]=repseg_2d[0] ; /*repeating columns*/
	     seg_2d_v[segno]=repseg_2d[1] ; /*repeating rows*/
	  }
	  else {
	     if( (seg=(signed short*)realloc
		    (seg, sizeof(signed short)*(segno+1)))
				    ==NULL) outof_memory(textb[0]);
	     seg[segno]=repseg; /*repeating segment=size of groups*/
	  }
	  if( (segseed = (char**) realloc(segseed,sizeof(char*)*segno+1))
				    ==NULL) outof_memory(textb[0]);
	  if ((segseed[segno]=(char*)calloc(bytesL,sizeof(char)))
				    ==NULL) outof_memory(textb[0]);
	  memcpy(segseed[segno],pre_state,bytesL);
    }
    precount++;
    nextindex++;

    if (stp){
       print_current_state(pre_state,lightred);
       end_page(scale);
    }

    if (exhaustive_testing){ /*tick off used state*/
       if (dontcompress==1 || (nonlocal && !regular2d) ||
	    exhaustive_testing==2)
	       set_bitlong(tickoff,dec_equiv(pre_state,L),1);
       else{
	  /*tickoff equivalents (all 0s or 1s)*/
	  if (allbitssame==1 && insegloop==0 && !rulemix){
	     memcpy(tempState, pre_state, bytesL);
	     if (regular2d){
		for (z0=1;z0<=repseg_2d[0];z0++){
		   for (z1=1;z1<=repseg_2d[1];z1++){
		      if (!(z0==1 && z1==1))/*miss out first=same*/
			 rotate_array_2d(tempState,'u',1);
		   }
		   rotate_array_2d(tempState,'l',1);
		}
		set_bitlong(tickoff,dec_equiv(tempState,L),1);
		/*print_current_state(tempState,lightred);*/
		/*end_page();*/
	     }
	     else{
		for (z=1;z<=repseg-1;z++){
		   rotate_array(nhood,tempState,'l',0,1);
		   set_bitlong(tickoff,dec_equiv(tempState,L),1);
		   /*print_current_state(tempState,lightred);*/
		   /*end_page();*/
		}
	     }
	  }
       }
    }
    pre3:;
    return(reject);
}

/*********** accept the pre-image and print, Nov 93 ********************/
void accept_pre_image(char *pre){

	/*store pre-image*/
	sprintf(textb[0],"accept pre-image");
	if (pretog){
	   if( (preim0 = (char**) realloc(preim0,
		  sizeof(char*)*(nextindex+1)))
				==NULL) outof_memory(textb[0]);
	   if( (xx0 = (signed short*)
		realloc(xx0,sizeof(signed short)*(nextindex+1)))
				==NULL) outof_memory(textb[0]);
	   if( (yy0 = (signed short*)
		realloc(yy0,sizeof(signed short)*(nextindex+1)))
				==NULL) outof_memory(textb[0]);
	   if ((preim0[nextindex]=(char*)calloc(bytesL,sizeof(char)))
				==NULL) outof_memory(textb[0]);
	   /*store valid preim*/
	   memcpy(preim0[nextindex], pre, bytesL);
	}
	else{
	   if( (preim1 = (char**) realloc(preim1,
			    sizeof(char*)*(nextindex+1)))
				==NULL) outof_memory(textb[0]);
	   if( (xx1 = (signed short*)
		realloc(xx1,sizeof(signed short)*(nextindex+1)))
				==NULL) outof_memory(textb[0]);
	   if( (yy1 = (signed short*)
	       realloc(yy1,sizeof(signed short)*(nextindex+1)))
				==NULL) outof_memory(textb[0]);
	   if ((preim1[nextindex]=(char*)calloc(bytesL,sizeof(char)))
				==NULL) outof_memory(textb[0]);
	   /*store valid preim*/
	   memcpy(preim1[nextindex], pre, bytesL);
	}
}

/********************* interrupt_fan, Nov 93 *************************/
void interrupt_pre_fan(void){
 signed short tempx,tempy,xbox;

   if (event_ready()){   /*to interrupt, early exit*/
    if (is[0]=='q'){
      tempx=getx;
      tempy=gety;
      earlyexit=1;

      /* bug in UNIX version ??
      if (pretog) memcpy(A,preim1[thisindex],bytesL);
      else memcpy(A,preim0[thisindex],bytesL);
      */

     startinterrupt:
      sprintf(textb[1],"early exit - in pre-image fan");

      if (basinfield) sprintf(textb[0],
	   "next tree/basin-n, options-o, stop field-q, cont-ret:");
      else if (direction!='b') sprintf(textb[0],
	   "next tree-n, options-o, stop basin-q, cont-ret:");
      else if (direction=='b')sprintf(textb[0],
	   "options-o, stop subtree-q, cont-ret:");

      xbox=draw_prompt_box(2);
      outtext(textb[1]);
      moveto(xbox,gety+CHeight);
      if (pre_fansize_freq_hist) myouttext("inhist-h, ");
      myouttext(textb[0]);
      input_string(1,0);
      erase_prompt_box(2);
      moveto(tempx,tempy);
      if (is[0]=='o'){
	 finish_options(1);
	 goto startinterrupt;
      }
      if (is[0]=='h' && pre_fansize_freq_hist){
	 show_pre_fansize_freq_hist();
	 goto startinterrupt;
      }

      if (is[0]=='q' || is[0]=='n'){
	 moveto(tempx,tempy);
	 return;
      }
      earlyexit=0;
    }
   }
}

/******* display partial pre-image stack histogram, Aug 94 ************/
void setup_ppstack_hist(void){
   signed short z,maxhistwidth,tempx,tempy;
   unsigned short zu;

     tempx=getx;
     tempy=gety;
     if (ppL!=lineL){
	ppL=lineL;

	pp_startx0=vgax(126);
	pp_starty0=Maxy-vgay(40);

	pp_bartotw=vgax(10);
	maxhistwidth=Maxx-(pp_startx0+vgax(50)+vgax(10));
	if ((lineL+1)*pp_bartotw > maxhistwidth)
	   pp_bartotw=(signed short)((float)maxhistwidth/(lineL+1));
	pp_barwidth=pp_bartotw-2;
	if (pp_barwidth<=0) pp_barwidth=1;
	pp_widthx=vgax(50)+(lineL+1)*pp_bartotw;
	pp_depthy=vgay(150);
	setfillstyle(SOLID_FILL,black);
	bar(pp_startx0+1,pp_starty0-pp_depthy+1,
			     pp_startx0+pp_widthx-1,pp_starty0-1);
	setcolor(red);
	rectangle(pp_startx0,pp_starty0-pp_depthy,
			     pp_startx0+pp_widthx,pp_starty0);
	pp_startx=pp_startx0+vgax(50);
	pp_starty=pp_starty0-vgay(25);

	setcolor(white);
	if (pp_ymax==0){
	   pp_ymax=(signed short)ceil(pow((double)(lineL*nhood),
				 1+(double)nhood/30+(double)nhood/150));
	   if (pp_ymax<10) pp_ymax=10;
	}
	pp_divy=(signed short)ceil((float)pp_ymax/4);

	if (pp_divy<5)      pp_divy-=pp_divy%2;
	else if (pp_divy<10) pp_divy-=pp_divy%5;
	else if (pp_divy<100) pp_divy-=pp_divy%10;
	else if (pp_divy<1000) pp_divy-=pp_divy%100;
	else if (pp_divy<10000) pp_divy-=pp_divy%1000;
	if (pp_divy<1) pp_divy=1;

	for (z=0;z<=lineL-1;z++){
	   line(pp_startx+z*pp_bartotw,pp_starty+2,
		pp_startx+pp_barwidth+z*pp_bartotw,pp_starty+2);
	   if (z==0 || z==lineL-1){
	      moveto(pp_startx+z*pp_bartotw,pp_starty+vgay(4));
	      sprintf(textb[0],"%d",lineL-1-z);
	      outtext(textb[0]);
	   }
	}
	for (zu=0;zu<=pp_ymax;zu+=pp_divy){
	   pp_heighty=(signed short)ceil((vgay(120)*(float)zu/pp_ymax));
	   line(pp_startx-vgax(10),pp_starty-pp_heighty,
				   pp_startx-vgax(5),pp_starty-pp_heighty);
	   moveto(pp_startx-vgax(30),pp_starty-pp_heighty-CHeight/2);
	   sprintf(textb[0],"%d",zu);
	   outtext(textb[0]);
	}
     }
     setfillstyle(SOLID_FILL,black);
     bar(pp_startx0+vgax(50),pp_starty0-pp_depthy+1,
				   pp_startx0+pp_widthx-1,pp_starty);
     setfillstyle(SOLID_FILL,green);
     pp_startx=pp_startx0+vgax(50);
     moveto(tempx,tempy);
}
