/************ capara, select ca parameters *********************/

#include "edecfunc.h"

/******** specify the size if a cell in pixels, Aug 93 ******/
char select_cell_size(){
  char dscale;

   if (hires) dscale=6; /*size in pixels of network cell*/
   else dscale=4;
   sprintf(textb[0],"enter cell size in pixels, default %d:",dscale);
   next_line(xtext,1);
   myouttext(textb[0]);
   input_string(2,1);
   if (is[0]=='q') return(-1);
   scale=atoi(is);
   if (is[0]==13 || atoi(is)<1) return(dscale);
   else return((char)atoi(is));
}

/******** specify line length for single basin, 13 May 1993 **************/
void select_linelength_singlebasin(){

 start:
   scale=select_cell_size();
   if (scale==-1){
	is[0]='q';
	return;
   }
   sprintf(textb[0],"Network size (length) max to fit %i, default %i:"
				,(Maxx+1)/scale,14);
   next_line(xtext,1);
   myouttext(textb[0]);
   input_string(4,1);
   if (is[0]=='q'){
	setpback_x_lines(1);
	goto start;
   }
   lineL=atoi(is);
   if (is[0]==13 || lineL<1) lineL = 14;
   L=lineL-1;  /*lineL gives actual line length*/
	       /*L is max array index, ie.*/
	       /*L,L-1,L-2, . . . . . . . . . . .,3,2,1,0*/
   /*no of bytes required to contain lineL bits*/
   bytesL=(signed short)ceil((double)lineL/8);
}

/******** specify line length for basin field, 26 June 1993 **************/
void select_linelength_31(){
  
  signed short defaultL;

 start:
   defaultL=10;
   sprintf(textb[0],"Network size (length) max 32, default %d:",defaultL);
   next_line(xtext,1);
   myouttext(textb[0]);
   input_string(2,1);
   if (is[0]=='q') return;
   lineL=atoi(is);
   if (is[0]==13 || lineL > 31 || lineL<1) lineL = defaultL;


   L=lineL-1;  /*lineL gives actual line length*/
	       /*L is max array index, ie.*/
	       /*L,L-1,L-2, . . . . . . . . . . .,3,2,1,0*/
   bytesL=(signed short)ceil((double)lineL/8);     /*no of bytes required to contain lineL bits*/
   scale=select_cell_size();
   if (scale==-1){
	setpback_x_lines(1);
	goto start;
   }
   return;
}

/******************** specify range of network size, Aug 1993 **************/
void select_linelength_range(){
  char dstartL,dendL;

 start:
   dstartL=5;
   dendL=12;
   sprintf(textb[0],"Start size, default %d:",dstartL);
   next_line(xtext,1);
   myouttext(textb[0]);
   input_string(2,1);
   if (is[0]=='q') return;
   startL=atoi(is);
   if (is[0]==13 || lineL > 31 || startL<1) startL = dstartL;
   sprintf(textb[0],"End size, default %d:",dendL);
   next_line(xtext,1);
   myouttext(textb[0]);
   input_string(2,1);
   if (is[0]=='q'){
	setpback_x_lines(1);
	return;
   }
   endL=atoi(is);
   if (is[0]==13 || lineL > 31) endL = dendL;
   if (endL<=startL) rangeL=0; /*cancel range, revert to one CA size only*/
   /*no of bytes required to contain lineL bits*/
   lineL=startL;
   L=lineL-1;
   bytesL=(signed short)ceil((double)lineL/8);
   scale=select_cell_size();
   if (scale==-1){
      setpback_x_lines(2);
      goto start;
   }
   return;
}

/**** select size of neighbourhood 1-9, 13 May 1993, rev Dec 93 *******/
void select_nhood_size(char inbox){
 unsigned short z;

   setcolor(white);
   if (!inbox) next_line(xtext,1);
   nhood_mixed=0;

   if ((nhoodm=(char *)calloc(lineL,sizeof(char)))
				   ==NULL) outof_memory("nhoodm");
   if (nhood==0) nhood=3;
   sprintf(textb[0],
      "Neighbourhood size, mixed-m, or enter 1-9 (default %d):",nhood);
   if (!inbox){
      setfillstyle(SOLID_FILL,black);
      bar(getx,gety+2,getx+textwidth(textb[0])+vgax(20),
					    gety+CHeight);
   }
   else draw_prompt_box(1);
   myouttext(textb[0]);
   input_string(1,0);

   if (is[0]=='m') set_dif_nhoods();
   if (is[0]=='q'){
      if (!inbox) setpback_x_lines(1);
      return;
   }

   else if ((atoi(is)<1 || atoi(is)>9 || is[0]==13)); /*do nout*/
   else nhood=atoi(is);
   if (!nhood_mixed){
      for (z=0; z<=lineL-1;z++) nhoodm[z]=nhood;
   }
}

/**************** set different neighbourhood sizes **************/
void set_dif_nhoods(void){
 unsigned short tempL,startindex,poss,endposs,mixloaded;
 signed short rows,tempx,tempy,xbox;
 char bmix,indexjump=0;


   tempx=getx;
   tempy=gety;
   erase_prompt_box(2);

   nhood_mixed=1;

  startm:
   for (poss=0;poss<=lineL-1;poss++) nhoodm[poss]=0;
   tempL=lineL;
   nhood_lb=1;
   nhood_ub=9;
   draw_prompt_box(1);
   sprintf(textb[0],
     "set nhood MIX: load-l, by hand-h, at random (default):");
   myouttext(textb[0]);
   input_string(1,0);
   if (is[0]=='q'){
      moveto(tempx,tempy);
      return;
   }
   if (is[0]=='l'){     
      /*load from standard file format*/
      if (is[0]=='l') mixloaded=load_save_nhoodmix('l');
      /*load from Manor's file format*/
      if (is[0]=='L') mixloaded=load_save_nhoodmix('L');
      if (is[0]=='q') goto startm;
      if (mixloaded<lineL){
	 xbox=draw_prompt_box(2);
	 sprintf(textb[0],"mix loaded (%d) less than net size (%d)",
	                                       mixloaded,lineL);
	 sprintf(textb[1],"enter background mix 1-9 (default 5):");
	 outtext(textb[0]);
	 moveto(xbox,gety+CHeight);
	 myouttext(textb[1]);
	 input_string(1,0);
	 if (atoi(is)>=1 && atoi(is)<=9) bmix=atoi(is);
	 else bmix=5;
	 for (poss=mixloaded;poss<=lineL-1;poss++) nhoodm[poss]=bmix;
	 erase_prompt_box(2);
      }
      nhood_lb=nhood_ub=1;
      for (poss=0;poss<=lineL-1;poss++){
	 /*find lower and upper bounds*/
	 if (nhoodm[poss]<nhood_lb) nhood_lb=nhoodm[poss];
	 if (nhoodm[poss]>nhood_ub) nhood_ub=nhoodm[poss];
      }
   }

   else if (is[0]=='h'){
      for (poss=0;poss<=lineL-1;poss++){
	 draw_prompt_box(1);
	 sprintf(textb[0],
	       "set nhood size (1-9) at cell %d (reverse-r):",poss);
	 myouttext(textb[0]);
	 input_string(1,0);
	 if (is[0]=='q') goto startm;
	 if (is[0]=='r'){
	    if (poss>0) poss-=2;
	 }
	 if (atoi(is)>=1 && atoi(is)<=9) nhoodm[poss]=atoi(is);
	 else nhoodm[poss]=myrand()%10;
      }
      for (poss=0;poss<=lineL-1;poss++){
	 /*find lower and upper bounds*/
	 if (nhoodm[poss]<nhood_lb) nhood_lb=nhoodm[poss];
	 if (nhoodm[poss]>nhood_ub) nhood_ub=nhoodm[poss];
      }
   }
   else{
     startm1:
      draw_prompt_box(1);
      sprintf(textb[0],"set nhood bounds 1-9: lower (default 1):");
      myouttext(textb[0]);
      input_string(1,0);
      if (is[0]=='q') goto startm;
      if (is[0]==13); /*do nout*/
      else if (atoi(is)>=1 && atoi(is)<=9) nhood_lb=atoi(is);
      sprintf(textb[0]," upper (default 9):");
      myouttext(textb[0]);
      input_string(1,0);
      if (is[0]=='q') goto startm1;
      if (is[0]==13); /*do nout*/
      else if (atoi(is)>=nhood_lb && atoi(is)<=9) nhood_ub=atoi(is);

      for (poss=0;poss<=lineL-1;poss++){
	 while(!(nhoodm[poss]>=nhood_lb && nhoodm[poss]<=nhood_ub)){
	    nhoodm[poss]=myrand()%10;
	 }
      }
   }
  startjump:
   if (!indexjump) startindex=lineL;
   indexjump=0;
   rows=(signed short)ceil
      ((double)(startindex*CWidth)/(getmaxx()-vgax(10)-(Maxx/2)))+3;
   if (rows*CHeight>Maxy-vgay(20)){
      rows=(Maxy-vgay(20))/CHeight;
   }
   sprintf(textb[0],
      "mixed n'hoods %d-%d: net size=%d, startindex=%d",
			     nhood_lb,nhood_ub,lineL,startindex-1);
   if (lineL!=tempL)
      sprintf(textb[0],
	"mixed n'hoods %d-%d: net size=%d (was %d) startindex=%d",
			     nhood_lb,nhood_ub,lineL,tempL,startindex-1);
   if (basinfield && lineL>32){
      sprintf(textb[1],"(network>32, field changed to single)");
      rows+=1;
   }
   xbox=draw_prompt_box(rows);
   outtext(textb[0]);
   if ( basinfield && lineL>32){
      basinfield=0;
      moveto(xbox,gety+CHeight);
      outtext(textb[1]);
   }
   moveto(xbox,gety+CHeight);
   for (poss=startindex-1;poss!=Maxu;poss--){
      if (getx>getmaxx()-vgax(10)){
	 moveto(xbox,gety+CHeight);
	 if (gety>=Maxy-vgay(20)-3*CHeight){
	    moveto(xbox,gety-CHeight);
	    break;
	 }
      }
      sprintf(textb[0],"%d",nhoodm[poss]);
      outtext(textb[0]);
   }
   if (poss==Maxu) endposs=0;
   else endposs=poss+1;
   moveto(xbox,gety+CHeight);
   sprintf(textb[0],"mix shown from cell index %d-%d",startindex-1,endposs);
   outtext(textb[0]);
   moveto(xbox,gety+CHeight);

   if (poss!=Maxu) sprintf(textb[0],
	   "reset-r save-s more-m jump-j cont-ret:");
   else sprintf(textb[0],
	   "reset-r save-s jump-j cont-ret:");

   myouttext(textb[0]);
   input_string(1,0);
   if (is[0]=='q' || is[0]=='r'){
      erase_prompt_box(rows);
      goto startm;
   }
   else if (is[0]=='j'){ /*jump to new cell poss*/
      setfillstyle(SOLID_FILL,black);
      bar(xbox,gety+2,Maxx-3,gety+CHeight+2);
      sprintf(textb[0],"jump to index (%d-0):",lineL-1 );
      moveto(xbox,gety);
      myouttext(textb[0]);

      /*input_string(strlen(itoa(lineL-1,textb[0],10)),0);*/
      sprintf(textb[0],"%d",lineL-1);
      input_string(strlen(textb[0]),0);

      if (atoi(is)>=0 && atoi(is)<=lineL-1){
	 startindex=atoi(is)+1;
	 indexjump=1;
	 erase_prompt_box(rows);
	 goto startjump;
      }
   }
   else if (is[0]=='m' && poss!=Maxu){ /*continue to next cell poss*/
      startindex=poss+1;
      indexjump=1;
      erase_prompt_box(rows);
      goto startjump;
   }
   else if (is[0]=='s'){
     load_save_nhoodmix('s');
     if (is[0]=='q') goto startm;
   }
   erase_prompt_box(rows);
   nhood=nhood_ub;
   moveto(tempx,tempy);
}

/**** select if totalistic, 13 May 1993, rev Dec 93 *******/
void select_totalistic(void){

   setcolor(white);
   next_line(xtext,1);
   sprintf(textb[0],"totalistic rule-t:");
   myouttext(textb[0]);
   input_string(1,0);
   if (is[0]=='q'){
      setpback_x_lines(0);
      return;
   }
   if (is[0]!='t') totalistic=0;
   else totalistic=1;
}

/*****set up and draw n'hood matrix (rule table),13 May 1993***********/
void setup_nhood_matrix(char innernhood, char outernhood){
 signed short zz,z,sod,
     outertable,innertable,
     tempy,tempx1,tempy1,
     spacing,xleftpix;
 char color,mscale,msep,xleft;

   innernhood=outernhood=nhood;/*keep nhood matrix simple*/
   xleft=4; /*offset from left of nhood matrix in textwidth units*/
   mscale=vgax(5);
   setfillstyle(SOLID_FILL,black);
   bar(xtext-xleft,gety+3*mscale-1,Maxx-5,Maxy-vgay(33));

   if (nhood>5) mscale=vgax(4);
   msep=(ceil)( (double)mscale/4);
   innertable=(signed short)pow(2,(double)innernhood)-1;
   outertable=(signed short)pow(2,(double)outernhood)-1;
   if ((mscale+1)*outertable > Maxx-20){
      sod= (Maxx-10)/outertable;
      mscale=sod-1;
      if (mscale<=2){
	 mscale=2;
	 msep=1;
      }
      if (mscale==3) msep=1;
      if (nhood==9 && hires==0){
	 mscale=1;
	 msep=0;
      }
      if (nhood==8 && hires==1) mscale=3;
   }
   next_line(xtext,1);

   /*matrix set in allocate_mem_nhood_matrix(char thisnhood)*/
   xleftpix=xtext*CWidth;
   if (nhood==9 && hires==1) xleftpix=0;

   next_line(xtext-xleft,1);

   spacing= (outertable+1)/4;
   if (spacing<1) spacing=1;
   for (zz=outernhood-1;zz>=0;zz--){
      tempy=gety;

      moveto(xleftpix,tempy);
      for(z=outertable;z>=0;z--){
	 if (get_bit(nm[zz],z)==1){
	    color=yellow;
	    if (innernhood!=outernhood){
	       if (z<=innertable && zz<innernhood) color=lightred;
	    }
	    setfillstyle(SOLID_FILL,color);
	 }
	 else setfillstyle(SOLID_FILL,darkgray);
	 bar(getx,tempy,getx+mscale-msep,tempy+mscale-msep);
	 /*put a green dot on zero cell, for printout */
	 if (get_bit(nm[zz],z)==0 && mscale>=3)
	     putpixel(getx+mscale/2,gety+mscale/2,green);
	 tempx1=getx;
	 tempy1=gety;

	 /*left outer scale*/
	 if (!(nhood==9 && hires==1)){
	    if ((zz==outernhood-1 || zz==0) && z==outertable){

	       sprintf(textb[0],"%d--",zz);
	       moveto(getx-textwidth(textb[0])-1,
			       tempy-CHeight*.5+(mscale-msep)/2);
	       outtext(textb[0]);
	    }
	 }
	 moveto(tempx1,tempy1);
	 /*right inner scale*/
	 if (innernhood!=outernhood){
	    if ((zz==innernhood-1 || zz==0) && z==0){
		  sprintf(textb[0],"--%d",zz);
		  moveto(getx+mscale-msep+2,
			       tempy-CHeight*.5+(mscale-msep)/2);
		  outtext(textb[0]);
	    }
	 }
	 moveto(tempx1,tempy1);
	 /*nhood scale*/
	 if ((zz==0) && ((z+1)%spacing==0 || z==0)){
	    moveto(getx+mscale-msep-textwidth("|"),tempy+mscale-1);
	    if (z==0) moverel(mscale-msep-1,0);
	    outtext("|");
	    moveto(getx-CHeight,gety+CHeight-1);
	    sprintf(textb[0],"%d",z);
	    outtext(textb[0]);
	 }
	 moveto(tempx1,tempy1);
	 moverel(mscale,0);
      }
      moveto((xtext-xleft)*CWidth,tempy+mscale);
   }
   moverel(0,CHeight*2);
   if (nhood<3) moverel(0,(3-nhood)*mscale);
}

/****************** select rule/code/mix, Dec 1993 *********************/
signed short rule_selection(void){

  unsigned short poss;
  signed short  tablemax,tablebytes,codebytes,whichdiff,
       sod,z,zz,diffz,
       tempx,tempy,tempx1,xbox,endy;
  char setcanalyzing,
       thisnhood,
       outernhood, /*nhood, at least 5*/
       diffbyhand,
       forcezero,
       centrec,tot;

   outernhood=nhood+2;
   if (nhood>=5) outernhood=nhood;
   if (nhood_mixed==0) setup_nhood_matrix(nhood,outernhood);
   tablemax= (signed short)pow(2,(double)nhood)-1;/*max index of ruletable*/
   tablebytes=(signed short)ceil(pow(2,(double)nhood)/8);
   codebytes=(signed short)ceil((double)(nhood+1)/8);
   tempx=getx;
   tempy=gety;

 selectrule:

   if (nhood_mixed==0){
      if (totalistic==0) sprintf(textb[0],
			 "RULES: single rule (default), load rule mix-l");
      else sprintf(textb[0],"single code (default), load rule mix-l,");
      sprintf(textb[1],"mix: no limit-n, or set limit up to 200:");

      xbox=draw_prompt_box(2);
      outtext(textb[0]);
      moveto(xbox,gety+CHeight);
      myouttext(textb[1]);
      input_string(3,0);
      erase_prompt_box(2);
      moveto(tempx,tempy);
      if (is[0]=='q') return(0);

      if (is[0]=='l'){
	 rulemix=1;
	 allocate_mem_rulemix(nhood);
	 allocate_mem_tcodemix(nhood);
	 load_save_wrs('l',carule[0],2);/*dummy rule*/
	 return(tempy);
      }
      if (is[0]==13){
	 rulemix=0;
	 moveto(tempx,tempy);
	 if (totalistic==0) select_rule(0,carule,1,Maxu);
	 else select_code(0,cacode,carule,1,Maxu);
	 endy=gety;
	 return(endy);
      }
      else if (atoi(is)<=200 && atoi(is)>0){
	 rulemix=1;
	 nodiffrules=atoi(is);
      }
      else{
	 rulemix=1;
	 nodiffrules=0;
      }
   }
   else{ /*mixed nhoods, allocate mem as if for largest nhood*/
      rulemix=1;
      nodiffrules=0;
   }

   /**** rulemix only from here ****/
   allocate_mem_rulemix(nhood);
   allocate_mem_tcodemix(nhood);

   forcezero=1;
   sprintf(textb[0],
	   "if random, allow any rule-a, or force all 0s->0 (default):");
   draw_prompt_box(1);
   myouttext(textb[0]);
   input_string(1,0);
   erase_prompt_box(1);
   if (is[0]=='q'){
      if (!nhood_mixed){
	 rulemix=0;
	 free_mem_rulemix();
	 free_mem_tcodemix();
	 goto selectrule;
      }
      else return(0);
   }
   if (is[0]=='a') forcezero=0;

   /*select limited rule mix min=1, allocate to cells at ramdom from list*/
   if (nodiffrules>0 && !nhood_mixed){
      diffbyhand=0;
      if (totalistic==0) sprintf(textb[0],
	  "limited ruleset (%d), set by hand-h, at random(default):",
						          nodiffrules);
      else sprintf(textb[0],
	  "limited codeset (%d), set by hand-h, at random(default):",
						          nodiffrules);
      draw_prompt_box(1);
      outtext(textb[0]);
      input_string(1,0);
      erase_prompt_box(1);
      if (is[0]=='q'){
	 rulemix=0;
	 free_mem_rulemix();
	 free_mem_tcodemix();
	 goto selectrule;
      }
      if (is[0]=='h') diffbyhand=1;
      allocate_mem_diffrules(nhood,nodiffrules);
      allocate_mem_diffcodes(nhood,nodiffrules);
      if (diffbyhand==1){
	 draw_prompt_box(1);
	 if (totalistic==0){
	    sprintf(textb[0],"select subset of %d rules",nodiffrules);
	    outtext(textb[0]);
	    moveto(tempx,tempy);
	    select_rule(0,diffrule,nodiffrules,Maxu);
	 }
	 else{
	    sprintf(textb[0],"select subset of %d totatistic codes",
							 nodiffrules);
	    outtext(textb[0]);
	    moveto(tempx,tempy);
	    select_code(0,diffcode,diffrule,nodiffrules,Maxu);
	 }
	 endy=gety;
	 if (is[0]=='q'){
	    free_mem_diffrules(nodiffrules);
	    free_mem_diffcodes(nodiffrules);
	    goto selectrule;
	 }
      }
      else{
	 for (diffz=0;diffz<=nodiffrules-1;diffz++){
	    if (totalistic==0){
	       for (zz=tablemax;zz>=0;zz--)
			      set_bit(diffrule[diffz],zz,(myrand()%100)/50);
	       if (forcezero==1) set_bit0(diffrule[diffz],0);
	    }
	    else{
	       for (zz=nhood;zz>=0;zz--)
			      set_bit(diffcode[diffz],zz,(myrand()%100)/50);
	       if (forcezero==1) set_bit0(diffcode[diffz],0);
	       for (zz=tablemax;zz>=0;zz--){
		  sod=0;
		  for (z=nhood-1;z>=0;z--) sod+=get_bit(nm[z],zz);
		  set_bit(diffrule[diffz],zz,get_bit(diffcode[diffz],sod));
	       }
	    }
	 }
      }
      if (lineL>1000){
	 moveto(memory_box(0)+2,2);
	 outtext("cell=");
	 tempx1=getx;
	 setfillstyle(SOLID_FILL,black);
      }
      for (poss=lineL-1;poss!=Maxu;poss--){
	 /*count down cells allocated*/
	 if (lineL>5000 && poss%500==0){
	    bar(tempx1,3,tempx1+vgax(50),3+CHeight);
            moveto(tempx1,gety);
	    sprintf(textb[0],"%d",poss);
	    outtext(textb[0]);
	 }
	 whichdiff= myrand()%nodiffrules;
	 memcpy(carule[poss],diffrule[whichdiff],tablebytes);
	 if (totalistic==1) memcpy(cacode[poss],
				 diffcode[whichdiff],codebytes);
      }
      free_mem_diffrules(nodiffrules);
      free_mem_diffcodes(nodiffrules);
      memory_box(1);
      moveto(tempx,tempy);
      if (diffbyhand==1) return(endy);
      else return(tempy);
   }
   else{
      /*
      if (!nhood_mixed)
	sprintf(textb[0],"select by hand-h, glider-g, random-(default):");
      else sprintf(textb[0],"select by hand-h, random-(default):");
      */
     selectnet:
      setcanalyzing=0;
      if (!nhood_mixed)
	 sprintf(textb[0],"select by hand-h, random-(default):");
      else
	 sprintf(textb[0],
	   "select by hand-h, maj-m, +flipped-f, random-(default):");
      sprintf(textb[1],"random + canalyzing-c:");

      xbox=draw_prompt_box(2);
      outtext(textb[0]);
      moveto(xbox,gety+CHeight);
      myouttext(textb[1]);
      input_string(1,0);
      erase_prompt_box(2);

      if (is[0]=='q'){
	 if (!nhood_mixed){
	    rulemix=0;
	    free_mem_rulemix();
	    free_mem_tcodemix();
	    goto selectrule;
	 }
	 else return(0);
      }

      if (is[0]=='c') setcanalyzing=1;

      if (is[0]=='h'){
	 moveto(tempx,tempy);
	 if (totalistic==0) select_rule(0,carule,lineL,Maxu);
	 else select_code(0,cacode,carule,lineL,Maxu);
	 endy=gety;
	 return(endy);
      }

      /*create rule-scheme of all glider rule files, save later*/
      /*
      if (is[0]=='g' && !nhood_mixed){
	 for (poss=1;poss<=no_glider_rules[nhood]-1;poss++)
	       load_glider_rule(carule[poss],poss);
	 erase_prompt_box(1);
	 moveto(tempx,tempy);
	 if (is[0]=='q'){  //in case file not found
	    rulemix=0;
	    free_mem_rulemix();
	    free_mem_tcodemix();
	    goto selectrule;
	 }
	 else return(tempy);
      }
      */
      else{
	 if (lineL>5000){
	    moveto(memory_box(0)+2,2);
	    outtext("cell=");
	    tempx1=getx;
	    setfillstyle(SOLID_FILL,black);
	 }
	 for (poss=lineL-1;poss!=Maxu;poss--){
	    if (nhood_mixed){
	       thisnhood=nhoodm[poss];
	       /*max index of ruletable*/
	       tablemax= (signed short)pow(2,(double)thisnhood)-1;
	       tablebytes=(signed short)ceil(pow(2,(double)thisnhood)/8);
	       codebytes=(signed short)ceil((double)(thisnhood+1)/8);
	    }
	    else thisnhood=nhood;
	    /*count down cells allocated*/
	    if (lineL>5000 && poss%500==0){
	       bar(tempx1,3,tempx1+vgax(50),3+CHeight);
               moveto(tempx1,gety);
	       sprintf(textb[0],"%d",poss);
	       outtext(textb[0]);
	    }
	    if ((is[0]=='m' || is[0]=='f') && nhood_mixed){/*majority rule*/
	       /*centre of nhood or rectangle*/
	       centrec=ceil((double)thisnhood/2)-1;
	       for (zz=0;zz<=tablemax;zz++){
		  tot=0;
		  /*find total of 1s in nhood*/
		  for (z=thisnhood-1;z>=0;z--){
		     if (get_bit(nm[z],zz)) tot+=1;
		  }
		  set_bit0(carule[poss],zz);
		  /*odd or even nhoods, output=majority*/
		  if (tot>thisnhood/2) set_bit1(carule[poss],zz);
		  /*even nhoods & tie, output=centre*/
		  if (thisnhood%2==0 && tot==thisnhood/2)
		     set_bit(carule[poss],zz,get_bit(nm[centrec],zz));

		  /*flip ends*/
		  if (is[0]=='f' && (zz==0 || zz==tablemax))
		    set_bit(carule[poss],zz,abs(get_bit(nm[centrec],zz))-1);
	       }
	    }

	    else if (totalistic==0){
	       for (zz=tablemax;zz>=0;zz--)
		    set_bit(carule[poss],zz,(myrand()%100)/50);
	       if (forcezero==1) set_bit0(carule[poss],0);
	    }
	    else{
	       for (zz=thisnhood;zz>=0;zz--)
			 set_bit(cacode[poss],zz,(myrand()%100)/50);
	       if (forcezero==1) set_bit0(cacode[poss],0);
	       for (zz=tablemax;zz>=0;zz--){
		  sod=0;
		  for (z=thisnhood-1;z>=0;z--) sod+=get_bit(nm[z],zz);
		  set_bit(carule[poss],zz,get_bit(cacode[poss],sod));
	       }
	    }
	    moveto(tempx1,gety);
	 }
	 if (setcanalyzing){
	    memory_box(1);
	    set_canalyzing_net(forcezero);
	    if (is[0]=='q') goto selectnet;
	 }
	 memory_box(1);
	 moveto(tempx,tempy);
	 return(tempy);
      }
   }
}

/**** show/select percentage/number of canalizing genes/inputs, Feb 95 ****/
void set_canalyzing_net(char forcezero){
  unsigned short poss,temp,cgenenet,newcgenenet,
		 zu,zu1;
  unsigned long  zulong,count_tries,inputtotal,cinputnet,newcinputnet,
		 canalcount;
  /*float cinputfreq;*/
  float newcinputfreq,
	cgenefreq,newcgenefreq;
  signed short  tablemax,tempx1,
		z,zz,xbox,ybox;
  unsigned short  startcanaltotal;
  char cz,
       /* *notewires,*/
       thisbit,
       search_direction,nleft,nright,
       reducecanal,
       binv,
       boutv,
       settype,
       ctype,
       wire,
       outvalue;
  signed short *shuff_wire;

  float left=0,top=0,right=0,bottom=0,
	cellscale=0,cellsep=0,
	maxside=0;
  unsigned char pixcolor;
  signed short ii,jj,twod_net_diag_right;

   /*to shuffle wiring*/
   sprintf(textb[0],"shuff_wire");
	if ((shuff_wire=(signed short*)calloc(9,sizeof(signed short)))
			    ==NULL) outof_memory(textb[0]);

   if (!nhood_mixed) tablemax=(signed short)pow(2,(double)nhood)-1;
   /*to note position of (non)canalyzing inputs in nhood*/
   /*
   sprintf(textb[0],"notewires");
   if ((notewires=(char *)calloc(nhood,sizeof(char)))==NULL)
						outof_memory(textb[0]);*/

   /*draw basic grid for % canalyzing input distribution digram*/
   if (twod){
	if (i2d>=j2d)  maxside=i2d;
	else maxside=j2d;

	if (i2d<=30 && j2d<=30){
	   cellscale=vgax(7);
	   cellsep=vgax(3);
	}
	else {
	   cellscale=floor((float)vgax(250)/maxside);
	   if (cellscale>=3) cellsep=2;
	   else cellsep=1;
	}
	if (cellscale<1){
	   cellscale=1;
	   cellsep=1;
	}
	/*right edge of 2d network diagram*/
	twod_net_diag_right=vgax(95)+(i2d+1)*cellscale;

	bottom=vgay(390);
	top=bottom-(j2d+1)*cellscale;
	/*left=vgax(60);*/
	left=twod_net_diag_right;
	right=left+(i2d+1)*cellscale;

	/*draw box (and/or save below)*/
#       if __BORC__
	   draw_box(-1,left-vgax(15),top-vgay(15),
			       right+vgax(15),bottom+vgay(40),0,0);
#       elif __WATCOM__||__UNIX__
	   draw_box(7,left-vgax(15),top-vgay(15),
			       right+vgax(15),bottom+vgay(40),0,0);
#       endif

  }
  start:
   xbox=draw_prompt_box(2);
   myouttext("set canalyzing genes-g inputs-(def):");
   input_string(1,0);

   if (is[0]=='q'){
      erase_prompt_box(2);
      /*free(notewires);*/
      free(shuff_wire);
#     if __WATCOM__||__UNIX__
      if (twod){
	 /*putimage(left-vgax(15),top-vgay(15),boximage[7],COPY_PUT);*/
	 freeimage(boximage[7]);
      }
#     endif
      return;
   }
   if (is[0]=='g') ctype='g';
   else ctype='i';

   moveto(xbox,gety+CHeight);
   if (ctype=='i')
	myouttext("canalyzing inputs: number-n, percentage (def):");
   else myouttext("canalyzing genes: number-n, percentage-(def):");
   input_string(1,0);
   erase_prompt_box(2);

   if (is[0]=='q') goto start;
   if (is[0]=='n') settype='n';
   else settype='p';

  resetcanal:
   cgenenet=cinputnet=inputtotal=0;
   if (twod){
      /*draw net color coded to show % canalyzing input distribution*/
      draw_box(-1,left-vgax(40),top-vgay(50),
			       right+vgax(40),bottom+vgay(40),1,0);
      for (z=0;z<=bytesL-1;z++) iscanal[z]=0; /*set to null*/
      /*draw 2-d outline*/
      draw_box(-1,left+cellscale-2,top+cellscale-2,right,bottom,1,0);

      /*-d grid*/
      /*
      for (zz=j2d-1;zz>=0;zz--){
	 for (z=i2d-1;z>=0;z--){
	    if (zz==j2d-1 || zz==0 || z==i2d-1 || z==0) pixcolor=white;
	    else pixcolor=lightcyan;
	    moveto(right-(z+1)*cellscale+((cellscale-cellsep)/2),
		     bottom-(zz+1)*cellscale+((cellscale-cellsep)/2));
	    putpixel(getx,gety,pixcolor);
	 }
      }
      */
      /*add co-ords to grid*/
      moveto(right-i2d*cellscale+(cellscale-cellsep)/2,
		     bottom-j2d*cellscale+(cellscale-cellsep)/2);
      line(getx,gety-vgay(10),getx,gety-vgay(5));
      sprintf(textb[0],"%d",i2d-1);
      moveto(getx-textwidth(textb[0])/2,gety-vgay(12)-CHeight);
      outtext(textb[0]);

      moveto(right-i2d*cellscale+(cellscale-cellsep)/2,
		     bottom-j2d*cellscale+(cellscale-cellsep)/2);
      line(getx-vgax(10),gety,getx-vgax(5),gety);
      sprintf(textb[0],"%d",j2d-1);
      moveto(getx-textwidth(textb[0])-vgax(11),
				     gety-(float)CHeight*.7);
      outtext(textb[0]);

      moveto(right-cellscale+((cellscale-cellsep)/2),
		     bottom-cellscale+((cellscale-cellsep)/2));
      line(getx+vgax(5),gety,getx+vgax(10),gety);
      moveto(getx+vgax(12),gety-(float)CHeight*.7);
      outtext("0");

      moveto(right-cellscale+((cellscale-cellsep)/2),
		     bottom-cellscale+((cellscale-cellsep)/2));
      line(getx,gety+vgax(5),getx,gety+vgax(10));
      moveto(getx-CHeight/2,gety+vgay(9));
      outtext("0");


   }
   for (poss=lineL-1;poss!=Maxu;poss--){
      if (nhood_mixed) inputtotal+=nhoodm[poss];
      canalyzing(nhoodm[poss],0,carule[poss]);
      if (twod){
	 ii=poss%i2d;
	 jj=poss/i2d;
	 moveto(right-(ii+1)*cellscale,bottom-(jj+1)*cellscale);
	 if (canaltotal>0){
	    if (cellscale>1){
	       if (canaltotal==(unsigned short) nhoodm[poss]) 
                       setfillstyle(SOLID_FILL,white);
	       else if ((float)canaltotal/nhoodm[poss]>=.75)
			setfillstyle(SOLID_FILL,yellow);
	       else if ((float)canaltotal/nhoodm[poss]>=.5)
			setfillstyle(SOLID_FILL,lightred);
	       else if ((float)canaltotal/nhoodm[poss]>=.25)
			setfillstyle(SOLID_FILL,green);
	       else setfillstyle(SOLID_FILL,cyan);
	       bar(getx,gety,getx+cellscale-cellsep,gety+cellscale-cellsep);
	    }
	    else if (cellscale==1){
	       if (canaltotal==(unsigned short) nhoodm[poss]) pixcolor=white;
	       else if ((float)canaltotal/nhoodm[poss]>=.75) pixcolor=yellow;
	       else if ((float)canaltotal/nhoodm[poss]>=.5) pixcolor=lightred;
	       else if ((float)canaltotal/nhoodm[poss]>=.25) pixcolor=green;
	       else pixcolor=cyan;
	       putpixel(getx,gety,pixcolor);
	    }
	    cinputnet+=canaltotal;
	    cgenenet+=1;
	    set_bit1(iscanal,poss);/*note gens already canalyzing*/
	 }
      }
      else if (canaltotal>0){
	 cinputnet+=canaltotal;
	 cgenenet+=1;
	 set_bit1(iscanal,poss);/*note gens already canalyzing*/
      }
   }
   if (!nhood_mixed) inputtotal=lineL*nhood;
   cinputfreq=(float)cinputnet/inputtotal;
   cgenefreq=(float)cgenenet/lineL;

   sprintf(textb[0],
     "canalyzing inputs = %lu/%lu=%.1f%%  genes = %d/%d=%.1f%%",
       cinputnet,inputtotal,cinputfreq*100,cgenenet,lineL,cgenefreq*100);

   if (ctype=='i'){
      if (settype=='p') sprintf(textb[1],
	  "set new percentage canalyzing inputs, accept-ret:");
      else sprintf(textb[1],
	  "set new number of canalyzing inputs, accept-ret:");
   }
   else{
   if (settype=='p') sprintf(textb[1],
	  "set new percentage canalyzing genes, accept-ret:");
      else sprintf(textb[1],
	  "set new number of canalyzing genes, accept-ret:");
   }
   if (lineL<=64){
      xbox=draw_prompt_box(3);
      ybox=gety;
      moveto(xbox,ybox+3),
      print_layered_bitstring(64,iscanal,lineL-1,scale,sep,0,1);
      moveto(xbox,ybox+CHeight);
   }
   else xbox=draw_prompt_box(2);
   outtext(textb[0]);
   moveto(xbox,gety+CHeight);
   myouttext(textb[1]);
   if (settype=='p') input_string(3,0);
   else{
      /*input_string(strlen(itoa(lineL,textb[0],10)),0);*/
      if (ctype=='i' && settype!='p')
		 sprintf(textb[0],"%lu",lineL*inputtotal);
      else sprintf(textb[0],"%d",lineL);
      input_string(strlen(textb[0]),0);
   }
   if (is[0]=='q'){
      if (lineL<=64) erase_prompt_box(3);
      else erase_prompt_box(2);
      goto start;
   }
   if (is[0]==13){
      if (lineL<=64) erase_prompt_box(3);
      else erase_prompt_box(2);
      /*free(notewires);*/
      free(shuff_wire);
#     if __WATCOM__||__UNIX__
	 if (twod){
	    /*putimage(left-vgax(15),top-vgay(15),boximage[7],COPY_PUT);*/
	    freeimage(boximage[7]);
         }
#     endif
      return;
   }
   if (ctype=='g'){
      canalcount=reducecanal=0;
      if (settype=='p'){
	 if (atoi(is)<=100 && atoi(is)>=0){
	    newcgenefreq=((float)atoi(is))/100;
	    newcgenenet=newcgenefreq*lineL;
	    /*if more*/
	    if (cgenefreq<newcgenefreq){
	       reducecanal=0;
	       canalcount=(unsigned short)((newcgenefreq-cgenefreq)*lineL);
	    }
	    /*if less*/
	    else{
	       reducecanal=1;
	       canalcount=(unsigned short)((cgenefreq-newcgenefreq)*lineL);
	    }
	 }
      }
      else{
	 if (atoi(is)<=lineL && atoi(is)>=0){
	    newcgenenet=atoi(is);
	    newcgenefreq=(float)newcgenenet/lineL;
	    /*if more*/
	    if (cgenenet<newcgenenet){
	       reducecanal=0;
	       canalcount=newcgenenet-cgenenet;
	    }
	    /*if less*/
	    else{
	       reducecanal=1;
	       canalcount=cgenenet-newcgenenet;
	    }
	 }
      }
      if (canalcount==0) goto resetcanal;

      count_tries=0;
      for (zu=canalcount;zu>=1;zu--){
	 count_tries+=1;
	 if (count_tries>lineL) break;
	 poss=myrand()%lineL;
	 
	 search_direction=myrand()%2;

	 if (search_direction){  /*start search towards left <-*/
	    nleft=0;
	    for (zu1=poss;zu1<=lineL-1;zu1++){
	       thisbit=get_bit(iscanal,zu1);
	       if ((!reducecanal && !thisbit) /*increase canal*/
		      || (reducecanal && thisbit) ){ /*reduce canal*/
		  poss=zu1;
		  nleft=1;  /*found*/
		  break;
	       }
	    }
	    if (!nleft){ /*if not found search towards right ->*/
	       nright=0;
	       for (zu1=poss-1;zu1!=Maxu;zu1--){
		  thisbit=get_bit(iscanal,zu1);
		  if ((!reducecanal && !thisbit) /*increase canal*/
			 || (reducecanal && thisbit) ){ /*reduce canal*/
		     poss=zu1;
		     nright=1;  /*found*/
		     break;
		  }
	       }
	    }
	 }
	 else {  /*start search towards right ->*/
	    nright=0;
	    for (zu1=poss;zu1!=Maxu;zu1--){
	       thisbit=get_bit(iscanal,zu1);
	       if ((!reducecanal && !thisbit) /*increase canal*/
		      || (reducecanal && thisbit) ){ /*reduce canal*/
		  poss=zu1;
		  nright=1;  /*found*/
		  break;
	       }
	    }
	    if (!nright){ /*if not found search towards left ->*/
	       nleft=0;
	       for (zu1=poss+1;zu1<=lineL-1;zu1++){
		  thisbit=get_bit(iscanal,zu1);
		  if ((!reducecanal && !thisbit) /*increase canal*/
			 || (reducecanal && thisbit) ){ /*reduce canal*/
		     poss=zu1;
		     nleft=1;  /*found*/
		     break;
		  }
	       }
	    }
	 }
	 if (!nleft && !nright) break; /*if not found*/

	 if (nhoodm[poss]==1 && reducecanal){
	    zu++;
	    continue;/*cant be altered*/
	 }
	 /*max index of ruletable*/
	 if (nhood_mixed)
		 tablemax=(signed short)pow(2,(double)nhoodm[poss])-1;
	 /*reduce canalyzing*/
	 if (reducecanal){
	    /*reset canalyzing gene at random to non canalyzing*/
	    while (1){
	       for (zz=tablemax;zz>=0;zz--)
	               set_bit(carule[poss],zz,myrand()%2);
	       if (forcezero==1) set_bit0(carule[poss],0);
	       /*test if still canalyzing*/
	       canalyzing(nhoodm[poss],0,carule[poss]);
	       if (canaltotal==0) break;
	    }
	    set_bit0(iscanal,poss);
	 }
	 /*increase canalyzing*/
	 else{
	    /*reset non-canalyzing gene at to canalyzing*/
	    wire=myrand()%nhoodm[poss];/*random wire*/
	    binv=myrand()%2;           /*input variable 0 or 1*/
	    outvalue=canalyzing(nhoodm[poss],0,carule[poss]);
	    if (canaltotal==0) boutv=myrand()%2; /*output variable 0 or 1*/
	    else boutv=outvalue;/*same vale as existing canalyzing output*/
	    /*make input "wire" canalyzing*/
	    for (zz=0;zz<=tablemax;zz++){
	       if (get_bit(nm[wire],zz)==binv) set_bit(carule[poss],zz,boutv);
	    }
	    set_bit1(iscanal,poss);
	 }
      }
   }
   /*alter % or number of canalyzing inputs*/
   if (ctype=='i'){
      canalcount=reducecanal=0;
      if (settype=='p'){
	 if (atoi(is)<=100 && atoi(is)>=0){
	    newcinputfreq=((float)atoi(is))/100;
	    newcinputnet=newcinputfreq*inputtotal;
	    /*if more*/
	    if (cinputfreq<newcinputfreq){
	       reducecanal=0;
	       canalcount=(unsigned short)
		      ((newcinputfreq-cinputfreq)*inputtotal);
	    }
	    /*if less*/
	    else{
	       reducecanal=1;
	       canalcount=(unsigned short)
		      ((cinputfreq-newcinputfreq)*inputtotal);
	    }
	 }
      }
      else{
	 if (atol(is)<=inputtotal && atol(is)>=0){
	    newcinputnet=atol(is);
	    newcinputfreq=(float)newcinputnet/inputtotal;
	    /*if more*/
	    if (cinputnet<newcinputnet){
	       reducecanal=0;
	       canalcount=newcinputnet-cinputnet;
	    }
	    /*if less*/
	    else{
	       reducecanal=1;
	       canalcount=cinputnet-newcinputnet;
	    }
	 }
      }
      if (canalcount==0) goto resetcanal;

      count_tries=0;
      if (canalcount>1000){
	 moveto(memory_box(0)+2,2);
	 outtext("  cf=");
	 tempx1=getx;
	 setfillstyle(SOLID_FILL,black);
      }
      for (zulong=canalcount;zulong>=1;zulong--){
	 nleft=nright=0;
	 count_tries+=1;
	 if (reducecanal){
	    if (cinputfreq<=newcinputfreq) break;
	 }
	 else{
	    if (cinputfreq>=newcinputfreq) break;
	 }

	 /*show % canalyzing inputs so far*/
	 if (canalcount>1000 && count_tries%25==0){
	    bar(tempx1,3,tempx1+vgax(50),3+CHeight);
	    moveto(tempx1,gety);
	    sprintf(textb[0],"%.1f%%",cinputfreq*100);
	    outtext(textb[0]);
	 }

	 /*if (count_tries>inputtotal*10) break;*//*limit search cycles*/
	 /*problem setting random position in large net size*/
	 poss=myrand()%lineL;
	 
	 shuffle_order(shuff_wire,nhoodm[0]);
	 /*
	 draw_prompt_box(1);
	 for (cz=nhoodm[0]-1;cz>=0;cz--){
	    sprintf(textb[0],"%d=%d ",cz,shuff_wire[cz]);
	    outtext(textb[0]);
	 }
	 input_string(1,0);
	 */
	 search_direction=myrand()%2;
	 /*to reduce, search for canalyzing genes*/
	 /*to inceace, search for non-canalyzing genes for preferance*/

	 if (search_direction){  /*start search towards left <-*/
	    nleft=0;
	    for (zu1=poss;zu1<=lineL-1;zu1++){
		outvalue=canalyzing(nhoodm[zu1],0,carule[zu1]);
		if (rulemix) shuffle_order(shuff_wire,nhoodm[zu1]);
		/*draw_prompt_box(1);*/
		for (cz=nhoodm[zu1]-1;cz>=0;cz--){
		    wire=shuff_wire[cz];

		    /*sprintf(textb[0],"%d=%d ",cz,wire);
		    outtext(textb[0]);
		    input_string(1,0);*/

		    if ((get_bit(canal,wire)==0 && !reducecanal) /*increase canal*/
			  || (get_bit(canal,wire)==1 && reducecanal)){/*reduce canal*/
		       poss=zu1;

		       nleft=1;  /*found*/
		       break;
		   }
		}
		if (nleft==1) break;
	    }
	    if (nleft==0){ /*if not found search towards right ->*/
	       nright=0;
	       for (zu1=poss-1;zu1!=Maxu;zu1--){
		  outvalue=canalyzing(nhoodm[zu1],0,carule[zu1]);
		  if (rulemix) shuffle_order(shuff_wire,nhoodm[zu1]);
		  /*draw_prompt_box(1);*/
		  for (cz=nhoodm[zu1]-1;cz>=0;cz--){
		     wire=shuff_wire[cz];

		     /*sprintf(textb[0],"%d=%d ",cz,wire);
		     outtext(textb[0]);
		     input_string(1,0);*/

		     if ((get_bit(canal,wire)==0 && !reducecanal) /*increase canal*/
			  || (get_bit(canal,wire)==1 && reducecanal)){/*reduce canal*/

			poss=zu1;
			nright=1;  /*found*/
			break;
		     }
		  }
		  if (nright==1) break;
	       }
	    }
	 }
	 else {  /*start search towards right ->*/
	    nright=0;
	    for (zu1=poss;zu1!=Maxu;zu1--){
	       outvalue=canalyzing(nhoodm[zu1],0,carule[zu1]);
	       if (rulemix) shuffle_order(shuff_wire,nhoodm[zu1]);
	       /*draw_prompt_box(1);*/
	       for (cz=nhoodm[zu1]-1;cz>=0;cz--){
		   wire=shuff_wire[cz];

		   /*sprintf(textb[0],"%d=%d ",cz,wire);
		   outtext(textb[0]);
		   input_string(1,0);*/

		   if ((get_bit(canal,wire)==0 && !reducecanal) /*increase canal*/
			  || (get_bit(canal,wire)==1 && reducecanal)){/*reduce canal*/

		     poss=zu1;
		     nright=1;  /*found*/
		     break;
		  }
	       }
	       if (nright==1) break;
	    }
	    if (!nright){ /*if not found search towards left ->*/
	       nleft=0;
	       for (zu1=poss+1;zu1<=lineL-1;zu1++){
		   outvalue=canalyzing(nhoodm[zu1],0,carule[zu1]);
		   if (rulemix) shuffle_order(shuff_wire,nhoodm[zu1]);
		   /*draw_prompt_box(1);*/
		   for (cz=nhoodm[zu1]-1;cz>=0;cz--){
		       wire=shuff_wire[cz];

		       /*sprintf(textb[0],"%d=%d ",cz,wire);
		       outtext(textb[0]);
		       input_string(1,0);*/

		       if ((get_bit(canal,wire)==0 && !reducecanal) /*increase canal*/
			  || (get_bit(canal,wire)==1 && reducecanal)){/*reduce canal*/

			poss=zu1;
			nleft=1;  /*found*/
			break;
		     }
		  }
		  if (nleft==1) break;
	       }
	    }
	 }

	 /*draw_prompt_box(1);
	 sprintf(textb[0],"cz=%d wire=%d poss=%d nleft=%d nright=%d",
				     cz,wire,poss,nleft,nright);
	 outtext(textb[0]);
	 input_string(1,0);*/

	  /*if (reducecanal){*/
	    if (!nleft && !nright) break; /*if not found*/
	 /*}*/
	 if (nhoodm[poss]==1 && reducecanal){
	    zulong--;
	    continue;/*cant be altered*/
	 }
	 /*max index of ruletable*/
	 if (nhood_mixed)
		   tablemax=(signed short)pow(2,(double)nhoodm[poss])-1;
	 /*reduce canalyzing*/
	 startcanaltotal=canaltotal;
	 if (reducecanal && canaltotal>0){
	    /*reset canalyzing input at random to non-canalyzing*/
	    /*flip 1 or 2  bit at random, likely to reduce canalyzing*/
	    for (z=0;z<=1;z++){
	       temp=myrand() % tablemax+1;
	       set_bit(carule[poss],temp,
		    abs(get_bit(carule[poss],myrand()%temp)-1));
	       temp=myrand()%2;
	       if (temp==0) break;
	    }
	    /*this doesnt seem to work*/
	    /*while(1){
	       temp=myrand() % tablemax+1;
	       set_bit(carule[poss],temp,
		    abs(get_bit(carule[poss],myrand()%temp)-1));
	       canalyzing(nhoodm[poss],0,carule[poss]);
	       if (canaltotal<startcanaltotal) break;
	       else  set_bit(carule[poss],temp,
		       abs(get_bit(carule[poss],myrand()%temp)-1));
	    }*/
	    canalyzing(nhoodm[poss],0,carule[poss]);
	    if (canaltotal==0) set_bit0(iscanal,poss);
	 }
	 /*increase canalyzing*/
	 else if (!reducecanal){
	    /*make input "wire" canalyzing*/
	    binv=myrand()%2;   /*input variable 0 or 1*/
	    if (canaltotal==0) boutv=myrand()%2; /*output variable 0 or 1*/
	    else boutv=outvalue;/*same vale as existing canalyzing output*/
	    for (zz=0;zz<=tablemax;zz++){
	       if (get_bit(nm[wire],zz)==binv)
			    set_bit(carule[poss],zz,boutv);
	    }
	    canalyzing(nhoodm[poss],0,carule[poss]);
	    if (canaltotal>startcanaltotal) set_bit1(iscanal,poss);
	 }
	 cinputnet+=canaltotal-startcanaltotal;
	 cinputfreq=(float)cinputnet/inputtotal;

      }
   }
   goto resetcanal;
}

/**** show/select percentage/number of canalyzing genes/inputs, Feb 95 ****/
void set_canalyzing_rule(unsigned short poss){
  unsigned short newcanaltotal;
  signed short  tries,
		tablemax,
		z,zz;
  char countn,
       *notewires,
       reducecanal,
       binv,
       boutv,
       ctype,
       wire;

   tablemax=(signed short)pow(2,(double)nhoodm[poss])-1;
   /*to note position of (non)canalyzing inputs in nmhood*/
   sprintf(textb[0],"notewires");
   if ((notewires=(char *)calloc(nhoodm[poss],sizeof(char)))==NULL)
						outof_memory(textb[0]);
   if ((direction=='f' && limitcheck==0) && secondpart)
      draw_box(12,Maxx/2,Maxy-CHeight-vgay(6),
						 Maxx-2,Maxy,1,0);
  start:
   z_parameter_all(nhoodm[poss],0,carule[poss]);
   if (!(direction=='f' && limitcheck==0) || secondpart==0){
      show_rule_bottom(nhoodm[poss],1,carule[poss],0);
      draw_prompt_box(1);
   }
   else draw_box(-1,Maxx/2,Maxy-CHeight-vgay(6),Maxx-2,Maxy,1,0);

   myouttext("set canalyzing inputs: explicitly-e, number at random-n:");
   input_string(1,0);

   if (is[0]=='e') ctype='e';
   else if (is[0]=='n') ctype='n';
   else{
      free(notewires);
      if ((direction=='f' && limitcheck==0) && secondpart){
	 putimage(Maxx/2,Maxy-CHeight-vgay(6),
					       boximage[12],COPY_PUT);
	 freeimage(boximage[12]);
      }
      else erase_prompt_box(1);
      return;
   }
   if (ctype=='e'){
     explicit1:
      if (!(direction=='f' && limitcheck==0) || secondpart==0){
	 draw_prompt_box(1);
      }
      else draw_box(-1,Maxx/2,Maxy-CHeight-vgay(6),
						    Maxx-2,Maxy,1,0);
      sprintf(textb[0],"wire (0-%d):",nhoodm[poss]);
      myouttext(textb[0]);
      input_string(1,0);
      if (is[0]==13){
	 wire=myrand()%nhoodm[poss];
	 sprintf(textb[0],"%d",wire);
	 outtext(textb[0]);
      }
      else if (atoi(is)>=0 && atoi(is)<=nhoodm[poss]-1) wire=atoi(is);
      else goto start;

      myouttext(" input value (1,0):");
      input_string(1,0);
      if (is[0]==13){
	 binv=myrand()%2;
	 sprintf(textb[0],"%d",binv);
	 outtext(textb[0]);
      }
      else if (is[0]=='0' || is[0]=='1') binv=atoi(is);
      else goto explicit1;

      myouttext(" output value (1,0):");
      input_string(1,0);
      if (is[0]==13){
	 boutv=myrand()%2;
	 sprintf(textb[0],"%d",boutv);
	 outtext(textb[0]);
      }
      else if (is[0]=='0' || is[0]=='1')  boutv=atoi(is);
      else goto explicit1;

      for (zz=0;zz<=tablemax;zz++){
	 if (get_bit(nm[wire],zz)==binv) set_bit(carule[poss],zz,boutv);
      }
      goto start;
   }
   if (ctype=='n'){
      reducecanal=0;
      sprintf(textb[0],
	 "canalyzing inputs=%d, set new number (0-%d):",
				       canaltotal,nhoodm[poss]);
      if (!(direction=='f' && limitcheck==0) || secondpart==0){
	 draw_prompt_box(1);
      }
      else draw_box(-1,Maxx/2,Maxy-CHeight-vgay(6),
						    Maxx-2,Maxy,1,0);

      outtext(textb[0]);
      input_string(1,0);
      if (is[0]=='q' || is[0]==13) goto start;
      if (atoi(is)>=0 && atoi(is)<=nhoodm[poss]) newcanaltotal=atoi(is);
      if (newcanaltotal==canaltotal) goto start;
      if (newcanaltotal<canaltotal) reducecanal=1;

      /*check and record (non)canalyzing inputs*/
      canalyzing(nhoodm[poss],0,carule[poss]);
      countn=0;
      for (z=0;z<=nhoodm[poss]-1;z++){
	 if (get_bit(canal,z)==reducecanal){
	    notewires[countn]=z;
	    countn++;
	 }
      }
      wire=notewires[myrand()%countn];/*select a (non)canalyzing input*/
      tries=0;
      /*make non-canalyzing "wire" canalyzing*/
      if (!reducecanal){
	 while(1){
	    if (tries>100) break;
	    tries+=1;
	    binv=myrand()%2;           /*input variable 0 or 1*/
	    boutv=myrand()%2;          /*output variable 0 or 1*/
	    if (tries>20){ /*if bitflips arent working, scramble*/
	       for (zz=0;zz<=tablemax;zz++)
				set_bit(carule[poss],zz,myrand()%2);
	    }
	    for (zz=0;zz<=tablemax;zz++){
	       if (get_bit(nm[wire],zz)==binv)
				set_bit(carule[poss],zz,boutv);

	    }
	    canalyzing(nhoodm[poss],0,carule[poss]);
	    if (canaltotal==newcanaltotal) break;
	 }
      }
      /*make canalyzing "wire" non-canalyzing*/
      else{
	 while(1){
	    if (tries>100) break;
	    tries+=1;
	    binv=myrand()%2;           /*input variable 0 or 1*/
	    boutv=myrand()%2;          /*output variable 0 or 1*/
	    if (tries>20){ /*if bitflips arent working, scramble*/
	       for (zz=0;zz<=tablemax;zz++)
				set_bit(carule[poss],zz,myrand()%2);
	       }
	    else{
	       zz=myrand()%tablemax+1;
	       /*flip a bit in canalyzing output*/
	       if (get_bit(nm[wire],zz)==binv)
			    set_bit(carule[poss],zz,abs(boutv-1));
	    }
	    canalyzing(nhoodm[poss],0,carule[poss]);
	    if (canaltotal==newcanaltotal) break;
	 }
      }
      goto start;
   }
}

/********************* select rule prompts, Dec 1993 **********************/
char reselect_rule_prompts(signed short cellindex,char select){
 signed short xbox,tempx,tempy;
 char rselect;

   tempx=getx;
   tempy=gety;
   sprintf(textb[0],
	      "index=%d (nhood=%d), default selection=%c, to change enter",
				    cellindex,nhoodm[cellindex],select);
   if (totalistic) sprintf(textb[1],
		     "maj=m dec-d random-r bits-b hex-h repeat-p:");
   else {
      /*decimal equivalent up to 32 bits only*/
      if (nhoodm[cellindex]<=4) sprintf(textb[1],
		"maj-m dec-d random-r bits-b hex-h repeat-p load-l:");
      if (nhoodm[cellindex]==5) sprintf(textb[1],
		"maj-m life-f dec-d random-r bits-b hex-h repeat-p load-l:");
      if (nhoodm[cellindex]>5) sprintf(textb[1],
		"maj-m life-f random-r bits-b hex-h repeat-p load-l:");
   }
   sprintf(textb[2],"start again-q");
   xbox=draw_prompt_box(3);
   outtext(textb[0]);
   moveto(xbox,gety+CHeight);
   myouttext(textb[1]);

   input_string(1,0);
   rselect=is[0];
   if (rselect!='q'){
      if (totalistic){
	 if (rselect!='d'&&rselect!='b'&&rselect!='h'&&rselect!='p'
			   &&rselect!='r') rselect=select;
      }
      else{
	 if (nhoodm[cellindex]<=4){
	    if (rselect!='d'&&rselect!='b'&&rselect!='h'&&rselect!='p'
		 &&rselect!='r'&&rselect!='l') rselect=select;
	 }
	 else if (nhoodm[cellindex]==5){
	    if (rselect!='f'&&select!='d'&&rselect!='b'&&rselect!='h'
	      &&rselect!='p'&&rselect!='r'&& rselect!='l') rselect=select;
	 }

	 else{
	    if (rselect!='f'&&rselect!='b'&&rselect!='h'&&rselect!='p'
	      && rselect!='d'&& rselect!='l') rselect=select;
	 }
      }
   }
   erase_prompt_box(3);
   moveto(tempx,tempy);

   return(rselect);
}

/********************* select rule prompts, Dec 1993 **********************/
signed short reselect_rule_index(signed short cellindex,
				  signed short number_rules){
 signed short tempx,tempy,newindex;

   tempx=getx;
   tempy=gety;
   sprintf(textb[0],"this index=%d, enter new index 0-%d:",
				       cellindex,number_rules-1);
   draw_prompt_box(1);
   myouttext(textb[0]);
   input_string(4,0);
   newindex=atoi(is);
   erase_prompt_box(1);
   moveto(tempx,tempy);
   if (newindex>=0 && newindex<=number_rules-1) return(newindex);
   else return(cellindex);
}

/********************* specify rule, 13 May 1993 **********************/
signed short select_rule(char inbox, char** thisrule,
               signed short number_rules,unsigned short poss){
  char select,ruleloaded=0,tempn,tnhood;
  unsigned long ruledec,rulemax;
  signed short tablemax,tablebytes,zz,z,tot,temp2,
      tempx2,tempy2,centrec,tempxr,tempyr,
      tempy3,
      startx,starty;
  unsigned short cellindex,cindex,cposs;

#define revise { \
     tempxr=getx;\
     tempyr=gety;\
     if (number_rules==1) goto start;\
     else{\
	sprintf(textb[0],\
	"change: index%d-i, start again-a, selection-s, cont-ret:",\
						cellindex);\
	draw_prompt_box(1);\
	myouttext(textb[0]);\
	input_string(1,0);\
	if (is[0]=='q') goto start;\
	else if (is[0]=='s'){\
	   select=reselect_rule_prompts(cellindex,select);\
	   if (select=='q') goto start;\
	   else{\
	      cellindex-=1;\
	      continue;\
	   }\
	}\
	else if (is[0]=='i'){\
	   cellindex=\
	   reselect_rule_index(cellindex,number_rules)-1;\
	   continue;\
	}\
	else if (is[0]=='a') goto start;\
	moveto(tempxr,tempyr);\
     }\
  }

  setcolor(white);
  startx=getx;
  starty=gety;

  if (poss!=Maxu) tnhood=nhoodm[poss];
  else tnhood=nhood;

 start:
  if (inbox==0){
     setfillstyle(SOLID_FILL,black);
     bar(xtext,starty+2,Maxx,Maxy-vgay(50));
  }
  /*else draw_box(12, 20,343,400,Maxy+1, 1,0);*/

  moveto(startx,starty);
  tablemax= (signed short)pow(2,(double)tnhood)-1;
  tablebytes=(signed short)ceil(pow(2,(double)tnhood)/8);
  if (tnhood<=5)
	      rulemax=(unsigned long) (pow(2,(double)(tablemax+1))-1);

  if (tnhood<=4){  /*decimal equivalent up to 32 bits only*/
     sprintf(textb[0],"Select k%d-rule, empty-e (default-dec)",tnhood);
     sprintf(textb[1],
	"maj-m random-r bits-b hex-h repeat-p load-l default-ret:");
  }
  if (tnhood==5){
     sprintf(textb[0],"Select k%d-rule, empty-e (default-random)",tnhood);
     sprintf(textb[1],
	"maj-m life-f dec-d random-r bits-b hex-h repeat-p load-l:");
  }
  if (tnhood>5){
     sprintf(textb[0],"Select k%d-rule, empty-e, (default-random)",tnhood);
     sprintf(textb[1],
	"maj-m life-f random-r bits-b hex-h repeat-p load-l:");
  }
  next_line(xtext,1);
  myouttext(textb[0]);
  next_line(xtext,1);
  myouttext(textb[1]);
  input_string(1,0);
  select=is[0];
  if (is[0]=='q') return(0);
  if (tnhood<=4){
     if (select!='m' && select!='e' && select!='b' && select!='h'&&
	   select!='p' && select!='r' &&  select!='l') select='d';
  }
  else if (select!='m' && select!='e' && select!='f' && select!='b' &&
     select!='h' && select!='p' && select!='d' &&  select!='l') select='r';
  tempy3=gety;

  for (cellindex=0;cellindex<=number_rules-1;cellindex++){
    if (poss!=Maxu){
       cindex=0;/*to revise rule at one cell*/
       cposs=poss;
    }
    else cindex=cposs=cellindex;

    if (nhood_mixed){
       tablemax=(signed short) pow(2,(double)nhoodm[cposs])-1;
       tablebytes=(signed short)ceil(pow(2,(double)nhoodm[cposs])/8);
    }
    if (inbox==0 && rulemix){
       setfillstyle(SOLID_FILL,black);
       bar(xtext,tempy3+1.5*CHeight,Maxx,Maxy-vgay(50));
       sprintf(textb[0],
	      "index-%d (nhood=%d rulemix), default selection is %c",
			  cindex,nhoodm[cposs],select);
       draw_prompt_box(1);
       outtext(textb[0]);
       moveto(xtext,tempy3);
    }
    if (select=='e'){
       for (z=tablemax;z>=0;z--) set_bit0(thisrule[cindex],z);
       goto start;
    }
    if (select=='r'){
       random_bits(nhoodm[cposs],0,1,1,
	       thisrule[cindex],tablemax,vgax(4),vgax(2));
       if (is[0]=='q') {revise};
    }

    if (select=='l'){
       tempx2=getx;
       tempy2=gety;
       tempn=nhoodm[cposs];

       /*updates nhood if different size only for one rule,
       if rulemix or nhood_mixed rejects different nhood*/
       ruleloaded=load_save_wrs('l',thisrule[cindex],0);
       if (is[0]=='q') {revise};
       if (tempn!=ruleloaded){
	  if (!rulemix && !nhood_mixed && !secondpart){
	     tnhood=ruleloaded;
	     draw_prompt_box(1);
	     sprintf(textb[0],
		 "rule loaded, nhood changed from %d to %d, cont-ret",
						   tempn,tnhood);
	     myouttext(textb[0]);
	     input_string(1,0);

	     moveto(tempx2,tempy2);
	     next_line(xtext,1.5);
	     tablemax= (signed short)pow(2,(double)tnhood)-1;
	     print_layered_bitstring(64,carule[0],tablemax,scale,sep,0,1);
	     next_line(getx/CWidth+CWidth,-.5);
	  }
	  else{
	     get_prompt_box(5,1);
	     draw_prompt_box(1);
	     sprintf(textb[0],
		"not loaded, tried nhood=%d, this nhood=%d, return-continue",
						 ruleloaded,tnhood);
	     myouttext(textb[0]);
	     input_string(1,0);
	     putimage((signed short)
			    ((float)Maxx)/2,2,boximage_prompt[5],COPY_PUT);
	     ruleloaded=0;
	     {revise};
	  }
       }
       else{
	  moveto(tempx2,tempy2);
	  next_line(xtext,1.5);
	  print_layered_bitstring(64,thisrule[cindex],
						 tablemax,scale,sep,0,1);
	  next_line(getx/CWidth+CWidth,-.5);

       }
       next_line(xtext,1);/*pause to see rule*/
       sprintf(textb[0],"rule loaded, revise-q, cont-ret:");
       myouttext(textb[0]);
       input_string(1,0);
       if (is[0]=='q') {revise};
    }

    if (select=='b'){   /*enter as bits*/
       tempx2=getx;
       tempy2=gety;
       define_bits(nhoodm[cposs],1,thisrule[cindex],tablemax,0,scale,sep);
       if (is[0]=='q') {revise};
       if (inbox==0){
	  /*decimal equivalent up to 32 bits only*/
	  if (nhoodm[cposs]<=5){
	     ruledec=dec_equiv(thisrule[cindex],tablemax);
	     next_line(getx/CWidth,-.7);
	     sprintf(textb[0]," rule%d=(dec)%lu (hex)",
				     nhoodm[cposs],ruledec);
	     outtext(textb[0]);
	  }
	  print_current_bitstring_hexbytes(1,thisrule[cindex],
				     nhoodm[cposs],Maxx/2,white,0);
	  next_line(xtext,tablemax/64);
       }
    }
    if (select=='f'){   /*1-D or 2-D game of LIFE*/
       /*centre of nhood or rectangle*/
       centrec=ceil((double)nhoodm[cposs]/2)-1;
       for (zz=0;zz<=tablemax;zz++){
	  tot=0;
	  /*find total of 1s in nhood*/
	  for (z=nhoodm[cposs]-1;z>=0;z--){
	     if (get_bit(nm[z],zz)) tot+=1;
	  }
	  /*birth dead + 3 live neighbours*/
	  if (get_bit(nm[centrec],zz)==0 && (tot==3))
				   set_bit1(thisrule[cindex],zz);
	  /*death by overcrowding.. live+4 or more live nieghbours
	  or exposure.. live+1 or less live nieghbours */
	  else if (get_bit(nm[centrec],zz)==1){
	     if (tot>=5 || tot<=2) set_bit0(thisrule[cindex],zz);
	     /*survival*/
	     else set_bit1(thisrule[cindex],zz);
	  }
	  else set_bit0(thisrule[cindex],zz);
       }
       if (inbox==0){
	  next_line(xtext,1.5);
	  print_layered_bitstring(64,thisrule[cindex],
					   tablemax,scale,sep,0,1);
	  next_line(getx/CWidth+CWidth,-.5);
       }
    }
    if (select=='m'){   /*majority rule*/
       /*centre of nhood or rectangle*/
       centrec=ceil((double)nhoodm[cposs]/2)-1;
       for (zz=0;zz<=tablemax;zz++){
	  tot=0;
	  /*find total of 1s in nhood*/
	  for (z=nhoodm[cposs]-1;z>=0;z--){
	     if (get_bit(nm[z],zz)) tot+=1;
	  }
	  set_bit0(thisrule[cindex],zz);
	  /*odd or even nhoods, output=majority*/
	  if (tot>nhoodm[cposs]/2) set_bit1(thisrule[cindex],zz);
	  /*even nhoods & tie, output=centre*/
	  if (nhoodm[cposs]%2==0 && tot==nhoodm[cposs]/2)
	       set_bit(thisrule[cindex],zz,get_bit(nm[centrec],zz));
       }
       if (inbox==0){
	  next_line(xtext,1.5);
	  print_layered_bitstring(64,thisrule[cindex],
					   tablemax,scale,sep,0,1);
	  next_line(getx/CWidth+CWidth,-.5);
       }
    }
    if (select=='d'){   /*enter as dec*/
       if (nhoodm[cposs]<=5){  /*decimal equivalent up to 32 bits only*/
	  tempx2=getx;
	  tempy2=gety;
	  sprintf(textb[0],"k%d-rule, enter 0-%lu (default-random):",
				   nhoodm[cposs],rulemax);
	  next_line(xtext,1);
	  myouttext(textb[0]);

	  /*input_string(strlen(ultoa(rulemax,textb[0],10)),1);*/
	  sprintf(textb[0],"%lu",rulemax);
	  input_string(strlen(textb[0]),1);


	  if (is[0]=='q') {revise};
	  ruledec=(unsigned long)_atold(is);
	  /*convert dec to bitstring*/
	  if (is[0]!=13 && ruledec<=rulemax){
	     dec_to_bit_line(thisrule[cindex],ruledec,tablemax+1);
	     if (inbox==0){
		next_line(xtext,2);
		print_layered_bitstring(64,thisrule[cindex],
						  tablemax,scale,sep,0,1);
		/*next_line((double)getx/CWidth,-.7);*/
                next_line(xtext,1);
		sprintf(textb[0]," rule%d=(dec)%lu (hex)",
					    nhoodm[cposs],ruledec);
		outtext(textb[0]);
		print_current_bitstring_hexbytes
		    (1,thisrule[cindex],nhoodm[cposs],Maxx/2,white,0);

	     }
	  }
       }
       if (is[0]==13 ||_atold(is)>rulemax || nhoodm[cposs]>5)
	     random_bits(nhoodm[cposs],0,1,1,
	       thisrule[cindex],tablemax,vgax(4),vgax(2));
    }
    if (select=='h'){  /*enter as hex*/
       tempx2=getx;
       tempy2=gety;
       temp2=((tablemax+1)/8)-1;
       if (temp2<0) temp2=0;
       /*draw boxes, input hex*/
       define_hex(nhoodm[cposs],1,thisrule[cindex],temp2,0,xtext);
       if (is[0]=='q') {revise};
       if (nhoodm[cposs]<3) thisrule[cindex][0] &= 0xf;
       if (nhoodm[cposs]==1){
	  for (z=3;z>=2;z--) set_bit0(thisrule[cindex],z);
       }
       if (inbox==0){
	  next_line(xtext,.5);
	  print_layered_bitstring(64,thisrule[cindex],
						tablemax,scale,sep,0,1);
	  next_line(getx/CWidth+CWidth,-.5);
	  if (nhoodm[cposs]<=5){
	     ruledec=dec_equiv(thisrule[cindex],tablemax);
	     sprintf(textb[0],"rule%d=(dec)%lu",nhoodm[cposs],ruledec);
	     outtext(textb[0]);
	  }
       }
    }
    if (select=='p'){   /*repeat last rule*/
       if (cindex==0){
	  load_last_rule(thisrule[cindex],nhoodm[cposs]);
	  if (is[0]=='q') {revise};
       }
       else if (nhoodm[cposs]!=nhoodm[cposs-1]){
	  load_last_rule(thisrule[cindex],nhoodm[cposs]);
	  if (is[0]=='q') {revise};
       }
       else memcpy(thisrule[cindex],thisrule[cindex-1],tablebytes);
       if (inbox==0){
	  next_line(xtext,1.5);
	  print_layered_bitstring(64,thisrule[cindex],
					   tablemax,scale,sep,0,1);
	  next_line(getx/CWidth+CWidth,-.5);
	  if (nhoodm[cposs]<=5){
	     ruledec=dec_equiv(thisrule[cindex],tablemax);
	     sprintf(textb[0],"rule%d=(dec)%lu (hex)",
					  nhoodm[cposs],ruledec);
	     outtext(textb[0]);
	  }
	  else next_line(xtext,1);
	  print_current_bitstring_hexbytes
		    (1,thisrule[cindex],nhoodm[cposs],Maxx/2,white,0);
       }
       if (rulemix && cindex>0) {revise};
    }

    if (rulemix){
       z_parameter_all(nhoodm[cposs],0,thisrule[cindex]);
       if (!(direction=='f' && limitcheck==0)||secondpart==0){
	  show_rule_bottom(nhoodm[cposs],0,thisrule[cindex],cindex);
       }
    }
  }
  if (!inbox) erase_box(Maxx/2,vgay(27),Maxx-2,vgay(50));
  if (tnhood<8) next_line(xtext,1);
  if (!inbox && !rulemix && (!nonlocal || regular2d)) transform_rule(0);
  if (!rulemix){
      save_last_rule(thisrule[0],nhoodm[0]);
      if (is[0]=='q') is[0]=0;
  }
  #if (__WATCOM__)
     setviewport(0,0,Maxx,Maxy, 1);
  #endif
  return(gety);
}

/***************** convert 3-rule to equivalent 5-rule ****************/
void transform_rule(unsigned short cellindex){
 signed short xbox,tablebytes,tablemax,z,zz,temp;
 char bit, *catemp,*nhoodtemp,final_nhood,gnhood,startnhood;
 unsigned short poss;

#define rulechanged\
	 z_parameter_all(nhoodm[cellindex],0,carule[cellindex]);\
	 if (!(direction=='f' && limitcheck==0)||secondpart==0)\
	    show_rule_bottom(nhoodm[cellindex],1,carule[cellindex],0);\
	 if (!rulemix) save_last_rule(carule[cellindex],nhoodm[cellindex]);\
	 goto start;

  start:
    sprintf(textb[0],"transform rule: comp-c neg-n ref-r canalyzing-C:");
    if (!rulemix){
       sprintf(textb[0],"transform rule: comp-c neg-n ref-r canalyzing-C");
       if (nhood<8) sprintf(textb[1],
	"equivalent with greater nhood: (%d-9), save-s:",nhood+1);
       else if (nhood==8) sprintf(textb[1],
	"equivalent with greater nhood: 8-rule -9, save-s:");
       else sprintf(textb[1],"save-s:"); /*nhood=9*/
    }

    tablebytes=(signed short)ceil(pow(2,(double)nhoodm[cellindex])/8);
    tablemax= (signed short)pow(2,(double)nhoodm[cellindex])-1;

    if (!rulemix) xbox=draw_prompt_box(2);
    else draw_prompt_box(1);
    outtext(textb[0]);
    if (!rulemix){
       moveto(xbox,gety+CHeight);
       myouttext(textb[1]);
     }
    input_string(1,0);
    if (!rulemix) erase_prompt_box(2);
    else erase_prompt_box(1);

    if (is[0]=='q' || is[0]==13) return;
    else if (is[0]=='s'){
       /*allow rule to be saved*/
       load_save_wrs('s',carule[cellindex],0);
       goto start;
    }
    /*canalyzing*/
    else if (is[0]=='C'){
       if (nhoodm[cellindex]>1){
	  set_canalyzing_rule(cellindex);
	  rulechanged;
       }
    }
    /*complementary transformation*/
    else if (is[0]=='c'){
       sprintf(textb[0],"catemp");
       if ((catemp=(char *)calloc(tablebytes,sizeof(char)))
				    ==NULL) outof_memory(textb[0]);
       for (z=0;z<=tablemax;z++)
		set_bit(catemp,z,abs(1-get_bit(carule[cellindex],z)));
       memcpy(carule[cellindex],catemp,tablebytes);
       free(catemp);
       rulechanged;
    }
    /*negative transformation*/
    else if (is[0]=='n'){
	  sprintf(textb[0],"catemp");
	  if ((catemp=(char *)calloc(tablebytes,sizeof(char)))
				    ==NULL) outof_memory(textb[0]);
	  for (z=0;z<=tablemax;z++)
		set_bit(catemp,tablemax-z,abs(1-get_bit(carule[cellindex],z)));
	  memcpy(carule[cellindex],catemp,tablebytes);
	  free(catemp);
	  rulechanged;
    }
    /*reflection transformation*/
    else if (is[0]=='r'){
       sprintf(textb[0],"catemp");
       if ((catemp=(char *)calloc(tablebytes,sizeof(char)))
				    ==NULL) outof_memory(textb[0]);
       sprintf(textb[0],"nhoodtemp");
       if ((nhoodtemp=(char *)calloc(2,sizeof(char)))
				    ==NULL) outof_memory(textb[0]);
       /*swap outputs of pairs of (asymmetric) reflected nhoods*/
       for (z=0;z<=tablemax;z++){
	  dec_to_bit_line(nhoodtemp,(unsigned long)z,nhoodm[cellindex]);
	  /*reflect bits*/
	  for (zz=0;zz<=(nhoodm[cellindex]-1);zz++){
	     set_bit(nhoodtemp,(nhoodm[cellindex]-1)-zz,get_bit(nm[zz],z));
	  }
	  poss=(unsigned short) dec_equiv(nhoodtemp,nhoodm[cellindex]-1);
	  set_bit(catemp,poss,get_bit(carule[cellindex],z));
       }
       memcpy(carule[cellindex],catemp,tablebytes);
       free(catemp);
       free(nhoodtemp);
       rulechanged;
    }
    /*change to equivalent rule with greater nhood*/

    else if (!rulemix && (atoi(is)>nhood && atoi(is)<=9)){
       final_nhood=atoi(is);
       startnhood=nhood;
       for (zz=startnhood;zz<=final_nhood-1;zz++){
	  gnhood=zz+1;
	  tablebytes=(signed short)ceil(pow(2,(double)nhood)/8);
	  tablemax= (signed short)pow(2,(double)nhood)-1;
	  sprintf(textb[0],"catemp");
	  if ((catemp=(char *)calloc(tablebytes,sizeof(char)))
				       ==NULL) outof_memory(textb[0]);
	  memcpy(catemp,carule[0],tablebytes);
	  free_mem_rule0();
	  free_mem_tcode0();
	  free_mem_all_0s_all_1s_rules();
	  if (!loc_twod_fonly) free_mem_wiring();
	  nhood=gnhood;
	  if (!nhood_mixed){
	     for (z=0; z<=lineL-1;z++) nhoodm[z]=nhood;
	  }
	  allocate_mem_rule0(nhood);
	  allocate_mem_tcode0(nhood);
	  allocate_mem_all_0s_all_1s_rules(nhood);
	  if (!loc_twod_fonly) allocate_mem_wiring();
	  /*convert n.rule to n+1.rule*/
	  for (z=tablemax; z>=0; z--){
	     bit=get_bit(catemp,z);
	     temp=1;
	     if (nhood%2==0){ /*new even nhood*/
		set_bit(carule[0],(z<<1)+1,bit);/*oldnhood+1, added on right*/
		set_bit(carule[0],z<<1,bit);/*oldnhood+0, added on right*/
	     }
	     else{ /*new odd nhood*/
		/*1 + oldnhood, added on left*/
		set_bit(carule[0],(z+(temp<<(nhood-1))),bit);
		/*0 + oldnhood, added on left, no change*/
		set_bit(carule[0],z,bit);
	     }
	  }
	  free(catemp);
       }
       if (!nonlocal){
	  for (poss=lineL-1;poss!=Maxu;poss--)
			   oneD_local_wire_cell(poss,lineL-1);
       }
       else if (regular2d) wireup_2d_nhood(i2d,j2d,i2d-1,j2d-1,0,0);
       cell_out_freq();
       rulechanged;
    }
}

/********************* specify code, 17 June 1993 **********************/
signed short select_code(char inbox,char** thiscode,
      char** thisrule,signed short number_rules,unsigned short poss){
 char select,tnhood,centrec;
 signed short codedec,codemax,codebytes,z,zz,
      startx, starty,tempxr,tempyr,
      tablemax,
      sod=0,lineno,temp2,
      tempy3;
 unsigned short cellindex,copyindex,cindex,cposs;
 unsigned long ruledec;

#define revise {\
     tempxr=getx;\
     tempyr=gety;\
     if (number_rules==1) goto start;\
     else{\
	sprintf(textb[0],\
	  "change: index%d-i, start again-a, selection-s, cont-ret:",\
						cellindex);\
	draw_prompt_box(1);\
	myouttext(textb[0]);\
	input_string(1,0);\
	if (is[0]=='q') goto start;\
	else if (is[0]=='s'){\
	   select=reselect_rule_prompts(cellindex,select);\
	   if (select=='q') goto start;\
	   else{\
	      cellindex-=1;\
	      continue;\
	   }\
	}\
	else if (is[0]=='i'){\
	   cellindex=\
	   reselect_rule_index(cellindex,number_rules)-1;\
	   continue;\
	}\
	else if (is[0]=='a') goto start;\
	moveto(tempxr,tempyr);\
     }\
  }

  setcolor(white);
  startx=getx;
  starty=gety;
  if (poss!=Maxu) tnhood=nhoodm[poss];
  else tnhood=nhood;

 start:
  if (inbox==0){
	setfillstyle(SOLID_FILL,black);
	bar(xtext,starty+2,Maxx,Maxy-vgay(50));
  }
  
  moveto(startx,starty);
  tablemax= (signed short)pow(2,(double)tnhood)-1;/*max index of ruletable*/
  codemax=(signed short)pow(2,(double)tnhood+1)-1;/*max code dec*/
  codebytes=(signed short)ceil((double)(tnhood+1)/8); /*bytes for code, min=1*/
  sprintf(textb[0],
    "Select k%d totalistic code (default-dec)",tnhood);
  sprintf(textb[1],"maj-m random-r bits-b hex-h repeat-p:");
  next_line(xtext,1);
  outtext(textb[0]);
  next_line(xtext,1);
  outtext(textb[1]);
  input_string(1,0);
  if (is[0]=='q') return(0);

  select=is[0];
  if (select!='m' && select!='b' && select!='h' &&
		      select!='p' && select!='r') select='d';
  tempy3=gety;

  for (cellindex=0;cellindex<=number_rules-1;cellindex++){

     if (poss!=Maxu){
	cindex=0;/*to revise rule at one cell*/
	cposs=poss;
     }
     else cindex=cposs=cellindex;

     if (nhood_mixed){
	tablemax=(signed short)pow(2,(double)nhoodm[cposs])-1;
	codemax=(signed short)pow(2,(double)nhoodm[cposs]+1)-1;
	codebytes=(signed short)ceil((double)(nhoodm[cposs]+1)/8);
     }
     if (inbox==0 && rulemix){
	setfillstyle(SOLID_FILL,black);
	bar(xtext,tempy3+1.5*CHeight,Maxx,Maxy-vgay(50));
	sprintf(textb[0],
	    "index-%d (k=%d rulemix), default selection is %c",
			      cindex,nhoodm[cposs],select);
	draw_prompt_box(1);
	outtext(textb[0]);
	moveto(xtext,tempy3);
     }
     if (select=='r'){
	random_bits(nhoodm[cposs],0,2,1,thiscode[cindex],
				nhoodm[cposs],vgax(4),vgax(2));
	codedec=dec_equiv(thiscode[cindex],nhoodm[cposs]);
	if (is[0]=='q') {revise};
     }
     else if (select=='b'){
	define_bits(nhoodm[cposs],
	    0,thiscode[cindex],nhoodm[cposs],0,CWidth,2);
	if (is[0]=='q') {revise};
	codedec=(signed short)dec_equiv(thiscode[cindex],
						nhoodm[cposs]);
	if (inbox==0){
	    next_line((double)getx/CWidth,-.7);
	    if (nhoodm[cposs]<5) outtext(" ");
	    sprintf(textb[0],"code%d=(dec)%d",nhoodm[cposs],codedec);
	    outtext(textb[0]);
	}
     }
     else if (select=='m'){   /*majority rule*/
	/*centre of nhood or rectangle*/
	centrec=ceil((double)nhoodm[cposs]/2)-1;
	for (zz=0;zz<=nhoodm[cposs];zz++){
	   set_bit0(thiscode[cindex],zz);
	   /*odd or even nhoods, output=majority*/
	   if (zz>nhoodm[cposs]/2) set_bit1(thiscode[cindex],zz);
	   /*even nhoods & tie, output=centre*/
	   if (nhoodm[cposs]%2==0 && zz==nhoodm[cposs]/2)
	       set_bit(thiscode[cindex],zz,get_bit(nm[centrec],zz));
	}
	if (inbox==0){
	    codedec=(signed short)dec_equiv(thiscode[cindex],
						    nhoodm[cposs]);
	    moverel(CWidth,CHeight/2);
	    print_bit_line(thiscode[cindex],nhoodm[cposs]+1,
						       lightred, 4, 2);
	    moverel(0,-CHeight/2);

	    sprintf(textb[0]," code%d=(dec)%d (hex)",nhoodm[cposs],codedec);
	    outtext(textb[0]);
	    print_current_bitstring_hexbytes(2,thiscode[cindex],
				   nhoodm[cposs],Maxx/2,white,0);
	}
     }
     else if (select=='d'){
	sprintf(textb[0],"k%d totalistic code, enter 0-%d (default-random):"
				  ,nhoodm[cposs],codemax);
	next_line(xtext,1);
	outtext(textb[0]);
	/*input_string(strlen(itoa(codemax,textb[0],10)),1);*/
	sprintf(textb[0],"%d",codemax);
	input_string(strlen(textb[0]),1);

	if (is[0]=='q') {revise};
	codedec=atoi(is);
	/*conver dec to bitstring*/
	if (is[0]!=13 && codedec<=codemax){
	   dec_to_bit_line(thiscode[cindex],codedec,nhoodm[cposs]+1);
	   if (inbox==0){
	      next_line(xtext,2);
	      print_bit_line(thiscode[cindex],nhoodm[cposs]+1,
							lightred, 4, 2);
              next_line(xtext,1);
	      /*next_line((double)getx/CWidth,-.7);*/
	      sprintf(textb[0]," code%d=%d ",nhoodm[cposs],codedec);
	      outtext(textb[0]);
	   }
	}
	if (is[0]==13 ||_atold(is)>codemax){
	   random_bits(nhoodm[cposs],0,2,1,thiscode[cindex],
				   nhoodm[cposs],vgax(4),vgax(2));
	   codedec=dec_equiv(thiscode[cindex],nhoodm[cposs]);
	}
     }
     else if (select=='h'){  /*enter as hex*/
	temp2=((nhoodm[cposs]+1)/8)-1;
	if (temp2<0) temp2=0;
	/*draw boxes, input hex*/
	define_hex(nhoodm[cposs],1,thiscode[cindex],temp2,0,xtext);
	if (is[0]=='q') {revise}
	if (nhoodm[cposs]>=8) for (z=15;z>=nhoodm[cposs]+1;z--)
					 set_bit0(thiscode[cindex],z);
	if (nhoodm[cposs]<=6) for (z=7;z>=nhoodm[cposs]+1;z--)
					 set_bit0(thiscode[cindex],z);
	if (inbox==0){
	   next_line(xtext,.5);
	   codedec=(signed short)dec_equiv(thiscode[cindex],
						    nhoodm[cposs]);
	   print_bit_line(thiscode[cindex],nhoodm[cposs]+1,
						       lightred, 4, 2);
	   next_line((double)getx/CWidth,-.7);
	   sprintf(textb[0]," code%d=(dec)%d (hex)",nhoodm[cposs],codedec);
	   outtext(textb[0]);
	   print_current_bitstring_hexbytes(2,thiscode[cindex],
				   nhoodm[cposs],Maxx/2,white,0);
	}
     }
     else if (select=='p'){   /*repeat last code*/
	if (cindex==0){
	   if ((signed short)dec_equiv(thiscode[0],tnhood)==0){
	      /*if nothing to copy - assign random code*/
	      random_bits(nhoodm[cposs],0,2,1,thiscode[cindex],
				nhoodm[cposs],vgax(4),vgax(2));
	      codedec=dec_equiv(thiscode[cindex],nhoodm[cposs]);
	   }
	}
	else if (number_rules>1){
	   copyindex=cindex-1;
	   memcpy(thiscode[cindex],thiscode[copyindex],codebytes);
	}
	if (inbox==0){
	   next_line(xtext,2);
	   print_bit_line(thiscode[cindex],tnhood+1,lightred, 4, 2);
	   moveto(getx,
		gety+(signed short)vgay(-(float)CHeight/1.3));
	   codedec=(signed short)dec_equiv(thiscode[cindex],tnhood);
	   sprintf(textb[0]," thiscode[%d]=(dec)%d",tnhood,codedec);
	   outtext(textb[0]);
	   next_line(getx/CWidth+CWidth,-.5);
	}
	if (rulemix && cindex>0) {revise};

     }
     /*convert code to rule*/
     for (zz=tablemax;zz>=0;zz--){
	sod=0;
	for (z=nhoodm[cposs]-1;z>=0;z--) sod+=get_bit(nm[z],zz);
	set_bit(thisrule[cindex],zz,get_bit(thiscode[cindex],sod));
     }
     if (inbox==0){
	next_line(xtext,2);
	print_layered_bitstring(64,thisrule[cindex],
						tablemax,scale,sep,0,1);
	if (nhoodm[cposs]>=5){
	   next_line(xtext,.5);
	}
	if (nhoodm[cposs]<=5) {
	   ruledec=dec_equiv(thisrule[cindex],tablemax);
	   if (nhoodm[cposs]<5){
	      /*next_line((double)getx/CWidth,-.7);
	      outtext(" ");*/
              next_line(xtext,1);
	   }
	   sprintf(textb[0],"rule%d=(dec)%lu (hex)",nhoodm[cposs],ruledec);
	   outtext(textb[0]);
	}
	lineno=print_current_bitstring_hexbytes
		 (1,thisrule[cindex],nhoodm[cposs],Maxx/2,white,0);
     }
     if (rulemix){
	z_parameter_all(nhoodm[cposs],0,thisrule[cindex]);
	if (!(direction=='f' && limitcheck==0)||secondpart==0){
	   show_rule_bottom(nhoodm[cposs],0,thisrule[cindex],cindex);
	}
     }
     if (!rulemix) break;
  }
  if (inbox==0){
     erase_box(Maxx/2,vgay(27),Maxx-2,vgay(50));
     next_line(xtext,lineno+.5);
     if (nhoodm[cposs]<8) next_line(xtext,1);
  }
  return(gety);
}

/************************* revise one rule, 5 June 1994 **************/
void revise_rule_or_code(unsigned short thisposs,
	       signed short tablebytes,signed short codebytes){
 float oldxtext;

   allocate_mem_diffrules(nhoodm[thisposs],1);
   allocate_mem_diffcodes(nhoodm[thisposs],1);
   /*memory_box(1);*/
   if (totalistic==0) memcpy(diffrule[0],carule[thisposs],tablebytes);
   else{
      memcpy(diffcode[0],cacode[thisposs],codebytes);
      memcpy(diffrule[0],carule[thisposs],tablebytes);
   }
   draw_box(5,vgax(330),vgay(343),Maxx-2,Maxy,1,0);
   moveto(vgax(340),vgay(345)-CHeight);
   oldxtext=xtext;
   xtext=(float)vgax(340)/CWidth;
   if (totalistic==0){
      select_rule(1,diffrule,1,thisposs);
      memcpy(carule[thisposs],diffrule[0],tablebytes);
   }
   else{
      select_code(1,diffcode,diffrule,1,thisposs);
      memcpy(cacode[thisposs],diffcode[0],codebytes);
      memcpy(carule[thisposs],diffrule[0],tablebytes);
   }
   xtext=oldxtext;
   free_mem_diffrules(1);
   free_mem_diffcodes(1);
   putimage(vgax(330),vgay(343),boximage[5],COPY_PUT);
   freeimage(boximage[5]);
   z_parameter_all(nhoodm[thisposs],0,carule[thisposs]);
   /*memory_box(1);*/
   is[0]=0;
}

/********* specify initial (seed) state, 13 May 1993 *****************/
void select_seed(char* thisseed, char *text, char restore_box){
 char seedset,select,wasrandom=0,
      cellscale,cellsep;
 float tempxtext;
 signed short temp,lineno,
     startx,starty,tempx2,tempy2,temp2,
     rightbox,mes_width,width_req,height_req,bottombox,hex=0,
     foldposs;
 unsigned short zu,seglen,maxseglen,startseg,endseg;
 unsigned long seed; /*=decimal eq. of CA seed*/

#  define clearspace(possx,possy) {\
      setfillstyle(SOLID_FILL,black);\
      bar(possx,possy+2,rightbox-1,bottombox-1);\
      moveto(possx,possy);\
   }

   if (lineL<=(unsigned short)pow(2,(double)8)) hex=1; /*256*/
   startx=getx;

   if (!twod){ /*to select 1d bit seed in 2d*/
      i2d=(signed short)ceil(pow((double)lineL,.5));
      j2d=(signed short)ceil((double)lineL/i2d);
   }

   if (!twod) foldposs=64;  
   else foldposs=i2d;
              
   if (hires || Maxx>=800){
      cellscale=5;
      cellsep=2;
      if (lineL>=80*80-1) cellscale=4; 
      if (lineL>=150*150-1) cellscale=3;      
      if (lineL>=(unsigned short)(200*200-1)){
         cellscale=2;
         cellsep=1;
      }       
   }
   else{  
      cellscale=4;
      cellsep=2;
      if (lineL>=36*36-1) cellscale=3;                 
      if (lineL>=56*56-1){                      
	 cellscale=2;
	 cellsep=1;         
      }
      if (lineL>=(unsigned short)(96*96-1)){
         cellscale=1;
         cellsep=1;
      }
   }   
   tempxtext=xtext;
   if (restore_box) xtext=((float)startx/CWidth);

   width_req=Maxx*.5;
   if (!twod) mes_width=CWidth*6+cellscale*lineL/foldposs;
   else  mes_width=CWidth*6+cellscale*i2d;
   if (mes_width>width_req) width_req=mes_width;
   rightbox=startx-3+width_req;
   if (!twod) height_req=CHeight*10+cellscale*lineL/foldposs;
   else height_req=CHeight*6+cellscale*j2d;
   bottombox=Maxy-vgay(33);
   starty=bottombox-height_req;

   draw_box(12,startx-3,starty,rightbox,bottombox,1,0);
   
   if (memcmp(text,"SEED",4)==0) showbits_1d_as_2d=0;

 start:
   clearspace(startx,starty);
   if (twod && diff_plot){ /*line top and bottom to indicate sub-networks*/
      line(startx+(cellscale*i2d)/2,starty+CHeight*2,
                                 startx+(cellscale*i2d)/2,starty+CHeight*4);
      line(startx+(cellscale*i2d)/2,bottombox-CHeight*2,
                                 startx+(cellscale*i2d)/2,bottombox);
   }
   /*check if a seed exists, if so setting bits is default*/
   seedset=0;
   for (zu=0;zu<=bytesL;zu++){
      if (bitseed[zu]>=1){
         seedset=1;
         break; 
      }
   }
   if (seedset) sprintf(textb[3],"(default-b)");
   else if (twod) sprintf(textb[3],"(default-r)"); 
   else{ 
      if (lineL<=32) sprintf(textb[3],"(default-d)"); 
      else sprintf(textb[3],"(default-r)"); 
   }

   if (twod){
      if (lineL<=32){
	 sprintf(textb[0],"Select %s, empty-e fill-f random-r dec-d",text);
	 sprintf(textb[1],"bits2d-b hex-h repeat-p load-l %s:",textb[3]);
      }
      else{
	 sprintf(textb[0],
	   "Select %s, empty-e fill-f random-r",text);
	 sprintf(textb[1],"bits2d-b hex-h repeat-p load-l %s:",textb[3]);
      }
   }
   else{
      if (lineL<=32){
	 sprintf(textb[0],"Select %s, empty-e fill-f dec-d random-r",text);
	 sprintf(textb[1],
	    "bits1d-b bits2d-B hex-h repeat-p load-l %s:",textb[3]);
      }
      else{
	 sprintf(textb[0],
	   "Select %s, empty-e fill-f random-r",text);
	 sprintf(textb[1],"bits1d-b bits2d-B hex-h repeat-p load-l %s:",textb[3]);
      }
   }

   myouttext(textb[0]);
   next_line(xtext,1);
   myouttext(textb[1]);
   input_string(1,0);
   if (is[0]=='q'){
      if (restore_box) putimage(startx-3,starty,boximage[12],COPY_PUT);
      freeimage(boximage[12]);
      xtext=tempxtext;
      return;
   }
   select=is[0];
   
   if (lineL<=32){
      if (select!='e' && select!='f' && select!='b' && select!='B' &&
	    select!='d' && select!='h' && select!='p' && 
                                 select!='r' && select!='l'){
	 if (seedset){
             if (twod) select='B';
             else select='b';
         }
         else select='d';
      }
   }
   else{
      if (select!='e' && select!='f' && select!='b' && select!='B' &&
	    select!='r' && select!='h' && select!='p' && select!='l'){
         if (seedset){
             if (twod) select='B';
             else select='b';
         }
         else select='r';
      }
   }
   if (select=='e'){
      memcpy(thisseed,all_0s,bytesL);
      goto start;
   }
   else if (select=='f'){
      memcpy(thisseed,all_1s,bytesL);
      goto start;
   }
   else if (select=='r'){
      next_line(xtext,1);
      tempx2=getx;
      tempy2=gety;

     startr:
      if ((twod && i2d<20) || (!twod && lineL<20)){
	 random_bits(nhood,0,0,hex,thisseed,L,vgax(4),vgax(2));
	 if (is[0]=='q'){
	    clearspace(tempx2,tempy2);
	    goto start;
	 }
      }
      else{
	 if (!twod) sprintf(textb[0],
	   "central segment only enter size (default %d), all-a:",lineL/5);
	 else sprintf(textb[0],
	   "central 2-d block only enter diameter (default %d), all-a:",
								   i2d/5);
	 myouttext(textb[0]);

	 /*input_string(strlen(itoa(lineL,textb[0],10)),0);*/
	 sprintf(textb[0],"%d",lineL);
	 input_string(strlen(textb[0]),0);

	 if (is[0]=='q') goto start;
	 seglen=atoi(is);

	 if (is[0]=='a')
		   random_bits(nhood,0,0,hex,thisseed,L,vgax(4),vgax(2));
	 else{
	    if (is[0]==0 || is[0]==13){
	      if (!twod) seglen=lineL/5;
	      else seglen=i2d/5;
	    }
	    random_bits(nhood,seglen,0,hex,thisseed,L,vgax(4),vgax(2));
	 }
	 if (is[0]=='q'){
	    clearspace(tempx2,tempy2);
	    goto startr;
	 }
      }
   }
   else if (select=='l'){
      load_save_wrs('l',thisseed,'s');
      if (is[0]=='q') goto start;
      next_line(xtext,1.5);
      if (lineL<33){
	   seed=dec_equiv(thisseed,L);
	   sprintf(textb[0],"(dec) %lu, ",seed);
	   myouttext(textb[0]);
      }
      if (L<16*16-1){
	   outtext("(hex)");
	   lineno=print_current_bitstring_hexbytes
			   (0,thisseed,0,rightbox,white,0);
	   next_line(xtext,lineno+3);
      }
      print_layered_bitstring(foldposs,thisseed,L,cellscale,cellsep,0,0);

      next_line(xtext,1);/*pause to see rule*/
      sprintf(textb[0],"seed loaded, revise-q, cont-ret:");
      myouttext(textb[0]);
      input_string(1,0);
      if (is[0]=='q') goto start;
   }
   else if (select=='b' || (select=='B' && twod)){
      maxseglen=lineL; /*define segment of ca as bitstring*/
      next_line(xtext,1);
      tempx2=getx;
      tempy2=gety;

     startb:
      if (!twod){
	 sprintf(textb[0],
	       "enter segment to define as bitstring, max/default %d:",
							  maxseglen);
	 myouttext(textb[0]);
	 sprintf(textb[0],"%d",maxseglen);
	 input_string(strlen(textb[0]),1);

	 if (is[0]=='q') goto start;
	 seglen=atoi(is);
	 if (seglen>=maxseglen || is[0]==13) seglen=maxseglen;
	 if (seglen<maxseglen){
	    sprintf(textb[0],
		"enter start position from left 0-%d, default centred: ",
							L-seglen);
	    next_line(xtext,1);
	    myouttext(textb[0]);
	    
	    /*input_string(strlen(itoa(L-seglen,textb[0],10)),1);*/
	    sprintf(textb[0],"%d",L-seglen);
	    input_string(strlen(textb[0]),1);

	    if (is[0]=='q'){
	       clearspace(tempx2,tempy2);
	       goto startb;
	    }
	    startseg=atoi(is);
	 }
	 if (startseg<=L-seglen) startseg=L-startseg;
	 if (startseg>=L-seglen || is[0]==13) startseg=(L/2)+(seglen/2);
	 endseg=startseg-seglen+1;
	 define_bits(nhood,0,thisseed,startseg,endseg,scale,sep);
	 if (is[0]=='q'){
	    clearspace(tempx2,tempy2);
	    goto startb;
	 }
      }
      else{
	 startseg=L;
	 endseg=0;
	 define_bits(nhood,0,thisseed,startseg,endseg,scale,sep);
	 if (is[0]=='q') goto start;
      }
      if (lineL<=32){
	 seed=dec_equiv(thisseed,L);
	 sprintf(textb[0]," (dec)%lu (hex)",seed);
	 myouttext(textb[0]);
      }
      if (lineL<=(unsigned short)pow(2,(double)8)){
	 lineno=print_current_bitstring_hexbytes(0,thisseed,
						0,rightbox,white,0);
	 next_line(xtext,lineno+1);
      }
   }
   else if (select=='B' && !twod){
      showbits_1d_as_2d=1;
      sprintf(textb[0],"now %dx%d, reset i-axis:",i2d,j2d);
      next_line(xtext,1);
      myouttext(textb[0]);
      input_string(3,0);
      if (is[0]=='q') goto start;
      if (is[0]==13);
      else if (atoi(is)>0 && atoi(is)<=lineL){
	 i2d=atoi(is);
	 j2d=(signed short)ceil((double)lineL/i2d);
      }

      if (j2d>16){
	 putimage(startx-3,starty,boximage[12],COPY_PUT);
	 freeimage(boximage[12]);

	 foldposs=i2d;
	 height_req=CHeight*10+cellscale*lineL/foldposs;
	 starty=bottombox-height_req;
	 draw_box(12,startx-3,starty,rightbox,bottombox,1,0);
      }

      maxseglen=lineL; /*define segment of ca as bitstring*/
      next_line(xtext,1);
      tempx2=getx;
      tempy2=gety;

      startseg=L;
      endseg=0;
      twod=1;
      define_bits(nhood,0,thisseed,startseg,endseg,scale,sep);
      if (is[0]=='q'){
	 twod=0;
	 goto start;
      }
      if (lineL<=32){
	 seed=dec_equiv(thisseed,L);
	 sprintf(textb[0]," (dec)%lu (hex)",seed);
	 myouttext(textb[0]);
      }
      if (lineL<=(unsigned short)pow(2,(double)8)){
	 lineno=print_current_bitstring_hexbytes(0,thisseed,
						0,rightbox,white,0);
	 next_line(xtext,lineno+1);
      }
      twod=0;
   }

   else if (select=='d'){
      if (scale>2) sep=2;
      else sep=1; /*1..no division between cells, 2..1 pix black div*/
      if (lineL>32){
	 random_bits(nhood,0,0,hex,thisseed,L,vgax(4),vgax(2));
	 wasrandom=1;
	 if (is[0]=='q') goto start;
      }
      if(lineL<33){
	 next_line(xtext,1);
	 tempx2=getx;
	 tempy2=gety;

	startd:
	 sprintf(textb[0],"decimal seed, enter 0-%lu (default-random):"
				   ,(unsigned long) pow(2,(double)lineL)-1);
	 myouttext(textb[0]);

	 /*temp=strlen(ultoa((unsigned long)pow(2,(double)lineL)-1,
							textb[0],10));*/
	 sprintf(textb[0],"%lu",(unsigned long)pow(2,(double)lineL)-1);
	 temp=strlen(textb[0]);
	 input_string(temp,1);

	 if (is[0]=='q') goto start;
	    seed=(unsigned long)_atold(is);   /* str too long*/
            if (is[0]==13 ||_atold(is)>
              (unsigned long) pow(2,(double)lineL)-1)
	         random_bits(nhood,0,0,hex,thisseed,L,vgax(4),vgax(2));	 
	 else{  /*conver dec to bitstring*/
	    next_line(xtext,2);
	    dec_to_bit_line(thisseed,seed,lineL);
	    print_bit_line(thisseed,lineL,lightred, scale, sep);
	 }
	 if (is[0]=='q'){
	    clearspace(tempx2,tempy2);
	    goto startd;
	 }
      }
   }
   else if (select=='h'){  /*enter as hex*/
      tempx2=getx;
      tempy2=gety;

      /*bytes required from max--0*/
      temp2=(signed short)ceil( (double)lineL/8);
      /*draw boxes, input hex*/
      define_hex(nhood,0,thisseed,temp2-1,0,xtext);
      if (is[0]=='q'){
	 setpback_x_lines(1);
	 goto start;
      }
      /*no of extra bits on left*/
      temp= temp2*8-lineL;
      if (temp>0){
	 for (zu=temp+lineL-1;zu>=lineL;zu--) set_bit0(thisseed,zu);
      }
      if (lineL>512 || (twod && j2d>16)){
	 moveto(tempx2,tempy2);
	 next_line(xtext,2);
	 setfillstyle(SOLID_FILL,black);
	 bar(getx,gety,rightbox-1,bottombox-1);
      }
      else next_line(xtext,1.5);
      print_layered_bitstring(64,thisseed,L,scale,sep,0,1);
      next_line(getx/CWidth+CWidth,-.5);
   }

   /*repeat last seed*/
   else if (select=='p'){
       next_line(xtext,1.5);
       print_layered_bitstring(64,thisseed,L,scale,sep,0,1);
   }

   if (memcmp(text,"SEED",4)!=0 && (select=='r'|| wasrandom==1)){
      wasrandom=0;
      if (lineL<=(unsigned short)pow(2,(double)8)){
	 next_line(xtext,.5);
	 lineno=print_current_bitstring_hexbytes(0,thisseed,
						0,rightbox,white,0);
	 next_line(xtext,lineno+1);
      }
   }

   /*allow seed to be saved*/
   if (select!='l' && !dont_save) load_save_wrs('s',thisseed,'s');
   /*
   if (is[0]=='q'){
      clearspace(startx,starty);
      goto start;
   }*/
   if (restore_box) putimage(startx-3,starty,boximage[12],COPY_PUT);
   freeimage(boximage[12]);
   memory_box(1);
   xtext=tempxtext;
}
