/************************ DRAW BASINS ************************/

#include "edecfunc.h"

/******************* draw pre-image fan, May 93 ***********************/
void draw_fan(){

 float interval2, /*distance between levels*/
       gap,       /* ?? gap between points on fan*/
       constantinterval;

   heading=0;
   if (startsegfan==0){
      if (level==0 && attperiod>0){
	 xx=cyclex[attindex];
	 yy=cycley[attindex];
      }
      else if (level==0 && attperiod==0){
	 xx=ox;  /*transient sub-tree only*/
	 yy=oy;  /*start position = origin*/
      }
      else {
	 if (pretog){  /*pretog==1*/
	    xx=xx1[thisindex];
	    yy=yy1[thisindex];
	 }
	 else {
	    xx=xx0[thisindex];
	    yy=yy0[thisindex];
	 }
      }
   }
   else {  /*for segmented fan, all 0s od 1s*/
      xx=segx[segindex];
      yy=segy[segindex];
      startsegfan=0;
   }

   if (level<lastlevel-1){      /* index is LASTLEVEL-1*/
      thisrad=rad[level];
      nextrad=rad[level+1];
   }
   else{
      constantinterval=rad[lastlevel-1]-rad[lastlevel-2];
      thisrad=rad[lastlevel-1]+constantinterval*(level-(lastlevel-1));
      nextrad=thisrad+constantinterval;
   }
   interval2=nextrad-thisrad; /*dist. between levels*/
   gap=interval2/2; /*controls spread of fan*/
   spot=(interval2/8)*(thisrad/nextrad); /*diamiter of spot*/
   /*garden of Eden states*/
   if (fansize==0){
      moveto(xx,yy);
      draw_node(A,white,1);
      if (dontcopytrees<3){
	 compute_heading();
	 if (insegloop==1) copy_fan_tree(A);
	 if (cyclematch>1) copy_cycle_tree(A);
      }
      return;
   }
   compute_heading();
   if (level==0) {
      angle=1.65*PI/fansize;
      /*360 degrees for transient tree only*/
      if (attperiod==0) angle=2*PI/fansize;
      else if (attperiod==2) angle=.85*PI/fansize;
      else if (attperiod>2) angle=2* atan((double)(gap/nextrad))/
					      pow((double)fansize,.5);
   }
   else if (attperiod<=1 && level==1 && thismax==1)
				     angle=1.65*PI/fansize;
   /*angle between nodes centred from point attractor*/
   else angle=2* atan( (double) (gap/nextrad))
					/ pow( (double)fansize,.5);
   /*to limit angle of fan*/
   if (attperiod==1 || attperiod==0){
      if ((level==0 || (level==1 && thismax==1))==0){
	 if (angle*fansize > .85*PI*(rad[0]/thisrad))
				angle=(.85*PI/fansize)*(rad[0]/thisrad);
      }
   }
   else if (attperiod>2 || (attperiod==0 && level>0)){
      if (angle*fansize > .85*PI * ((rad[0])/nextrad))
			angle=(.85*PI/fansize)*((rad[0])/nextrad);
   }
   if (attperiod<6 || pretested==0){
      if (attperiod<6 || pretested==0){
	 if (linec==black){  /*change color for each new transient*/
	    linec=lightred;  /*if on att cycle, or each new fan if*/
	    spotc=green;     /*cycle is less than 6 long or*/
	 }                   /*starting from a given input*/
	 else if (linec==lightred){
	    linec=lightcyan;
	    spotc=lightred;
	 }
	 else if (linec==lightcyan){
	    linec=green;
	    spotc=lightred;
	 }
	 else if (linec==green){
	    linec=yellow;
	    spotc=green;
	 }
	 else if (linec==yellow){
	    linec=lightred;
	    spotc=green;
	 }
      }
   }
   if (segfan==0) plot_motor(1,A);
   else plot_motor_segfan(1,A);
   if (insegloop==1 && dontcopytrees==0) copy_fan_tree(A);
   if (cyclematch>1 && dontcopytrees==0) copy_cycle_tree(A);
}

/****************** heading of centre line of fan, May 93 **************/
void compute_heading(void){
 double ratio;

   if (level==0 && (attperiod==1 || attperiod==0))
			      heading=-deg * 45; /*45 degrees*/
   if (attperiod>1 || level>0){
      if (xx!=ox){
	 ratio=fabs((double)(yy-oy)/(double)(xx-ox));
	 heading= (float) atan (ratio);
	 if (yy<oy && xx>ox) heading=2*PI-heading;
	 else if (yy<oy && xx<ox) heading=PI+heading;
	 else if (yy>=oy && xx<ox) heading=PI-heading;
      }
      else if (xx==ox && yy<oy) heading=3*PI/2;
      else if (xx==ox && yy>oy) heading=PI/2;
      /*tilt heading 15 degrees for level 1 of cycles*/
      if (level==0) heading-=(PI/12);
   }
}

/**************** plot pre-image fan, May 93 **************************/
void plot_motor(char savecoords,char* tempA){

 float stangle,heading2;
 unsigned short z;

   stangle=heading+((fansize-1) * angle/2);
   for (z=1;z<=fansize;z++){
      moveto (xx,yy);
      heading2=stangle-angle*(z-1); /*pre-im angle*/
      cx=(signed short)(cos(heading2)*nextrad+ox);
      cy=(signed short)(sin(heading2)*nextrad+oy);
      if (savecoords){   /*first equivalent only*/
	 if (pretog==0){ /*co-ords of copies not recorded*/
	    xx1[nextbefore+z]=cx;/*predes. to be future inputs*/
	    yy1[nextbefore+z]=cy;/*first equivalents only*/
	 }
	 if (pretog==1){
	    xx0[nextbefore+z]=cx;/*predes. to be future inputs*/
	    yy0[nextbefore+z]=cy;/*first equivalents only*/
	 }
      }
      if (savecoords==1 || dontcopytrees==0){
	 setcolor(linec);
	 lineto (cx,cy);
      }
   }
   moveto(xx,yy);
   draw_node(tempA,spotc,savecoords);
}

/************** plot fan in equivalent segments, June 93 ************/
void plot_motor_segfan(char savecoords,char* tempA){

 float stangle,heading2=0,headingcopies;
 unsigned short z;
 signed short zz,copies;

   segfanangle=angle*((double)fansize)/totalsegfan;
   stangle=heading+((totalsegfan-1) * segfanangle/2);
   heading2=stangle;
   linec=black;
   for (z=1;z<=fansize;z++){
      if (linec==black){
	 linec=lightred;
	 spotc=green;
      }
      /*change color for each new transient if on att cycle,
      or each new fan if cycle is less than 6 long or
      starting from a given input*/
      else if (linec==lightred){
	 linec=lightcyan;
	 spotc=lightred;
      }
      else if (linec==lightcyan){
	 linec=green;
	 spotc=lightred;
      }
      else if (linec==green){
	 linec=yellow;
	 spotc=green;
      }
      else if (linec==yellow){
	 linec=lightred;
	 spotc=green;
      }

      moveto (xx,yy);
      if (z>1){
	 if (regular2d) heading2-=segfanangle*seg_2d_h[z-1]*seg_2d_v[z-1];
	 else heading2-=segfanangle*seg[z-1]; /*pre-im angle*/
      }
      cx=(signed short)(cos(heading2)*nextrad+ox);
      cy=(signed short)(sin(heading2)*nextrad+oy);
      if (savecoords){   /*first equivalent only*/
	 if (pretog==0){ /*co-ords of copies not recorded*/
	    xx1[nextbefore+z]=cx;/*predes. to be future inputs*/
	    yy1[nextbefore+z]=cy;/*first equivalents only*/
	 }
	 if (pretog==1){
	    xx0[nextbefore+z]=cx;/*predes. to be future inputs*/
	    yy0[nextbefore+z]=cy;/*first equivalents only*/
	 }
      }
      if (savecoords==1 || dontcopytrees==0){
	 setcolor(linec);
	 lineto (cx,cy);
      }
      headingcopies=heading2;
      if (regular2d){
	 copies=seg_2d_h[z]*seg_2d_v[z]-1;
      }
      else copies=seg[z]-1;
      for (zz=1;zz<=copies;zz++){

	 headingcopies-=segfanangle;
	 cx=(signed short)(cos(headingcopies)*nextrad+ox);
	 cy=(signed short)(sin(headingcopies)*nextrad+oy);
	 if(!dontcopytrees) moveto(xx,yy);
	 else moveto(xx+(cx-xx)*3/4,yy+(cy-yy)*3/4);

	 lineto (cx,cy);
      }
   }
   moveto(xx,yy);
   draw_node(tempA,spotc,savecoords);
}

/********** draw node as spot, dec number or string, June 93 ***********/
void draw_node(char* tempA,signed short nodecolor,char savecoords){
 signed short getxtemp,getytemp,byteno,count1s;
 unsigned z;
 #if (__WATCOM__)
    signed short blockwidth;
 #endif
 unsigned char forecolor,blockcolor,tarcolor,precolor;

    if (shownumbers==-1) return;

#define highline	{if (memcmp(tempA,tar,bytesL)==0){\
			      blockcolor=tarcolor;\
			 }\
			 else {\
			   for (z=0;z<=notolearn-1;z++){\
			     if (memcmp(tempA,learn_pre[z],bytesL)==0){\
				blockcolor=precolor;\
				break;\
			     }\
			   }\
			 }}

#if (__WATCOM__)
#define smallspot	 _setpixel(xx,yy-1);\
			 _setpixel(xx-1,yy);\
			 _setpixel(xx+1,yy);\
			 _setpixel(xx,yy+1);
#endif

    if (labelsizefactor!=1 && (shownumbers==1||shownumbers==2)){
#      if (__BORC__)
	  setusercharsize(labelsizefactor*tx1*rad[0]/40,
			tx2,labelsizefactor*ty1*rad[0]/40,ty2);
#      elif (__WATCOM__)
	  _setcharsize((signed short)((ceil)((float)
	     (labelsizefactor*ty1*rad[0]/40))),
	      (signed short)((ceil)((float)(labelsizefactor*tx1*rad[0]/40))));
#      endif
    }
    /*to show up exceptions in Raja's rule*/
    if (show_maj>=0){

       count1s=0;
       for (z=0;z<=L;z++) count1s+=get_bit(tempA,z);
       if (show_maj==0) count1s=lineL-count1s;
    }
    /*spot*/
    if (shownumbers==0){
	setcolor(nodecolor);
	if (dontcopytrees==1 && savecoords==0) lineto(xx,yy);
	else{
	   if (show_maj>=0){
	      if (count1s>lineL/2) {
		 setcolor(white);
		 /*darkgray better to print*/
		 if (bground=='w') setfillstyle(SOLID_FILL,blue);
                 if (bground=='b') setfillstyle(SOLID_FILL,yellow);
		 bar3d(xx-1,yy-1,xx+2,yy+2,0,0);
	      }
#             if (__BORC__||__UNIX__)
	         else circle (xx,yy,spot);
#             elif (_WATCOM__)
	      else{
		 if (spot<1) {smallspot}
		 else circle(xx,yy,spot);
	      }
#             endif
	   }
	   else if (hilight_learn){
	      tarcolor=lightred;
	      precolor=yellow;
	      blockcolor=black;
	      highline;
	      if (blockcolor!=black){
		 setfillstyle(SOLID_FILL,blockcolor);
		 bar(xx-1,yy-1,xx+2,yy+2);
		 setcolor(white);
		 rectangle(xx-3,yy-3,xx+4,yy+4);
	      }

	      else if (hilight_learn !=2){
#             if (__BORC__||__UNIX__)
		 circle (xx,yy,spot);
#             elif (__WATCOM__)
		 if (spot<1) {smallspot}
		 else circle(xx,yy,spot);
#             endif
	      }
	   }
	   else{
#          if (__BORC__||__UNIX__)
	      circle (xx,yy,spot);
#          elif (__WATCOM__)
              if (spot<1) {smallspot}
	      else circle(xx,yy,spot);
#          endif
	   }
	}
	goto endspot;
    }
    /*decimal equivalent*/
    if (shownumbers==1 && lineL<33){
       getxtemp=getx;
       getytemp=gety;
       sprintf(textb[1],"%lu",dec_equiv(tempA,L));

       setcolor(white);
       blockcolor=black;
       if (hilight_learn){
	  tarcolor=lightred;
	  precolor=yellow;
	  highline;
       }
       if (!(hilight_learn==2 && blockcolor==black)){
	  setfillstyle(SOLID_FILL,blockcolor);
	  if (blockcolor!=black) setcolor(black);
#         if (__BORC__)
	     bar(getx-1,gety+2,getx+textwidth(textb[1])-1,
					gety+textheight(textb[1])+1);
#         elif (__WATCOM__)
	     if (dec_equiv(tempA,L)<10) blockwidth=textwidth(textb[1]);
	     else blockwidth=textwidth(textb[1])-1;
	     bar(getx+1,gety+2,getx+blockwidth,
					gety+textheight(textb[1])+1);
#         elif (__UNIX__)
             if (blockcolor!=black) setcolor(black);
	     bar(getx-1,gety+2,getx+textwidth(textb[1])-1,
					gety+CHeight+1);
#         endif

	  moveto(getxtemp,getytemp);
	  outtext(textb[1]);
       }
       goto endspot;
    }
    /*hex equivalent*/
    if (shownumbers==2){
       byteno=(signed short)ceil( (double)lineL/8);
       getxtemp=getx;
       getytemp=gety;

       forecolor=white;
       blockcolor=black;
       if (hilight_learn){
	  tarcolor=lightred;
	  precolor=yellow;
	  highline;
       }
       if (!(hilight_learn==2 && blockcolor==black)){
	  setfillstyle(SOLID_FILL,blockcolor);
	  if (blockcolor!=black) forecolor=black;
#      if (__BORC__)
	  bar(getx-1,gety+2,getx+(byteno*2*textwidth("z"))-1,
					gety+textheight("z")+1);
#      elif (__WATCOM__)
	  bar(getx+1,gety+2,getx+(byteno*2*textwidth("z"))+1,
					gety+textheight("z")+1);
#      elif (__UNIX__)
          if (blockcolor!=black) forecolor=black;
	  bar(getx-1,gety+2,getx+(byteno*2*CWidth)-1,
					gety+CHeight+1);
#      endif

	  moveto(getxtemp,getytemp);
	  print_current_bitstring_hexbytes(0,A,-2,10000,forecolor,0);
	  moveto(getxtemp,getytemp);
       }
       goto endspot;
    }
    /*graghic bit-string*/
    if (shownumbers==3){
       if (hilight_learn){
	  tarcolor=lightred;
	  precolor=yellow;
	  blockcolor=white;
	  highline;
       }
       else{
	  if (linec==lightcyan) blockcolor=magenta;
	  else if (linec==green) blockcolor=cyan;
	  else if (linec==yellow) blockcolor=lightred;
	  else if (linec==lightred) blockcolor=yellow;
	  else blockcolor=white;
       }
       if (!(hilight_learn==2 && blockcolor==white)){
	  if (twod || showbits_1d_as_2d)
	      print_current_state_twod(tempA,blockcolor);
	  else print_current_state_h(tempA,blockcolor);
       }
   }
  endspot:
#  if (__BORC__)
     if (labelsizefactor!=1 && (shownumbers==1||shownumbers==2))
				     setusercharsize(tx1,tx2,ty1,ty2);
#  elif (__WATCOM__)
     if (labelsizefactor!=1 && (shownumbers==1||shownumbers==2)){
		_setcharsize(ty1,tx1);             /*watcom*/
		_gettextsettings(&ts);
     }
#  endif

}

/************* copy equivalent trees on cycle, Aug 93 ****************/
void copy_cycle_tree(char *tempA){
 signed short subperiod,z=0;
 unsigned short z0,z1,cm_d;

#define locate_cycle_tree heading-=(2*PI/attperiod)*subperiod;\
			      if (heading<2*PI) heading+=2*PI;\
			      if (level==0 && attperiod>0){\
				 xx=cyclex[attindex-z*subperiod];\
				 yy=cycley[attindex-z*subperiod];\
			      }\
			      else{\
				 xx=(signed short)(cos(heading)*thisrad+ox);\
				 yy=(signed short)(sin(heading)*thisrad+oy);\
			      }

    if (regular2d){
       if (cyclematch_2d_diag[0]>1 || cyclematch_2d_diag[1]>1){
	  if (cyclematch_2d_diag[0]>1) cm_d=cyclematch_2d_diag[0];
	  else if (cyclematch_2d_diag[1]>1) cm_d=cyclematch_2d_diag[1];
	  subperiod=attperiod/cm_d;
	  for (z0=1;z0<=cm_d;z0++){
	     /*miss out last=same*/
	     if (z0!=cm_d){
		z+=1;
		locate_cycle_tree;
		if (shownumbers>0){
		   if (cyclematch_2d_diag[0]>1)
			   rotate_array_2d(tempA,'r',1);
		   else rotate_array_2d(tempA,'l',1);
		   rotate_array_2d(tempA,'u',1);
		}
		if (fansize==0){
		   moveto(xx,yy);
		   draw_node(tempA,white,0);
		}
		else plot_motor(0,tempA);
	     }
	  }
       }
       else{
	  subperiod=attperiod/(cyclematch_2d[0]*cyclematch_2d[1]);
	  for (z0=1;z0<=cyclematch_2d[0];z0++){
	     if (cyclematch_2d[1]==1 &&
		    shownumbers>0) rotate_array_2d(tempA,'l',1);
	     for (z1=1;z1<=cyclematch_2d[1];z1++){
		/*miss out last=same*/
		if (!(z0==cyclematch_2d[0] && z1==cyclematch_2d[1])){
		   z+=1;
		   locate_cycle_tree;
		   if (shownumbers>0) rotate_array_2d(tempA,'u',1);
		   if (fansize==0){
		      moveto(xx,yy);
		      draw_node(tempA,white,0);
		   }
		   else plot_motor(0,tempA);
		}
	     }
	     if (cyclematch_2d[1]>1 &&
		    shownumbers>0) rotate_array_2d(tempA,'l',1);
	  }
       }
    }
    else{
       subperiod=attperiod/cyclematch;
       for (z=1;z<=cyclematch-1;z++){
	  locate_cycle_tree;
	  /*rotate heading*/
	  if (shownumbers>0)
	          rotate_array(nhood,tempA,'l',0,attrepseg/cyclematch);
	  if (fansize==0){
	     moveto(xx,yy);
	     draw_node(tempA,white,0);
	  }
	  else plot_motor(0,tempA);
       }
    }
}

/****** copy equivelent sub-trees on segmented fan, Aug 93 ************/
void copy_fan_tree(char *tempA){
 signed short z,z0,z1;

#define locate_fan_tree heading=heading-segfanangle;\
			   if (heading<2*PI) heading+=(2*PI);\
			   cx=(signed short)(cos(heading)*nextrad+ox);\
			   cy=(signed short)(sin(heading)*nextrad+oy);\
			   xx=(signed short)(cos(heading)*thisrad+ox);\
			   yy=(signed short)(sin(heading)*thisrad+oy);

   if (regular2d){
      for (z0=1;z0<=seg_2d_h[segindex];z0++){
	 if (seg_2d_v[segindex]==1 &&
		    shownumbers>0) rotate_array_2d(tempA,'l',1);
	 for (z1=1;z1<=seg_2d_v[segindex];z1++){
	    if (z0==seg_2d_h[segindex] && z1==seg_2d_v[segindex]) continue;
	    locate_fan_tree;
	    if (shownumbers>0) rotate_array_2d(tempA,'u',1);
	    if (fansize==0){
	       moveto(xx,yy);
	       draw_node(tempA,white,0);
	       continue;
	    }
	    plot_motor(0,tempA);
	 }
	 if (seg_2d_v[segindex]>1 &&
		    shownumbers>0) rotate_array_2d(tempA,'l',1);
      }
   }
   else{
      for (z=1;z<=seg[segindex]-1;z++){
	 locate_fan_tree;
	 if (shownumbers>0) rotate_array(nhood,tempA,'l',0,1);
	 if (fansize==0){
	    moveto(xx,yy);
	    draw_node(tempA,white,0);
	    continue;
	 }
	 plot_motor(0,tempA);
      }
   }
}

