/****************** EXTERNAL revised feb 96 *************/
#ifndef __BORLANDC__           /*borlandc compiler*/
#  define __BORLANDC__ 0
#endif
#define __BORC__ __BORLANDC__

#ifndef __386__       /*watcom c/386 compiler*/
#  define __386__ 0
#endif
#define __WATCOM__  __386__

#ifndef unix
#  define unix 0
#endif
#define __UNIX__ unix

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#if __BORC__||__WATCOM__
#  include <conio.h>
#  include <string.h>
#  include <CTYPE.H>
#  include <DOS.H>
#  include <time.h>
#  include <process.h>
#  include <bios.h>
#  include <limits.h>
#  include <io.h>
#  include <fcntl.h>
#  include <sys\stat.h>
#endif

#if __BORC__
#  include <graphics.h>
#  include <alloc.h>
#elif __WATCOM__
#  include <graph.h>
#  include <malloc.h>
#  include <dos.h>
#endif

#if __UNIX__
#  include <string.h>
#  include <ctype.h>
#  include <memory.h>
#  include <sys/param.h>
#  include <sys/syscall.h>
#  include <sys/time.h>
#  include <sys/types.h>
#  include <sys/uio.h>

#  include <X11/Xos.h>
#  include <X11/Xlib.h>
#  include <X11/Xutil.h>
#  include <X11/cursorfont.h>
#endif

#include "eglob_a.h"
#include "eglob_b.h"


/* xwindows compatability */
#if __BORC__
#   define getx getx()
#   define gety gety()
#   define log2 log
#elif __WATCOM__
#   define getx _getcurrentposition().xcoord
#   define gety _getcurrentposition().ycoord
#endif

#if __BORC__||__WATCOM__
#   define Maxx getmaxx()
#   define Maxy (getmaxy()-vgay(14))
#   define myrand() rand()
    /***for printer***/
#   define ESC	'\x1B'
#   define LPT1	0
#   define LPT2	1
#   define freeimage(a) free(a)
#endif

#if __BORC__
#   define prn_putc(x)  biosprint(0,(x),LPT1)
#elif __WATCOM__
#   define prn_putc(x) _bios_printer(_PRINTER_WRITE,LPT1,(x))
#endif

#if __BORC__
#   define limitL 18 /*limit for exhaustie testing or random graph*/
#   define limit2d 100 /*100 x 100 limit of 2d square grid (can be rectangle)*/

#elif __WATCOM__
#   define HORIZ_DIR 0  /*Left to right*/
#   define VERT_DIR  1  /*Bottom to top (rotated 90)*/
#   define SOLID_FILL 1       /* Solid fill         */
#   define INTERLEAVE_FILL 9  /* Interleaving lines */
#   define CLOSE_DOT_FILL 11  /* Closely spaced dots*/
#endif

#if __WATCOM__||__UNIX__
#  define limitL 32
#   define limit2d 255
#endif

#if __UNIX__
   /************* redefine fill pattern  *********/
#   define SOLID_FILL FillSolid
#   define INTERLEAVE_FILL FillStippled
#   define CLOSE_DOT_FILL FillSolid
#endif

/*note (pos)>>3 = pos/8 and (pos)&7 = pos%8, faster*/
#define get_bit(array,pos) ((array[(pos)>>3]>>((pos)&7)) & 1)
#define set_bit(array,pos,bit) {if (bit) array[(pos)>>3] |= 1<<((pos)&7);\
			       else array[(pos)>>3] &= ~(1<<((pos)&7));}
#define set_bit0(array,pos) array[(pos)>>3] &= ~(1<<((pos)&7))
#define set_bit1(array,pos) array[(pos)>>3] |= 1<<((pos)&7)

#define PI   (4*atan(1)) /*PI = 180 degrees*/
#define	deg  (PI/180)   /*deg = 1 degree*/


#define northwest  in=ii+1;jn=jj+1;\
		   if (in>i2d-1) in=0;\
		   if (jn>j2d-1) jn=0;
#define north      jn=jj+1;in=ii;\
		   if (jn>j2d-1) jn=0;
#define northeast  in=ii-1;jn=jj+1;\
		   if (in<0) in=i2d-1;\
		   if (jn>j2d-1) jn=0;
#define west       in=ii+1;jn=jj;\
		   if (in>i2d-1) in=0;
#define centre     jn=jj;\
		   in=ii;
#define east       in=ii-1;jn=jj;\
		   if (in<0) in=i2d-1;
#define southwest  in=ii+1;jn=jj-1;\
		   if (in>i2d-1) in=0;\
		   if (jn<0) jn=j2d-1;
#define south      jn=jj-1;in=ii;\
		   if (jn<0) jn=j2d-1;
#define southeast  in=ii-1;jn=jj-1;\
		   if (in<0) in=i2d-1;\
		   if (jn<0) jn=j2d-1;

/***** define arrows ********/
#define LeftArrow 128+75
#define RightArrow 128+77
#define UpArrow 128+72
#define DownArrow 128+80

/*redefines and functions for watcom*/
#if __WATCOM__
      /******* rededines ***********/
#  define _atold atol
#  define farcoreleft stackavail

#  define COPY_PUT _GPSET  /*Copies source bitmap onto screen */
#  define XOR_PUT  _GXOR   /*Exclusive ORs source image with that already onscreen*/
#  define OR_PUT   _GOR    /*Inclusive ORs image with that already onscreen*/
#  define AND_PUT  _AND    /*ANDs image with that already onscreen */
#  define NOT_PUT  _GRPESET/*Copy the inverse of the source*/

#  define rectangle(left, top, right, bottom) \
	_rectangle(_GBORDER,(left),(top),(right),(bottom))

#  define moverel(dx,dy) _moveto(dx+getx,(dy)+gety)
#  define linerel(dx,dy) _lineto((dx)+getx,(dy)+gety);

#  define moveto _moveto
#  define lineto _lineto

   /*DOS getimage function*/
#  define getimage _getimage
#  define putimage _putimage
#  define imagesize _imagesize
#  define setcolor _setcolor
#  define getcolor _getcolor
#  define getpixel _getpixel
#  define clearviewport() _clearscreen((_GVIEWPORT))
#  define cleardevice()   _clearscreen((_GCLEARSCREEN))

   /*just set clip*/
#  define setviewport(left,top,right,bottom,clip) \
		       _setcliprgn((left),(top),(right),(bottom))

#  define circle(xcentre,ycentre,radius) \
   _ellipse(_GBORDER,(xcentre)-(int)ceil(radius),\
		  (ycentre)-(int)ceil(radius),\
		  (xcentre)+(int)ceil(radius),\
		  (ycentre)+(int)ceil(radius))

  /********** functions for watcom ******************/
  extern void
     outtext(char *buf),
     line(signed short xpos,signed short ypos,
		  signed short xpos1,signed short ypos1),
     putpixel(signed short xpos, signed short ypos, signed short color),
     setfillstyle(signed short pattern, signed short color),
     bar(signed short left, signed short top,
		  signed short right, signed short bottom),
     bar3d(signed short left, signed short top,
	   signed short right, signed short bottom,
		 signed short depth, signed short topflag),
     fillpoly(signed short numpoints, signed short *polypoints);

  extern signed short
    getmaxx(void),
    getmaxy(void),
    textheight(char *buf),
    textwidth(char *buf);

  extern unsigned long get_memory(void);
#endif

#if __UNIX__
   /************** redefine various graphics functions  *********/

   /*Declare functions with are not in the headers*/
   /*Simon 1/1/96*/
   extern char     *sprintf();
   extern char     *fprintf();
   extern char     *printf();
   extern int      random();
   extern int 	   gettimeofday();

#  define _atold(a) atol(a)
#  define rectangle(a,b,a1,b1) XDrawRectangle(D,*current_draw,Gc,a,b,(a1)-(a),(b1)-(b))

#  define cleardevice()  XClearWindow(D,W)
#  define circle(x,y,radius) \
     XDrawArc(D,*current_draw,Gc,x-radius,y-radius,radius*2,radius*2,0,360*64)
#  define line(x,y,x1,y1) XDrawLine(D,*current_draw,Gc,x,y,x1,y1)
#  define rand() random()
#  define myrand() random()

#  define COPY_PUT GXcopy   /*Copies source bitmap onto screen */
#  define XOR_PUT  GXxor    /*Exclusive ORs source image with that already onscreen*/
#  define OR_PUT   GXor     /*Inclusive ORs image with that already onscreen*/
#  define AND_PUT  GXand    /*ANDs image with that already onscreen */
#  define NOT_PUT  GXinvert /*Copy the inverse of the source*/

   /*new drawing routines*/
   void getimage(short x, short y, short x1, short y1, Pixmap *image);
   void putimage(short x, short y, Pixmap *image, short drawing_mode);
   void freeimage(Pixmap *image);
   void copy_part_image(Drawable *source_d, Drawable *dest_d,
			short source_x, short source_y,
			short dest_x, short dest_y,
			short width, short height);

   /*new xwindow functions*/
   extern void  show_old_colors(void),
	     revise_graphics(void),
	     close_graphics(void),
	     setup_images(void),
	     free_images(void),
	     resize_window(void),     /*New -- simon*/
	     redraw_window(void),
	     setup_fonts(void),
	     subsec_delay(long microsec);
   extern void  setfillstyle(signed short pattern, signed short color),
	     moveto(signed short xpos, signed short ypos),
	     moverel(signed short xpos, signed short ypos),
	     outtext(char *textbuf),
	     setcolor(unsigned char thiscolor),
	     clearviewport(void),
	     setviewport(signed short left,signed short top,
		    signed short right, signed short bottom,
			     signed short clip),
	     linerel(signed short dx,signed short dy),
	     lineto (signed short x,signed short y),
	     bar(signed short a,signed short b,
		      signed short a1,signed short b1),
	     bar3d(signed short a,signed short b,
		signed short a1,signed short b1,
		     signed short dummy1,signed short dummy2),
	     fillpoly(signed short numpoints,int polypoints[]),
	     pieslice(signed short x,signed short y,
		signed short stangle,signed short entangle,
				       signed short radius),
	     putpixel(signed short xpos, signed short ypos,
					    unsigned char color),
	     printimage(void);
   extern signed short textwidth(char *textbuf),
		    getmaxx(void),
		    getmaxy(void);

   extern unsigned char getcolor(void),
		     getpixel(signed short x,signed short y);

   unsigned long filelength(signed short fid);
   /*different for DOS*/
   void flashing_cursor(signed short startx,signed short endx,
	  signed short starty,signed short endy,
	  signed short xl,signed short yt,signed short xr,signed short yb,
			     unsigned char cursecolor);
#endif

#if __BORC__||__WATCOM__
   void flashing_cursor(signed short xl,signed short yt,signed short xr,
		    signed short yb,unsigned char cursecolor);
#endif


/************* new functions *************/
extern char event_ready(void);

/*functions moved from "run_forward()"*/
extern char
   select_stat_filename(void),
   moment(unsigned long edataruleno,
      char show_edata,char file_edata,char *thisrule,
	 float *edata,signed short n, unsigned char color1,
	    char fscale,char fsep,unsigned short stpwidth);
extern void
   glider_rule(char fscale,char fsep),
   /*frame for graph alongside space-time pattern*/
   draw_stpframe(signed short stpwidth,float eegwidth),
   interrupt_key_index(char frozen_islands,char rule_unmixed,
      char wiring_madelocal, char showlookupfreq,char lookup_entropy),
   draw_entgraph_frame(char draw_clear,
      signed short stpwidth, char show_edata,char ylabel),
   ent_3d(char *Zbuf,char *lambdabuf,
      unsigned long filebytes,char graphtype);
unsigned long stat_rule(char autostat,unsigned long statrule_index);

/************** declare functions 13 May 1993 ********************/
extern void
     draw_Derrida_plot(void),
     set_local_2d_wiring(unsigned short n,unsigned short *pnhood),
     draw_Hamming_plot(char draw_clear,signed short stpwidth),
     duplicate_net(void),
     /********** memory ***********/
     allocate_mem_buffers(void),
     free_mem_buffers(void),
     allocate_mem_CA_states(void),
     free_mem_CA_states(void),
     allocate_mem_rule0(char thisnhood),
     allocate_mem_rulemix(char thisnhood),
     reallocate_mem_rulemix(char thisnhood,char increace),
     free_mem_rule0(void),
     free_mem_rulemix(void),
     allocate_mem_tcode0(char thisnhood),
     allocate_mem_tcodemix(char thisnhood),
     reallocate_mem_tcodemix(char thisnhood,char increace),
     free_mem_tcode0(void),
     free_mem_tcodemix(void),
     allocate_mem_diffrules(char thisnhood,signed short nodiffrules),
     allocate_mem_diffcodes(char thisnhood,signed short nodiffrules),
     free_mem_diffrules(signed short nodiffrules),
     free_mem_diffcodes(signed short nodiffrules),
     allocate_mem_all_0s_all_1s_rules(char thisnhood),
     free_mem_all_0s_all_1s_rules(void),
     allocate_mem_nhood_matrix(char thisnhood),
     free_mem_nhood_matrix(char thisnhood),
     allocate_mem_Z_parameter(void),
     free_mem_Z_parameter(void),
     outof_memory(char *what),

     /******** ca parameters********/
     set_dif_nhoods(void),
     setup_nhood_matrix(char innernhood, char outernhood),
     setpback_x_lines(char xlines),
     select_linelength_singlebasin(void),
     select_linelength_31(void),
     select_linelength_range(void),
     select_nhood_size(char inbox),
     select_totalistic(void),
     select_seed(char *thisseed,char *text,char restore_box),
     transform_rule(unsigned short index),
     /*for tickoff array*/
     set_bitlong(char *array,unsigned long pos,char bit),
     define_bits(char nhoodz,char isrule,char *array,unsigned short leftpos,
		unsigned short rightpos,char cellscale,char cellsep),
     define_hex(char nhoodz,char isrule,char *array,signed short leftpos,
		signed short rightpos,float thisxtext),
     input_hex(char nhoodz,char isrule,char *array,signed short hexbyteposl,
					 signed short hexbyteposr),
     /*1 or 0 only, drawn as bars*/
     input_string_cell(char nhoodz,char isrule,char* array,
       unsigned short leftpos,unsigned short  rightpos,char stringtype,
	 signed short cellscale,signed short cellsep,signed short endx,
						    signed short endy),
     random_bits(char nhoodz,unsigned short blockdiam, char isrule,
		char hex, char *array, unsigned short leftpos,
			     char thisscale, char thissep),
     set_central_block(char *array,unsigned short blockdiam),
     dec_to_bit_line(char* bitline, unsigned long decvalue,
					    signed short size),
     select_pattern_scrolling(void),
     format_draw(void),
     set_mutation(void),
     set_bit_flips(void),
     select_stepforward(void),
     select_foreward_back(void),
     forward_only_para(void),

     wire_rule_extra_cell(char increace),
     upstream_only(void),
     run_forward(void),
     draw_range_single(void),
     draw_range_field(void),
     draw_field(void),
     progress_bar(void),
     print_field_data(void),
     next_line(float chwidth,float lineht),
     print_layered_bitstring(signed short foldpos,char *array,
	     unsigned short leftpos,char thisscale,
		     char thissep, char makerandom, char isrule),
     print_current_state(char *temp, signed short color),
     print_current_state_h(char *temp, signed short color),
     print_current_state_twod(char *temp, signed short color),
     show_rule_bottom(char nhoodz,char printout,char* thisrule,
					  unsigned short cellindex),
     open_graphics(char firstgraphics),
     setup_VGA_colors(void),
     setup_hires_colors(void),
     draw_intro_text(char firstgraphics),
     revise_text_size(void),
     setup_plot(void), /*set up viewport and level intervals*/
     amend_layout(void),
     set_layout_defaults(void),
     draw_layout_preview(void),

     show_statespace_matrix(char *thisstate),
     run_backward(void),
     pre_images(void),

     prepair_pre_rand(void),
     free_pre_rand(void),
     pre_images_rand(void),
     pre_exhaustive(void), /*find pre-images from pair array*/
     prestate_successor_pairs(void),/*set up state-successor pairs*/
     accept_pre_image(char *pre),
     interrupt_pre_fan(void),
     draw_basin(void),
     free_basin_memory(void),
     draw_fan(void),
     compute_heading(void),
     plot_motor(char savecoords,char *tempA),/*draw preimage fan,*/
     /*savecoords=1 to save co-ords, tempA=CA state*/
     /*draw nodes as spots, numbers or bitstrings etc*/
     plot_motor_segfan(char savecoords,char* tempA),
     draw_node(char* tempA,signed short nodecolor,char savecoords),
     copy_cycle_tree(char *tempA),
     copy_fan_tree(char *tempA),

     z_parameter_all(char nhoodz,char showz,char* thisrule),
     
     set_canalyzing_net(char forcezero),
     set_canalyzing_rule(unsigned short poss),
     repeating_seg_2d(char *array);

extern char* rotate_array(char nhoodz,char *array,char direction,
			   char isrule,signed short rotinterval);
extern char* rotate_array_2d(char *array,char direction,
			   signed short rotinterval);
			   
			   
void end_page(char cur_scale);


extern char
     canalyzing(char nhoodz,char showz,char* thisrule),
     rot_cycle_equiv_2d(register char *array),
     trans_sym_2d(register char *array),
     check_pre_image(char *pre_state),
     mutate_rule(char nhoodz),
     final_quit(void),
     select_cell_size(void),
     get_bitlong(char *array,unsigned long pos),/*for tickoff array*/
     print_rule_in_box(signed short ypos,char* thisrule);/*return nhood*/

extern unsigned char
     random_seed(unsigned char color1,
                 signed short rand_seed_percent),
     random_bitflip_state(unsigned char color1),
     random_block(signed short blockdiam,unsigned char color1),
     singleton_seed(unsigned char color1),
     singleton_neg_seed(unsigned char color1),
     bit_flip(char what,unsigned char color1),
     bit_flipback(unsigned char color1),
     wire_move(char what,unsigned char color1);

extern signed short
     vgax(signed short xcoord),
     vgay(signed short ycoord),
     memory_box(char showmem),
     set_nhdcolor(signed short nhood,signed short z),
     write_rule(char nhoodz,char printout,signed short xrulestart,
      signed short yrulestart,char* thisrule, unsigned short cellindex),
     print_current_bitstring_hexbytes(char isrule, char *array,char nhoodz,
		 signed short xright,signed short color,char printer),

     rot_cycle_equiv(register char *array),
     repeating_seg(register char *array),
     keycheck(signed short incount),
     input_string(char r, char stringtype);

extern unsigned short
     dec_equiv_sound(char *temparray,
		      signed short leftpos,signed short rightpos);

extern unsigned long
     dec_equiv(char *array, char leftpos),
     print_bit_line(char *temp,unsigned short size,unsigned short color,
			     signed short cellscale, signed short cellsep);

/************ mouse, boxes, graphs, save/load, printing etc ******************/
extern void
     change_drive_dir(char which),
     save_last_rule(char* rule,char thisnhood),
     load_glider_rule(char* rule,signed short fileno),
     load_glider_buf(signed short no_of_glider_rules),

     forget_graph(void), /*graph of probability of forgetting*/

     gofE_z_graph(void), /*graph of garden of Eden dencity - Z parameter*/
     biased_new_rule(void),
     draw_lambda_z_graph(char dontbias), /*graph of lambda-Z*/

     allocate_code_mem(void), /*to avoid plotting equiv codes*/
     
     show_pre_fansize_freq_hist(void),
     load_save_exhaustive(char load_save),

     save_data(char *buf),
     save_binary_data(unsigned char *buf,unsigned long sizeofbuf),

     save_screen(void),
     load_screen(void),
     /*create mouse*/
     mouse_call(int regeax,int regbx,  /*must be int*/
			  int regcx,int regdx),
     /***for printer*****/
     bitImage(signed short N),

#    if __BORC__||__WATCOM__
     printimage(char Land_Port,
      unsigned char notcolor1,unsigned char notcolor2,
	signed short x1,signed short y1,signed short x2, signed short y2),
#    endif

     select_print_style(void),
     print_option(void), /*offer print option*/
     print_out(char *array),
     draw_bottom_title(void),
     finish_options_box(char alloptions),

     get_prompt_box(char bufno,char lines), /*gets image of prompt box*/
     erase_prompt_box(char lines),
     draw_hint_box(char savehintbox,char* thistext,signed short startx),
     erase_hint_box(void),
     draw_box(char rememberbox,signed short xtopleft,signed short ytopleft,
		signed short xbotright,signed short ybotright,
			      char outline,signed short bcolor),
     erase_box(signed short xtopleft,signed short ytopleft,
		 signed short xbotright,signed short ybotright),
     myouttext(char *string), /*avoids gap before input (borland)*/
     finish_options(char alloptions);/*print-save-load-etc options*/
extern char
     select_filename(char *load_save,char *title,
			  char *extention,char *defname),
     select_list_files(char* filespec,signed short leftbox,signed short topbox),
     load_last_rule(char* rule,char thisnhood);

extern unsigned char
     getScrBits_Land( unsigned char notcolor1,
	   unsigned char notcolor2,signed short px, signed short py),
     getScrBits_Port( unsigned char notcolor1,
	  unsigned char notcolor2,signed short px, signed short py),
     load_save_wrs
	  (char load_save,char* wrsbuf,char wrstype);/*return nhood*/
extern signed short
     draw_prompt_box(char lines);  /*returns start x position of text*/
unsigned short load_rule_stats(void);/*rule list statistics*/


/************* random Boolean network functions *************/
/************* random wiring *************/
extern void
     allocate_mem_wiring(void),
     reallocate_mem_wiring(char increace),
     free_mem_wiring(void),
     select_wiring_options(void),
     wire_up_network(void),
     randomly_wire_cell(unsigned short  poss,unsigned short  maxL),
     oneD_local_wire_cell(unsigned short  poss,unsigned short  maxL),
     wireup_2d_nhood(signed short i, signed short j,
		   signed short itop,signed short jtop,
			    signed short ibot,signed short jbot),
     twoD_local_wire_cell(unsigned short i,unsigned short j),
     show_graphic_wiring_1d(char showrules),
     show_graphic_wiring_2d(char showrules),
     cell_out_freq(void), /*calc cell output-wire frequency*/
     print_wiring_cell(signed short startx, signed short starty,
						unsigned short poss);
    /*showout=1..shows output frequency histogram
      parts=1....pause on screen full
      startindex.. L-0
      return.....CA index reached*/
extern unsigned short
     load_save_nhoodmix(char load_save),
     print_wiring_scheme(char showout,char parts,unsigned short startindex);

/************* mixed rules *************/
extern void
     show_w_r_scheme(void),
     revise_rule_or_code(unsigned short thisposs,
		 signed short tablebytes,signed short codebytes),
     /*for 2-d space-time patterns*/
     draw_axon_plane(char fscale,signed short tempy,unsigned char color0),
     /************* learning algoritm *************/
     sculpt_basin_field(void),
     shuffle_order(signed short* array, signed short size),
     review_asp_pre_images(char par, char hamming,
	 unsigned long startdec,unsigned long enddec,
		  unsigned short prestep, char pre_range),

     setup_ppstack_hist(void),
     show_average_pp_hist(void);
     /*possibly different rules at each cell*/
extern signed short
     rule_selection(void), /*returns gety()*/
     select_rule(char inbox,char** thisrule,
	    signed short number_rules,unsigned short poss),
     select_code(char inbox,char** thiscode,
	 char** thisrule, signed short number_rules,unsigned short poss),
     reselect_rule_index(signed short cellindex,signed short number_rules);
extern char
     reselect_rule_prompts(signed short cellindex,char select);


