/************************* GLOBAL DATA 1 ************************/
#ifndef __BORLANDC__           /*borlandc compiler*/
#   define __BORLANDC__ 0
#endif
#define __BORC__ __BORLANDC__

#ifndef __386__       /*watcom c/386 compiler*/
#   define __386__ 0
#endif
#define __WATCOM__  __386__

#ifndef unix
#   define unix 0
#endif
#define __UNIX__ unix


#define kNumBoxImages		20
#define kNumBoxPromptImages	10


/********************************************************/
#if __WATCOM__
   #include <graph.h>
#endif
/********************************************************/
#ifndef EXT
   #define EXT extern
#endif

/* xwindows compatibility */
EXT signed short Leftx;
EXT unsigned short CWidth,
		   CHeight;

/*for watcom compiler*/
#if __WATCOM__
   EXT struct xycoord xy;       /*current x,y coordinates*/
   EXT struct textsettings ts;  /*current text settings*/
   EXT struct videoconfig vc;   /*curent video info*/
   EXT struct _fontinfo info;   /*info about font*/
   EXT unsigned char fillcolor; /*to fill inside rectangles etc*/
   EXT signed short fillpattern;
   EXT char title_file_found,
	    first_title;
   EXT void *title_image;  /*bottom title image*/
#endif
#if __UNIX__
   EXT Display *D;
   EXT int     S;
   EXT Window  W;
   EXT Drawable	*current_draw;
   EXT GC      Gc,GcRev;
   EXT XEvent  Event;
   EXT Cursor rightCursor, 
              leftCursor;
   EXT XFontStruct *font,
                   *propfont,
                   *italicfont;
   EXT char fonttype; /*non-prop=0, prop=1*/
   EXT signed short pointsize; /*of text font*/
   EXT unsigned short screen_depth;	/*depth of screen*/
   EXT Pixmap 
        *stpimage, /*space-time pattern image buffer for scrolling*/
        **boximage, /*pointer to image buffers for box*/
        **boximage_prompt, /*image buffer for prompt box */   
        *statblock; /*block for mean ent-standard dev of ent graph*/    
        
   EXT unsigned char oldcolor[15];
   EXT XRectangle viewport[1];
   EXT char inside_rect;/*pointer is inside drawing rectangle*/
   EXT signed short 
        getx,gety,
        putimageH,putimageW,
        pixmap_width; /*width of pixmap run_forward( and end_page(*/
   EXT signed short Maxx,Maxy,WinMaxy; 

   EXT unsigned char
    nowcolor, /*keeptrack of current forground color*/
    fillcolor,
    White,
    Black,
    Yellow,
    Gold, 
    Khaki,
    Wheat,
    Tan,
    Goldenred,
    Orange,
    Coral,
    Salmon,
    Red,
    Orange_Red,
    Indian_Red,
    Firebrick,
    Brown,
    Sienna,
    Maroon,
    Medium_Violet_Red,
    Violet_Red,
    Pink,
    Green,
    Spring_Green,
    Medium_Spring_Green,
    Green_Yellow,
    Pale_Green,
    Yellow_Green,
    Lime_Green,
    Medium_Sea_Green,
    Sea_Green,
    Forest_Green,
    Olive_Drab,
    Dark_Olive_Green,
    Dark_Green,
    Cadet_Blue,
    Medium_Aquamarine,
    Dark_Turquoise,
    Turquoise,
    Aquamarine,
    Cyan,
    Blue,
    Medium_Blue,
    Medium_Slate_Blue,
    Cornflower_Blue,
    Sky_Blue,
    Light_Blue,
    Light_Steel_Blue, 
    Steel_Blue,
    Dark_Slate_Blue,
    Navy,
    Navy_Blue,
    Midnight_Blue,
    /* extra */
    Ghost_White;
   EXT int *Color_Table;
   EXT Colormap default_cmap;
   EXT XColor color_def;
#endif

/************************* GLOBAL DATA 1 ************************/
/************** global variables 13 May 1993 ********************/

/*names for colors*/
EXT unsigned char   /*colors*/
		black,        /* 0 */
		blue,         /* 1 */
		green,        /* 2 */
		cyan,         /* 3 */
		red,          /* 4 */
		magenta,      /* 5 */
		brown,        /* 6 */
		lightgray,    /* 7 */
		darkgray,     /* 8 */
		lightblue,    /* 9 */
		lightgreen,   /* 10 */
		lightcyan,    /* 11 */
		lightred,     /* 12 */
		lightmagenta, /* 13 */
		yellow,       /* 14 */
		white,        /* 15 */

  matrixcolor, /*diff colors for each basin in state space matrix*/
  *is,    /*input string buffer*/
  *nhd,  /*pointer to array of nhood values-for CA cell colors*/
  *glider_buf, /*buffer to hold glider rules*/
  *statbuf;  /*buffer for rule statistical sample*/

EXT char        /*flags 0 or 1*/
  rules_set,    /*if mem for rules was allocated*/
  nhood_mixed,  /*different size nhoods at each cell*/
  ncolor,    	/*1-color acc to nhood, 0-color acc to value*/
  totalistic,   /*indicates a totalistic rule*/
  segfan,       /*condition found,1 for segmented fan, else 0*/
  allbitssame, 	/*1 for all 0s or 1s, else 0*/
  insegloop,   	/*inside the fan segment loop*/
  startsegfan, 	/*starting a new fan segment*/
  justonepreimage,  /*indicates 1 pre-image from point att*/
  pretog,      	/*to toggle **preim0 and **preim1*/
  earlyexit,   	/*allows interupt before pre-image fan is complete*/
  earlyexitbasin,   /*to note early exit for basin*/
  earlyexitfield,   /*   "      "        for field*/
  isrepeat,    	/* =1 if repeat found*/
  seed_was_set,	/*indicates new seed*/
  hires,       	/*0=VGA; 1=upgradeto IBM8514 1024 * 768*/
  scrolling,   	/*to select scrolling or successive pages*/
  nowscrolling,	/*to indicate scrolling in progress*/
  basinfield,   /*1=singlebasin, 0=basin of attraction field*/
  toggle_single_field, /*toggle above*/
  stp,	        /*to suppress space-time pattern*/
  fieldpause,	/*pause between fields*/
  rangeL,      	/*range of CA size*/
  mutantdontpause,  /*1=dont pause after mutant graphics, 0=pause*/
  acceptall,    /*accept all drawing defaults*/
  stppause,     /*1=DONT PAUSE on space-time screenfull, 0=pause*/
  screensavedemo, /*generates randomly located basins*/
  show_ss_matrix, /*show states on 2-d matris as basins are drawn*/
  show_ss_matrixF, /* as above forwards only*/
  ss_m_att_only, /*show attractor states only in state space matrix*/
  see_ppstack,  /*to see growth of partial pre-image stack*/
  diff_plot,    /*to plot difference between 2 networks*/
  exhaustive_testing, /*find pre-images by exhaustive testing*/
  dontcompress, /*dont compress basins/fields by symetries etc*/
  layout_notset, /*layout defaults to be set*/
  in_startbasin,
  in_startfield,
  successive_basins, /*show basin field as successive basins*/
  show_one_att_state,/*show one attractor state as bit pattern in each basin*/
  forward_only, /*forward only, just space-time patterns*/
  set_z_high,   /*search rule with high Z paramater*/
  secondpart,   /*first and second part of prog, after rules set*/
  showbits_1d_as_2d, /*to show 1d bit nodes in 2d*/

		/*flags more than 0,1*/
  accept_from,  /*accept defaults from.. all,layout,presentation,etc*/
  datapause, 	/*pause for tree data=2, basin only=1, default=0*/
  shownumbers, 	/*0-dont show,1-show,2-show bitstring*/
  dontcopytrees,/*0-copy trees,1-show g-E nodes,2-reduce g-E nodes*/
  pdata,	/*print data to printer, 1-basin only, 2-also tree data*/
  filedata,     /*data to file,          "             "   */
  mutate,/*5-code,4-code rand,3-rule,2-rule rand,1-onebit cum,0-bit single*/
  was_changed,  /*rule/s or wiring was changed, so dont mutate automaticaly*/
  stpgraph,     /*0=do nothing, 1=pattern density, 2=look up frequency*/
  pause_show_code,/*for lambda-Z graph totalistic codes*/

  /*char flags*/
  direction,	 /*'f'-forward, 'b'-back*/
  bground,       /*'b'-black, 'w'-white*/
  codetypeonly,  /*for lambda-Z graph totalistic codes
		   all codes-a, clusters-c equivs-e*/

     *nhoodm,   /*for different nhood size at each cell*/
     *rot,      /*for segment repeats,equivalent cycle states etc */
     *exh_pairs, /*array for exhaustive pairs*/
     **nm,     /*nhood_matrix top left 4,31...bottom right 0,0*/
     *canal,   /*for canalyzing inputs*/
     *iscanal,   /*to distinguish canalizing cells (genes)*/
     **carule,     /*pointer to pointers to rule tables*/
     **cacode,     /*pointer to pointers to totalistic code tables*/
     **diffrule, /*limited set of rules for rulemix*/
     **diffcode, /*limited set of codes for rulemix*/
     *arule,      /*array for any size nhood rule in backwards proc.*/
     *arule1,     /*another...*/
     *arule2,     /*another......*/
     *A,                  /*pointer to active ca line - bits*/
     *F,                  /*           next                 */
     *B,                  /*           previous             */
     *bitseed,            /*           seed                 */
     *firstseed,          /*           seed for pre-images  */
     *all_0s,             /*	       all_0s*/
     *all_1s,             /*	       all_1s*/
     *tempState,    /*pointer to temp state, attractor or pre-image*/
     *tempState2,   /* another, for tickoff*/
     **segseed,   /*pointer to pointers of first state in each segment of
			pre-image fan for all 0s and 1s*/
     nhood,  /*nhood=size of neighbourhoods, or upper bound if different sizes*/
     
     nhood_lb, /*lower bound if different sizes*/
     nhood_ub, /*upper bounds*/
     *p;     /*start string assumed for goback*/

EXT unsigned short canaltotal; /*total canalyzing inputs in nhood*/
EXT signed short
    tx1,tx2,ty1,ty2, txd,tyd, /*for text sizes and default text sizes*/
    globax,globbx,globcx,globdx, /*for mouse*/
    mouse_x,mouse_y;  /*position of mouse*/

EXT char mouse_found, /*1 if found, 0 if not*/
     button, /*if pressed - 'l' or 'r'*/
     button_not_rel; /*if not releaced - 'l' or 'r'*/

EXT unsigned long
     totalgraphrules,/*no of rules in G-density or lambda-Z graphs*/
     endcount; /*counts mutants for gd-z graph*/

EXT signed short
    scrolly, /* lowest row for scrolling*/
    Maxint, /*=32767 max signed signed short*/
    lambda_bias, /*bias lambda ratio when setting random rule*/
    totcode_eq_or_cl,/*total code equivalents or clusters*/
    gens,   /*no of generations for analysis*/
    frozen_gens, /*no of generations to highlight frozen cells*/
    msize, /*size if state space matrix*/
    *seg,   /*pointer to
		size of segments of pre-image fan for all 0s and 1s*/
    *seg_2d_h, /*same for 2d, horiz and*/
    *seg_2d_v, /*             vertical*/

    /*to see partial pre-image stack growth, rnd wiring*/
    pp_startx0,pp_starty0,pp_startx,pp_starty,
    pp_widthx,pp_depthy,pp_heighty,
    pp_divy,pp_barwidth,pp_bartotw,pp_wild,

    no_glider_rules[10], /*number of glider rules saved for diff nhoods*/
    repseg_2d[2];/*length repeating segments horiz-0, vert-1*/
EXT unsigned short
    /*two-d*/
    cyclematch_2d[2],     /*no of rotation equivalent cols/rows in cycle*/
    cyclematch_2d_diag[2];/*  "      diagonal shifts, pos or neg     */


EXT unsigned long /*to find average histogram*/
      pp_wild_tot,
      pp_histcount,
      *pp_hist_total,
      matrixx,matrixy; /*state space matrix, max x,y axis*/


EXT unsigned short
	 Maxu, /* max unsigned short in = 65535*/
	 pp_hist_max, /*max stack in 2 latest histograms*/
	 *pp_hist,/*pointer to actual pp stack for each cell, rnd wiring*/
	 pp_ymax, /*max anticipated pp stack, rnd wiring*/
	 segno, /*no of segments in pre-image fan from all 0s and 1s*/
         segindex, /*index of fan segments, all 0s or 1s*/
	 startL,endL, /*start and end sizes for range*/
	 lineL,    /*line length no of cells in array, L,L-1,.....,0*/
	 ppL, /*check for new line length to view pp stack growth*/
	 L,        /*L=lineL-1, index of 1st array cell*/
	 bytesL,     /*no of bytes in bitseed*/
	 rangebytesL,     /*no of bytes in rangeseed*/

	 /*one-d*/
	 cyclematch,  /*no of rotation equivalent segments in cycle*/
	 attrepseg, /*length of equiv. segments in attractor state*/

	 /*two-d*/
	 attrepseg_2d_h,/*colums,  no repeating in toroidal bit array,*/
	 attrepseg_2d_v,/*rows,    same for all states on att cycle*/
	 basinno_2d_h,/*basin with states rotated horiz by 1*/
	 basinno_2d_v,/*for each above, basin with states rotated vert by 1*/

	 attrepseg_2d_patch,/*patches*/

	 level,     /*current level*/
	 thisindex, /*index in current level*/
	 nextindex, /*index in next level*/
	 nextbefore,/*index before start of pre-image fan*/
	 thismax,   /*no of states in current level*/
	 nextmax,  /*   "     "       next    "   */
	 fansize,     /*size of pre-image fan*/
	 maxtreelevel,   /*max level in given tree*/
	 maxbasinlevel,  /*max level in given basin*/
	 totbasinsinfield;  /* total no of basins*/

EXT signed long wires_to_move, /*when mutating by wire moves*/
	    bits_to_flip;  /*  "      "    by bit flips*/
EXT unsigned long
	      totalsegfan, /*total states in segfan*/
	      attperiod,  /*attractor period*/
	      stepforward,  /*itterations forward before going backward*/
	      precount,   /*counts pre-images*/
	      pretested,  /*count of states tested*/
	      thisstart,  /*total count of first state in current level*/
	      gofEno,     /*count of garden of Eden states in tree*/
	      totalgofE,  /*  "     total        "        in basin*/
	      totalprecount, /*total states*/
	      treesize,    /*size of given tree or sub-tree*/
	      totsubtree,  /*total "        "      "       */
	      basinsize,   /*total no of states in basin*/
	      totatt_states, /*total no of attractor states */
	      maxtreefan,  /*max size of pre-image fan in given tree*/
	      maxbasinfan,
	      maxfieldfan, /*                            in field*/
	      fieldsize, /*size of field - check against state space*/
	      fieldgofE; /*count of garden of Eden states in field*/


EXT float

      cinputfreq, /*fraction canalyzing inputs*/
      xtext,  /*start position of text in textwidth units*/
      fieldgofEdensity, /*dencity of g of E states in field*/
      basingofEdensity, /*  "          "      "    in basin*/
      totsubgofEdensity,/*  "          "      "    in subtree*/
      segfanangle;      /*small angle between segfan pre-images*/


