/***************** run forwards ***********************/
#include "edecfunc.h"
#include <fcntl.h>
#if __BORC__||__WATCOM__
#   include <io.h>
#   include <sys\stat.h>
#elif __UNIX__
#   include <sys/types.h>
#   include <sys/uio.h>
#endif

/*variables for difference plot*/
typedef struct diff_var {
   char  pause_dam_hist,
         d_bin_type;           
   unsigned short  
                 *damage_buf,
                 diff_sample_count,
                 damage_count,
                 old_damage_count,
		 d_maxy,
                 d_histno,
                 d_ittcount,
                 max_d_hist,
                 min_d_hist,
                 same_limit;  
   signed short 
              d_leftx,
              d_topy,
              d_boty;
   double 
        d_divx,
        d_divy, 
        d_height,
        d_width;
   float percent_damage;
} diff_var;

#if __UNIX__
void reallocate_pixmap(short left, short top, short width,
		 short height, Pixmap *the_pixmap);
#endif

/*statistical sample */
void setup_diff_plot(diff_var *dp);
void show_diff_plot(diff_var *dp);
void draw_diff_graphframe(char first, char xlog,diff_var *dp);

/****for Unix, allocate the offscreen pixmap referred to by pointer****/
#if __UNIX__
void reallocate_pixmap(short left, short top,
		short width, short height,Pixmap *the_pixmap){
	/*If the pixmap already exists, free it first*/
	if (*the_pixmap != 0)
		freeimage(the_pixmap);
	/*Now create one with the new size*/
	getimage(left, top, width, height, the_pixmap);
}
#endif

/******* run CA forward, find attractor cycle, 13 May 93 **********/
void run_forward(void){

# if __BORC__||__WATCOM__ /*not xwindows*/
     unsigned long imsize; /*for current block plot in stat graph*/
# elif __UNIX__
     Pixmap *offscreen_pixmap;
# endif

 diff_var dp; /*declaring structure for diff plot*/

 /*damage_extra=0,diff_sample_count=1*/
 unsigned long edataruleno=0, /*rule count for statistics plot*/
	     statrule_index, /*index for loading stat sample rules*/
	     frozen_1s,frozen_0s; /*to show % frozen*/
 unsigned short n,
	  sstep, /*start time-step for entropy data*/
	  estep, /*end time-step for entropy record*/
	  *pnhood, /*memory for pseudo-nhood*/
	  notocheck=0,
	  zu,zu1,
          same_count;
 signed short
    u, /*index into rule table*/
    z,zz,ylimit,
    xbox,ybox,tempx,tempy,newbar,newbar0,temp,
    startxbox,startybox,thisxbox,thisybox,
    xboxmax,yboxmax,barno,barlength,
    xspace,xpix,
    stpwidth,   /*width of space-time pattern+10*/
    tablemax,
    *eegcount,
    **lookupcount, *oldbar,
    tempbytesL,
    strip,step,downy,
    tot_eegcount,
    tot_lookupcount,
    actgens, /*actual generatios for analysis if less than gens*/
    diffgap,
    tempdiffx,
    tempdiffy,  
    topleftx,
    toplefty,   
    ii,jj;

#if __BORC__||__UNIX__
   int poly[8];
#elif __WATCOM__
   signed short poly[8];
#endif

 unsigned char
	ecolor, /*color for eeg-entropy graph*/
	*tempnhd,/*temp pointer for nhood colors for changing CA size*/
	nhdcolor, /*cell color according to n'hood*/
	color1,color0,
	thiscolor,
        diffcolor;   
 unsigned long ittcount=0;       /*counts states forward itterations*/
 /*width of eeg, nhood lookup frequency graph, width of frequency bar*/
 float *edata, /*to save entropy data*/
       eegwidth,lookupfreqwidth,barw,
       pixposx,pixposy,
       axo_cell_h,aa,wx,polyx,polyy;/*cell distorted by 45 deg*/
 double eegratio,
	eegratiobefore,
	lookupratio,
	entropy;
 char tempstp,tempcolor, 
     i,itt_step=0,tempchar,
     isdiff,
     cell_not_changed=0,
     frozen_islands=0,
     **lastA, /*state at timestep t-1,t-2,...t=10*/
     *temppoint, /*temp pointers for swaping char arrays, 
                   and chang CA size*/
     **rcheck,
     repeatfound=0,
     flipmem=0,
     screenend=0,
     showeeg,
     showlookupfreq=0,
     lookup_entropy=0,
     show_edata=0,
     file_edata=0, /*to file statistical data*/
     automatic_was_set=0,
     barsep=0,
     keyindex, /*flag keyindex shown*/
     oldnhood, /*in case rule with diff nhood is loaded*/
     resetscreen=0,
     rule_unmixed=0,     /*to toggle mixed-single rule/s*/
     fscale,fsep,
     Hamming_plot=0;
     signed short Ham_t0,Ham_t1;
#    if __BORC__||__WATCOM__ /*not xwindows*/
        char makesound=0;
#    endif

   if (limitcheck>0 && direction=='f') diff_plot=0;
   /*set up diff statistical sample  */    
   if (diff_plot==3) setup_diff_plot(&dp);

   /*do this for "forwards only" and single basins, not for fields
   or subtrees*/
   if (exhaustive_testing==2 && !basinfield && direction=='f'){
	is[0]=0;
	prestate_successor_pairs();
	if (is[0]=='q') goto exitFunc;
   }
   /*show index to interrupt keys*/
#  define showkey  interrupt_key_index(frozen_islands,rule_unmixed,\
	     wiring_madelocal,showlookupfreq,lookup_entropy);

   tempstp=stp;
   wiring_madelocal=0;
   fscale=scale;
   fsep=sep;
   if (fscale>vgax(5)) fsep=2;
   else fsep=1;
   if (gens<1) gens=1;
   

   /*memory for pseudo-nhood*/
   if ((pnhood=(unsigned short *)calloc(nhood,sizeof(unsigned short)))
			      ==NULL) outof_memory("pnhood");

   if ((direction=='f' && limitcheck>0) || direction=='b') 
                                    ncolor=stpgraph=diff_plot=0;
   /*looking for attractor - basins*/
   if (direction=='f' && limitcheck>0){
      if ((rcheck=(char**)calloc(1,sizeof(char*)))
			      ==NULL) outof_memory("rcheck");
      if ((rcheck[0]=(char *)calloc(bytesL,sizeof(char)))
			      ==NULL) outof_memory("rcheck[0]");
      memcpy(rcheck[0],A,bytesL);  /*seed input for repeat check*/
      if ((att=(char**)calloc(1,sizeof(char*)))
			      ==NULL) outof_memory("att");
   }
   /*set width if space-time pattern for attractor basins, 
     reset for stp only*/
   if (twod==0) stpwidth=lineL*fscale;   
   else if (twod==2) stpwidth=lineL*fscale/i2d;
   
   if (direction=='f' && limitcheck==0){ /*forwards only*/

      /*memory for entropy data*/
      sstep=30;
      estep=430;

#     if __BORC__||__WATCOM__ /*xwindows*/
	 /*size of block for current statistics plot,
         statblock is global*/
	 imsize=imagesize(0,0,5,5);

	 if ((statblock = malloc(imsize)) == NULL){
	    draw_prompt_box(1);
	    sprintf(textb[0],"Out of memory! image, return-abort");
	    getch();
	    final_quit();
	 }
#     endif

      /*nominal size array*/
      if ((edata=(float *)calloc(1,
	     sizeof(float)))==NULL) outof_memory("edata");

      /*nominal calloc of buffer to hold statistical rule sample*/
      if ((statbuf=(char *)calloc(1,
	     sizeof(char)))==NULL) outof_memory("statbuf");
      totstatrules=0; /*stat rules not yet loaded*/

      /*allocale mem prevoius states, at timestep t-1,t-2,...etc*/
      if ((lastA=(char**)calloc(frozen_gens,sizeof(char*)))
				       ==NULL) outof_memory("lastA");
      for (z=0;z<=frozen_gens-1;z++){
		 sprintf(textb[0],"lastA[%d]",z);
		 if ((lastA[z]=(char *)calloc(bytesL,sizeof(char)))
						==NULL) outof_memory(textb[0]);
      }
      /*position of bitflip - to allow flipback*/
      if ((flippos=(signed short *)calloc(1,sizeof(signed short)))==NULL)
		outof_memory("flippos");

      flipmem=1;
      diffgap=3; /*gap between sub-networks*/
      /*set width of pattern including gaps*/
      if (twod==0){
         stpwidth=lineL*fscale+vgax(10);
	 if (diff_plot) stpwidth+=diffgap*fscale+(lineL/2)*fscale+vgax(10);
      }
      else if (twod==2){
	 if (diff_plot) stpwidth=
                 lineL*fscale/i2d+fscale*diffgap+vgax(10);
	 else stpwidth=lineL*fscale/i2d+vgax(10);
      }

      showeeg=0;
      /*set width of graphs*/
      eegwidth=lookupfreqwidth=vgax(100);
      /*
      if (stpgraph==1 && twod!=2){		
	 draw_stpframe(stpwidth,eegwidth);
	 showeeg=1;
      }*/

      /*set up state space matrix*/
#     define reset_matrix \
	   if (show_ss_matrixF) show_statespace_matrix(NULL);

      reset_matrix;

#     define set_entropy_pix_color \
	  if (lookup_entropy || Hamming_plot){	\
	      if (ecolor==yellow) ecolor=lightred;\
	      else if (ecolor==lightred) ecolor=lightcyan;\
	      else if (ecolor==lightcyan) ecolor=green;\
	      else if (ecolor==green) ecolor=white;\
	      else if (ecolor==white) ecolor=yellow;\
	  }

      if (showeeg==1){
	  /*alloc mem to eegcount for each generation*/
	 if ((eegcount=(signed short *)calloc(gens,sizeof(signed short)))
				   ==NULL)  outof_memory("eegcount");
	 tot_eegcount=0;
	 for (z=L; z>=0; z--){
	    if (get_bit(A,z)) tot_eegcount+=1;
	 }
	 eegratiobefore=(double)tot_eegcount/lineL;
      }
      showlookupfreq=0;

      if (stpgraph>1 && twod!=2 && !nhood_mixed){
	 if (stpgraph==2) showlookupfreq=1;
	 else showlookupfreq=2;
	 tablemax=(signed short)pow(2,(double)nhood)-1;
	 if ((lookupcount=(signed short**)
                calloc(gens,sizeof(signed short*)))
			==NULL) outof_memory("lookupcount");
	 /*alloc mem to lookupcount for each nhood*/
	 for (z=0;z<=gens-1;z++){
	    sprintf(textb[0],"lookupcount[%d]",z);
	    if ((lookupcount[z]=(signed short *)calloc
		   (tablemax+1,sizeof(signed short)))
			    ==NULL) outof_memory(textb[0]);
	 }
	 /*alloc mem for size of old bar*/
	 if ((oldbar=(signed short *)
                calloc(tablemax+1,sizeof(signed short)))
			     ==NULL) outof_memory("oldbar");

	 /*if (twod!=2) draw_stpframe(stpwidth,lookupfreqwidth);*/

	 startxbox=stpwidth+(signed short)lookupfreqwidth+vgax(10);
	 xboxmax=startxbox+(signed short)lookupfreqwidth;
	 startybox=vgay(57);
	 barno=tablemax+1;
	 if (barno>128) barno=128; /*as for nhood=7*/
	 barw=(float)(Maxy-startybox)/barno;
	 if (barw>6) barw=6;
	 yboxmax=startybox+(signed short)barw*barno;
	 barsep=2;
	 draw_box(-1,startxbox-3,startybox-2,xboxmax+2,yboxmax+1,1,0);

	 if (nhood<8) barlength=(signed short)lookupfreqwidth;
	 else barlength=(signed short)
                    lookupfreqwidth/((tablemax+1)/barno);
      }
   } /*if forward only*/

#  if __UNIX__
      /*allocate mem for pixmap*/
      if ((offscreen_pixmap =
          (Pixmap *)malloc(sizeof(Pixmap *))) == NULL)
		outof_memory("Pixmap pointer");

      *offscreen_pixmap = 0;

      if (twod){
         pixmap_width=fscale*i2d+1;
         /*allow for division*/
         if (diff_plot) pixmap_width+=(fscale*diffgap);
         reallocate_pixmap(0,0,pixmap_width,
		              fscale*j2d+1, offscreen_pixmap);
      }
      else if (twod==0){        
	 pixmap_width=stpwidth+1;
         /*allow for graph*/
         if (stp && limitcheck==0 && direction=='f'
	        && (showlookupfreq==1 || showeeg==1)){ 
            pixmap_width+=(signed short)eegwidth;           
         }
         reallocate_pixmap(0,0,pixmap_width,Maxy,offscreen_pixmap);
      }      
#  endif
	
   ittcount=attperiod=0;
   if (stp){
      color0=black;
      color1=yellow;
      seed_was_set=1;    /*indicates a new seed set with key 4*/
      /*
      setviewport(0,0,lineL*fscale+2,Maxy,1);
      if (twod==2){ 
         setviewport(0,0,lineL*fscale/i2d+2,
                              Maxy,1);
      clearviewport();
      setviewport(0, 0, Maxx, Maxy, 1);
      */
      if (direction=='f' && limitcheck==0){
	 /*show index to interrupt keys*/
	 showkey;
	 keyindex=1;
      }
      moveto(0,0);
   }
   if (limitcheck==0 && direction=='f'){ 
      /*draw frame to window*/
      if (stpgraph && twod!=2) draw_stpframe(stpwidth,eegwidth);
     /*draw frame to pixmap*/ 
#     if __UNIX__
         *current_draw = *offscreen_pixmap; 
         if (stpgraph && twod!=2) draw_stpframe(stpwidth,eegwidth);
         *current_draw = W;        
#     endif
   }
   if (twod){
      /*draw frame*/
      /*if plotting difference between 2 equalsize/shape  networks
      draw 2 frames seperated by a 3 cell gap*/
#     if __BORC__||__WATCOM__
#     define draw_2d_frame {                           \
	  setcolor(white);                             \
	  if (diff_plot){                              \
	      rectangle(0,0,fscale*(i2d/2)+1,fscale*j2d+1); \
              rectangle(fscale*(i2d/2)+fscale*diffgap-1,0,  \
                   fscale*i2d+fscale*3+1,fscale*j2d+1);     \
	      topleftx=(fscale*(i2d+diffgap))/4;        \
	      toplefty=fscale*(j2d+diffgap);                \
	      rectangle(topleftx-1,toplefty-1,              \
		topleftx+fscale*(i2d/2),toplefty+fscale*j2d);\
	  }                                                 \
	  else rectangle(0,0,fscale*i2d+1,fscale*j2d+1);    \
      }
#     elif __UNIX__
#     define draw_2d_frame {                            \
	  *current_draw = *offscreen_pixmap;            \
	  setcolor(white);                              \
	  if (diff_plot){                               \
	      rectangle(0,0,fscale*(i2d/2)+1,fscale*j2d+1); \
	      rectangle(fscale*(i2d/2)+fscale*diffgap-1,0,  \
		   fscale*i2d+fscale*3+1,fscale*j2d+1);     \
	  }                                                 \
	  else rectangle(0,0,fscale*i2d+1,fscale*j2d+1);    \
	  *current_draw = W;                                \
          if (diff_plot){                                   \
	     topleftx=(fscale*(i2d+diffgap))/4;             \
	     toplefty=fscale*(j2d+diffgap);                 \
	     rectangle(topleftx-1,toplefty-1,               \
		topleftx+fscale*(i2d/2),toplefty+fscale*j2d);\
	  }                                                  \
      }
#     endif

      axo_cell_h=sin(PI/4)*fscale;
      wx=fscale*i2d;
      aa=axo_cell_h*j2d;
      if (twod==2) draw_2d_frame;  /*gets erased in xwindows??*/   
      if (twod==3){
	  if (fscale>vgax(5)) fsep=2;
	  else fsep=1;
	  strip=downy=0;
	  polyx=0;
	  polyy=aa;
	  moveto(polyx,polyy);
	  draw_axon_plane(fscale,gety,color0);
      }
   }
   /*clear the difference plot buffer to retain damaged cells*/
#  define clear_diff_plot {\
      for (zu=0;zu<=bytesL;zu++) tempState[zu]=0;\
   }
   if (diff_plot) clear_diff_plot; /*clear the difference plot buffer*/
   same_count=0; /*steps that diff pattern doesnt change*/ 

   while (1) {
        if (diff_plot==3 && dp.d_ittcount==ittcount)
                       random_bitflip_state(color1);
	/*memory_box(1);*/
	ittcount++;
	actgens=gens;
	if (ittcount<gens) actgens=ittcount;

	/**** random_graphs ********/
	if (exhaustive_testing==2){
	   if (stp){
	      print_current_state(A,lightred);
	      end_page(fscale);
	   }
	   memcpy(F,exh_pairs+dec_equiv(A,L)*bytesL,bytesL);
	   goto skip_for;
	}
        frozen_1s=frozen_0s=0;

#       if __UNIX__                 
           /*draw lines to scroll frame*/    
           if (nowscrolling==1 && twod==0 && stp){   
              tempcolor=getcolor();  
              *current_draw=*offscreen_pixmap; 
	      setcolor(red);                     
	      for (z=0;z<=4;z++){
                 if (stpgraph==2 && z>0 && z<4) continue;
                 if (fscale==1) putpixel(stpwidth+
                               (eegwidth/4)*z,gety,red);
                 else line(stpwidth+(eegwidth/4)*z,gety,
                            stpwidth+(eegwidth/4)*z,gety-fscale);
	      }                                      
              *current_draw=W;
           }
#       endif                  

	/*scan CA line from left to right -->*/
	for (n=L; n!=Maxu; n--){
	   /*local nhood with periodic boundary conditions*/
	   if (nonlocal==0 || (!twod && wiring_madelocal==1)){
	      /*i.e. for nhood=9 lineL=3 to work*/
	      if (L<nhoodm[n]/2){
		 for (i=0;i<=nhoodm[n]-1;i++){
		    temp=lineL+n-(nhoodm[n]/2)+i;
		    if (temp<0) temp+=lineL;
		    pnhood[i]=abs(temp)%lineL;
		 }
	      }
	      else{
		 for (i=0;i<=nhoodm[n]-1;i++)
			pnhood[i]=(lineL+n-(nhoodm[n]/2)+i)%lineL;
	      }
	   }
	   /*set local 2d wiring*/
	   else if (loc_twod_fonly || (twod && wiring_madelocal==1))
		set_local_2d_wiring(n,pnhood);
	   /*nonlocal=1, get psuedo-nhood from wiring scheme*/
	   else{
	      for (i=0;i<=nhoodm[n]-1;i++) pnhood[i]=wiring[n][i];
	   }
	   /*show space-time pattern - print current cell, cell value*/
	   if (stp){
	      /*color cell according to value, (or if frozen)*/
	      if (ncolor==0 || seed_was_set==1) {
		  /*chech for frozen state in last x generations*/
		 if (frozen_islands && direction=='f' && limitcheck==0){
		    cell_not_changed=0;
		    if (ittcount>frozen_gens){
		       /*check cell not changed since last time-step*/
		       cell_not_changed=1;
		       if (get_bit(A,n)!=get_bit(lastA[0],n))
						    cell_not_changed=0;
		       /*if same check if x previous generations frozen*/
		       if (cell_not_changed==1){
			  for (z=1;z<=frozen_gens-1;z++){
			     if (get_bit(lastA[z-1],n)!=get_bit(lastA[z],n)){
				cell_not_changed=0;
				break;
			     }
			  }
		       }
		       /*if cell frozen for x previous gens*/
                       /*frozen cells: 1=lightred ,0=red rest=background*/
                       if (frozen_islands==2){
                          if (cell_not_changed==1){
                              if (get_bit(A,n)==1){ 
                                  thiscolor=lightred;
                                  frozen_1s++;
                              }
			      else{
				  thiscolor=green;
				  frozen_0s++;
                              }
		          }
			  /*color changing cell as background*/
			  else thiscolor=black;
                       }
                        /*frozen cells lightred rest normal*/
		        else if (frozen_islands==1){ 
                           if (cell_not_changed==1)  thiscolor=lightred;   
                           else{ /*if cell_not_changed==0, cell did change*/
		              /*color changing cell as normal*/
		              if (get_bit(A,n)==1) thiscolor=color1;
		              else thiscolor=color0;
                           }
                        }		 
    	            }
		 }
                 /*normal color*/
                 else if (frozen_islands==0){                   
			if (get_bit(A,n)==1) thiscolor=color1;
		        else thiscolor=color0;                   
		 }

		 if (twod!=3){
		    /*1d or 2d - draw cells by value*/		    
#                   if __BORC__ || __WATCOM__ /*not xwindows*/
		       if (fscale==1) putpixel(getx,gety,thiscolor);
		       else if (getpixel(getx,gety)!=thiscolor){
			   setfillstyle(SOLID_FILL,thiscolor);
				bar(getx,gety,getx+fscale-fsep,
						gety+fscale-fsep);
		       }		    
#                   elif __UNIX__ /*draw to pixmap*/
                       if (twod!=1) *current_draw = *offscreen_pixmap;
		       if (fscale==1) putpixel(getx,gety,thiscolor);
                       else { 
            	          setfillstyle(SOLID_FILL,thiscolor);
	       		  bar(getx,gety,getx+fscale-fsep,gety+fscale-fsep);
		       }		    	
                        if (twod!=1) *current_draw = W; /*draw to window*/ 
#                   endif	      
		    moverel(fscale,0);
		 }
		 /*  2______3  2-d space-time patterns in 3-d axonometric
		     /     /
		    /     /
		   /     /
		  /_____/
		 1      4      */
		 else{
		    step+=1;
		    if (cell_not_changed==1 ||
			     (get_bit(A,n)==1 && frozen_islands<2)){
		       setcolor(thiscolor);
		       /*1st vertex*/
		       poly[0] =polyx+(step-1)*fscale;
		       poly[1] =polyy-sin(PI/4)*strip*fscale;
		       if (fscale==1) putpixel(poly[0],poly[1],thiscolor);
		       else{
			  /*2nd*/
			  poly[2] =poly[0]+axo_cell_h;
			  poly[3] =poly[1]-axo_cell_h;
			  /*3rd*/
			  poly[4] = poly[2]+fscale;
			  poly[5] = poly[3];
			  /*4th*/
			  poly[6] = poly[0]+fscale;
			  poly[7] = poly[1];
			  setfillstyle(SOLID_FILL,thiscolor);
			  /* draw a filled polygon */
			  fillpoly(4, poly);
		       }
		    }
		 }
	    }
            /*print current cell, nhood value*/
	    if (ncolor==1 && seed_was_set==0){
	       if (nhd[n]>0){
		  nhdcolor=set_nhdcolor(nhoodm[n],nhd[n]);
		  if (nhd[n]==(signed short)pow((double)nhoodm[n],2)-1)
						       nhdcolor=white;
	       }
	       else nhdcolor=color0;	
	       if (twod!=3){

#                 if __UNIX__   /*draw to pixmap*/
		      if (twod!=1) *current_draw = *offscreen_pixmap;	
#                 endif	
		  if (fscale==1) putpixel(getx,gety,nhdcolor);
		  else{ 
		     setfillstyle(SOLID_FILL,nhdcolor);
		     bar(getx,gety,getx+fscale-fsep,gety+fscale-fsep);
		  }                                
#                 if __UNIX__
		       if (twod!=1)*current_draw = W; /*draw to window*/
#                 endif			      
		  moverel(fscale,0);
	       }
	       else{
		  step+=1;
		  if (get_bit(A,n)==1){
		     if (nhdcolor==0) nhdcolor=white;
		     setcolor(nhdcolor);		
		     /*1st vertex*/
		     poly[0] =polyx+(step-1)*fscale;
		     poly[1] =polyy-sin(PI/4)*strip*fscale;
		     if (fscale==1) putpixel(poly[0],poly[1],nhdcolor);
		     else{
			/*2nd*/
			poly[2] =poly[0]+axo_cell_h;
			poly[3] =poly[1]-axo_cell_h;
			/*3rd*/
			poly[4] = poly[2]+fscale;
	       	        poly[5] = poly[3];
			/*4th*/
			poly[6] = poly[0]+fscale;
			poly[7] = poly[1];
			setfillstyle(SOLID_FILL,nhdcolor);
			/* draw a filled polygon */
			fillpoly(4, poly);
		     }
		  }
	       }
	     }
	   }
	   u=0; /*find dec value of actual or pseudo-nhood*/
	   for (i=nhoodm[n]-1;i>=0;i--)
	       u+=get_bit(A,pnhood[i])*(signed short)pow(2,(double)i);
	   /*set cell next line according to rule look-up table*/
	   if ((!rulemix)||rule_unmixed){
	      set_bit(F,n,get_bit(carule[0],u));
	   }
	   else set_bit(F,n,get_bit(carule[n],u));
	   nhd[n]=u;  /*keep track of nhood that was looked up*/
	   /*count nhood look up frequency*/
	   if (showlookupfreq && stp) lookupcount[0][u]+=1;
           /*create diffgap  cell gap*/
	   if (((lineL-n)%(lineL/2)==0) &&               
                     diff_plot && stp && !twod && n<lineL && n>0){
               setfillstyle(SOLID_FILL,black);
	       bar(getx,gety-fscale,getx+fscale*diffgap,gety);
               moveto(getx+fscale*diffgap,gety);  
           }
	   if (stp && twod>1){
	      if ((lineL-n)%i2d==0){
		 if (twod==2)  moveto(0,gety+fscale);
		 else if (twod==3){
		    step=0;
		    strip+=1;
		    polyx=sin(PI/4)*strip*fscale;
		 }
	      }
	      else if (diff_plot && twod==2 && (lineL-n)%(i2d/2)==0)
		  moveto(getx+fscale*diffgap,gety);
	   }
	} /***** next n (cell)*******/

	if (stp){
	   if (direction=='f' && limitcheck==0){
	     tempx=getx;
	     tempy=gety;
	     if (frozen_islands==2){
		xbox=Maxx-vgax(160);
		draw_box(-1,xbox-3,2,Maxx-2,2+CHeight+vgay(6),1,0);
		moveto(xbox,gety);
		sprintf(textb[0],"frozen: 0=%.1f%% 1=%.1f%% t=%.1f%%",
		  (float)(frozen_0s*100)/lineL,(float)(frozen_1s*100)/lineL,
			    (float)((frozen_0s+frozen_1s)*100)/lineL);
		outtext(textb[0]);
	     }
	     if (showeeg==1 || lookup_entropy){
		for (z=L; z>=0; z--){
		   if (get_bit(A,z)) eegcount[0]+=1;
		}
		tot_eegcount=0;
		for (zz=0;zz<=actgens-1;zz++) tot_eegcount+=eegcount[zz];
		eegratio=(double)tot_eegcount/(lineL*actgens);
		if (showeeg==1){
		   setcolor(white);
		   if (twod!=2){
		      moveto(stpwidth+(signed short)ceil
			  (eegwidth*eegratiobefore),gety-fscale);

#                     if __UNIX__ /*draw to pixmap*/
                         *current_draw = *offscreen_pixmap;
#                     endif	
		      lineto(stpwidth+(signed short)ceil
			  (eegwidth*eegratio),gety+fscale);	    	
#                     if __UNIX__ /*draw to screen*/
                         *current_draw = W; /*draw to window*/
#                     endif		     
		   }

		}
		/*shunt generations*/
		for (zz=actgens-1;zz>=1;zz--){
		       eegcount[zz]=eegcount[zz-1];
		}
		eegcount[0]=0; /*clear current*/
		eegratiobefore=eegratio;
	     }
	     if (showlookupfreq || lookup_entropy){
		entropy = 0;

		for (z=tablemax; z>=0; z--){
		   /*superimposed graph of lookupfrequency-time*/
		   nhdcolor=set_nhdcolor(nhood,z);
		   if (nhdcolor==0 || nhdcolor==darkgray) nhdcolor=white;
		   tot_lookupcount=0;
		   for (zz=0;zz<=actgens-1;zz++){
		       tot_lookupcount+=lookupcount[zz][z];
		   }
		   lookupratio=(float)tot_lookupcount/(lineL*actgens);
		   newbar=stpwidth+
			 (signed short)ceil(lookupfreqwidth*lookupratio);
                   if (twod!=2){

#                     if __UNIX__ /*draw to pixmap*/
                        *current_draw = *offscreen_pixmap;
#                     endif
		      if (fscale==1) putpixel(newbar,gety,nhdcolor);
		      if (fscale>1){
			 setcolor(nhdcolor);
			 line(newbar,gety,newbar,gety+fscale);
		      }   	
#                     if __UNIX__ /*draw to pixmap*/
                        *current_draw = W;
#                     endif
                   }                   
		   if (lookupratio!=0)
			  entropy+=(lookupratio*log(lookupratio));
		}

		/*plot entropy*/
		setcolor(lightred);
		newbar=stpwidth+(signed short)(lookupfreqwidth*
				 (entropy/log(1.0/(tablemax+1))));
		if (!twod){		      
#                  if __UNIX__ /*draw to pixmap*/
                      *current_draw = *offscreen_pixmap;
#                  endif                    
		   line(newbar0,gety-fscale,newbar,gety);
#                  if __UNIX__ /*draw to window*/
                      *current_draw = W;
#                  endif
		}
		newbar0=newbar;
		if (showlookupfreq==2){
		   if (ittcount==1){
		      thisxbox=startxbox-1;
		      thisybox=startybox-1;
		   }
		   thisxbox+=1;
		   thisybox+=1;

		   xbox=thisxbox;
		   ybox=thisybox;
		}
		else{
		   ybox=startybox;
		   xbox=startxbox;
		}
		moveto(xbox,ybox);
		for (z=tablemax; z>=0; z--){
		   if (z!=tablemax && z!=0 && (tablemax-z)%128==0){
		      xbox+=(signed short)
			      lookupfreqwidth/((tablemax+1)/barno);
		      if (showlookupfreq==2) ybox=thisybox;
		      else ybox=startybox;
		   }
		   tot_lookupcount=0;
		   for (zz=0;zz<=actgens-1;zz++){
		       tot_lookupcount+=lookupcount[zz][z];
		   }
		   newbar=(signed short)lookupfreqwidth*
		       ((float)tot_lookupcount/(lineL*actgens));
		   if (newbar>barlength)newbar=barlength;
		   if (!(lookup_entropy && nhood>5)){
		    if (showlookupfreq==1){
		      /*if new<old erase old, erase difference*/
		      if (newbar<oldbar[z]){
			 setfillstyle(SOLID_FILL,black);
			 bar(xbox+newbar,ybox,
			   xbox+oldbar[z],ybox+(signed short)barw-barsep);
		      }
		      /*if new>old add difference*/
		      else if (newbar>oldbar[z]){
			 nhdcolor=set_nhdcolor(nhood,z);
			 if (nhdcolor==0||nhdcolor==darkgray||nhdcolor==10
			       ||nhdcolor==11||nhdcolor==14) nhdcolor=white;
			 setfillstyle(SOLID_FILL,nhdcolor);
			 bar(xbox+oldbar[z],ybox,xbox+newbar,
			       ybox+(signed short)barw-barsep);
		      }
		    }
		    else{
		      if (newbar>=3){
			 /*draw line as series of dots*/
			 for (xpix=xbox+1;xpix<=xbox+newbar-1;xpix++){
			    if (getpixel(xpix,ybox)==black)
					     putpixel(xpix,ybox,darkgray);
			 }
		      }
		      setcolor(white);
		      if (getpixel(xbox,ybox)==black)
					     putpixel(xbox,ybox,white);
		      /*draw line as series of dots only on 0 background*/
		      xspace=xbox+newbar-(xbox-1+oldbar[z]);
		      pixposx=xbox-1+oldbar[z];
		      pixposy=ybox-1;
		      for (xpix=0;xpix<=abs(xspace);xpix++){
			 if (getpixel(pixposx,pixposy)==black)
				       putpixel(pixposx,pixposy,white);
			 if (abs(xspace)!=0){
				pixposx+=xspace/abs(xspace);
				pixposy+=1.0/abs(xspace);
			 }
		      }
		    }
		   }
		   ybox+=(signed short)barw;
		   oldbar[z]=newbar;

		   /*shunt generations*/
		   for (zz=actgens-1;zz>=1;zz--)
			       lookupcount[zz][z]=lookupcount[zz-1][z];
		   lookupcount[0][z]=0; /*clear current*/
		}
	     }

	     if (lookup_entropy){
		/*plot eeg-entropy*/
		if (show_edata==0 || show_edata==1){
		putpixel(stpwidth+vgax(100)+2+vgax(10)+
		 eegratio*vgax(200),
		  Maxy-2-vgax(10)-(entropy/log(1.0/(tablemax+1)))*vgay(200),
		   ecolor);
		}
		/*save entropy to calculate statistics*/
		if (show_edata==1 || show_edata==2){
		   if (ittcount==1){
		      for (z=1;z<=estep-sstep+1;z++) edata[z]=0;
		   }
		   if (ittcount>=sstep){
		      if (ittcount==estep+1){
			 automatic_was_set=moment(edataruleno,
			   show_edata,file_edata,carule[0],
			     edata,estep-sstep+1,color1,
				      fscale,fsep,stpwidth);
			 if (automatic_was_set>=1){
			    show_edata=2;
			    keyindex=0;
			    edataruleno=0;
			    if (automatic_was_set==2) file_edata=1;
			 }
			 screenend=1;
			 ittcount=0;
			 set_entropy_pix_color;
			 random_seed(color1,100);  /*set new random seed*/
			 if (show_edata==2){
			    if (automatic_was_set==0){
			       edataruleno+=1;
			       moveto(Maxx-vgax(120),2);
			       setcolor(white);
			       sprintf(textb[0],"rule count=%lu",edataruleno);
			       outtext(textb[0]);
			    }
			 }
			 automatic_was_set=0;
			 memcpy(F,A,bytesL);
		      }
		      /*save entropy*/
		      else edata[ittcount-sstep+1]=
				   (float)(entropy/log(1.0/(tablemax+1)));
		   }
		}
	   }

	   if (show_ss_matrixF) show_statespace_matrix(A);
	   moveto(tempx,tempy);
	   }
	   if (showlookupfreq==2){
	     if (thisxbox+xboxmax+2-(startxbox-3)>=Maxx
	       || thisybox+yboxmax+1-(startybox-2)>=Maxy) screenend=1;
	   }
	   /***************** draw pattern *****************/  
	   if (twod<2 && stp){
	       /*one-d, either start from the top or scroll*/
	       if (scrolling==0 ){
#                 if __UNIX__                  
		     /*show the pixmap on the screen*/
		  if (twod!=1) copy_part_image(offscreen_pixmap,
			 &W,0,gety-fscale,0,
			   gety-fscale,pixmap_width,fscale);  

#                 endif
	          moveto(0,gety+fscale);
	          if (Maxy-gety<fscale) screenend=1;		
	       }
	       else{ /*if scrolling*/		 
#                 if __UNIX__                  
                     *current_draw=*offscreen_pixmap;            
                     end_page(fscale);
                     *current_draw=W;
#                 elif __BORC__||__WATCOM__
		     end_page(fscale);
#                 endif                  

	       }
	   }
           /***** frame for 2-d drawn as 3-d projection *****/
	   else if (twod==3 && stp){
	       strip=0;
	       downy+=1;
	       polyx=0;
	       /*erase outline*/
	       if (downy>1){
		  setcolor(black);
		  line(polyx,polyy,polyx+wx,polyy);
		  line(polyx+wx,polyy,polyx+wx+aa,polyy-aa);
		  if (fscale<2 && downy%2==0){
		     putpixel(polyx,polyy,white);
		     putpixel(polyx+wx,polyy,white);
		     putpixel(polyx+wx+aa,polyy-aa,white);
		  }
	       }
	       polyy=sin(PI/4)*(j2d-1+downy)*fscale;
	       moveto(polyx,polyy);
	       /*draw outline*/
	       setcolor(white);
	       line(polyx,polyy,polyx+wx,polyy);
	       line(polyx+wx,polyy,polyx+wx+aa,polyy-aa);
	       if (Maxy-polyy<fscale){
			polyy=sin(PI/4)*(j2d-1)*fscale;
			downy=0;
			screenend=1;
	       }
	   }
           /********* two-d ********/
           else if (twod==2 && stp){   		
#             if __UNIX__
                 /*show the pixmap on the screen*/
	         putimage(0,0,offscreen_pixmap,COPY_PUT);
                 /*draw frame*/ 
                 /*first rectangle gets erased in xwindows??*/
                 if (ittcount==1)  draw_2d_frame;
#             endif
	      moveto(0,0);
	   		
	   }
	}
#       if __BORC__||__WATCOM__ /*xwindows*/
	   if (makesound==1) {
		nosound();     /*turns speaker off*/
		if (L<8){
		   sound(dec_equiv_sound(A, L,0));
		   delay(dec_equiv_sound(A,L,0)/2);
		}
		else{
		   sound(dec_equiv_sound(A, L,L-8));
		   delay(dec_equiv_sound(A,8,0)/2);
		}
	   }
#       endif
	if (direction=='f' && limitcheck==0){
           if (Hamming_plot==1 && ittcount>3){
               Ham_t0=Ham_t1=0;
	       for (z=0;z<=lineL-1;z++){
                   if (get_bit(A,z)!=get_bit(lastA[0],z)) Ham_t0+=1;
                   if (get_bit(A,z)!=get_bit(F,z)) Ham_t1+=1;              
	       }              
               putpixel(stpwidth+vgax(100)+2+vgax(10)+
                     ((float)Ham_t0/lineL)*vgax(200),
		         Maxy-2-vgax(10)-((float)Ham_t1/lineL)*vgay(200),ecolor);
           }
          
	   /*remember time steps t-2,t-3,...t-10*/
	   for (z=frozen_gens-1;z>=1;z--) memcpy(lastA[z],lastA[z-1],bytesL);
	   /*remember time step t-1*/
	   memcpy(lastA[0],A,bytesL);
	}
	
 skip_for: /*random_graphs*/
	/*memcpy(A,F,bytesL);*/	
	temppoint=A; /*copy F to A*/
	A=F;
	F=temppoint;
	seed_was_set=0;

        if (itt_step==1){ 
           tempx=getx;
	   	   tempy=gety;
           tempchar=is[0];
           draw_prompt_box(1);
           outtext("next iteration -return, end pause -q:");
           input_string(1,0);
           if (is[0]!=13) itt_step=0;
           is[0]=tempchar;
           moveto(tempx,tempy);
        }
        /* * * * * * * plot difference pattern * * * * * * */  
        if (diff_plot){
	   dp.damage_count=dp.percent_damage=0;
	   tempdiffx=getx;
	   tempdiffy=gety;
	   setcolor(white);

	   /*draw 2d difference pattern*/
	   if (twod==2){
              if (stp){
	         topleftx=(fscale*(i2d+diffgap))/4;
	         toplefty=fscale*(j2d+diffgap);
	         moveto(topleftx,toplefty);
              }
	      for (jj=j2d-1;jj>=0;jj--){
		 for (ii=i2d-1;ii>=i2d/2;ii--){
		    isdiff=0;
		    /*cell already damaged*/
		    if (diff_plot>=2 &&  /*retain damage*/
			    get_bit(tempState,jj*i2d+ii)==1){
		       dp.damage_count+=1;
                       if (stp){
		          setfillstyle(SOLID_FILL,magenta);
		          bar(getx,gety,getx+fscale-fsep,
					    gety+fscale-fsep);
		          moverel(fscale,0);
                       }
		       continue;
		    }
		    /*no difference*/
		    if (get_bit(A,jj*i2d+ii)==
			  get_bit(A,jj*i2d +(ii-i2d/2))){ /*same*/
                       if (stp){
		          if (bground=='w') diffcolor=darkgray;
		          else if (bground=='b') diffcolor=white;
                       }
		    }
		    /*cell is different*/
		    else{
		       dp.damage_count+=1;
		       isdiff=1;
		       diffcolor=magenta;
		    }
                    if (stp){
		       setfillstyle(SOLID_FILL,diffcolor);
		       bar(getx,gety,getx+fscale-fsep,
					    gety+fscale-fsep);
                    }
		    if (diff_plot>=2 && isdiff==1) /*set damage*/
			   set_bit1(tempState,jj*i2d+ii);
		    if (stp) moverel(fscale,0);
                    
		 }
		 if (stp) moveto(topleftx,gety+fscale);
	      }
	   }
	   /*draw 1d difference pattern*/
	   else if (twod==0){
              if (stp){
	         moveto((lineL+diffgap)*fscale+vgax(10),gety);
#                if __UNIX__ /*draw to pixmap*/
		    *current_draw = *offscreen_pixmap;
#                endif
              }
	      for (n=lineL-1;n>=lineL/2;n--){
		 isdiff=0;
		 /*cell already damaged*/
		 if (diff_plot>=2 &&  /*retain damage*/
			    get_bit(tempState,n)==1){
		    dp.damage_count+=1;
                    if (stp){
		       setfillstyle(SOLID_FILL,magenta);
		       bar(getx,gety,getx+fscale-fsep,
					    gety+fscale-fsep);
		       moverel(fscale,0);
                    }
		    continue;
		 }
		 /*no difference*/
		 if (get_bit(A,n)==get_bit(A,n-(lineL/2))){
                    if (stp){
		       if (bground=='w') diffcolor=darkgray;
		       else if (bground=='b') diffcolor=white;
                    }
		 }
		 /*cell is different*/
		 else{
		    dp.damage_count+=1;
		    isdiff=1;
		    if (stp) diffcolor=magenta;
		 }
                 if (stp){
		    setfillstyle(SOLID_FILL,diffcolor);
		    bar(getx,gety,getx+fscale-fsep,gety+fscale-fsep);
                 }
		 if (diff_plot>=2 && isdiff==1) /*set damage*/
			   set_bit1(tempState,n);
		 if (stp) moverel(fscale,0);
	      }
              if (stp){
#                if __UNIX__
		    *current_draw = W; /*draw to window*/
#                endif
              }
	   }
           if (stp){
	      xbox=Maxx-vgax(160);
	      draw_box(-1,xbox-3,2+CHeight+vgay(6),
		   Maxx-2,2+(CHeight+vgay(6))*2,1,0);
	      moveto(xbox,gety);
	      dp.percent_damage=
                      100.0*(float)dp.damage_count/(lineL/2);
              sprintf(textb[0],"damage=%d/%d=%.2g%%",
	         dp.damage_count,lineL/2,dp.percent_damage);
	      outtext(textb[0]);
           }
           /*statistical damage sample  */
	   if (diff_plot==3){ 
              if (dp.old_damage_count==dp.damage_count){
                 if (dp.damage_count==0) 
                          same_count=dp.same_limit+1; 
                 else if (ittcount>dp.d_ittcount) 
                          same_count+=1;
              }
              else same_count=0;	  
             
              if (same_count>dp.same_limit && 
                                ittcount>dp.d_ittcount){

                 show_diff_plot(&dp); /*update the graph*/
                 /*set new duplicate random seeds*/	
                 color1=random_seed(color1,100);
		 /*clear the difference plot buffer*/
                 clear_diff_plot;
                 reset_matrix;
                 dp.diff_sample_count+=1;
                 dp.old_damage_count=dp.damage_count=same_count=0;
                 ittcount=0;
              }
              dp.old_damage_count=dp.damage_count;
           }
           moveto(tempdiffx,tempdiffy);
        }
	/* * * * * * * check for repeat - divert to draw basin * *  * * * */
	if (limitcheck>0 && direction=='f'){ 
	  notocheck=ittcount-1;
	  if (notocheck>limitcheck) notocheck=limitcheck;
	  for (zu=0;zu<=notocheck;zu++){
	    if (memcmp(rcheck[zu],A,bytesL)==0){   /*if repeat found*/
	       attperiod=ittcount-zu;
	       sprintf(textb[0],"att");
	       if ((att=(char**) realloc(att,sizeof(char*)*(attperiod+1)))
					    ==NULL) outof_memory(textb[0]);
	       for (z=1;z<=attperiod;z++){
		  /*sprintf(textb[0],"att[%d]",z);*/
		  if ((att[z]=(char *)calloc(bytesL,sizeof(char)))
				     ==NULL) outof_memory(textb[0]);
	       }
	       if (stp) end_page(fscale);
	       /*transfer info from history array to attractor array*/
	       for (z=1;z<=attperiod;z++){
		  memcpy(att[z],rcheck[zu-1+z],bytesL);
		  if (stp){
		     print_current_state(att[z],cyan);
		     end_page(fscale);
		  }
	       }
	       /*free history array*/
	       for (zu1=0;zu1<=notocheck;zu1++)  free(rcheck[zu1]);
	       free(rcheck);
	       free(pnhood);
	       repeatfound=1;
	       if (stp){
		  setviewport(0, 0, (L+1)*fscale+2, Maxy, 1);
		  clearviewport();
		  setviewport(0, 0, Maxx, Maxy, 1);
		  moveto(0,0);
	       }
	       is[0]=0;
	       draw_basin();
	       attperiod=0;
	       if (stp) end_page(fscale);
	       goto exitFunc;
	    }
	  }
	  if (ittcount<=limitcheck && repeatfound==0){
	     sprintf(textb[0],"rcheck");
	     if((rcheck=(char**) 
                 realloc(rcheck,sizeof(char*)*(ittcount+1)))
				 ==NULL) outof_memory(textb[0]);
	     sprintf(textb[0],"rcheck[%lu]",ittcount);
	     if ((rcheck[ittcount]=(char *)
                    calloc(bytesL,sizeof(char)))
			    ==NULL) outof_memory(textb[0]);
	     memcpy(rcheck[ittcount],A,bytesL);
	  }
	}
	/* * end of check for repeat - divert to draw basin  * * * */
	if (direction=='b'){ 
           /*start backward after stepforward iterations*/
	   if (stepforward==ittcount){    /*print final state*/
	      if (stp){
		 end_page(fscale);
		 print_current_state(A,lightgreen);
		 end_page(fscale);
	      }
	      free(pnhood);
	      is[0]=0;
	      goto exitFunc;
	   }
	}
	/* * * * change space-time parameters on the fly * * * * * */
	if (event_ready()){ /*forwards only*/
	   if (limitcheck==0 && direction=='f'){
	      if (is[0]=='r'||is[0]=='1'||is[0]=='Z'||is[0]=='z'||
	       is[0]=='w'||is[0]=='b'||is[0]=='2'||is[0]=='s'||is[0]=='4'||
	       is[0]=='%'||is[0]=='k'||is[0]=='5'||is[0]=='6'|| 
               is[0]=='7'||is[0]=='8'||
	       is[0]=='g'||is[0]=='v'||is[0]=='V'||is[0]=='B'
			 ||is[0]=='m'||is[0]=='C'){
		  if (showeeg||showlookupfreq){
#                    if __UNIX__ /*clear pixmap*/
                        *current_draw = *offscreen_pixmap;
#                    endif	
		     setcolor(red);
		     if (showeeg) line(stpwidth, gety,
				stpwidth+eegwidth,gety);
		     if (showlookupfreq) line(stpwidth, gety,
				stpwidth+lookupfreqwidth,gety);
		     setcolor(white);		 
#                    if __UNIX__ /*clear pixmap*/
                        *current_draw = W;             
#                    endif	
	          }
	       }


	       switch(is[0]){		 
                   case'S':/*toggle space-time patterns on-of*/
                      stp=abs(stp-1);
		      break;    

                   case'=':/*toggle diffplot dont keep/keep damage*/
			   /*if showing diff histogram
			     interrupt for options*/
		      if (diff_plot){
			 if (diff_plot==3) dp.pause_dam_hist=1;
			 else{
			    if (diff_plot==1) diff_plot=2;
			    else if (diff_plot==2) diff_plot=1;
			    clear_diff_plot;
			    if (keyindex==1) showkey;
			 }
		      }
                      break;    

                  case'#':/*toggle scrolling*/   
		      if (!twod){
			/*moveto(0,0);*/
	                 if (scrolling==1){
                            scrolling=0;       	                    
                            if (nowscrolling==1){
#                              if __BORC__||__WATCOM__
		                  freeimage(stpimage);
#                              endif
                            }			    
                            /*clear area of screen*/
	                    if (diff_plot) setviewport(0,0,
                              stpwidth+lineL*fscale,Maxy,1);
	                    else setviewport(0,0,stpwidth,Maxy,1);  
			    clearviewport();
	                    setviewport(0, 0, Maxx, Maxy, 1);

#                           if __UNIX__ /*clear pixmap*/
                               *current_draw = *offscreen_pixmap;
	                       setfillstyle(SOLID_FILL,black);
	                       bar(0,0,pixmap_width,Maxy); 	
                               draw_stpframe(stpwidth,eegwidth);
                               *current_draw = W;
                               putimage(0,0,offscreen_pixmap,COPY_PUT);
#                           endif	
	                 }
	                 else scrolling=1;
                         nowscrolling=0;
                         if (keyindex==1) showkey;
                      }
                      break;
                  case'+':
                      /*pause at each itteration*/
                      itt_step=1;
                      break;    
                  case'C':
                      /*alter canalyzing for mixed rule*/
                      if (rulemix){
                         tempx=getx;
		         tempy=gety;
                         set_canalyzing_net(0);
                         if (diff_plot==2) clear_diff_plot;
                         moveto(tempx,tempy);
		      }
                      break;                    
		  case'h':
                      /*toggle 0.normal color
		      1.frozen cells lightred (was green) rest normal
		      2.frozen cells lightred (was green) rest background */
		      ncolor=0; /*restore cell color*/
		      cell_not_changed=0;
		      if (frozen_islands==0) frozen_islands=1;
		      else if (frozen_islands==1) frozen_islands=2;
		      else if (frozen_islands==2) frozen_islands=0;

		      if (keyindex==1) showkey;
		      break;
		 
		  case 'H':
                     /*change generation size, frozen cells*/
		     tempx=getx;
		     tempy=gety;
		     sprintf(textb[0],
			"enter new 'frozen' Generation size (now %d):",
							     frozen_gens);
		     draw_prompt_box(1);
		     myouttext(textb[0]);
		     input_string(3,1);
		     if (is[0]!=13 && atoi(is)>0){
			/*free mem previous generation size*/
			for (z=frozen_gens-1;z>=0;z--) free(lastA[z]);
			free(lastA);
			frozen_gens=atoi(is);
			/*allocale mem new generation size*/
			sprintf(textb[0],"carule");
			if ((lastA=(char**)calloc(frozen_gens,sizeof(char*)))
				       ==NULL) outof_memory(textb[0]);
			for (z=0;z<=frozen_gens-1;z++){
			   sprintf(textb[0],"lastA[%d]",z);
			   if ((lastA[z]=(char *)calloc(bytesL,sizeof(char)))
					==NULL) outof_memory(textb[0]);
			}
		     }
		     moveto(tempx,tempy);
		     if (keyindex==1) showkey;
		     break;
		  /*random rule/s*/
		  case 'r':
		      color1=bit_flip('r',color1);
		      reset_matrix;
		      set_entropy_pix_color;
		      if (lookup_entropy==1) random_seed(color1,100);
                      if (diff_plot==2) clear_diff_plot;
		      break;
		  /*random bit flip*/
		  case '1':
		      color1=bit_flip('1',color1);
		      reset_matrix;
		      set_entropy_pix_color;
		      break;
		  /*restore bit flip*/
		  case '2':
		     if (rulemix) break;
		     color1=bit_flipback(color1);
		     reset_matrix;
		     set_entropy_pix_color;
		     break;
		  /*flip for higher z*/
		  case 'Z':
		     if (rulemix) break;
		     color1=bit_flip('Z',color1);
		     reset_matrix;
		     set_entropy_pix_color;
		     break;
		  /*flip for lower z*/
		  case 'z':
		     if (rulemix) break;
		     color1=bit_flip('z',color1);
		     reset_matrix;
		     set_entropy_pix_color;
		     break;
		  /*flip all 1s*/
		  case 'w':
		     color1=bit_flip('w',color1);
		     reset_matrix;
		     set_entropy_pix_color;
		     break;
		  /*force all 1s to 1*/
		  case 'W':
		     color1=bit_flip('W',color1);
		     reset_matrix;
		     set_entropy_pix_color;
		     break;
		  /*flip all 0s*/
		  case 'b':
		     color1=bit_flip('b',color1);
		     reset_matrix;
		     set_entropy_pix_color;
		     break;
		  /*force all 0s to 0*/
		  case 'B':
		     color1=bit_flip('B',color1);
		     reset_matrix;
		     set_entropy_pix_color;
		     break;
		  /*move 1 or  more wires*/
		  case 'm':
		     if (!loc_twod_fonly)
			nonlocal=1;
			color1=wire_move('m',color1);
			if (keyindex==1 && nonlocal==0) showkey;
			reset_matrix;
			set_entropy_pix_color;
		     break;
		  /*reset number of wires to move then move*/
		  case 'M':
		     if (!loc_twod_fonly)
			nonlocal=1;
			color1=wire_move('M',color1);
			if (keyindex==1)  showkey;
			reset_matrix;
			set_entropy_pix_color;
		     break;
		  /*load glider rules*/
		  case 'g':
		     glider_rule(fscale,fsep);

		     if (ncolor==0){
			if (color1==white) color1=yellow;
			else if (color1==yellow) color1=white;
		     }
		     reset_matrix;
		     set_entropy_pix_color;
		     break;
		  /*load rule from statistical sample, set index*/
		  case 'V':
		     tempx=getx;
		     tempy=gety;
		     statrule_index=stat_rule(0,0);
		     if (ncolor==0){
			if (color1==white) color1=yellow;
			else if (color1==yellow) color1=white;
		     }
		     reset_matrix;
		     set_entropy_pix_color;
		     random_seed(color1,100);
		     screenend=1;
		     moveto(tempx,tempy);
		     break;
		  /*load rule from statistical sample,
		    decriment index automaticaly*/
		  case 'v':
		     if (totstatrules==0) break;
		     tempx=getx;
		     tempy=gety;
		     statrule_index+=1;
		     if (statrule_index>totstatrules) statrule_index=1;
		     stat_rule(1,statrule_index);
		     if (ncolor==0){
			if (color1==white) color1=yellow;
			else if (color1==yellow) color1=white;
		     }
		     reset_matrix;
		     set_entropy_pix_color;
		     random_seed(color1,100);
		     screenend=1;
		     moveto(tempx,tempy);
		     break;
		  /*toggle nhood color<->cell value*/
		  case '3':
		  		ncolor=abs(ncolor-1);
		  		break;
		  /*toggle 0 color background<->grey*/
		  case '0':
		     if (color0==darkgray){
			if (twod==2) draw_2d_frame;/*redraw frame*/
			color0=black;
		     }
		     else color0=darkgray;
		     if (twod==3) draw_axon_plane(fscale,gety-1,color0);
		     break;
#                 if __BORC__||__WATCOM__ /*xwindows*/
		     /*toggle sound*/
		     case 'o':
		        if (!makesound) makesound=1;
		        else{
			   nosound();
			   makesound=0;
		        }
		        break;
#                 endif
		  /*reset state space matrix*/
		  case 'y':
		      if (show_ss_matrixF) reset_matrix;
		      break;
		  /*toggle space matrix on-off*/
		  case 'Y':
		      if (show_ss_matrixF){
			 tempx=getx;
			 tempy=gety;
			 draw_box(-1,Maxx-vgax(136)-vgax(msize)-1,
			      Maxy-2-vgay(msize)-1,
			       Maxx-vgax(136),Maxy-2,0,0);
			 show_ss_matrixF=0;
			 moveto(tempx,tempy);
		      }
		      else{
			 show_ss_matrixF=1;
			 reset_matrix;
		      }
		      break;
		  /*toggle eeg...showlookupfreq*/
		  case 's':
		     if (nhood_mixed) break;
		     if (showeeg==1) {
			tempx=getx;
			tempy=gety;
			showlookupfreq=1;
			showeeg=0;
			stpgraph=2;
			tablemax=(signed short)pow(2,(double)nhood)-1;
			lookupfreqwidth=vgax(100);
			ittcount=0;
			
			/*screenend=1;*/
			if (!lookup_entropy){
			   free(eegcount);
			   sprintf(textb[0],"lookupcount");
			   if ((lookupcount=(signed short**)
				    calloc(gens,sizeof(signed short*)))==
						NULL) outof_memory(textb[0]);
			   /*alloc mem for lookupcount for each nhood*/
			   for (z=0;z<=gens-1;z++){
			      sprintf(textb[0],"lookupcount[%d]",z);
			      if ((lookupcount[z]=(signed short *)
				 calloc(tablemax+1,sizeof(signed short)))
				      ==NULL) outof_memory(textb[0]);
			   }
			   /*alloc mem for size of old bar*/
			   sprintf(textb[0],"oldbar");
			   if ((oldbar=(signed short *)calloc
			       (tablemax+1,sizeof(signed short)))
				      ==NULL)outof_memory(textb[0]);
			}
			
			/*redraw frame to window*/
                        draw_stpframe(stpwidth,lookupfreqwidth); 
#                       if __UNIX__
                            /*redraw frame to pixmap*/
                            *current_draw = *offscreen_pixmap; 
                            draw_stpframe(stpwidth,lookupfreqwidth);      
                            *current_draw = W;
#                       endif
			   
			startxbox=stpwidth+
                              (signed short)lookupfreqwidth+vgax(10);
			xboxmax=startxbox+(signed short)lookupfreqwidth;
			startybox=vgay(57);
			barno=tablemax+1;
			if (barno>128) barno=128; /*as for nhood=7*/
			barw=(float)(Maxy-startybox)/barno;
			if (barw>6) barw=6;
			yboxmax=startybox+(signed short)barw*barno;
			barsep=2;
			if (!(lookup_entropy && nhood>5)){
			   draw_box(-1,startxbox-3,startybox-2,
						  xboxmax+2,yboxmax+1,1,0);
			}
			if (nhood<8)barlength=(signed short)lookupfreqwidth;
			else barlength=
			  (signed short)lookupfreqwidth/((tablemax+1)/barno);
			newbar0=stpwidth;
			thisxbox=startxbox-1;
			thisybox=startybox-1;
			if (keyindex==1)  showkey;
			moveto(tempx,tempy);
			break;
		     }
		     if (showlookupfreq) {
			tempx=getx;
			tempy=gety;
			showeeg=1;
			showlookupfreq=0;
			stpgraph=1;
			eegwidth=vgax(100);

                        /*redraw frame to window*/
                        draw_stpframe(stpwidth,eegwidth); 
#                       if __UNIX__
                            /*redraw frame to pixmap*/
                            *current_draw = *offscreen_pixmap; 
                            draw_stpframe(stpwidth,lookupfreqwidth);      
                            *current_draw = W;
#                       endif
			if (!lookup_entropy){
			   free(oldbar);
			   for (z=0;z<=gens-1;z++) free(lookupcount[z]);
			   free(lookupcount);
			   /*alloc mem for eegcount for each generation*/
			   sprintf(textb[0],"eegcount");
			   if ((eegcount=(signed short *)calloc
				   (gens,sizeof(signed short)))
					    ==NULL) outof_memory(textb[0]);
			}
			if (keyindex==1) showkey;
			moveto(tempx,tempy);
			break;
		     }
		     /*show graph eeg...lookup_entropy*/
		  case 'u':
		     if (nhood_mixed || stpgraph==0 || show_edata) break;
		     tempx=getx;
		     tempy=gety;
		     if (lookup_entropy==1){
			lookup_entropy=0;
			
			/*clear space*/
			draw_entgraph_frame(0,stpwidth,show_edata,0);
			if (showlookupfreq) free(eegcount);
			if (showeeg){
			   free(oldbar);
			   for (z=0;z<=gens-1;z++) free(lookupcount[z]);
			   free(lookupcount);
			}
			if (keyindex==1) showkey;
		     }
		     else if (lookup_entropy==0){
			lookup_entropy=1;
			ecolor=yellow;
			if (keyindex && lineL>170){
			   erase_box(Maxx-vgax(130)-3,Maxy-vgay(420),
							  Maxx-2,Maxy-2);
			   keyindex=0;
			}
			else if (keyindex==1) showkey;
			draw_entgraph_frame(1,stpwidth,show_edata,0);
			if (showlookupfreq==0) {
			   tablemax=(signed short)pow(2,(double)nhood)-1;
			   ittcount=0;
			   screenend=1;
			   sprintf(textb[0],"lookupcount");
			   if ((lookupcount=(signed short**)
				    calloc(gens,sizeof(signed short*)))==
						NULL) outof_memory(textb[0]);
			   /*alloc mem for lookupcount for each nhood*/
			   for (z=0;z<=gens-1;z++){
			      sprintf(textb[0],"lookupcount[%d]",z);
			      if ((lookupcount[z]=(signed short *)
				 calloc(tablemax+1,sizeof(signed short)))
				      ==NULL) outof_memory(textb[0]);
			   }
			   /*alloc mem for size of old bar*/
			   sprintf(textb[0],"oldbar");
			   if ((oldbar=(signed short *)calloc
			       (tablemax+1,sizeof(signed short)))
				      ==NULL)outof_memory(textb[0]);
			}

			if (showeeg==0) {
			   /*alloc mem for eegcount for each generation*/
			   sprintf(textb[0],"eegcount");
			   if ((eegcount=(signed short *)calloc
				   (gens,sizeof(signed short)))
					    ==NULL) outof_memory(textb[0]);
			}
		     }
		     moveto(tempx,tempy);
		     break;
                  case 'D':
		     tempx=getx;
		     tempy=gety;		   			
		     /*clear space*/
                     if (Hamming_plot==1){
                        Hamming_plot=0;
                        draw_Hamming_plot(0,stpwidth);
		     }
                     
                     else{
                        Hamming_plot=1;
                        ecolor=yellow;
	                draw_Hamming_plot(1,stpwidth);
		     }
		     if (keyindex==1) showkey;
		     moveto(tempx,tempy);
		     break;
		  case 'E':
		     if (nhood_mixed || stpgraph==0
				     || lookup_entropy==0) break;

		     tempx=getx;
		     tempy=gety;

		     edataruleno=0;
		     random_seed(color1,100);
		     ittcount=0;
		     screenend=1;
		     xbox=draw_prompt_box(3);
		     setcolor(white);
		     if (show_edata==0){
			show_edata=1;
			myouttext(
			  "statistics: set automatic-a, manual-m:");
		     }
		     else myouttext(
			"statistics: manual-def, automatic-a, exit-e:");

		     input_string(1,0);
		     if (is[0]=='a'){
			show_edata=2;
			draw_entgraph_frame(0,stpwidth,show_edata,0);
		     }
		     else if (is[0]=='e'){
			if (show_edata==2)/*clear space*/
			   draw_entgraph_frame(0,stpwidth,show_edata,0);
			show_edata=0;
			break;
		     }
		     else{
			if (show_edata==2) /*clear space*/
			   draw_entgraph_frame(0,stpwidth,show_edata,0);
			show_edata=1;
		     }
		     moveto(xbox,gety+CHeight);
		     sprintf(textb[0],
			"specify start - end position of entropy record)");
		     myouttext(textb[0]);
		     moveto(xbox,gety+CHeight);
		     sprintf(textb[0],"start (default %d):",sstep);
		     myouttext(textb[0]);
		     input_string(4,0);

		     if (is[0]!=13 && is[0]!='q') sstep=atoi(is);

		     moveto(getx+vgax(10),gety);
		     sprintf(textb[0],"end (default %d):",estep);
		     myouttext(textb[0]);
		     input_string(4,0);
		     if (is[0]!=13 && is[0]!='q') endmut=atoi(is);

		     if (show_edata==2) file_edata=
				    select_stat_filename();

		     free(edata);
		     sprintf(textb[0],"edata");
		     if ((edata=(float *)calloc(estep-sstep+2,
			    sizeof(float)))==NULL) outof_memory(textb[0]);

		     erase_box(Maxx-vgax(130)-3,Maxy-vgay(420),
						    Maxx-2,Maxy-2);
		     keyindex=0;
		     draw_entgraph_frame(1,stpwidth,show_edata,0);
		     moveto(tempx,tempy);
		     break;

		  /*showlookupfreq: toggle lookupfreq histogram<-->graph*/
		  case 'L':
		     if (lookup_entropy && nhood>5) break;
		     if (nhood_mixed) break;
		     if (stpgraph>1){
			tempx=getx;
			tempy=gety;
			if (showlookupfreq==1){
			   showlookupfreq=2;
			   erase_box(startxbox-3,startybox-2,
					       xboxmax+2,yboxmax+1);
			   thisxbox=startxbox-1;
			   thisybox=startybox-1;
			}
			else if (showlookupfreq==2){
			   if (keyindex) setviewport(startxbox-3,vgay(20),
						 Maxx-vgax(135),Maxy,1);
			   else setviewport(startxbox-3,vgay(20),
						 Maxx,Maxy,1);
			   clearviewport();
			   setviewport(0, 0, Maxx, Maxy, 1);
			   showlookupfreq=1;
			   draw_box(-1,startxbox-3,startybox-2,
					   xboxmax+2,yboxmax+1,1,0);
			}
			for (z=tablemax; z>=0; z--) oldbar[z]=0;
			showkey;
			moveto(tempx,tempy);
		     }
		     break;
		  /*showlookupfreq: change generation size*/
		  case 'G':
		     if (twod) break;
		     if (stpgraph){
			tempx=getx;
			tempy=gety;
			sprintf(textb[0],
			   "enter new 'analysis'generation size (now %d):"
								    ,gens);
			draw_prompt_box(1);
			myouttext(textb[0]);
			input_string(3,1);
			moveto(tempx,tempy);
		     }
		     if (is[0]!=13 && atoi(is)>0){
			if (showeeg){
			   free(eegcount);
			   gens=atoi(is);
			   sprintf(textb[0],"eegcount");
			   if ((eegcount=(signed short*) calloc
					(gens,sizeof(signed short)))
					   ==NULL) outof_memory(textb[0]);
			}
			if (showlookupfreq){
			   for (z=0;z<=gens-1;z++) free(lookupcount[z]);
			   free(lookupcount);
			   gens=atoi(is);
			   ittcount=0;
			   screenend=1;
			   sprintf(textb[0],"lookupcount");
			   if ((lookupcount=(signed short**)
					calloc(gens,sizeof(signed short*)))
					    ==NULL) outof_memory(textb[0]);
			   /*alloc mem for lookupcount for each nhood*/
			   for (z=0;z<=gens-1;z++){
			      sprintf(textb[0],"lookupcount[%d]",z);
			      if ((lookupcount[z]=(signed short *)
				    calloc(tablemax+1,sizeof(signed short)))
					    ==NULL) outof_memory(textb[0]);
			   }
			}
		     }
		     if (keyindex==1)  showkey;
		     break;
		  /*set new random seed*/
		  case '4': color1=random_seed(color1,rand_seed_percent);
		     reset_matrix;
		     if (diff_plot==2) clear_diff_plot;
		     break;
		  /*set new random block*/
		  case 'k':
		     if (twod) color1=random_block(i2d/5,color1);
		     else color1=random_block(lineL/5,color1);
		     if (twod==3) draw_axon_plane(fscale,gety-1,color0);
		     reset_matrix;
                      if (diff_plot==2) clear_diff_plot;
		     break;
		  case 'p':  /*draw plane in axonometric*/
		     if (twod==3){
			if (color0==darkgray) color0=black;
			else color0=darkgray;
			draw_axon_plane(fscale,gety-1,color0);
		     }
		     break;
		  case 't':  /*toggle 2d<->3d*/
		     if (twod && diff_plot==0){
			clearviewport();
			if (twod==2){
			   twod=3;
			   strip=downy=0;
			   polyx=0;
			   axo_cell_h=sin(PI/4)*fscale;
			   wx=fscale*i2d;
			   aa=axo_cell_h*j2d;
			   polyy=aa;
			   moveto(0,polyy);
			   draw_axon_plane(fscale,gety-1,color0);
			}
			else if (twod==3){
			   twod=2;                    
			   draw_2d_frame;/*redraw frame*/
                           moveto(0,0);                     
			}
			if (keyindex==1)  showkey;			
		     }
                     break;
		  case 'T':  /*toggle 2d<->1d*/
		     if (twod  && diff_plot==0){
			if (twod==2 || twod==3){
			   twod=1;
			   fscale=1;
			   fsep=1;
			   temp=stpwidth;
			   stpwidth=lineL*fscale+vgax(10);
			   newbar0-=temp-stpwidth;
	   
			   if (showlookupfreq){
			      startxbox=stpwidth+
				  (signed short)lookupfreqwidth+vgax(10);
			      xboxmax=startxbox+
					(signed short)lookupfreqwidth;
			      if (!(lookup_entropy && nhood>5)){
				 draw_box(-1,startxbox-3,
				    startybox-2,xboxmax+2,yboxmax+1,1,0);
			      }
			      for (z=tablemax; z>=0; z--) oldbar[z]=0;
			   }
			   moveto(0,0);
			}
			else if (twod==1){
			   twod=2;
                           /*redraw frame to window*/	
                           draw_2d_frame;
#                          if __UNIX__
                              *current_draw = *offscreen_pixmap; 
                              draw_2d_frame;                           
                              *current_draw = W;
#                          endif		
			   moveto(0,0);
			}
			if (keyindex==1)  showkey;
		     }
			break;
		  /*set sinlgeton seed ..000010000..*/
		  case '5':
			color1=singleton_seed(color1);
			reset_matrix;
			break;
		  /*set negative singleton seed ..111101111.. */
		  case '6':
			color1=singleton_neg_seed(color1);
			reset_matrix;
			break;
		  /*flip one bit in current state at random* position*/
		  case 'R':
			color1=random_bitflip_state(color1);
			reset_matrix;
			break;

		  /*toggle local...nonlocal wiring*/
		  case '7':
		     if (!loc_twod_fonly && nonlocal){
			wiring_madelocal=abs(wiring_madelocal-1);
			if (color1==white) color1=yellow;
			else if (color1==yellow) color1=white;
			if (keyindex==1) showkey;
			reset_matrix;
			break;
		     }
		  /*toggle rulemix-rule[0] only*/
		  case '8':
		     if (rulemix){
			rule_unmixed=abs(rule_unmixed-1);
			if (color1==white) color1=yellow;
			else if (color1==yellow) color1=white;
			if (keyindex==1) showkey;
			reset_matrix;
			break;
		     }
		     
		  /*increace CA size by 1*/
		  case 'i':
		     if (twod==0 && diff_plot==0){
			 
			if ((temppoint=(char*)calloc(bytesL,sizeof(char)))
				  ==NULL) outof_memory("temppoint");
			if ((tempnhd=(unsigned char *)calloc(lineL,
				  sizeof(unsigned char)))==NULL)
				   outof_memory("tempnhd");
			memcpy(tempnhd,nhd,lineL);
			memcpy(temppoint,A,bytesL);
			tempbytesL=bytesL;
			free_mem_CA_states();
			L++;
			lineL = L+1;
			bytesL=(unsigned short)ceil((double)lineL/8);
			allocate_mem_CA_states();
			wire_rule_extra_cell(1);	
			memcpy(nhd,tempnhd,lineL-1);
			memcpy(A,temppoint,tempbytesL);
			memcpy(bitseed,temppoint,tempbytesL);
			free(tempnhd);
			free(temppoint);				
			setviewport((L+1)*fscale, 0, Maxx,Maxy,1);
			clearviewport();
			setviewport(0,0,Maxx,Maxy,1);
			if (keyindex==1) showkey;

			/*reset width of pattern including gaps*/
                        stpwidth=lineL*fscale+vgax(10);
			if (diff_plot) stpwidth+=
                             ((lineL/2)*fscale+diffgap*fscale+vgax(10));
                        /*redraw frame to window*/
                        if (showeeg)draw_stpframe(stpwidth,eegwidth);
                        if (showlookupfreq)
			      draw_stpframe(stpwidth,lookupfreqwidth);
	
			if (showlookupfreq){
			   startxbox=stpwidth+
				(signed short)lookupfreqwidth+vgax(10);

			   xboxmax=startxbox+(signed short)lookupfreqwidth;
			   if (!(lookup_entropy && nhood>5)){
			       draw_box(-1,startxbox-3,startybox-2,
						xboxmax+2,yboxmax+1,1,0);
			   }
			   for (z=tablemax; z>=0; z--) oldbar[z]=0;
			}
			
			if (scrolling==1){
			   if (nowscrolling==1){
#         		      if __BORC__||__WATCOM__
				 freeimage(stpimage);
#                             endif
			      nowscrolling=0;
			   }
			}
			reset_matrix;
#                       if __UNIX__          
                           pixmap_width=stpwidth+1;
                           if (showlookupfreq==1 || showeeg==1) 
                                     pixmap_width+=(signed short)eegwidth;
                           reallocate_pixmap(0,0,pixmap_width,Maxy, 
                                                     offscreen_pixmap);
                           /*redraw frame to pixmap*/
                           *current_draw = *offscreen_pixmap; 
                           if (showeeg)draw_stpframe(stpwidth,eegwidth);
                           if (showlookupfreq)
			      draw_stpframe(stpwidth,lookupfreqwidth);
                           *current_draw = W;
#                       endif              
		     }
		     break;

		  /*decreace CA size by 1*/
		  case 'd':
		     if (twod==0 && diff_plot==0){
		     sprintf(textb[0],"temppoint");
		     if ((temppoint=(char*)calloc(bytesL,sizeof(char)))
			       ==NULL) outof_memory(textb[0]);
		     sprintf(textb[0],"tempnhd");
		     if ((tempnhd=(unsigned char*)calloc(lineL,
			sizeof(unsigned char)))==NULL) outof_memory(textb[0]);
			memcpy(tempnhd,nhd,lineL-1);
			memcpy(temppoint,A,bytesL);
			set_bit0(temppoint,L);
			L-=1;
			lineL=L+1;
			bytesL=(unsigned short)ceil((double)lineL/8);
			sprintf(textb[0],"temppoint");
			if( (temppoint = (char*) realloc(temppoint,
				  sizeof(char)*bytesL))
				      ==NULL) outof_memory(textb[0]);
			free_mem_CA_states();
			allocate_mem_CA_states();
			wire_rule_extra_cell(-1);

			memcpy(nhd,tempnhd,lineL);
			memcpy(A,temppoint,bytesL);
			memcpy(bitseed,temppoint,bytesL);
			free(tempnhd);
			free(temppoint);
			
			setviewport((L+1)*fscale,0,Maxx,Maxy,1);
			clearviewport();
			setviewport(0,0,Maxx,Maxy,1);
			if (keyindex==1) showkey;

                        /*reset width of pattern including gaps*/
                        stpwidth=lineL*fscale+vgax(10);
			if (diff_plot) stpwidth+=
                                ((lineL/2)*fscale+diffgap*fscale+vgax(10));
                        /*redraw frame to window*/
                        if (showeeg)draw_stpframe(stpwidth,eegwidth);
                        if (showlookupfreq)
			      draw_stpframe(stpwidth,lookupfreqwidth);

			if (showlookupfreq){
			    startxbox=stpwidth+
				      (signed short)lookupfreqwidth+vgax(10);
			    xboxmax=startxbox+(signed short)lookupfreqwidth;
			    if (!(lookup_entropy && nhood>5)){
			       draw_box(-1,startxbox-3,startybox-2,
				   xboxmax+2,yboxmax+1,1,0);
			    }
			    for (z=tablemax; z>=0; z--) oldbar[z]=0;
			}
			
			if (scrolling==1){
			   if (nowscrolling==1){
#         		      if __BORC__||__WATCOM__
				  freeimage(stpimage);
#                             endif
			      nowscrolling=0;
			   }
			}
#                       if __UNIX__          
                           pixmap_width=stpwidth+1;
                           if (showlookupfreq==1 || showeeg==1) 
                                     pixmap_width+=(signed short)eegwidth;
                           reallocate_pixmap(0,0,pixmap_width,Maxy, 
                                                     offscreen_pixmap);
                           /*redraw frame to pixmap*/
                           *current_draw = *offscreen_pixmap; 
                           if (showeeg)draw_stpframe(stpwidth,eegwidth);
                           if (showlookupfreq)
			      draw_stpframe(stpwidth,lookupfreqwidth);
                           *current_draw = W;

#                       endif     
			reset_matrix
		     }
		     break;
		  /*expand scale*/
		  case 'e':
		     if (limitcheck==0){
                        tempx=getx;
			tempy=gety;
			fscale++;
			if (twod){
			   if (twod==2){                              
                              if (diff_plot) ylimit=fscale*(j2d*2+diffgap)+1;
                              else ylimit=fscale*j2d+1;
                              if (ylimit>Maxy) ylimit=Maxy;
			      if (diff_plot)
			         setviewport(0,0,fscale*(i2d+diffgap)+1,ylimit,1);
			      else setviewport(0,0,fscale*i2d+1,ylimit,1);
                           }
			   clearviewport();
			   setviewport(0,0,Maxx,Maxy,1);
			   setcolor(white);
			   if (keyindex==1) showkey;
			}
			temp=stpwidth;

			/*reset width of pattern including gaps*/
			if (twod==0){
                           stpwidth=lineL*fscale+vgax(10);
			   if (diff_plot) stpwidth+=
                                   ((lineL/2)*fscale+diffgap*fscale+vgax(10));
			}
			else if (twod==2){
			   if (diff_plot) stpwidth=
			      lineL*fscale/i2d+fscale*diffgap+vgax(10);
			   else stpwidth=lineL*fscale/i2d+vgax(10);
			}
                        /*redraw frame to window*/
                        if (twod==2) draw_2d_frame;
                        if (showeeg)draw_stpframe(stpwidth,eegwidth);
                        if (showlookupfreq)
			      draw_stpframe(stpwidth,lookupfreqwidth);

                        if (showlookupfreq){                          
			   startxbox=stpwidth+
				 (signed short)lookupfreqwidth+vgax(10);
			   xboxmax=startxbox+(signed short)lookupfreqwidth;
			   if (!(lookup_entropy && nhood>5)){
			      if (startxbox-3<Maxx)
				 draw_box(-1,startxbox-3,startybox-2,
				    xboxmax+2,yboxmax+1,1,0);
			   }
			   for (z=tablemax; z>=0; z--) oldbar[z]=0;
			   thisxbox=startxbox-1;
			   thisybox=startybox-1;
			}
			
			/*fsep=2->1 pix div, fsep=1-> no div*/
			if (fscale>vgax(5)) fsep=2;
			else fsep=1;
			if (scrolling==1){
			   if (nowscrolling==1){
#         		       if __BORC__||__WATCOM__
				  freeimage(stpimage);
#                              endif
			       /*gety+=(fscale-1);*/
                               nowscrolling=0;
			   }
			}
			if (twod==3){
			   strip=downy=0;
			   axo_cell_h=sin(PI/4)*fscale;
			   wx=fscale*i2d;
			   aa=axo_cell_h*j2d;
			   polyx=0;
			   polyy=axo_cell_h*j2d;
			   moveto(polyx,polyy);
			   draw_axon_plane(fscale,gety-1,color0);
			}
			reset_matrix;

#                       if __UNIX__     
                           if (twod==2){
                              pixmap_width=fscale*i2d+1;
                              /*allow for division*/
                              if (diff_plot) pixmap_width+=
                                              (fscale*diffgap);
                              reallocate_pixmap(0,0,pixmap_width,
		                    fscale*j2d+1, offscreen_pixmap);
                              *current_draw = *offscreen_pixmap; 
                              draw_2d_frame;
                              *current_draw = W;
                           }
                           else if (twod==0){        
                              pixmap_width=stpwidth+1;
                              /*allow for graph*/
                              if (showlookupfreq==1 || showeeg==1) 
                                     pixmap_width+=(signed short)eegwidth;
                              reallocate_pixmap(0,0,pixmap_width,Maxy, 
                                                    offscreen_pixmap);	

                              /*redraw frame to pixmap*/
                           *current_draw = *offscreen_pixmap; 
                           if (showeeg)draw_stpframe(stpwidth,eegwidth);
                           if (showlookupfreq)
			      draw_stpframe(stpwidth,lookupfreqwidth);
                           *current_draw = W;

                           }      
#                       endif
                        moveto(tempx,tempy);
		     } /*if limitcheck == 0 */                     
		     break;

		  /*contract scale*/
		  case 'c':
		     if (limitcheck==0){
			fscale--;
			if (fscale<=0){
			   fscale=1;
			   break;
			}			
                        if (twod){
			   if (twod==2){
                              fscale++;
			      if (diff_plot) setviewport(0,0,
				 fscale*(i2d+diffgap)+1,
                                   fscale*(j2d*2+diffgap)+1,1);
			      else setviewport(0,0,fscale*i2d+1,fscale*j2d+1,1);
                              fscale--;
                           }
			   clearviewport();
			   setviewport(0,0,Maxx,Maxy,1);
			   setcolor(white);
			}
			else clearviewport();
			if (keyindex==1) showkey;
			temp=stpwidth;

			/*reset width of pattern including gaps*/
			if (twod==0){
                           stpwidth=lineL*fscale+vgax(10);
			   if (diff_plot) stpwidth+=
                                   ((lineL/2)*fscale+diffgap*fscale+vgax(10));
			}
			else if (twod==2){
			   if (diff_plot) stpwidth=
			      lineL*fscale/i2d+fscale*diffgap+vgax(10);
			   else stpwidth=lineL*fscale/i2d+vgax(10);
			   
			}

			newbar0-=temp-stpwidth;
                        /*redraw frame to window*/
                        if (twod==2) draw_2d_frame;
                        if (showeeg) draw_stpframe(stpwidth,eegwidth);
                        if (showlookupfreq)
			      draw_stpframe(stpwidth,lookupfreqwidth);	
			if (showlookupfreq){		  
			   startxbox=stpwidth+
				 (signed short)lookupfreqwidth+vgax(10);
			   xboxmax=startxbox+(signed short)lookupfreqwidth;
			   if (!(lookup_entropy && nhood>5)){
			       draw_box(-1,startxbox-3,startybox-2,
				  xboxmax+2,yboxmax+1,1,0);
			   }
			   for (z=tablemax;z>=0;z--) oldbar[z]=0;
			   thisxbox=startxbox-1;
			   thisybox=startybox-1;
			}
			/*fsep=2->1 pix div, fsep=1-> no div*/
			if (fscale>vgax(5)) fsep=2;
			else fsep=1;
			if (scrolling==1){
			   if (nowscrolling==1){
#         		      if __BORC__||__WATCOM__
				 freeimage(stpimage);
#                             endif
			      moveto(getx,gety+fscale+1);
                              nowscrolling=0;
			   }                           
			}
			if (twod==3){
			   strip=downy=0;
			   axo_cell_h=sin(PI/4)*fscale;
			   wx=fscale*i2d;
			   aa=axo_cell_h*j2d;
			   polyx=0;
			   polyy=axo_cell_h*j2d;
			   moveto(polyx,polyy);
			   draw_axon_plane(fscale,gety-1,color0);
			}
			reset_matrix;
#                       if __UNIX__     
                           if (twod==2){
                              pixmap_width=fscale*i2d+1;
                              /*allow for division*/
                              if (diff_plot) pixmap_width+=
                                              (fscale*diffgap);
                              reallocate_pixmap(0,0,pixmap_width,
		                    fscale*j2d+1, offscreen_pixmap);
                              *current_draw = *offscreen_pixmap; 
                              draw_2d_frame;
                              *current_draw = W;
                           }
                           else if (twod==0){        
                              pixmap_width=stpwidth+1;
                              /*allow for graph*/
                              if (showlookupfreq==1 || showeeg==1) 
                                  pixmap_width+=(signed short)eegwidth;
                              reallocate_pixmap(0,0,pixmap_width,Maxy, 
                                                    offscreen_pixmap);	
                              *current_draw = *offscreen_pixmap; 
                              if (showeeg)draw_stpframe(stpwidth,eegwidth);
                              if (showlookupfreq)
			         draw_stpframe(stpwidth,lookupfreqwidth);
                              *current_draw = W;

                           }      
#                       endif
		     }
		     break;

		  /*toggle pause on screenfull*/
		  case 'f':
		     stppause=abs(stppause-1);
		     if (keyindex==1)  showkey;
		     break;
		  /*toggle remove - restore interrupt key index*/
		  case 'x':
		     if (keyindex){
			tempx=getx;
			tempy=gety;
			erase_box(Maxx-vgax(130)-3,Maxy-vgay(420),
							  Maxx-2,Maxy-2);
			keyindex=0;
			moveto(tempx,tempy);
		     }
		     else {
			showkey;
			keyindex=1;
		     }
		     break;

	       }/*end switch*/
	   }/*if space-time pattern only*/
	}/*if event_ready()*/


	if (is[0]=='q' && limitcheck>0 && direction=='f'){
	   /*interrupt while looking for attractor*/
	   tempx=getx;
	   tempy=gety;
	   xbox=draw_prompt_box(2);
	   sprintf (textb[0],
	     "still looking for attractor cycle, %lu iterations",ittcount);
	   outtext(textb[0]);
	   moveto(xbox,gety+CHeight);
	   outtext("exit-q, cont-ret:");
	   input_string(1,0);
	   if (is[0]=='q'){
	      free(pnhood);
	      for (zu=0;zu<=notocheck;zu++)  free(rcheck[zu]);
	      free(rcheck);
	      free(att[0]);
	      free(att);
	      memory_box(1);
	      goto exitFunc;
	   }
	   moveto(tempx,tempy);
	}
	else if (is[0]=='q' || (stppause==1 && screenend==1)){
#       if __BORC__||__WATCOM__ /*xwindows*/
	   nosound();
#       endif
	   setcolor(white);
	   tempx=getx;
	   tempy=gety;
	   if (!rulemix || rule_unmixed) z_parameter_all(nhood,0,carule[0]);

	   if (twod==2) draw_2d_frame; /*redraw frame*/

	   if (limitcheck==0 && direction=='f'){
	      oldnhood=nhood;

	      resetscreen=print_rule_in_box(2,carule[0]);
	      if (keyindex==1) showkey;
	      if (showlookupfreq){
		 if (is[0]=='4' || is[0]=='k'){
		    for (z=tablemax; z>=0; z--) oldbar[z]=0;
		 }
	      }
	      /*if different nhood rule was loaded
		get rid of lookupfreq graph, swap to eeg*/
	      if (nhood!=oldnhood){
		 if (showlookupfreq) {
		    showeeg=1;
		    showlookupfreq=0;
		    stpgraph=1;
		    eegwidth=vgax(100);
		    if (twod!=2 && twod!=3){
		       erase_box(startxbox-3,startybox-2,xboxmax+2,yboxmax+1);
#                      if __UNIX__
                          *current_draw = *offscreen_pixmap; 
#                      endif
                          draw_stpframe(stpwidth,eegwidth);
#                      if __UNIX__
                          *current_draw = W;
#                      endif		
		    }
		    free(oldbar);
		    for (z=0;z<=gens-1;z++) free(lookupcount[z]);
		    free(lookupcount);
		    sprintf(textb[0],"eegcount");
		    if ((eegcount=(signed short*) calloc
				  (gens,sizeof(signed short)))
					 ==NULL) outof_memory(textb[0]);
		 }
	      }
	   }
	   if (resetscreen==1) screenend=1;

	   moveto(tempx,tempy);
	   if (is[0]=='q'){
	      /*free mem previous states*/
	      for (z=frozen_gens-1;z>=0;z--) free(lastA[z]);
	      free(lastA);
	      if (flipmem==1) free(flippos);
	      if (limitcheck>0 && direction=='f'){
		 for (z=ittcount;z>=0;z--) free(rcheck[z]);
		 free(rcheck);
		 free(att);
		 /*memory_box(1);*/
	      }
	      if (showlookupfreq || lookup_entropy){
		 free(oldbar);
		 for (z=0;z<=gens-1;z++) free(lookupcount[z]);
		 free(lookupcount);
	      }
	      if (showeeg || lookup_entropy) free(eegcount);
	      free(pnhood);
	      free(edata);
#             if __BORC__||__WATCOM__ /*xwindows*/
		 free(statblock);
#             endif
	      free(statbuf);
	      totstatrules=0;
	      if (exhaustive_testing==2 &&
		      direction=='f' && limitcheck==0) free(exh_pairs);
	      /*memory_box(1);*/
	      goto exitFunc;
	   }
	}

/*--------Screen end------------*/
	if (screenend==1){
	   if (twod<2){
	      if (diff_plot) setviewport(0, 0,stpwidth+lineL*fscale,Maxy,1);
	      else setviewport(0, 0,stpwidth,Maxy,1);
	   }
	   else if (twod==2) /*setviewport(0, 0,i2d*fscale+2,Maxy,1);*/
		   setviewport(0, 0,stpwidth,Maxy,1);
	   else if (twod==3){
	      setviewport(0, 0,polyx+fscale*i2d+axo_cell_h*j2d,Maxy,1);
	      strip=downy=0;
	      polyx=0;
	      polyy=axo_cell_h*j2d;
	   }

	   if (showlookupfreq==2){
	      thisxbox=startxbox-1;
	      thisybox=startybox-1;
	      for (z=tablemax; z>=0; z--) oldbar[z]=0;

	      setviewport(0,0,stpwidth,vgay(20),1);
	      clearviewport();

	      if (keyindex) setviewport(0,vgay(20),Maxx-vgax(135),Maxy,1);
	      else setviewport(0,vgay(20),Maxx,Maxy,1);
	   }
      
           clearviewport();
	   setviewport(0, 0, Maxx, Maxy, 1);

#          if __UNIX__ /*clear pixmap*/
              *current_draw = *offscreen_pixmap;
	      setfillstyle(SOLID_FILL,black);
	      bar(0,0,pixmap_width,Maxy);     	    	
              *current_draw = W;
              putimage(0,0,offscreen_pixmap,COPY_PUT);
#          endif	      
	   /*redraw frame to window*/
           if (showeeg) draw_stpframe(stpwidth,eegwidth);
           if (showlookupfreq) draw_stpframe(stpwidth,lookupfreqwidth);
           /*redraw frame to pixmap*/
#          if __UNIX__
              *current_draw = *offscreen_pixmap; 
              if (showeeg) draw_stpframe(stpwidth,eegwidth);
              if (showlookupfreq) draw_stpframe(stpwidth,lookupfreqwidth);
              *current_draw = W;
#          endif	
	   if (showlookupfreq){
	      startxbox=stpwidth+(signed short)lookupfreqwidth+vgax(10);
	      xboxmax=startxbox+(signed short)lookupfreqwidth;
	      if (!(lookup_entropy && nhood>5)){
		 draw_box(-1,startxbox-3,startybox-2,xboxmax+2,yboxmax+1,1,0);
		 for (z=tablemax; z>=0; z--) oldbar[z]=0;
	      }
	   }
	   moveto(0,0);
	   if (twod==3){
	      moveto(polyx,polyy);
	      draw_axon_plane(fscale,gety,color0);
	   }
	   screenend=0;
	}
	is[0]=0;
   } /******* while loop **********/
exitFunc:
   /*memory for damage statistical sample*/
   if (diff_plot==3) free(dp.damage_buf); /*statistical sample*/
#  if __UNIX__
      freeimage(offscreen_pixmap);
      free(offscreen_pixmap);
#  endif
   if (direction=='f' && limitcheck==0) stp=tempstp;
}
/************ setup diff statistical sample plot *************/
void setup_diff_plot(diff_var *dp){

 signed short xbox;
 unsigned short zu;
      
      dp->diff_sample_count=1;
      dp->old_damage_count=0;

      /*memory for damage statistical sample*/
      xbox=draw_prompt_box(4);
      outtext(
      "Damage Spread: show binned damage-b, actual sizes-default:");
      input_string(1,0);
      if (is[0]=='b') dp->d_bin_type='b';
      else dp->d_bin_type='n'; 

      moveto(xbox,gety+CHeight);
      dp->max_d_hist=lineL/2;
      dp->min_d_hist=20;
      if (dp->min_d_hist>dp->max_d_hist) 
           dp->min_d_hist=dp->max_d_hist;

      if (dp->d_bin_type=='b'){
	 dp->d_histno=100;
	 sprintf(textb[0],
	   "select no of damage bins (min 20 default %d):",
					 dp->d_histno);
	 myouttext(textb[0]);
	 input_string(5,0);
	 if (atoi(is)>=20 && atoi(is)<=dp->max_d_hist) 
                      dp->d_histno=atoi(is);
	 /*buffer for no of frequency bins*/
	 if ((dp->damage_buf=(unsigned short *)
	    calloc(dp->d_histno+1,sizeof(unsigned short)))
			   ==NULL) outof_memory("dp->damage_buf");
      }
      else {
	 dp->d_histno=dp->max_d_hist;
	 sprintf(textb[0],
	   "select cut-off damage size (min 20 default %d):",
					       dp->max_d_hist);
	 myouttext(textb[0]);
	 input_string(5,0);
	 if (atoi(is)>=20 && atoi(is)<=dp->max_d_hist) 
                       dp->d_histno=atoi(is);

	 /*buffer for all possible damage frequencies*/
	 if ((dp->damage_buf=(unsigned short *)
	    calloc(dp->max_d_hist+1,sizeof(unsigned short)))
		       ==NULL) outof_memory("dp->damage_buf");
      }
     
      moveto(xbox,gety+CHeight);
      dp->d_ittcount=0;
      myouttext(
          "no itterations before damage start (default 0):");
      input_string(5,0);
      if (is[0]!=13 && atoi(is)!=Maxu) dp->d_ittcount=atoi(is);
      moveto(xbox,gety+CHeight);
      dp->same_limit=5;
      sprintf(textb[0],"no itterations same damage (default %d):",
                                            dp->same_limit);
      outtext(textb[0]);
      input_string(5,0);
      if (is[0]!=13 && atoi(is)!=Maxu) dp->same_limit=atoi(is);   
      erase_prompt_box(4);
     
      draw_diff_graphframe(1,0,dp);

      setcolor(lightred);

      /*label x axis*/
      for (zu=0;zu<=dp->d_histno;zu++){	
         if (zu%((unsigned short)((float)dp->d_histno/10))==0){
            line(dp->d_leftx+zu*dp->d_divx,dp->d_boty+1,
	    dp->d_leftx+zu*dp->d_divx,dp->d_boty+vgay(4));
	    moveto(dp->d_leftx+zu*dp->d_divx,dp->d_boty+vgay(4));
	    sprintf(textb[0],"%d",zu);
	    outtext(textb[0]);
         }
         else if (dp->d_histno<=201) 
           line(dp->d_leftx+zu*dp->d_divx,dp->d_boty+1,
		   dp->d_leftx+zu*dp->d_divx,dp->d_boty+vgay(2));
      }     
      /*label y axis*/
      for (zu=0;zu<=dp->d_maxy;zu++){
	 if (zu%((unsigned short)((float)dp->d_maxy/4))==0){
            moveto(dp->d_leftx-1,dp->d_boty-zu*dp->d_divy);
            linerel(-vgax(2),0);
	    sprintf(textb[0],"%d",zu);
            moverel(-(strlen(textb[0])*CWidth+vgax(3)),-vgay(4));
	    outtext(textb[0]);
         }
      }
}

/************ draw diff statistical sample plot *************/
void show_diff_plot(diff_var *dp){
  signed short xbox;
  unsigned short zu,zu1,temp_d_histno,
                 d_buf_index,damage_extra=0,log_count,
                 d_buf_total,max_bin,d_combine_bufs;
  char tobe_rescaled=0,xlog=0,ylog=0;
  double thisdivx;

        /*save % damage to buffer*/
        if (dp->d_bin_type=='b') d_buf_index=(unsigned short)
		      ((dp->percent_damage/100.0)*dp->d_histno);
        else if (dp->d_bin_type=='n') 
                             d_buf_index=dp->damage_count;

        if (d_buf_index>dp->d_histno) damage_extra+=1;
        else dp->damage_buf[d_buf_index]+=1;
		 
      rescale:/*rescale x axis if reset, show sample count*/
        /*ammend width of bars*/
        if ((signed short)dp->d_divx>=vgax(4)) 
                                   thisdivx=dp->d_divx-2;
        else if (dp->d_divx>=1) thisdivx=dp->d_divx-1;
        else thisdivx=0;
        /*show damage histogram*/
        /*rescale y axis bigger*/
        if (((double)dp->damage_buf[d_buf_index]*dp->d_divy) >
                       dp->d_height || tobe_rescaled==1){	

	   /*input_string(1,0);*/

           /*rescale y axis and redraw graph*/
           if (!xlog && !tobe_rescaled) dp->d_divy*=.75;
           tobe_rescaled=0;
	   dp->d_maxy=(unsigned short)(dp->d_height/dp->d_divy);

           draw_diff_graphframe(0,xlog,dp);
           /*ammend width of bars*/
           if ((signed short)dp->d_divx>=vgax(4)) 
                                   thisdivx=dp->d_divx-2;
           else if (dp->d_divx>=1) thisdivx=dp->d_divx-1;
           else thisdivx=0;
           setcolor(lightred);		    
           if (!xlog){
              /*label x axis*/
	      for (zu=0;zu<=dp->d_histno;zu++){
	         if (zu%((unsigned short)((float)
                                dp->d_histno/10))==0){
		    line(dp->d_leftx+zu*dp->d_divx,dp->d_boty+1,
			  dp->d_leftx+zu*dp->d_divx,dp->d_boty+vgay(4));
		    moveto(dp->d_leftx+zu*dp->d_divx,dp->d_boty+vgay(4));
		    sprintf(textb[0],"%d",zu);
		    outtext(textb[0]);
	          }
	          else if (dp->d_histno<=200)
		     line(dp->d_leftx+zu*dp->d_divx,dp->d_boty+1,
			 dp->d_leftx+zu*dp->d_divx,dp->d_boty+vgay(2));
	      }
               /*label y axis*/
	      for (zu=0;zu<=dp->d_maxy;zu++){
	         if (zu%((unsigned short)((float)
                                            dp->d_maxy/4))==0 ){
		    moveto(dp->d_leftx-1,dp->d_boty-zu*dp->d_divy);
		    linerel(-vgax(2),0);
		    sprintf(textb[0],"%d",zu);
		    moverel(-(strlen(textb[0])*CWidth+vgax(3)),-vgay(4));
		    outtext(textb[0]);
	         }
	      }
	   }	   
                    
	   /*find highest col*/
           if (xlog){ 
              thisdivx=vgax(25);
              log_count=0;
              setfillstyle(SOLID_FILL,yellow);
              max_bin=0;
              for (zu=0;zu<=dp->d_histno;zu++){
                 d_combine_bufs=zu*2-(zu-1);                 
                 d_buf_total=0;
                 for (zu1=zu;zu1<=zu+d_combine_bufs;zu1++){
		     /*if ((zu+d_combine_bufs)>dp->d_histno) break;*/	
                     if (zu1>dp->d_histno) break;
		     d_buf_total+=dp->damage_buf[zu1];		     
                 }
		 if (d_buf_total>max_bin) max_bin=d_buf_total;
                 if (zu>0) zu=zu+d_combine_bufs-1;
	      }
              moveto(dp->d_leftx-1,dp->d_boty);
              for (zu1=0;zu1<=4;zu1++){ /*label y axis*/
                 if (!ylog || zu1==0)moveto(dp->d_leftx-1,
                            dp->d_boty-(dp->d_height/4)*zu1);
                 else moveto(dp->d_leftx-1,
                    dp->d_boty-dp->d_height*
                       log2((dp->d_height/4)*zu1)/
                                 log2(dp->d_height) );
	         linerel(-vgax(3),0);
                 sprintf(textb[0],"%d",
                      (unsigned short) (((float)max_bin/4)*zu1));
	         moverel(-(strlen(textb[0])*CWidth+vgax(3)),-vgay(4));
	         outtext(textb[0]);		       
	      }
	   }                      
           setfillstyle(SOLID_FILL,white);
	   for (zu=0;zu<=dp->d_histno;zu++){                      
              if (xlog){
                 d_combine_bufs=zu*2-(zu-1);                 
                 d_buf_total=0;
                 for (zu1=zu;zu1<=zu+d_combine_bufs;zu1++){
		     /*if ((zu+d_combine_bufs)>dp->d_histno) break;*/
                    if (zu1>dp->d_histno) break;
		    d_buf_total+=dp->damage_buf[zu1];
		 }
                 line(dp->d_leftx+log_count*thisdivx,
                   dp->d_boty+1,dp->d_leftx+log_count*thisdivx,
                     dp->d_boty+vgay(4));
	         moveto(dp->d_leftx+log_count*thisdivx,
                                             dp->d_boty+vgay(4));
	         sprintf(textb[0],"%d",zu);
	         outtext(textb[0]);
                 moveto(dp->d_leftx+thisdivx*log_count,dp->d_boty);
                 if (d_buf_total>0){
		    if (!ylog) bar(getx,gety-
                       (((double)d_buf_total/
                              max_bin)*dp->d_height),
					    getx+thisdivx-3,gety);
                    else bar(getx,gety-dp->d_height*
                      log2((((double)d_buf_total/max_bin)*
                             dp->d_height))/log2(dp->d_height),
				       getx+thisdivx-3,gety);
                 }
                 if (zu>0)  zu=zu+d_combine_bufs-1;
                 log_count+=1;                          
	      }                          
              else{              
                 moveto(dp->d_leftx+dp->d_divx*zu,dp->d_boty);
                 d_buf_total=dp->damage_buf[zu];
	         if (d_buf_total==0) continue;
	         bar(getx,gety-d_buf_total*dp->d_divy,
					  getx+thisdivx,gety);
	      }
	   }
	   /*show extra*/
	   if (damage_extra>0 && !xlog){
	      setfillstyle(SOLID_FILL,yellow);
	      moveto(dp->d_leftx+dp->d_divx*(dp->d_histno+1),
                                                 dp->d_boty);
	      if ((damage_extra*dp->d_divy) < dp->d_height)
		    bar(getx,gety-damage_extra*dp->d_divy,
					getx+thisdivx,gety);
	      else bar(getx,gety-dp->d_height,getx+thisdivx,gety);
	   }
        }
        else if (d_buf_index<=dp->d_histno){
           setfillstyle(SOLID_FILL,white);
           moveto(dp->d_leftx+dp->d_divx*d_buf_index,dp->d_boty);
	   bar(getx,gety-dp->damage_buf[d_buf_index]*dp->d_divy,
					getx+thisdivx,gety);
        }
        /*show extra*/
        else if (damage_extra>0 && !xlog){
           setfillstyle(SOLID_FILL,yellow);
           moveto(dp->d_leftx+dp->d_divx*(dp->d_histno+1),
                                                 dp->d_boty);
           if (damage_extra*dp->d_divy<dp->d_height)
			  bar(getx,gety-damage_extra*dp->d_divy,
					getx+thisdivx,gety);
           else bar(getx,gety-dp->d_height,getx+thisdivx,gety);
        }
        /* show sample count*/
        setcolor(white);
        moveto(dp->d_leftx,dp->d_topy-vgay(25)+CHeight);
        outtext("sample no=");
        setfillstyle(SOLID_FILL,black);
        bar(getx,gety,getx+CWidth*6,gety+CHeight);
        sprintf(textb[0],"%d ",dp->diff_sample_count);
        outtext(textb[0]);

        
        if (xlog==1){
           setcolor(white);
           draw_prompt_box(1);
           if (ylog==1) outtext("y-axis log2, "); 
           outtext("x-axis bined by powers of 2, cont-ret:");
           input_string(1,0);
           xlog=ylog=0;
           dp->d_histno=temp_d_histno;
           tobe_rescaled=1;
	   goto rescale;
        }

        if (dp->pause_dam_hist==1){ /*was interrupted*/
           setcolor(white);
	   xbox=draw_prompt_box(2);
	   if (dp->d_bin_type=='b')
			outtext("undo pause-u:");
	   else if (dp->d_bin_type=='n'){
	      outtext("undo pause-u, damage: start-s same-m");
              moveto(xbox,gety+CHeight);
              if (dp->d_bin_type=='n') 
                          outtext("x-axis-x log-x-axis-X log-both-b:");
              else outtext("x-axis-x:");
           }
	   input_string(1,0);
	   erase_prompt_box(2);
	   if (is[0]=='u') dp->pause_dam_hist=0;
	   else if (is[0]=='x'){
              dp->d_histno=dp->max_d_hist;
	      xbox=draw_prompt_box(2);
	      outtext("revise cut-off damage size");
	      moveto(xbox,gety+CHeight);
	      sprintf(textb[0],"now %d (min 20 default %d):",
					  dp->d_histno,dp->max_d_hist);
	      myouttext(textb[0]);
	      input_string(5,0);
	      if (atoi(is)>=20 && atoi(is)<=dp->max_d_hist)
						dp->d_histno=atoi(is);
	      dp->d_divx=dp->d_width/(dp->d_histno+2);
	      /*reset extra*/
	      damage_extra=0;
	      if (dp->max_d_hist>dp->d_histno){
	         for (zu=dp->d_histno+1;zu<=dp->max_d_hist;zu++)
				 damage_extra+=dp->damage_buf[zu];
	      }
	      erase_prompt_box(2);
              tobe_rescaled=1;
	      goto rescale;
	   }
           else if (is[0]=='X' || is[0]=='b'){
              xlog=1;
              if (is[0]=='b') ylog=1;
              temp_d_histno=dp->d_histno;
              dp->d_histno=dp->max_d_hist;
              tobe_rescaled=1;
	      goto rescale;
           }
           else if (is[0]=='s'){
              xbox=draw_prompt_box(1);
              sprintf(textb[0],
                "no itterations before damage start (now %d):",
                                                 dp->d_ittcount);
              myouttext(textb[0]);
              input_string(5,0);
              if (is[0]!=13 && atoi(is)!=Maxu) 
                                     dp->d_ittcount=atoi(is);
              erase_prompt_box(1);
              tobe_rescaled=1;
              goto rescale;
           }
           else if (is[0]=='m'){
              xbox=draw_prompt_box(1);
              dp->same_limit=5;
              sprintf(textb[0],
                  "no itterations same damage (default %d):",
                                               dp->same_limit);
              outtext(textb[0]);
              input_string(5,0);
              if (is[0]!=13 && atoi(is)!=Maxu) 
                                       dp->same_limit=atoi(is);   
              erase_prompt_box(1);
              tobe_rescaled=1;
              goto rescale;
	   }
        }
      
}
/******** draw diff plot graph outline and titles and info  *************/
void draw_diff_graphframe(char first, char xlog,diff_var *dp){
   unsigned short xbox;


      dp->d_leftx=vgax(50);
      dp->d_boty=Maxy-vgay(30);
      dp->d_width=(float)vgax(430);
      dp->d_divx=dp->d_width/(dp->d_histno+2);
      dp->d_height=(double)vgay(100);
      dp->d_topy=dp->d_boty-dp->d_height;
      if (first==1) dp->d_divy=dp->d_height/vgay(10);
      dp->d_maxy=(unsigned short)(dp->d_height/dp->d_divy);

      setfillstyle(SOLID_FILL,black);
      setcolor(lightred);

      bar3d(vgax(2),dp->d_topy-vgay(30),
        dp->d_leftx+dp->d_width+vgax(20),dp->d_boty+vgay(28),0,0);
      bar3d(dp->d_leftx-1,dp->d_topy-1,
			dp->d_leftx+dp->d_width+1,dp->d_boty,0,0);
      moveto(dp->d_leftx,dp->d_topy-vgay(25));                    
      setcolor(white);
      setfillstyle(SOLID_FILL,white);
      outtext("Damage Histogram ");
      xbox=getx;             
      if (twod) sprintf(textb[0]," net=%dx%d",i2d/2,j2d);
      else sprintf(textb[0]," 1d net=%d",lineL/2);
      outtext(textb[0]);
      sprintf(textb[0],
        " damage:start=%d same=%d pause/reset-=",
                                   dp->d_ittcount,dp->same_limit);
      outtext(textb[0]);

      moveto(xbox,gety+CHeight);
      if (nhood_mixed) sprintf(textb[0]," k=%d-%d",nhood_lb,nhood_ub);
      else sprintf(textb[0]," k=%d",nhood);
      outtext(textb[0]);
      if (nonlocal==0 || regular2d) outtext(" local wiring");
      else outtext(" rand-wiring");
      if (zonesize){ 
         sprintf(textb[0]," zone-diam=%d",zonesize);
         outtext(textb[0]);
      }
      if (cinputfreq){ 
         sprintf(textb[0]," C-in=%.2f%%",cinputfreq*100);
         outtext(textb[0]);
      }
      moveto(dp->d_leftx+dp->d_width/4,dp->d_boty+vgay(15));
      if (dp->d_bin_type=='n') outtext("Damage value");
      else if (dp->d_bin_type=='b') outtext("Damage bin");
      moveto(vgax(5),dp->d_boty-dp->d_height/2+CHeight/2);
      outtext("Freq-");
      moveto(vgax(5),gety+CHeight);
      outtext("uency");

      moveto(dp->d_leftx+dp->d_width/4,dp->d_boty+vgay(15));
      if (dp->d_bin_type=='n'){
         outtext("Damage value");
         if (xlog==1) outtext(" - log base 2");
      }
      else if (dp->d_bin_type=='b') outtext("Damage bin");
      moveto(vgax(5),dp->d_boty-dp->d_height/2+CHeight/2);
      outtext("Freq-");
      moveto(vgax(5),gety+CHeight);
      outtext("uency");
      if (xlog){
         moveto(vgax(5),gety+CHeight);
	 outtext("log2");
      }
}





