/******** various functions that work with run_forward() ******/
#include "edecfunc.h"
#include <fcntl.h>
#if __BORC__||__WATCOM__
#   include <io.h>
#   include <sys\stat.h>
#elif __UNIX__
#   include <sys/types.h>
#   include <sys/uio.h>
#endif
/********************** load a rule from the glider file *********/
void glider_rule(char fscale,char fsep){
 signed short rulebytes,tablemax,
	  fileno, /*no of glider rule files for loading*/
	  tempx,tempy;


   if (nhoodm[0]==5 || nhoodm[0]==6 || nhoodm[0]==7){
      while (1){
	 if (nhoodm[0]==5) fileno=myrand()%63;
	 if (nhoodm[0]==6) fileno=myrand()%3;
	 if (nhoodm[0]==7) fileno=myrand()%10;
	 if (fileno) break;
      }
      /*load_glider_rule(carule[0],fileno);*/
      rulebytes=(signed short)ceil(pow(2,(double)nhood)/8);

      memcpy(carule[0],glider_buf+5+fileno*rulebytes,rulebytes);
      if ((lineL<(unsigned short)vgax(201) && fscale==1) || twod){
	 tempx=getx;
	 tempy=gety;
	 sprintf(textb[0],"1d glider rule=%d ",fileno);
	 draw_prompt_box(1);
	 outtext(textb[0]);
	 tablemax= (signed short)pow(2,(double)nhood)-1;
	 if (nhood<6){
	    moverel(0,vgax(3));
	    print_layered_bitstring(64,carule[0],tablemax,fscale,fsep,0,1);
	    moverel(0,-vgax(3));
	    outtext(" ");
	 }
	 print_current_bitstring_hexbytes(0,carule[0],nhood,Maxx,white,0);
	 moveto(tempx,tempy);
      }
   }
}

/********************** load a rule from the glider file *********/
unsigned long stat_rule(char autostat,unsigned long statrule_index){
 signed short rulebytes;
 unsigned long ruleindex=0;

   rulebytes=(signed short)ceil(pow(2,(double)nhood)/8);
   if (autostat==0){
      draw_prompt_box(1);
      if (totstatrules==0) load_rule_stats();
      if (totstatrules==0) return(ruleindex);

      draw_prompt_box(1);
      sprintf(textb[0],"rule sample: load new-n, rule index 1-%lu:",
						     totstatrules);
      outtext(textb[0]);
      input_string(5,0);
      if (is[0]=='q') return(ruleindex);
      if (is[0]=='n'){
	 load_rule_stats();
	 if (is[0]=='q' || totstatrules==0) return(ruleindex);
      }
      else if (is[0]==13) ruleindex=1;
      else if (atol(is)>0 && atol(is)<=totstatrules) ruleindex=atol(is);
      else ruleindex=1;;
   }
   else if (autostat==1) ruleindex=statrule_index;

   memcpy(carule[0],statbuf+(ruleindex-1)*(rulebytes+2),rulebytes);


   sprintf(textb[0],"index %lu",ruleindex);
   draw_prompt_box(1);
   outtext(textb[0]);

   sprintf(textb[0]," sdev=%.4f rule=",
      ((float)statbuf[(ruleindex-1)*(rulebytes+2)+rulebytes+1]*.18)/255);
   outtext(textb[0]);
   print_current_bitstring_hexbytes(0,carule[0],nhood,Maxx,white,0);

   return(ruleindex);
}


/***************** set local 2d wiring for nhood 1-9 *******************/
void set_local_2d_wiring(unsigned short n,unsigned short *pnhood){
   signed short ii,jj,in,jn;
   char i;
	      ii=n%i2d;
	      jj=n/i2d;

	      /*  * 0 *  ..the nhood */
	      if (nhoodm[n]==1){
		 centre;
		 pnhood[0]=i2d*jn+in;
	      }
	      /*  1
		  0 *  ..the nhood */
	      else if (nhoodm[n]==2){
		 for (i=1;i>=0;i--){
		    switch(i){
		       case 1:  north    ; break;
		       case 0:  centre   ;
		    }
		    pnhood[i]=i2d*jn+in;
		 }
	      }
	      /*  2 1 0   ..the nhood */
	      else if (nhoodm[n]==3){
		 for (i=2;i>=0;i--){
		    switch(i){
		       case 2:  west     ; break;
		       case 1:  centre   ; break;
		       case 0:  east     ;
		    }
		    pnhood[i]=i2d*jn+in;
		 }
	      }
	      /*     3
		   2 1 0   ..the nhood */
	      else if (nhoodm[n]==4){
		 for (i=3;i>=0;i--){
		    switch(i){
		       case 3:  north    ; break;
		       case 2:  west     ; break;
		       case 1:  centre   ; break;
		       case 0:  east     ;
		    }
		    pnhood[i]=i2d*jn+in;
		 }
	      }
	      /*   3
		 4 2 0   ..the nhood
		   1   */
	      else if (nhoodm[n]==5){
		 for (i=4;i>=0;i--){
		    switch(i){
		       case 4: west;      break;
		       case 3: north;     break;
		       case 2: centre;    break;
		       case 1: south;     break;
		       case 0: east;
		    }
		    pnhood[i]=i2d*jn+in;
		 }
	      }
	      /*  5 4 3
		  2 1 0   ..the nhood */
	      else if (nhoodm[n]==6){
		 for (i=5;i>=0;i--){
		    switch(i){
		       case 5:  northwest; break;
		       case 4:  north    ; break;
		       case 3:  northeast; break;
		       case 2:  west     ; break;
		       case 1:  centre   ; break;
		       case 0:  east     ;
		    }
		    pnhood[i]=i2d*jn+in;
		 }
	      }
	      /* triangular grid
			      odd rows
		    6 5	      from top     6 5     even rows     6 5
		    4 3 2   ..the nhood  4 3 2   ..the nhood    4 3 2
		    1 0   *                1 0                   1 0   */
	      else if (nhoodm[n]==7){
		 for (i=6;i>=0;i--){
		    if ((jj+1)%2==0){
		       switch(i){
			  case 6:  northwest; break;
			  case 5:  north    ; break;
			  case 4:  west     ; break;
			  case 3:  centre   ; break;
			  case 2:  east     ; break;
			  case 1:  southwest; break;
			  case 0:  south    ;
		       }
		       pnhood[i]=i2d*jn+in;
		    }
		    else{
		       switch(i){
			  case 6:  north    ; break;
			  case 5:  northeast; break;
			  case 4:  west     ; break;
			  case 3:  centre   ; break;
			  case 2:  east     ; break;
			  case 1:  south    ; break;
			  case 0:  southeast;
		       }
		       pnhood[i]=i2d*jn+in;
		    }
		 }
	      }
	      /* 7 6 5
		 4 3 2   ..the nhood
		 1   0    */
	      else if (nhoodm[n]==8){
		 for (i=7;i>=0;i--){
		    switch(i){
		       case 7:  northwest; break;
		       case 6:  north    ; break;
		       case 5:  northeast; break;
		       case 4:  west     ; break;
		       case 3:  centre   ; break;
		       case 2:  east     ; break;
		       case 1:  southwest; break;
		       case 0:  southeast;
		    }
		    pnhood[i]=i2d*jn+in;
		 }
	      }
	      /* 8 7 6
		 5 4 3   ..the nhood
		 2 1 0   */
	      else if (nhoodm[n]==9){
		 for (i=8;i>=0;i--){
		    switch(i){
		       case 8: northwest; break;
		       case 7: north;     break;
		       case 6: northeast; break;
		       case 5: west;      break;
		       case 4: centre;    break;
		       case 3: east;      break;
		       case 2: southwest; break;
		       case 1: south;     break;
		       case 0: southeast;
		    }
		    pnhood[i]=i2d*jn+in;
		 }
	      }
}

/******* draw axomometric plane for 2-d space-time patterns, Jan 94 ******/
void draw_axon_plane(char fscale,signed short tempy,unsigned char color0){
 signed short tempx,shiftx,compcolor,z,wx,aa;
 float axo_cell_h;

    tempx=getx;
    moveto(tempx,tempy);

	/* | aa|  wx  |

	---    3------4
	      /      /|
	aa   /      / |
	    /      /  |
 tempy --- 1------2   |
	   |      |   |7
	   |      |   /
	   |      |  /
	   |      | /
 Maxy-1 __ |______|/
	   5      6

	   |
	   tempx  */

   axo_cell_h=sin(PI/4)*fscale;
   wx=fscale*i2d;
   aa=axo_cell_h*j2d;
   if ((tempy-aa)<2 && fscale>3){
      /*draw vertical lines*/
      for (z=0;z<=i2d;z++) line(tempx+fscale*z,tempy,
			    tempx+fscale*z+aa,tempy-aa);
      /*draw horiz lines*/
      for (z=0;z<=j2d;z++) 
           line(tempx+axo_cell_h*z,tempy-axo_cell_h*z,
	      tempx+axo_cell_h*z+wx,tempy-axo_cell_h*z);
   }
   /*draw transluscent plane*/
   else{
      if ((tempy-aa)<2) color0=white;
      else if (color0==darkgray) color0=magenta;
      else color0=lightred;
      shiftx=0;
      while (gety>=tempy-aa){
	 while (getx<=wx+shiftx){
#           if __BORC__||__WATCOM__ /* not xwindows*/
	       compcolor=getpixel(getx,gety);
	       if (compcolor==0||compcolor==magenta||
		   compcolor==lightred) compcolor=color0;
	       else compcolor=0;;
#           endif
	    putpixel(getx,gety,compcolor);
	    moverel(2,0);
	 }
	 shiftx+=2;
	 moveto(shiftx,gety-2);
      }
     /*draw outline*/
     line(tempx,tempy,tempx+wx,tempy);             /*1-2*/
     line(tempx,tempy,tempx+aa,tempy-aa);          /*1-3*/
     line(tempx+aa,tempy-aa,tempx+aa+wx,tempy-aa); /*3-4*/
     line(tempx+wx,tempy,tempx+wx+aa,tempy-aa);    /*2-4*/
   }
   /*draw axo frame*/
   if ((tempy-axo_cell_h*j2d)<2){
      line(tempx,tempy,tempx,Maxy-1);                   /*1-5*/
      line(tempx,Maxy-1,tempx+wx,Maxy-1);               /*5-6*/
      line(tempx+wx,Maxy-1,tempx+wx,tempy);             /*6-2*/
      line(tempx+wx,Maxy-1,tempx+wx+aa,Maxy-1-aa);      /*6-7*/
      line(tempx+wx+aa,Maxy-1-aa,tempx+wx+aa,tempy-aa); /*7-4*/
   }
   moveto(tempx,tempy);
}

/**************** interupt key index, Dec 93 *****************/
void interrupt_key_index (char frozen_islands,char rule_unmixed,
	 char wiring_madelocal,char showlookupfreq,char lookup_entropy){
   signed short xbox,tempx,tempy,startline,endline;
#  define movedown moveto(xbox,gety+CHeight);
#  define movedown_plus moveto(xbox,gety+1.3*CHeight);

	tempx=getx;
	tempy=gety;
	xbox=Maxx-vgax(130);
	draw_box(-1,xbox-3,Maxy-vgay(420),Maxx-2,Maxy-2,1,0);

	setcolor(lightred);
        outtext("  ");
        startline=getx;
	outtext("INTERRUPT KEY INDEX");
        endline=getx;
	line(startline,gety+CHeight+1,endline,gety+CHeight+1);
	movedown;
	/****************** rules ***********************/
	outtext("  change rule table");
	setcolor(white);
	movedown;
	if (!rulemix) outtext("r..rand rule");
	else  outtext("r/C..rand rules/canalyz");
	movedown;
	outtext("1/2..rand bitflip/restore");
	movedown;
	if (!rulemix){
	   outtext("Z/z..force Z higher/lower");
	   movedown;
	}
	outtext("w/W..tog/force all 1s");
	movedown;
	outtext("b/B..tog/force all 0s");
	if (rulemix==1){
	   movedown;
	   if (rule_unmixed==0) outtext("8..RULEMIX/single");
	   else                 outtext("8..SINGLE/rulemix");

	}
	if (nhoodm[0]==5 || nhoodm[0]==6 || nhoodm[0]==7){
	   movedown;
	   outtext("g..load glider rule");
	   movedown;
	   outtext("v/V..next/load,jmp");
	}
	movedown_plus;
	/********************* wiring ********************/
	if (!loc_twod_fonly){
	   setcolor(lightred);
	   outtext("  change wiring");
	   setcolor(white);
	   movedown;
	   sprintf(textb[0],"m..move %lu wires",wires_to_move);
	   outtext(textb[0]);
	   movedown;
	   outtext("M..revise wire moves");
	}
	if (!loc_twod_fonly && nonlocal){
	   movedown;
	   outtext("7..tog wiring");
	   movedown;
	   if (wiring_madelocal==0) outtext("   nonlocal->local");
	   else                     outtext("   local->nonlocal");
	}
	movedown_plus;
	/******************* seed **********************/
	setcolor(lightred);
	outtext("  change seed/size");
	setcolor(white);
	movedown;
	outtext("4/k..rand seed/block");
	movedown;

	outtext("R..rand bitflip");
	movedown;
	outtext("5/6..singleton pos/neg");
	if (!twod){
	   movedown;
	   outtext("i/d..inc/decrease 1 cell");
	}
	movedown_plus;
	/*******************  presentation **********************/
	setcolor(lightred);
	outtext("  presentation");
	setcolor(white);
	movedown;
	outtext("S..tog space-time pattern");
	movedown;
	outtext("3..tog color setting,");
	movedown;
	outtext("  cell or nhood value");
	movedown;
	outtext("0..tog bground color");
	movedown;
#       if __BORC__||__WATCOM__ /*not xwindows*/
	   outtext("o..tog sound");
	   movedown
#       endif
	outtext("e/c..exp/contr scale");
	movedown_plus;
	/******************  1d 2d 3d ***********************/
	if (twod && diff_plot==0){
	   setcolor(lightred);
	   outtext("  2d space-time pattern");
	   setcolor(white);
	   movedown;
	   outtext("t/T..tog 3d-2d/2d-1d");
	   if (twod==3){
	      movedown;
	      outtext("p..draw plane");
	   }
	   movedown_plus;
	}
	/******************** frozen cells *********************/
	setcolor(lightred);
	outtext("  show frozen cells");
	setcolor(white);
	movedown;
	if (frozen_islands==0) outtext("h..CELL-semi-frozen");
	else if (frozen_islands==1) outtext("h..SEMI-frozen-cell");
	else if (frozen_islands==2) outtext("h..FROZEN-cell-semi");
	movedown;
	sprintf(textb[0],"H..generations (now %d)",frozen_gens);
	outtext(textb[0]);
        if (diff_plot){
           movedown;
           if (diff_plot==2) sprintf(textb[1],"%s","damage set");
           else sprintf(textb[1],"%s","damage not set");
           sprintf(textb[0],"=..tog diff(%s):",textb[1]);
	   outtext(textb[0]);
        }
	movedown_plus;
	/********************  analysis *********************/
	if (!twod && stpgraph){
	   setcolor(lightred);
	   outtext("  analysis");
	   setcolor(white);
	   movedown;
	   if (!nhood_mixed){
	      if (showlookupfreq) outtext("s..tog LOOKUPFREQ-eeg");
	      if (stpgraph==1) outtext("s..tog EEG-lookupfreq");
	      movedown;
	      if (stpgraph>1) {
		 if (showlookupfreq==1)
			outtext("L..tog HISTOGRAM-graph");
		 else if (showlookupfreq==2)
			outtext("L..tog GRAPH-histogram");
		 movedown;
	      }
	      outtext("u..eeg-entropy graph");
	      movedown;
	      if (lookup_entropy){
		 outtext("E..entropy-sdev graph");
		 movedown;
	      }
	   }
	   sprintf(textb[0],"G..generations (now %d)",gens);
	   outtext(textb[0]);
	   movedown_plus;
	}
	/******************* state space matrix **********************/
	setcolor(lightred);
	outtext("  state-space matrix");
	setcolor(white);
	movedown;
	outtext("y/Y..reset/tog on-off");
	movedown_plus;
	/********************  index, pause *********************/
	setcolor(lightred);
	outtext("  index,pause,quit");
	setcolor(white);
	movedown;
	outtext("x..tog index display");
	movedown;
	if (stppause) sprintf(textb[1],"on");
	else sprintf(textb[1],"off");
	sprintf(textb[0],"f..tog end pause (%s)",textb[1]);
	outtext(textb[0]);
	movedown;
        if (!twod){
           if (scrolling==1) sprintf(textb[1],"on");
	   else sprintf(textb[1],"off");
	   sprintf(textb[0],"#..tog scrolling (%s)",textb[1]);
	   outtext(textb[0]);
	   movedown;
        }
	sprintf(textb[0],"+..tog time-step  pause");
	outtext(textb[0]);
	movedown;
	outtext("q..pause or quit");
	moveto(tempx,tempy);
}

/**************** set colors acc to nhoods, Oct 93 *****************/
signed short set_nhdcolor(signed short tnhood,signed short z){
  signed short nhdcolor;

	if (z==0) nhdcolor=0;
	else{
	   if (hires==0){
	      if (tnhood==8||tnhood==9) nhdcolor=z/32;
	      else if (tnhood==6||tnhood==7) nhdcolor=z/8;
	      else if (tnhood==4||tnhood==5) nhdcolor=z/2;
	      else if (tnhood<=3) nhdcolor=z+8;
	   }
	   else{
	      if (tnhood==8||tnhood==9) nhdcolor=z/2;
	      else if (tnhood==6||tnhood==7) nhdcolor=z;
	      else if (tnhood==4||tnhood==5) nhdcolor=z+128;
	      else if (tnhood<=3) nhdcolor=z*16+(7*z/4);
	   }
	}
#       if __BORC__||__WATCOM__
	   return(nhdcolor);
#       elif __UNIX__
           return(oldcolor[nhdcolor]);/*xwindows*/
#       endif
}

/******************* draw frame for eeggraph, Oct 93 ********/
void draw_stpframe(signed short stpwidth,float framewidth){
  char z,tempcolor;
        tempcolor=getcolor();
        /*clear space*/
        setfillstyle(SOLID_FILL,black);
        bar(stpwidth,0,stpwidth+framewidth,Maxy);
                     
        /*draw frame*/
	setcolor(red);
	setfillstyle(SOLID_FILL,black);
       
	bar3d(stpwidth,0,stpwidth+framewidth,Maxy,0,0);
	if (stpgraph==1){
	   moveto(stpwidth+(signed short)(framewidth/4),0);
	   for (z=1;z<=3;z++){
		lineto(getx,Maxy);
		moveto(getx+(signed short)(framewidth/4),0);
	   }
	}
        setcolor(black);
        line(stpwidth+1,Maxy,stpwidth+framewidth,Maxy);
	moveto(0,0);
	setcolor(tempcolor);
   
}

/******* draw or erase graph frame for eeg-entropy, Aug 95 ******/
void draw_entgraph_frame(char draw_clear,
	       signed short stpwidth,char show_edata,char ylabel){
  signed short rightedge,tempx,tempy,
	       tempx1,tempy1,tempx2,z,xaxismax;
  unsigned char existcolor;
  float xinterval;

      tempx=getx;
      tempy=gety;

      if (show_edata==0 || show_edata==1)
	  rightedge=stpwidth+vgax(100)+2+vgax(200)+vgax(10);
      else if (show_edata==2){
	  rightedge=stpwidth+vgax(100)+2+vgax(256)+vgax(10);
	  if (rightedge>Maxx-2) rightedge=Maxx-2;
      }
      /*clear space*/
      draw_box(-1,stpwidth+vgax(100)+1,Maxy-2-vgay(200)-vgax(10),
	 rightedge,Maxy-1,0,0);

      if (draw_clear==0){
	 moveto(tempx,tempy);
	 return;
      }

      existcolor=getcolor();
      setcolor(lightred);
      /*draw graph outline*/
      draw_box(-1,stpwidth+vgax(100)+2+vgax(10),Maxy-2-vgay(200)-vgax(10),
	 rightedge,Maxy-2-vgax(10),1,0);


      /*draw x axis divisions*/
      moveto(stpwidth+vgax(100)+2+vgax(10),Maxy-2-vgax(10));
      if (show_edata==0 || show_edata==1){
	 xaxismax=9;
	 xinterval=20;
      }
      if (show_edata==2){
	 xaxismax=18;
	 xinterval=256.0/18;
      }
      tempx1=getx;
      tempy1=gety;

      for (z=1;z<=xaxismax-1;z++){
	 moveto(tempx1+vgax((signed short)(xinterval*z)),tempy1);
	 linerel(0,vgay(3));
      }
      /*draw y axis divisions*/
      moveto(stpwidth+vgax(100)+2+vgax(10),Maxy-2-vgax(10));
      tempx1=getx;
      for (z=1;z<=9;z++){
	 moveto(tempx1,gety-vgay(20));
	 linerel(-vgax(3),0);
      }

      /*label x axis*/
      moveto(stpwidth+vgax(102)+vgax(10),Maxy-vgay(10));
      outtext("0");
      moveto(stpwidth+vgax(102)+vgax(10)+vgax(80),Maxy-vgay(10));
      if (show_edata==0 || show_edata==1){
	 moveto(stpwidth+vgax(102)+vgax(10)+vgax(80),Maxy-vgay(10));
	 outtext("density");
	 moveto(stpwidth+vgax(100)+vgax(10)+vgax(200),Maxy-vgay(10));
	 outtext("1");
      }
      else  if (show_edata==2){
	 moveto(stpwidth+vgax(102)+vgax(10)+vgax(25),Maxy-vgay(10));
	 outtext ("standard deviation");
	 moveto(stpwidth+vgax(102)+vgax(10)+
	    vgax((signed short)(xinterval*10))-vgax(5),Maxy-vgay(10));
	 outtext("0.1");
	 moveto(stpwidth+vgax(100)+vgax(10)+
	    vgax((signed short)(xinterval*18))-vgax(10),Maxy-vgay(10));
	 outtext("0.18");
      }


      /*centre y axis title*/
#     if __BORC__
	 settextstyle(2,VERT_DIR , 0);
	 moveto(stpwidth+vgax(100),Maxy-vgay(17));
#     elif __WATCOM__
	 _settextorient(0,1);
	 moveto(stpwidth+vgax(102),Maxy-vgay(12));
#     elif __UNIX__
	 moveto(stpwidth+vgax(106),Maxy-vgay(17));
#     endif
      outtext("0");

#     if __WATCOM__
	 moveto(stpwidth+vgax(101),Maxy-vgay(90));
#     elif __UNIX__||__BORC__
	 moveto(stpwidth+vgax(98),Maxy-vgay(130));
#     endif

      if (show_edata==0 || show_edata==1){
	 sprintf(textb[0],"%s","entropy");
      }
      else if (show_edata==2){
	 if (ylabel==0) sprintf(textb[0],"mean entropy");
	 else if (ylabel==1) sprintf(textb[0],"Z parameter");
	 else if (ylabel==2) sprintf(textb[0],"lambda ratio");
      }
#     if __BORC__||__WATCOM__
	 outtext(textb[0]);

#     elif __UNIX__
	 moveto(getx+CWidth,gety);
	 tempx2=getx;
	 for (z=0;z<=strlen(textb[0])-1;z++){
	    sprintf(textb[1],"%c",textb[0][z]);
	    outtext(textb[1]);
	    moveto(tempx2,gety+CHeight*.7);
	 }
#     endif

#     if __BORC__
	 moveto(stpwidth+vgax(100),Maxy-vgay(15)-vgay(200));
	 outtext("1");
	 settextstyle(2, HORIZ_DIR, 0);
#     elif __WATCOM__
	 moveto(stpwidth+vgax(102),Maxy-vgay(8)-vgay(200));
	 outtext("1");
	 _settextorient(1,0);
#     elif __UNIX__
	 moveto(stpwidth+vgax(106),Maxy-vgay(13)-vgay(200));
	 outtext("1");
#     endif

      setcolor(existcolor);
      moveto(tempx,tempy);
}
/******* draw or erase graph frame for eeg-entropy, Aug 95 ******/
void draw_Hamming_plot(char draw_clear,signed short stpwidth){
  signed short z,rightedge,tempx,tempy, tempx1,tempy1,
	       xaxismax;
  unsigned char existcolor;
  float xinterval;

      tempx=getx;
      tempy=gety;

      
      rightedge=stpwidth+vgax(100)+2+vgax(200)+vgax(10);
      
      /*clear space*/
      draw_box(-1,stpwidth+vgax(100)+1,Maxy-2-vgay(200)-vgax(10),
	 rightedge,Maxy-1,0,0);

      if (draw_clear==0){
	 moveto(tempx,tempy);
	 return;
      }

      existcolor=getcolor();
      setcolor(lightred);
      /*draw graph outline*/
      draw_box(-1,stpwidth+vgax(100)+2+vgax(10),Maxy-2-vgay(200)-vgax(10),
	 rightedge,Maxy-2-vgax(10),1,0);


      /*draw x axis divisions*/
      moveto(stpwidth+vgax(100)+2+vgax(10),Maxy-2-vgax(10));
     
      xaxismax=9;
      xinterval=20;
      
      
      tempx1=getx;
      tempy1=gety;

      for (z=1;z<=xaxismax-1;z++){
	 moveto(tempx1+vgax((signed short)(xinterval*z)),tempy1);
	 linerel(0,vgay(3));
      }
      /*draw y axis divisions*/
      moveto(stpwidth+vgax(100)+2+vgax(10),Maxy-2-vgax(10));
      tempx1=getx;
      for (z=1;z<=9;z++){
	 moveto(tempx1,gety-vgay(20));
	 linerel(-vgax(3),0);
      }

      /*label x axis*/
      moveto(stpwidth+vgax(100)+2+vgax(10),Maxy-2-vgax(10));
      outtext("0");
      moveto(stpwidth+vgax(100)+2+vgax(10)+vgax(80),Maxy-2-vgax(10));
      
	 moveto(stpwidth+vgax(100)+2+vgax(10)+vgax(80),Maxy-2-vgax(10));
	 outtext("Hamming distance (t+1)");
	 moveto(stpwidth+vgax(100)+1+vgax(10)+vgax(200),Maxy-2-vgax(10));
	 outtext("1");
      /*centre y axis title*/
#     if __BORC__
	 settextstyle(2,VERT_DIR , 0);
	 moveto(stpwidth+vgax(100),Maxy-vgax(4)-vgax(14));
#     elif __WATCOM__
	 _settextorient(0,1);
	 moveto(stpwidth+vgax(102),Maxy-vgax(11));
#     endif
      outtext("0");
      moveto(stpwidth+vgax(98),Maxy-vgay(130));
      outtext("H(t)");
      moveto(stpwidth+vgax(100),Maxy-vgax(14)-vgay(200));
      outtext("1");

#     if __BORC__
	 settextstyle(2, HORIZ_DIR, 0);
#     elif __WATCOM__
	 _settextorient(1,0);
#     endif

      setcolor(existcolor);
      moveto(tempx,tempy);
}

/***************** set local 2d wiring for nhood 1-9 *******************/
char moment(unsigned long edataruleno,
    char show_edata,char file_edata,char *thisrule,float *edata,
	signed short n, unsigned char color1,
	char fscale,char fsep,unsigned short stpwidth){

 /*given array data[1...n] computes mean              =ave,
				    average deviation =adev,
				    standard deviation=sdev,
				    varience          =svar,
				    skewness          =skew,
				    kurtosis          =curt  */

 float ave,adev,sdev,svar,skew,curt;
 signed short j,xbox,tempx,tempy,rulebytes/*,z*/;
 float s,p;
 unsigned char *buf,char_ave,char_sdev;
 char automatic_was_set=0,file_e=0;

   s=0.0;
   for (j=1;j<=n;j++) s+=edata[j];
   ave=s/n;
   adev=svar=skew=curt=0.0;
   for (j=1;j<=n;j++){
      adev += fabs(s=(float)edata[j]-ave);
      svar += (p=s*s);
      skew += (p *= s);
      curt += (p *= s);
   }
   adev /= n;
   svar /= (n-1);
   sdev=sqrt(svar);
   if (svar){
      skew /= (n*svar*sdev);
      curt=curt/(n*svar*svar)-3.0;
   }
   /*else nrerror("No skew/kurtosis when varience = 0 (in MOMENT)");*/


   tempx=getx;
   tempy=gety;
   xbox=draw_prompt_box(4);
   if (show_edata==2) moveto(xbox,gety+CHeight);
   sprintf(textb[0],"k%d-rule=",nhood);
   outtext(textb[0]);

   if (nhood<6){
      sprintf(textb[0],"(dec)%lu ",
	 dec_equiv(thisrule,(signed short)pow(2,(float)nhood)-1));
      outtext(textb[0]);

   }
   if (nhood>7) sprintf(textb[0],"(hex)\n");
   else sprintf(textb[0],"(hex)");
   outtext(textb[0]);

   print_current_bitstring_hexbytes(1,thisrule,
					 nhood,Maxx,white,0);
   moveto(xbox,gety+CHeight);
   sprintf(textb[0],"mean=%f, average dev=%f, standard dev=%f",ave,adev,sdev);
   outtext(textb[0]);
   moveto(xbox,gety+CHeight);
   sprintf(textb[0],"varience=%f, skewness =%f, kurtosis=%f",svar,skew,curt);
   outtext(textb[0]);

   /*save statistical data to file*/
   /*rule,mean entropy,standard dev,...all as chars*/
   if (file_edata==1){
       rulebytes=(signed short)ceil(pow(2,(double)nhood)/8);
       /*buffer fo append to file*/
       sprintf(textb[0],"rulebuf");
       if ((buf=(char *)calloc(rulebytes+2,sizeof(char)))
				       ==NULL) outof_memory(textb[0]);
       memcpy(buf,thisrule,rulebytes);
       if (sdev>.18) sdev=0.18;

       char_ave=ave*255;
       char_sdev=(sdev/.18)*255;
       buf[rulebytes]=char_ave;
       buf[rulebytes+1]=char_sdev;

       /*check values */
       /*
       xbox=draw_prompt_box(3);
       sprintf(textb[0],"strlen=%d",strlen(buf));
       outtext(textb[0]);
       moveto(xbox,gety+CHeight);
       sprintf(textb[0],"%.3f=%d=%.3f, %.4f=%d=%.4f",
	   ave,char_ave,((float)char_ave)/255,
	      sdev,char_sdev,((float)char_sdev*.18)/255);

       outtext(textb[0]);
       moveto(xbox,gety+CHeight);
       for (z=0;z<=rulebytes+1;z++){
	   sprintf(textb[0],"%c",buf[z]);
	   outtext(textb[0]);
       }
       input_string(1,0);
       */
       save_binary_data(buf,(unsigned long)rulebytes+2);
       free(buf);
   }

   /*pause for each new rule*/
   if (show_edata==1){
      moveto(xbox,gety+CHeight);
      myouttext("next rule: automatic-a, glider-g, same-s, random-ret:");
      input_string(1,0);
      if (is[0]=='g') glider_rule(fscale,fsep);
      else if (is[0]=='s');

      else if (is[0]=='a'){
	 show_edata=2;
	 erase_box(Maxx-vgax(130)-3,Maxy-vgay(420),Maxx-2,Maxy-2);
	 automatic_was_set=1;
	 draw_entgraph_frame(1,stpwidth,show_edata,0);
	 file_e=select_stat_filename();
	 if (file_e==1) automatic_was_set=2;
      }
      else color1=bit_flip('r',color1);/*set new random rule*/
   }

   /*automatic next random rule*/
   else if (show_edata==2){
      /*plot green square for current, black pixel for last*/
      statx=stpwidth+vgax(100)+2+vgax(10)+
		     sdev*10*vgax((signed short)(256*10.0/18));
      staty=Maxy-2-vgax(10)-ave*vgay(200);

      if (edataruleno>0){
		 putimage(oldstatx-2,oldstaty-2,statblock,COPY_PUT);
		 putpixel(oldstatx,oldstaty,white);
      }

      getimage(statx-2,staty-2,statx+2,staty+2,statblock);
      setfillstyle(SOLID_FILL,green);
      bar(statx-2,staty-2,statx+2,staty+2);
      oldstatx=statx;
      oldstaty=staty;

      color1=bit_flip('r',color1);/*set new random rule*/
   }

   moveto(tempx,tempy);
   return(automatic_was_set);

}

/******************* select file name for statistical data *******/
char select_stat_filename(void){
   char file_ret,file_e;
   signed short fid;


     file_ret=select_filename("SAVE","STATISTICS","*.sta","my_stat");
     if (file_ret=='q') file_e=0;
     else file_e=1;

     memcpy(filename_data,filename,13);

     draw_prompt_box(1);
     sprintf(textb[0],"%s: append data-a, or new file-default:",
					 filename_data);
     outtext(textb[0]);
     is[0]=0;
     input_string(1,0);
     if (is[0]=='a')

#    if __BORC__||__WATCOM__
	fid=open(filename_data,O_RDWR|O_CREAT|O_APPEND|O_BINARY
						,S_IREAD|S_IWRITE);
        else
	   fid=open(filename_data,O_RDWR|O_CREAT|O_TRUNC|O_BINARY
						,S_IREAD|S_IWRITE);
#    elif __UNIX__
        fid=open(filename_data,O_RDWR|O_CREAT|O_APPEND
						,S_IREAD|S_IWRITE);
        else
	   fid=open(filename_data,O_RDWR|O_CREAT|O_TRUNC
						,S_IREAD|S_IWRITE);
#    endif
     if (fid==-1){
#       if __BORC__||__WATCOM__
	   sprintf(textb[0],"%s, RETURN-continue",sys_errlist[errno]);
#       elif __UNIX__
           sprintf(textb[0],"filing error, RETURN-continue");
#       endif
  
	draw_prompt_box(1);
	outtext(textb[0]);
	input_string(1,0);
	erase_prompt_box(1);
	input_string(1,0);
     }
     close(fid);
     return(file_e);
}

/***************** load statistical data ********************/
unsigned short load_rule_stats(void){

 signed short xbox,tempx,tempy,fid,rulebytes,sx,sy,stpwidth;
 char file_ret,show_list=0,unsorted,graphtype;
 unsigned short datachunk;
 unsigned long filebytes,lz,ruleindex=0;
 unsigned char *rulebuf,*Zbuf,*lambdabuf,
	       *chunkbuf,*chunkbuf1;

 float ave,sdev;

  tempx=getx;
  tempy=gety;

  stpwidth=lineL*scale+vgax(10);
  sprintf(textb[4],"LOAD ");
  file_ret=select_filename(textb[4],"STATISTICS","*.sta","my_stat");

  if (file_ret=='q'){
	moveto(tempx,tempy);
	is[0]='q';
	return(0);
  }
# if __BORC__||__WATCOM__
     fid=open(filename,O_RDWR|O_BINARY);
# elif __UNIX__
      fid=open(filename,O_RDWR);
# endif
  filebytes=(unsigned long) filelength(fid);
  if (fid==-1 || filebytes==0){
#       if __BORC__||__WATCOM__
           sprintf(textb[0],"%s, cont-ret",sys_errlist[errno]);
#       elif __UNIX__
           sprintf(textb[0],"filing erro, cont-ret");
#       endif
        draw_prompt_box(1);
	outtext(textb[0]);
	input_string(1,0);
	moveto(tempx,tempy);
	is[0]='q';
	close(fid);
	return(0);
  }

  free(statbuf);
  /*nominaly calloced in run_forward*/
  sprintf(textb[0],"statbuf");
  if ((statbuf=(char *)calloc(filebytes,sizeof(char)))
				   ==NULL) outof_memory(textb[0]);
  read(fid,statbuf,filebytes);
  /*statbuf remains during forward rum to allow loading rules
  from a rule sample*/

  rulebytes=(signed short)ceil(pow(2,(double)nhood)/8);
  /*rule buffer*/
  sprintf(textb[0],"rulebuf");
  if ((rulebuf=(char *)calloc(rulebytes,sizeof(char)))
				       ==NULL) outof_memory(textb[0]);
  datachunk=rulebytes+2;
  totstatrules=filebytes/datachunk;
  sprintf(textb[0],"Zbuf");
  if ((Zbuf=(char *)calloc(totstatrules+1,sizeof(char)))
				   ==NULL) outof_memory(textb[0]);
  sprintf(textb[0],"lambdabuf");
  if ((lambdabuf=(char *)calloc(totstatrules+1,sizeof(char)))
				   ==NULL) outof_memory(textb[0]);


 start:
  show_list=graphtype=0;
  draw_prompt_box(1);
  sprintf(textb[0],
	 "list=l sort-s graph:Z-Z lambda-L entropy-default quit-q:");
  myouttext(textb[0]);
  input_string(1,0);
  if (is[0]=='q'){
      is[0]=0;
      free(rulebuf);
      close(fid);
      moveto(tempx,tempy);
      return(filebytes);
  }
  if (is[0]=='s'){

      sprintf(textb[0],"chunkbuf");
	 if ((chunkbuf=(char *)calloc(datachunk,sizeof(char)))
				   ==NULL) outof_memory(textb[0]);
      sprintf(textb[0],"chunkbuf1");
	 if ((chunkbuf1=(char *)calloc(datachunk,sizeof(char)))
				   ==NULL) outof_memory(textb[0]);
      unsorted=1;
      while(unsorted==1){
	 unsorted=0;
	 for (lz=0;lz<=filebytes-1;lz+=datachunk){
	    if (statbuf[lz+rulebytes+1]<statbuf[lz+rulebytes+1+datachunk]){
	       unsorted=1;
	       /*swap chunks*/
	       memcpy(chunkbuf,statbuf+lz,datachunk);
	       memcpy(chunkbuf1,statbuf+lz+datachunk,datachunk);
	       memcpy(statbuf+lz,chunkbuf1,datachunk);
	       memcpy(statbuf+lz+datachunk,chunkbuf,datachunk);
	    }
	 }
      }
      select_stat_filename();
      save_binary_data(statbuf,filebytes);
      free(chunkbuf1);
      free(chunkbuf);
  }
  else if (is[0]=='l') show_list=1;
  else if (is[0]=='Z'){
     show_list=2;
     graphtype=1;
  }
  else if (is[0]=='L'){
     show_list=2;
     graphtype=2;
  }
  else show_list=2;

  if (show_list){
     xbox=(5*Maxx)/7+3;
     if (show_list==1){
#       if __BORC__
	   draw_box(-1,(5*Maxx)/7,2,Maxx-2,Maxy-2,1,0);
#       elif __WATCOM__||__UNIX__
	   draw_box(11,(5*Maxx)/7,2,Maxx-2,Maxy-2,1,0);
#       endif

	moveto(xbox,2);
	sprintf(textb[0],"%lu k=%d rules m-entropy stan-dev",
						 totstatrules,nhood);
	outtext(textb[0]);
	moveto(xbox,gety+CHeight);
     }
     else if (show_list==2) {

#       if __BORC__
	   draw_box(-1,stpwidth+vgax(100)+1,Maxy-2-vgay(200)-vgax(10),
						 Maxx-2,Maxy-2,0,0);
#       elif __WATCOM__||__UNIX__
	   draw_box(11,stpwidth+vgax(100)+1,Maxy-2-vgay(200)-vgax(10),
						 Maxx-2,Maxy-2,0,0);
#       endif

	draw_entgraph_frame(1,stpwidth,2,graphtype);
     }
     ruleindex=0;
     for (lz=0;lz<=filebytes-1;lz+=datachunk){
	ruleindex+=1;
	memcpy(rulebuf,statbuf+lz,rulebytes);

	ave=((float)statbuf[lz+rulebytes])/255;
	sdev=((float)statbuf[lz+rulebytes+1]*.18)/255;

	if (show_list==1){
	   sprintf(textb[2],"%lu. ",ruleindex);
	   outtext(textb[2]);
	   print_current_bitstring_hexbytes(1,rulebuf,nhood,Maxx,white,0);
	   moveto(xbox+textwidth(textb[2])+
		       CWidth*rulebytes*3,gety);

	   sprintf(textb[0],"  %.3f  %.4f",ave,sdev);
	   /* buffer char values*/
	   /*
	   sprintf(textb[0],"  %d  %d",
			statbuf[lz+rulebytes],statbuf[lz+rulebytes+1]);
	   */
	   outtext(textb[0]);
	   moveto(xbox,gety+CHeight);
	   if (gety>Maxy-CHeight*5 || ruleindex==totstatrules){

	      outtext("save screen-s printbox-p");
	      moveto(xbox,gety+CHeight);
	      if (ruleindex==totstatrules) outtext("jump-j quit-ret:");
	      else outtext("jump-j quit-q more-ret:");
	      input_string(1,0);
	      if (is[0]=='q' || (ruleindex==totstatrules && is[0]==13)) break;
	      if (is[0]=='s') save_screen();
	      else if (is[0]=='p')
	      /*print wiring box*/
#             if __BORC__||__WATCOM__
		 printimage('L',0,0,(5*Maxx)/7,2,Maxx-2,Maxy-2);
#             elif __UNIX__
                 printimage();/*xwindows*/
#             endif
	      else if (is[0]=='j'){
		 moveto(xbox,gety+CHeight);
		 sprintf(textb[0],"enter rule index 1-%lu:",totstatrules);
		 outtext(textb[0]);
		 input_string(5,0);
		 if (atol(is)>0 && atol(is)<totstatrules){
		    lz=(atol(is)-2)*datachunk;
		    ruleindex=atol(is)-1;
		    draw_box(-1,(5*Maxx)/7,2,Maxx-2,Maxy-2,1,0);
		    moveto(xbox,2);
		    sprintf(textb[0],"%lu k=%d rules m-entropy stan-dev",
						 totstatrules,nhood);
		    outtext(textb[0]);
		    moveto(xbox,gety+CHeight);
		    continue;
		 }
	      }
	      if (ruleindex!=totstatrules){
		 draw_box(-1,(5*Maxx)/7,2,Maxx-2,Maxy-2,1,0);
		 moveto(xbox,2);
		 sprintf(textb[0],"%lu k=%d rules m-entropy stan-dev",
						 totstatrules,nhood);
		 outtext(textb[0]);
		 moveto(xbox,gety+CHeight);
	      }
	   }
	}
	if (show_list==2){
	   /*plot black pixel*/
	   /*standard deviation*/
	   sx=stpwidth+vgax(100)+2+vgax(10)+
		   sdev*10*vgax((signed short)(256*10.0/18));


	   if (graphtype){
	      z_parameter_all(nhood,0,rulebuf);
	      if (graphtype==1){
		 sy=Maxy-2-vgax(10)-zparam[0]*vgay(200);
		 Zbuf[ruleindex]=(unsigned char)(255*zparam[0]);
	      }
	      else {
		 sy=Maxy-2-vgax(10)-lratio*vgay(200);
		 lambdabuf[ruleindex]=(unsigned char)(255*lratio);
	      }
	   }
	   /*mean entropy*/
	   else sy=Maxy-2-vgax(10)-ave*vgay(200);
	   putpixel(sx,sy,white);

	}
     }
  }


  if (show_list==2){
    start_show_list:
     draw_prompt_box(1);
     sprintf(textb[0],"%lu k=%d rules, save screen-s, show 3d-3, cont-ret:",
					      totstatrules,nhood);
     outtext(textb[0]);
     input_string(1,0);
     if (is[0]=='s'){
	save_screen();
	goto start_show_list;
     }
     else if (is[0]=='3'){
	ent_3d(Zbuf,lambdabuf,filebytes,graphtype);
	goto start_show_list;
     }
#    if __WATCOM__||__UNIX__
	putimage(stpwidth+vgax(100)+1,Maxy-2-vgay(200)-vgax(10),
					  boximage[11],COPY_PUT);
	freeimage(boximage[11]);
#    endif
  }
  else if (show_list==1){
#    if __BORC__
	draw_box(-1,(5*Maxx)/7,2,Maxx-2,Maxy-2,1,0);
#    elif __WATCOM__||__UNIX__
	putimage((5*Maxx)/7,2,boximage[11],COPY_PUT);
	freeimage(boximage[11]);
#    endif
  }

  goto start;
}
/***** draw 3d histogram of rule distribution in entropy-density plot ****/

void ent_3d(char *Zbuf,char *lambdabuf,
		 unsigned long filebytes,char graphtype){

 signed short tempx,tempy,tempx1,tempy1,xbox,i,z,zz,blocksize,blockstep,
	      rulebytes,stpwidth,rightedge,
	      topleftx,toplefty;
 unsigned short datachunk, **histbuf,
	      maxfreq,maxheight,histheight,lastheight,eraseht;
 unsigned long lz,ruleindex;
 unsigned char ave,sdev,blockno,stepthrough=0,showlog=0,showgrid=0;
 signed short sinblock,sintot,startx,starty,rightbar,lastrightx;
 float hblock,barwidth;

  tempx=getx;
  tempy=gety;


  stpwidth=lineL+vgax(10);
  rightedge=stpwidth+vgax(100)+2+vgax(256)+vgax(10);
  blockno=64;
  xbox=draw_prompt_box(2);
  sprintf(textb[0],
  "3d rule freq hist, subdiv (16,32,..etc def=%d, max=128):",blockno);
  myouttext(textb[0]);
  input_string(3,0);
  if (atoi(is)==1||atoi(is)==2||atoi(is)==4||atoi(is)==8||atoi(is)==16
    ||atoi(is)==32||atoi(is)==64||atoi(is)==128) blockno=atoi(is);
  moveto(xbox,gety+CHeight);
  myouttext("step-s and show %-S:");
  input_string(1,0);
  if (is[0]=='s') stepthrough=1;
  else if (is[0]=='S') stepthrough=2;
  myouttext(" show frequency as log-l:");
  input_string(1,0);
  if (is[0]=='l') showlog=1;

  blocksize=256/blockno;
  sinblock=(vgax(256/2))/blockno;
  sintot=sinblock*blockno;
  if (blockno<=64 && graphtype==0){
     is[0]=showgrid=0;
     outtext(" show grid-g");
     input_string(1,0);
     if (is[0]=='g') showgrid='g';
  }
  
  blocksize=256/blockno;

  maxfreq=0;
  maxheight=vgay(100);

  topleftx=rightedge-vgax(256);
  toplefty=Maxy-2-vgay(10)-vgay(203)-sintot;

  draw_box(-1,topleftx-sintot,toplefty-vgay(100),
		topleftx+vgax(256),toplefty+sintot,1,0);

  moveto(topleftx,toplefty);

  setcolor(lightred);
  linerel(vgax(256),0);
  linerel(-sintot,sintot);
  linerel(-vgax(256),0);
  linerel(sintot,-sintot);
  setcolor(white);

  rulebytes=(signed short)ceil(pow(2,(double)nhood)/8);
  datachunk=rulebytes+2;
  totstatrules=filebytes/datachunk;

  /*hist buffers*/
  sprintf(textb[0],"histbuf");
  if ((histbuf=(unsigned short**)calloc(blockno,sizeof(unsigned short*)))
				  ==NULL) outof_memory(textb[0]);
  for (z=0;z<=blockno-1;z++){
     sprintf(textb[0],"histbuf[%d]",z);
     if ((histbuf[z]=(unsigned short *)calloc(blockno,sizeof(unsigned short)))
				  ==NULL) outof_memory(textb[0]);
  }
  moveto(stpwidth+vgax(100)+2+vgax(10),Maxy-2-vgay(10));

  ruleindex=0;
  for (lz=0;lz<=filebytes-1;lz+=datachunk){
	if (graphtype){
	   ruleindex++;
	   if (graphtype==1) ave=Zbuf[ruleindex];
	   else ave=lambdabuf[ruleindex];
	}
	else ave=statbuf[lz+rulebytes];
	sdev=statbuf[lz+rulebytes+1];
	histbuf[ave/blocksize][sdev/blocksize]++;
	if (histbuf[ave/blocksize][sdev/blocksize]>maxfreq)
			      maxfreq=histbuf[ave/blocksize][sdev/blocksize];
  }

  if (blockno<=64 && graphtype==0 && showgrid=='g'){ /*show grid*/
     blockstep=0;
     setcolor(red);
     moveto(stpwidth+vgax(100)+2+vgax(10),Maxy-2-vgay(10));
     for (z=0;z<=blockno-2;z++){
	blockstep++;  /*show vertical subdiv*/
	moveto(stpwidth+vgax(100)+2+vgax(10)+vgax(blocksize*blockstep),
					       Maxy-2-vgax(10));
	linerel(0,-vgay(200));
     }
     blockstep=0;
     hblock=(float)200/blockno;
     moveto(stpwidth+vgax(100)+2+vgax(10),Maxy-2-vgax(10));
     for (z=0;z<=blockno-2;z++){
	blockstep++;  /*show horiz subdiv*/
	moveto(stpwidth+vgay(100)+2+vgay(10),
		    Maxy-2-vgay(10)-vgay((signed short)(hblock*blockstep)));
	linerel(vgax(256),0);
     }
  }

  setfillstyle(SOLID_FILL,darkgray);
  blockstep=0;
  setcolor(white);
  barwidth=((float)vgax(256))/blockno;

  for (zz=blockno-1;zz>=0;zz--){
     blockstep++;
     startx=topleftx-sinblock*blockstep;
     starty=toplefty+sinblock*blockstep;
     moveto(startx,starty);
     for (z=0;z<=blockno-1;z++){
	 lastheight=histheight;
	 if (histbuf[zz][z]>0){
	    if (showlog==1)
	       histheight=(unsigned short)(double)maxheight*
		       (log((double)histbuf[zz][z])/log((double)maxfreq));
	    else histheight=(unsigned short)(double)maxheight*
		       ((double)histbuf[zz][z]/(double)maxfreq);
	    rightbar=getx+barwidth;
	    bar(getx,gety-histheight,rightbar,gety);
	    rectangle(getx,gety-histheight,rightbar,gety);
	    if (z>0){
	       setcolor(darkgray);
	       if (lastheight<histheight) eraseht=lastheight;
	       else eraseht=histheight;
	       line(getx,gety+1,getx,gety-eraseht+1);
	       if (getx!=lastrightx)
		     line(lastrightx,gety+1,lastrightx,gety-eraseht+1);
	       setcolor(white);
	    }
	 }
	 else histheight=0;
	 lastrightx=rightbar;
	 moveto(startx+(z+1)*barwidth,gety);
     }
     if (stepthrough){
	if (stepthrough==2){
	   tempx1=getx;
	   tempy1=gety;
	   xbox=draw_prompt_box(5);
	   for (i=0;i<=blockno-1;i++){
	      if (getx>Maxx-CWidth*5)
		    moveto(xbox,gety+CHeight);
	      sprintf(textb[0],"%.1f ",
		       100*((float)histbuf[zz][i]/totstatrules));
	      /*sprintf(textb[0],"%d ",histbuf[zz][i]);*/
	      outtext(textb[0]);
	   }
	   moveto(tempx1,tempy1);
	}
	input_string(1,0);

     }
  }
  for (z=0;z<=blockno-1;z++) free(histbuf[z]);
  free(histbuf);
  moveto(tempx,tempy);

}
