/*********************** learn/forget ****************************/

#include "edecfunc.h"

/************************* learning, April 1994 *************************/
void sculpt_basin_field(void){

  char learn,scul,
       **norepre,**okrepre,*temp,
       maxdecL,pre_range,prestep,
       wr_status,
       hamming,
       par;
  signed short  *pnhood,*shuff_wire,*shuff_z,*shuff_z2,
       *shuff_norepre,*shuff_okrepre,
       u,u1,
       startx,starty,leftx,newno,z,zz,zzz,
       lrn,n,sn,i,wire,
       ok,no,
       index1,index2,
       tempx,tempy,
       sum1s;
  unsigned short zu,parsize;
  unsigned long maxstate,startdec,enddec,zdec;

  signed short startyb,height_req,bottombox,foldposs;
  char cellscale;

   /*anticipate size of state window*/
   /****************/
   cellscale=4;
   if (!twod) foldposs=64;
   else foldposs=i2d;

   if (hires) cellscale=7;
   if (lineL>36*36-1) cellscale=3;
   if (lineL>56*56-1) cellscale=2;
   if (lineL>96*96-1) cellscale=1;

   height_req=CHeight*10+cellscale*lineL/foldposs;
   bottombox=Maxy-vgay(33);
   startyb=bottombox-height_req;
   /******************/

  compress_1d_local=0;
  dont_save=1;
  /*memory for pseudo-nhood*/
  if ((pnhood=(signed short *)calloc(nhood,sizeof(signed short)))
			    ==NULL) outof_memory("pnhood");
  /*to shuffle wiring*/
  if ((shuff_wire=(signed short*)calloc(nhood,sizeof(signed short)))
			    ==NULL) outof_memory("shuff_wire");
  if ((shuff_z=(signed short*)calloc(lineL,sizeof(signed short)))
			    ==NULL) outof_memory("shuffle_z");
  if ((shuff_z2=(signed short*)calloc(lineL,sizeof("shuffle_z2")))
			    ==NULL) outof_memory(textb[0]);
  startx=getx;
  starty=gety;
  leftx=xtext*CWidth;
  regular2d=0;/*may be rewired*/
  if      (nonlocal==0 && rulemix==0)	wr_status=0;
  else if (nonlocal==0 && rulemix)	wr_status=1;
  else if (nonlocal && rulemix==0)	wr_status=2;
  else if (nonlocal && rulemix)	wr_status=3;

 start:
  moveto(leftx-3,startyb-vgay(15));
  sprintf(textb[0],"learn/forget/highlight: set target state");
  draw_box(13,getx,gety,getx+Maxx*.6,gety+vgay(15),1,0);
  outtext(textb[0]);
  moveto(leftx,vgay(315));
  select_seed(tar,"target state",1);
  if (is[0]=='q'){
	moveto(leftx-3,startyb-vgay(15));
	putimage(getx,gety,boximage[13],COPY_PUT);
	freeimage(boximage[13]);
	free(pnhood);
	free(shuff_wire);
	free(shuff_z);
	free(shuff_z2);
	moveto(startx,starty);
	memory_box(1);
	dont_save=0;
	return;
  }
 start1:
  /*sprintf(textb[4],"");*/
  moveto(leftx-3,startyb-vgay(15));
  draw_box(-1,getx,gety,getx+Maxx*.6,gety+vgay(15),1,0);
  moveto(leftx,gety);
  sprintf(textb[0],"pre-images: ");
  sprintf(textb[1],
       "as before-b parity-p range-r hamm-h1/2 number-(default 1):");
  myouttext(textb[0]);
  myouttext(textb[1]);
  input_string(4,0);
  if (is[0]=='q'){
     freeimage(boximage[13]);
     memory_box(1);
     goto start;
  }
  if (is[0]=='b'){
     newno=notolearn;
     if (newno==0) newno=1;
     goto skip_pre; /*same pre-images as before*/
  }
  if (is[0]==13||is[0]=='r'||is[0]=='h'||atoi(is)<=0) newno=1;
  else newno=atoi(is);
  pre_range=0;
  if (is[0]=='r') pre_range='r';
  else if (is[0]=='h'){
     hamming=1;
     pre_range='h';
     if (is[1]=='2') hamming=2;
  }
  else if (is[0]=='p') pre_range='p';
  if (pre_range=='p'){
     moveto(leftx-3,startyb-vgay(15));
     draw_box(-1,getx,gety,getx+Maxx*.6,gety+vgay(15),1,0);
     moveto(leftx,gety);
     myouttext("enter odd-1, even-(default):");
     input_string(1,1);
     if (is[0]=='q') goto start1;
     else if (is[0]=='1') par=1;
     else par=2;

     moveto(leftx-3,startyb-vgay(15));
     draw_box(-1,getx,gety,getx+Maxx*.6,gety+vgay(15),1,0);
     moveto(leftx,gety);

     if (lineL>20) parsize=20;
     else parsize=lineL;
     sprintf(textb[0],"enter part system size (default %d):",parsize);
     myouttext(textb[0]);
     /*input_string(strlen(itoa(lineL,textb[2],10)),1);*/
     sprintf(textb[2],"%d",lineL);
     input_string(strlen(textb[2]),1);
     if (is[0]=='q') goto start1;
     parsize=atoi(is);
     if (is[0]==13 || parsize<=0 || parsize>lineL) parsize=lineL;
     if (parsize>20) parsize=20;
     /*half have odd/even parity*/
     newno=(signed short) (pow(2,(double)(parsize)))/2;
  }
  if (pre_range=='r'){
     if (lineL>32) maxdecL=32;
     else maxdecL=lineL;
     maxstate=(unsigned long) (pow(2,(double)(maxdecL))-1);
     moveto(leftx-3,startyb-vgay(15));
     draw_box(-1,getx,gety,getx+Maxx*.6,gety+vgay(15),1,0);
     moveto(leftx,gety);
     sprintf(textb[0],
	   "range of pre-images (default 1-10, max %lu), start:",maxstate);
     myouttext(textb[0]);
     /*input_string(strlen(ultoa(maxstate,textb[2],10)),1);*/
     sprintf(textb[2],"%lu",maxstate);
     input_string(strlen(textb[2]),1);
     if (is[0]=='q') goto start1;
     startdec=(unsigned long)_atold(is);
     if (is[0]==13 || startdec<=0 || startdec>maxstate) startdec=1;
     myouttext(" end:");
     /*input_string(strlen(ultoa(maxstate,textb[2],10)),1);*/
     sprintf(textb[2],"%lu",maxstate);
     input_string(strlen(textb[2]),1);
     if (is[0]=='q') goto start1;
     enddec=(unsigned long)_atold(is);
     if (is[0]==13 || enddec<startdec) enddec=startdec+9;
     if (enddec>maxstate) enddec=maxstate;
     myouttext(" step:");
     input_string(1,1);
     if (is[0]=='q') goto start1;
     prestep=atoi(is);
     if (is[0]==13 || prestep<=0) prestep=1;
     newno=(signed short)(((float)(enddec-startdec+1))/prestep);
  }
  if (pre_range=='h'){
     newno=lineL; /*1 bit from target*/
     if (hamming==2) newno=lineL*lineL; /*2 bits from target*/
  }

  for (z=0;z<=notolearn-1;z++) free(learn_pre[z]);
  free(learn_pre);
  sprintf(textb[0],"learn_pre");
  if ((learn_pre=(char**)calloc(newno,sizeof(char*)))
			      ==NULL) outof_memory(textb[0]);
  for (z=0;z<=newno-1;z++){
	sprintf(textb[0],"pre[%d]",z);
	if ((learn_pre[z]=(char *)calloc(bytesL,sizeof(char)))
			      ==NULL) outof_memory(textb[0]);
  }

 skip_pre:

  memory_box(1);
  notolearn=newno;
  if (pre_range=='h'){
     index2=-1;
     for (zu=0;zu<=L;zu++){
	index1=zu;
	if (hamming==2) index1=index2+1;
	memcpy(learn_pre[index1],tar,bytesL);
	set_bit(learn_pre[index1],zu,abs(get_bit(learn_pre[index1],zu)-1));
	if (hamming==2){
	   index2=index1;
	   for (zz=0;zz<=L-1;zz++){
	      index2+=1;
	      memcpy(learn_pre[index2],learn_pre[index1],bytesL);
	      set_bit(learn_pre[index2],zz,
				abs(get_bit(learn_pre[index2],zz)-1));
	      for (zzz=0;zzz<=index2-1;zzz++){
		 if (memcmp(learn_pre[index2],learn_pre[zzz],
					       bytesL)==0) index2-=1;
	      }
	   }
	}
     }
     if (hamming==2){
	for (z=index2+1;z<=notolearn-1;z++) free(learn_pre[z]);
	notolearn=index2+1;
     }
  }
  else if (pre_range=='p'){
     sprintf(textb[0],"temp");
     if ((temp=(char *)calloc(bytesL,sizeof(char)))
				    ==NULL) outof_memory(textb[0]);
     maxstate=pow(2,(double)(parsize));
     zdec=-1;
     for (z=maxstate-1;z>=0;z--){
	sum1s=0;
	dec_to_bit_line(temp,z,lineL);
	for (zz=lineL-1;zz>=0;zz--){
	   if (get_bit(temp,zz)==1) sum1s++;
	}
	if (sum1s%2==0 && par==2){  /*even parity*/
	   zdec++;
	   memcpy(learn_pre[zdec],temp,bytesL);
	}
	else if (sum1s%2==1 && par==1){  /*odd parity*/
	   zdec++;
	   memcpy(learn_pre[zdec],temp,bytesL);
	}
     }
     free(temp);
  }
  else if (pre_range=='r'){
     zdec=startdec;
     for (z=0;z<=notolearn-1;z++){
	dec_to_bit_line(learn_pre[z],zdec,lineL);
	zdec+=prestep;
     }
  }
  else if (pre_range==0){
     for (z=0;z<=notolearn-1;z++){
	moveto(leftx,vgay(315));
	sprintf(textb[3],"aspiring pre-image %d",z+1);
	select_seed(learn_pre[z],textb[3],1);
	memory_box(1);
	if (is[0]=='q') goto start1;
     }
  }
  /*preview target - pre-images*/
  if (lineL<=32) review_asp_pre_images(par,hamming,
			  startdec,enddec,prestep,pre_range);

  if (is[0]=='q') goto start1;

  moveto(leftx-3,startyb-vgay(15));
  draw_box(-1,getx,gety,getx+Maxx*.6,gety+vgay(15),1,0);
  moveto(leftx,gety);

  sprintf(textb[0],"highlight only-h, FORGET-f, LEARN-ret:");
  if (wr_status==0) sprintf(textb[0],"hightlight only (default):");

  outtext(textb[0]);
  input_string(1,0);

  learn='l';
  if (is[0]=='q') goto start1;
  else if (is[0]=='f') learn='f';
  else if (is[0]=='h'){
     learn='h';
     goto end;
  }
  if (wr_status==0) goto end;
  moveto(leftx-3,startyb-vgay(15));
  draw_box(-1,getx,gety,getx+Maxx*.6,gety+vgay(15),1,0);
  moveto(leftx,gety);
  if (wr_status==1) sprintf(textb[1],"bit-flips only (default):");
  else if (wr_status==2) sprintf(textb[1],"wire-moves only (default):");
  else if (wr_status==3) sprintf(textb[1],
			      "wire-moves -w, bit-flips default:");
  if (learn=='f') sprintf(textb[0],"forget by %s",textb[1]);
  else if (learn=='l') sprintf(textb[0],"learn by %s",textb[1]);
  outtext(textb[0]);
  input_string(1,0);
  if (is[0]=='q') goto start1;
  else if (is[0]=='w') scul='w'; /*scul=sculpt*/
  else scul='b';
  if (wr_status==1) scul='b';
  if (wr_status==2) scul='w';
 startlearning:
  for (lrn=0;lrn<=notolearn-1;lrn++){
    shuffle_order(shuff_z2,lineL);/*shuffle cell order*/
    for (n=L; n>=0; n--){
      sn=shuff_z2[n];
      for (i=0;i<=nhoodm[n]-1;i++) pnhood[i]=wiring[sn][i];
      u=0; /*find dec value of actual or pseudo-nhood*/
      for (i=nhoodm[n]-1;i>=0;i--)
	  u+=get_bit(learn_pre[lrn],pnhood[i])*(signed short)pow(2,(double)i);
      if (get_bit(carule[sn],u)!=get_bit(tar,sn)){
	  if (learn=='f') break; /*already forgotten*/
      }
      else if (learn=='l') continue;
      if (scul=='b'){
	 set_bit(carule[sn],u,abs(get_bit(carule[sn],u)-1));
	 if (learn=='f') break;
      }
      if (scul=='w'){
	 /*shuffle wire order of psuedo nhood*/
	 shuffle_order(shuff_wire,nhoodm[n]);
	  /*try a wire move in shuffled order*/
	  for (wire=0;wire<=nhoodm[n]-1;wire++){
	    shuffle_order(shuff_z,lineL);/*shuffle cell order for coupling*/
	    /*try coupling at each poss*/
	    for (z=0;z<=lineL-1;z++){
	       /*try different wire coupling*/
	       pnhood[shuff_wire[wire]]=shuff_z[z];
	       for (zz=0;zz<=lrn;zz++){ /*no of pre-images to learn*/
		  u1=0;
		  for (i=nhoodm[n]-1;i>=0;i--)
		  u1+=get_bit(learn_pre[zz],
			    pnhood[i])*(signed short)pow(2,(double)i);
		  /*test ouput (and all pervious)*/
		  if (get_bit(carule[sn],u1)!=get_bit(tar,sn)){
		     if (learn=='l') goto nextposs;
		  }
		  else if (learn=='f') goto nextposs;
	       }
	       /*if no missmatch (or match-forget) found, accept re-wiring*/
	       wiring[sn][shuff_wire[wire]]=shuff_z[z];
	       goto nextcell;
	       nextposs:;
	    }
	  }
      }
      nextcell:;
      if (learn=='f') break;
    }
  }
  if (scul=='w'){
     sprintf(textb[0],"norepre");
     if ((norepre=(char**)calloc(notolearn,sizeof(char*)))
				       ==NULL) outof_memory(textb[0]);
     sprintf(textb[0],"okrepre");
     if ((okrepre=(char**)calloc(notolearn,sizeof(char*)))
				       ==NULL) outof_memory(textb[0]);
     for (z=0;z<=notolearn-1;z++){
	sprintf(textb[0],"norepre[%d]",z);
	if ((norepre[z]=(char *)calloc(bytesL,sizeof(char)))
				       ==NULL) outof_memory(textb[0]);
	sprintf(textb[0],"okrepre[%d]",z);
	if ((okrepre[z]=(char *)calloc(bytesL,sizeof(char)))
				       ==NULL) outof_memory(textb[0]);
     }
     memory_box(1);
     /*identify pre-images not learnt by rewiring*/
     no=-1;
     ok=-1;
     for (z=0;z<=notolearn-1;z++){
	for (n=L; n>=0; n--){
	   for (i=0;i<=nhoodm[n]-1;i++) pnhood[i]=wiring[n][i];
	   u=0; /*find dec value of actual or pseudo-nhood*/
	   for (i=nhoodm[n]-1;i>=0;i--)
	      u+=get_bit(learn_pre[z],
			pnhood[i])*(signed short)pow(2,(double)i);
	   if (get_bit(carule[n],u)!=get_bit(tar,n)) goto notlearnt;
	}
	ok+=1;
	memcpy(okrepre[ok],learn_pre[z],bytesL); /*learnt pre-images*/
	goto waslearnt;
       notlearnt:
	no+=1;
	memcpy(norepre[no],learn_pre[z],bytesL); /*not learnt*/
       waslearnt:;
     }
     moveto(leftx,vgay(315));
     tempx=getx;
     tempy=gety;
     draw_box(14,tempx-3,tempy,Maxx-vgax(70),Maxy-vgay(50),1,0);
     if (no>-1){
	moveto(leftx,gety+CHeight);
	for (z=0;z<=no;z++){
	   sprintf(textb[0],"%lu,",dec_equiv(norepre[z],L));
	   if (getx>Maxx-vgax(70)-textwidth("   <-no")-vgax(3))
			      moveto(leftx,gety+CHeight);
	   outtext(textb[0]);
	}
	outtext("<-no");
     }
     if (ok>-1){
	moveto(leftx,gety+CHeight);
	for (z=0;z<=ok;z++){
	   sprintf(textb[0],"%lu,",dec_equiv(okrepre[z],L));
	   if (getx>Maxx-vgax(70)-textwidth("   <-ok")-vgax(3))
			      moveto(leftx,gety+CHeight);
	   outtext(textb[0]);
	}
	outtext("<-ok");
     }
     /*all states successfully learnt or forgotten*/
     if ((no==-1 && learn=='l') || (ok==-1 && learn=='f')){
	for (z=0;z<=notolearn-1;z++){
	   free(norepre[z]);
	   free(okrepre[z]);
	}
	free(norepre);
	free(okrepre);
	memory_box(1);
	moveto(leftx,gety+CHeight);
	if (notolearn==1) outtext("success - aspiring pre-image");
	else outtext("success - all aspiring pre-images");
	if (learn=='l') outtext(" learnt");
	else if (learn=='f') outtext(" forgotten");
	moveto(leftx,gety+CHeight);
	outtext("continue-ret:");
	input_string(1,0);
     }
     else{
	if (learn=='l'){ /*LEARN*/
	   /*put last unlearnt at start*/
	   memcpy(learn_pre[0],norepre[no],bytesL);
	   /*if any learnt*/
	   if (ok>-1){
	      /*if more than one were learnt, shuffle then copy*/
	      if (ok>0){
		 sprintf(textb[0],"shuffle_okrepre");
		 if ((shuff_okrepre=(signed short*)calloc (ok+1,sizeof(signed short)))
				     ==NULL) outof_memory(textb[0]);
		 shuffle_order(shuff_okrepre,ok+1);
		 for (z=ok;z>=0;z--) memcpy(learn_pre[notolearn-1-no-z],
				      okrepre[shuff_okrepre[z]],bytesL);
		 free (shuff_okrepre);
	      }
	      else memcpy(learn_pre[1],okrepre[0],bytesL); /*just one*/
	   }
	   if (no>1){  /*shuffle unlearnt (exept last), then copy*/
	      sprintf(textb[0],"shuffle_norepre");
	      if ((shuff_norepre=(signed short*)calloc (no,sizeof(signed short)))
				     ==NULL) outof_memory(textb[0]);
	      shuffle_order(shuff_norepre,no);
	      for (z=no-1;z>=0;z--) memcpy(learn_pre[notolearn-1-z],
				   norepre[shuff_norepre[z]],bytesL);
	      free (shuff_norepre);
	   }
	   else memcpy(learn_pre[notolearn-1],norepre[0],bytesL);
	}
	if (learn=='f'){ /*FORGET*/
	   /*put last not forgotten at start*/
	   memcpy(learn_pre[0],okrepre[ok],bytesL);
	   /*if more than one were forgotten, shuffle then copy*/
	   if (no>0){
	      sprintf(textb[0],"shuffle_norepre");
	      if ((shuff_norepre=(signed short*)calloc (no+1,sizeof(signed short)))
					==NULL) outof_memory(textb[0]);
	      shuffle_order(shuff_norepre,no);
	      for (z=no;z>=0;z--) memcpy(learn_pre[notolearn-1-ok-z],
				      norepre[shuff_norepre[z]],bytesL);
	      free (shuff_norepre);
	   }
	   else memcpy(learn_pre[1],norepre[0],bytesL); /*just one*/

	   if (ok>1){  /*shuffle unforgotten (exept last), then copy*/
	      sprintf(textb[0],"shuffle_okrepre");
	      if ((shuff_okrepre=(signed short*)calloc (ok,sizeof(signed short)))
					==NULL) outof_memory(textb[0]);
	      shuffle_order(shuff_okrepre,ok);
	      for (z=ok-1;z>=0;z--) memcpy(learn_pre[notolearn-1-z],
				   okrepre[shuff_okrepre[z]],bytesL);
	      free (shuff_okrepre);
	   }
	   else memcpy(learn_pre[notolearn-1-z],okrepre[z],bytesL);
	}
	for (z=0;z<=notolearn-1;z++){
	   free(norepre[z]);
	   free(okrepre[z]);
	}
	free(norepre);
	free(okrepre);
	memory_box(1);
	moveto(leftx,gety+CHeight);
	if (wr_status==2) sprintf(textb[1],"wire-moves -w:");
	else if (wr_status==3) sprintf(textb[1],
				    "wire-moves -w, bit-flips -b:");
	if (learn=='f') sprintf(textb[0],"re-forget by %s",textb[1]);
	else if (learn=='l') sprintf(textb[0],"re-learn by %s",textb[1]);
	outtext(textb[0]);
	input_string(1,0);
	if (is[0]=='w' || is[0]=='b'){
	   if (is[0]=='b' && wr_status==3) scul='b';
	   putimage(tempx-3,tempy,boximage[14],COPY_PUT);
	   freeimage(boximage[14]);
	   goto startlearning;
	}
     }
     putimage(tempx-3,tempy,boximage[14],COPY_PUT);
     freeimage(boximage[14]);
  }
  moveto(leftx-3,startyb-vgay(15));
  draw_box(-1,getx,gety,getx+Maxx*.6,gety+vgay(15),1,0);
  moveto(leftx,gety);
  myouttext("learn more-m:");
  input_string(1,0);
  if (is[0]=='m'){
	moveto(leftx-3,startyb-vgay(15));
	putimage(getx,gety,boximage[13],COPY_PUT);
	freeimage(boximage[13]);
	memory_box(1);
	goto start;
  }
 end:

  hilight_learn=1;
  moveto(leftx-3,startyb-vgay(15));
  draw_box(-1,getx,gety,getx+Maxx*.6,gety+vgay(15),1,0);
  sprintf(textb[0],
      "highlighting: none-n, suppess all other nodes-s:");
  outtext(textb[0]);
  input_string(1,0);
  if (is[0]=='n') hilight_learn=0;
  if (is[0]=='s') hilight_learn=2;

  moveto(leftx-3,startyb-vgay(15));
  putimage(getx,gety,boximage[13],COPY_PUT);
  freeimage(boximage[13]);
  free(pnhood);
  free(shuff_wire);
  free(shuff_z);
  free(shuff_z2);
  memory_box(1);
  moveto(startx,starty);
  dont_save=0;
}

/************************* shuffle the order ************************/
void shuffle_order(signed short* array, signed short size){
 signed short z,zz;

   for (z=0;z<=size-1;z++){
      redowire:
      array[z]= rand()%(size);
      if (z>0){
	 for (zz=0;zz<=z-1;zz++){
	    if (array[z]==array[zz]) goto redowire;
	 }
      }
   }
}

/***** review target state and aspiring pre-images ***************/
void review_asp_pre_images(char par, char hamming,
	 unsigned long startdec,unsigned long enddec,
		  unsigned short prestep, char pre_range){

  signed short leftx,tempx,tempy,tempx1,tempy1,z;
  char review_interupt;

     leftx=xtext*CWidth;
     moveto(leftx,vgay(315));
     tempx=getx;
     tempy=gety;
     draw_box(14,tempx-3,tempy,Maxx-vgax(70),Maxy-vgay(50),1,0);


     sprintf(textb[0],"target=%lu, number of pre-images=%d, ",
				  dec_equiv(tar,L),notolearn);
     outtext(textb[0]);
     if (pre_range=='p'){
	if (par==2) outtext("parity=even, ");
	else if (par==1) outtext("parity=odd, ");
	sprintf(textb[0],"max state=%lu, ",
			     dec_equiv(learn_pre[0],L));
	outtext(textb[0]);
     }
     else if (pre_range=='h'){
	sprintf(textb[0],"%d bit mutants, max state=%lu, ",
			      hamming,dec_equiv(learn_pre[0],L));
	outtext(textb[0]);
     }
     else if (pre_range=='r'){
	sprintf(textb[0],"range %lu-%lu, step=%d",
			       startdec,enddec,prestep);
	outtext(textb[0]);
     }

     outtext("continue-ret:");
     tempx1=getx;
     moveto(leftx,gety+CHeight);
     tempy1=gety;

     review_interupt=0;
     for (z=0;z<=notolearn-1;z++){
	sprintf(textb[1],"%lu,",dec_equiv(learn_pre[z],L));
	if (getx>Maxx-vgax(70)-textwidth(textb[1]))
			       moveto(leftx,gety+CHeight);

	if (gety>Maxy-vgay(50)-CHeight-2){
	   moveto(getx,gety-1);
	   outtext("more-m continue-ret:");
	   input_string(1,0);
	   if (is[0]=='m'){
	      setfillstyle(SOLID_FILL,black);
	      bar(tempx-2,tempy1,Maxx-vgax(70)-1,Maxy-vgay(50)-1);
	      moveto(tempx,tempy1);
	   }
	   else{
	      review_interupt=1;
	      break;
	   }
	}
	outtext(textb[1]);
     }
     if (review_interupt==0){
	moveto(tempx1,tempy);
	input_string(1,0);
     }

     putimage(tempx-3,tempy,boximage[14],COPY_PUT);
     freeimage(boximage[14]);
}





