/***************** RUN CA/Random Boolean Network ***********************/

#include "edecfunc.h"

/************** add one cell, wire in and assigm rule *****************/
void wire_rule_extra_cell(char increace){ /*increace= -1 or +1*/
 signed short tablemax,tablebytes,z,zz,temp=0,
	      wire,codemax;
 unsigned short poss,depthL,rposs,tw;

   if (increace==0) return;

   if (increace==1){
      reallocate_mem_wiring(increace);/*for one more cell*/
      sprintf(textb[0],"nhoodm");
      if ((nhoodm=(char*)realloc(nhoodm,lineL*sizeof(char)))
					==NULL) outof_memory(textb[0]);
      if (!nhood_mixed) nhoodm[L]=nhood;
      else{
	 while(!(nhoodm[L]>=nhood_lb && nhoodm[L]<=nhood))
				     nhoodm[L]=myrand()%(nhood+1);
      }
   }
   /*rewire both ends for nhood/2 cells, local 1-D wiring*/
   if (nonlocal==0 || whatwire==1){
      
      /*if not watcom crashes if range start =1 (borland ok)*/
      if (nhood*2>=lineL){
	 for (poss=0;poss<=lineL-1;poss++) oneD_local_wire_cell(poss,L);
      }
      else{
	 depthL=(unsigned short)ceil((double)nhood/2);

	 /*right end*/
	 for (poss=0;poss<=depthL;poss++) oneD_local_wire_cell(poss,L);
	 /*left end*/
	 if (depthL<L){
	    for (poss=L-depthL;poss<=L;poss++)
		       oneD_local_wire_cell(poss,L);
	 }
      }
   }
   else if (increace==1){ /*wireup extra cell*/
      randomly_wire_cell(L,L);
      tw=0;/*total wires*/
      if (!nhood_mixed) tw=nhood*lineL;
      else{
	 for (poss=0;poss<=L;poss++) tw+=nhoodm[poss];
      }
      /*move av no of existing outwires to the new cell*/
      for (z=0;z<=tw/lineL;z++){
	 rposs=myrand()%lineL;/*random position*/
	 wiring[rposs][myrand()%(nhoodm[rposs]+1)]=L;
      }
   }
   else if (increace==-1){ /*re-wire all wires from removed cell*/
      for (poss=0;poss<=L+1;poss++){
	 for (wire=0;wire<=nhoodm[poss]-1;wire++){
	    /*rewire at random position*/
	    if (wiring[poss][wire]>L) wiring[poss][wire]=myrand()%lineL;
	 }
      }
   }
   if (increace==-1){
      reallocate_mem_wiring(increace);/*for one more cell*/
      sprintf(textb[0],"nhoodm");
      if ((nhoodm=(char*)realloc(nhoodm,lineL*sizeof(char)))
					==NULL) outof_memory(textb[0]);
   }
   cell_out_freq();

   if (rulemix){
      reallocate_mem_rulemix(nhood,increace);
      reallocate_mem_tcodemix(nhood,increace);
      if (increace==1){
	 if (nhood_mixed){/*assign a random rule at new cell*/
	    if (!totalistic){
	       tablemax=(signed short)pow(2,(double)nhoodm[L])-1;
	       for (z=tablemax;z>=0;z--) set_bit(carule[L],z,(myrand()%100)/50);
	    }
	    else{
	       codemax=(signed short)pow(2,(double)nhoodm[L]+1)-1;
	       for (z=codemax;z>=0;z--) set_bit(cacode[L],z,(myrand()%100)/50);
	       /*convert code to rule*/
	       for (zz=tablemax;zz>=0;zz--){
		  temp=0;
		  for (z=nhoodm[L]-1;z>=0;z--) temp+=get_bit(nm[z],zz);
		  set_bit(carule[L],zz,
			       get_bit(cacode[L],temp));
	       }
	    }
	 }
	 else{
	    /*copy an exist rule fromm random pos to new cell*/
	    tablebytes=(signed short)ceil(pow(2,(double)nhood)/8);
	    rposs=myrand()%L;
	    if (!totalistic) memcpy(carule[L],carule[rposs],tablebytes);

	    else{
	       memcpy(cacode[L],cacode[rposs],
			(signed short)ceil((double)(nhood+1)/8));
	       /*convert code to rule*/
	       for (zz=tablemax;zz>=0;zz--){
		  temp=0;
		  for (z=nhood-1;z>=0;z--) temp+=get_bit(nm[z],zz);
		  set_bit(carule[L],zz,get_bit(cacode[L],temp));
	       }
	    }
	 }
      }
   }
   return;
}

/**** draw several single basins or trees for range of L, Sept 93 *******/
void draw_range_single(void){
 signed short basinrangecount=0,/*count of range of single basins or trees*/
       poss,zz,z,tablemax,sod;
 char *rangeseed;      /*constant seed for range of CA sizes*/

   firstxspacing=xspacing;
   firstyspacing=yspacing;
   /*max index of ruletable*/
   tablemax= (signed short)pow(2,(double)nhood)-1;
   /*remember seed state*/
   sprintf(textb[0],"rangeseed");
   if ((rangeseed=(char*)calloc(rangebytesL,sizeof(char)))
				      ==NULL) outof_memory(textb[0]);
   memcpy(rangeseed,bitseed,rangebytesL);
   zonesize=lineL;
   for (L=startL-1;L<=endL-1;L++){
      if (is[0]=='q') break;
      totatt_states=isexception=0;
      /*next tree space-time pattern from the top*/
      if (stp){
	 setviewport(0, 0, (L+1)*scale+2, Maxy, 0);
	 clearviewport();
	 setviewport(0, 0, Maxx, Maxy, 0);
	 moveto(0,0);
      }
      if (!rulemix) show_rule_bottom(nhood,1,carule[0],0);
      basinrangecount+=1;
      if (basinrangecount>1){
	 free_mem_CA_states();
	 lineL=L+1;
	 bytesL=ceil((double)lineL/8);

	 wire_rule_extra_cell(1);

	 allocate_mem_CA_states();
	 memory_box(1);
	 memcpy(bitseed,rangeseed,rangebytesL);
	 xspacing*=xspacefact;
	 yspacing*=yspacefact;
	 /*move position of next basin to the right*/
	 ox+=xspacing;
	 /*if too close to right edge of screen, start new row*/
	 if ((Maxx-ox)<(signed short)((float)xspacing*rightborder)){
	    ox=firstox;
	    oy+=yspacing;
	 }
      }
      if (!twod && shownumbers==3 && showbits_1d_as_2d==1){
	 for (z=(signed short)ceil(pow((double)lineL,.5));z>=1;z--){
	    if (lineL%z==0) break;
	 }
	 j2d=z;
	 i2d=(signed short)ceil((double)lineL/j2d);
      }
      /*draw basin of attraction field*/
      if (direction=='f'){
	 bitflipcount=0;
	 run_forward();
      }
      /*if backward, upstream only, draw trees*/
      else upstream_only();
      if (pre_fansize_freq_hist) show_pre_fansize_freq_hist();
   }
   L-=1;
   lineL=L+1;
   bytesL=ceil((double)lineL/8);
   if (datapause==0 && mutantdontpause==0) finish_options(1);
   ox=firstox;
   oy=firstoy;
   xspacing=firstxspacing;
   yspacing=firstyspacing;
   free_mem_CA_states();

   free_mem_wiring();
   if (rulemix){
      free_mem_rulemix();
      free_mem_tcodemix();
   }
   lineL=startL;
   L=lineL-1;
   bytesL=rangebytesL;
   allocate_mem_CA_states();

   sprintf(textb[0],"nhoodm");
   if ((nhoodm=(char*)realloc(nhoodm,lineL*sizeof(char)))
					==NULL) outof_memory(textb[0]);
   if (nhood_mixed){
      for (poss=lineL-1;poss>=0;poss--){
	 while(!(nhoodm[poss]>=nhood_lb && nhoodm[poss]<=nhood))
						 nhoodm[poss]=myrand()%10;
      }
   }

   allocate_mem_wiring();
   if (whatwire==1){  /*rewire local*/
      for (poss=lineL-1;poss>=0;poss--) oneD_local_wire_cell(poss,lineL-1);
   }
   else{  /*rewire random*/
      zonesize=lineL;
      for (poss=L;poss>=0;poss--) randomly_wire_cell(poss,L);
      cell_out_freq();
   }
   if (rulemix){
      allocate_mem_rulemix(nhood);
      allocate_mem_tcodemix(nhood);
      for (poss=lineL-1;poss>=0;poss--){
	 if (nhood_mixed)
	      tablemax=(signed short)pow(2,(double)nhoodm[poss])-1;
	 if (totalistic==0){
	    for (zz=tablemax;zz>=0;zz--)
		     set_bit(carule[poss],zz,(myrand()%100)/50);
	 }
	 else{
	    for (zz=nhoodm[poss];zz>=0;zz--)
			set_bit(cacode[poss],zz,(myrand()%100)/50);
	    for (zz=tablemax;zz>=0;zz--){
	       sod=0;
	       for (z=nhoodm[poss]-1;z>=0;z--)sod+=get_bit(nm[z],zz);
	       set_bit(carule[poss],zz,get_bit(cacode[poss],sod));
	    }
	 }
      }
   }
   memcpy(bitseed,rangeseed,bytesL);
   free(rangeseed);
   memory_box(1);
}

/*************** backwards upstream from given state, Aug 1993 ********/
void upstream_only(void){
  signed short tempx,tempy,xbox,timemin;
  unsigned long totsubtreegofE=0,elapsedtime;
  unsigned short zu;
#if (__BORC__||__WATCOM__)
  clock_t starttime, endtime;
#elif (__UNIX__)
  unsigned long starttime,starttime_m,
                endtime,endtime_m;
  long  elapsedtime_m;
  struct timeval  tp;
  struct timezone tzp;
#endif
  float timesec;
  char hl_temp, *this_firstseed,printhex=0,this_isrepeat=0;

#   define show_seed {\
      tempx=getx;\
      tempy=gety;\
      moveto(ox,oy);\
      hl_temp=hilight_learn;\
      hilight_learn=1;\
      if (twod || showbits_1d_as_2d)\
	 print_current_state_twod(this_firstseed,yellow);\
      else print_current_state_h(this_firstseed,yellow);\
      hilight_learn=hl_temp;\
      moveto(tempx,tempy);\
   }
#  if (__BORC__||__WATCOM__)
      starttime = clock();  /*start time*/
#  elif (__UNIX__)   
      sprintf(textb[0],"tp");
      sprintf(textb[0],"tzp");
       
      gettimeofday(&tp,&tzp);
      starttime=(unsigned long)tp.tv_sec; /*xwindows*/
      starttime_m=(unsigned long)tp.tv_usec;
#  endif   
   
   if (exhaustive_testing){
      prestate_successor_pairs();
      if (is[0]=='q'){
	 if (screensavedemo==0) mutantdontpause=0;
         return;
      }
   }
   else if (nonlocal || nhood_mixed) prepair_pre_rand();
   sprintf(textb[0],"this_firstseed");
   if ((this_firstseed=(char *)calloc(bytesL,sizeof(char)))
					==NULL) outof_memory(textb[0]);

   if (show_ss_matrix) show_statespace_matrix(NULL);

   attperiod=cyclematch=maxtreefan=totsubtree=isexception=totatt_states=0;
   totsubtreegofE=totsubgofEdensity=0;
   memcpy(A,bitseed,bytesL);
   if (stepforward>0) run_forward();
   memcpy(firstseed,A,bytesL);
   memcpy(this_firstseed,A,bytesL);
   linec=black;
   if ((nonlocal==0 || compress_1d_local==1 || regular2d)
	&& !dontcompress && !rulemix && exhaustive_testing!=2){
      /*allocate mem for pre-images of all 0s and 1s*/
      if (regular2d){
	 sprintf(textb[0],"seg_2d_0");
	 if ((seg_2d_h=(signed short*)calloc(1, sizeof(signed short)))
				 ==NULL) outof_memory(textb[0]);
	 sprintf(textb[0],"seg_2d_1");
	 if ((seg_2d_v=(signed short*)calloc(1, sizeof(signed short)))
				 ==NULL) outof_memory(textb[0]);
      }
      else{
	 sprintf(textb[0],"seg");
	 if ((seg = (signed short*)calloc(1, sizeof(signed short)))
				 ==NULL) outof_memory(textb[0]);
      }
      sprintf(textb[0],"segseed");
      if( (segseed =(char**) calloc(2,sizeof(char*)))
				 ==NULL) outof_memory(textb[0]);
   }
   maxtreelevel=maxtreelevel=justonepreimage=insegloop=0;
   if (!rulemix) show_rule_bottom(nhood,1,carule[0],0);

#  if (__BORC__)/*not watcom*/
      draw_bottom_title();
      /*show various prompts*/
      if (see_ppstack==1 && nonlocal) sprintf(textb[1]," ppstack-p");
      else sprintf(textb[1],"");
      sprintf(textb[0],"%s  matrix-m STP-s scroll-# exp-e contr-c",textb[1]);
      draw_hint_box(0,textb[0],385);
#  endif

   earlyexit=0;

   if (rangeL){
      if (show_one_att_state==1) show_seed;
   }
   else show_seed;

   run_backward();
   this_isrepeat=isrepeat;
   if (segfan){  /*run back from each segfan state*/
      if (pdata==2 || filedata==2){  /*tree data*/
	 sprintf(textb[0],"   tree. root  no  s  g  gd  ml  mp\n");
	 if (pdata==2) print_out(textb[0]);
	 if (filedata==2) save_data(textb[0]);
      }
      insegloop=1;
      segfan=0;
      for (segindex=1;segindex<=segno;segindex++){
	 memcpy(firstseed,segseed[segindex],bytesL);
	 startsegfan=1;
	 run_backward();

	 /*to interrupt*/
	 if (is[0]=='q'){
	    earlyexit=1;
	    if (screensavedemo==0) mutantdontpause=0;
	    break;
	 }
	 /*interrupt tree, continue with next tree*/
	 if (is[0]=='n'){
	    earlyexit=1;
	    memory_box(1);
	    continue;
	 }
	 if (regular2d){
	    totsubtree+=treesize*
	    seg_2d_h[segindex]*seg_2d_v[segindex];
	    totsubtreegofE+=gofEno*seg_2d_h[segindex]*seg_2d_v[segindex];
	 }
	 else{
	    totsubtree+=treesize*seg[segindex];
	    totsubtreegofE+=gofEno*seg[segindex];
	 }
      }
      insegloop=0;
      /*free fanseg memory*/
      free(segx); 		/*free fanseg co-ords*/
      free(segy); 		/*free fanseg states*/
      if (justonepreimage) totsubtree+=2;
      else totsubtree+=1;
   }
   else{
      /*to interrupt*/
      if (is[0]=='q'){
	 earlyexit=1;
	 memory_box(1);
	 if (screensavedemo==0) mutantdontpause=0;
      }
      totsubtree=treesize;
      /*if attractor cycle included*/
      if (this_isrepeat) totsubtreegofE=gofEno-1;
      else totsubtreegofE=gofEno;
   }
   if (exhaustive_testing){
      free(exh_pairs);
      free(tickoff);
   }
   else if (nonlocal || nhood_mixed) free_pre_rand();

   if ((nonlocal==0 || compress_1d_local==1 || regular2d)
      && !dontcompress && !rulemix && exhaustive_testing!=2){
      if (segno>0) for (zu=1;zu<=segno;zu++) free(segseed[zu]);
      free(segseed);
      if (regular2d){
	 free(seg_2d_h);
	 free(seg_2d_v);
      }
      else free(seg);
   }
   totsubgofEdensity=(float)totsubtreegofE/totsubtree;
   if (rangeL){
      if (show_one_att_state==1) show_seed;
   }
   else show_seed;
   /*pause to show tree data*/
   xbox=draw_prompt_box(2);
   if (earlyexit){
      sprintf(textb[2],"EARLY EXIT, part ");
      if (screensavedemo==0) mutantdontpause=0;
   }
   else sprintf(textb[2],"%s","");
   /*subtree only*/
   if (!isrepeat) sprintf(textb[0],"%ssubtree=%lu ",textb[2],totsubtree);
   else sprintf(textb[0],"%ssubtree=basin=%lu ",textb[2],totsubtree);
   if (lineL<=160)  sprintf(textb[1],"seed(hex)=");
   else sprintf(textb[1],"%s","");
   outtext(textb[0]);
   if (lineL<=56) myouttext(textb[1]);
   if (pdata || filedata){
      printhex=1;
      if (pdata){
	 print_out(textb[0]);
	 print_out(textb[1]);
      }
      if (filedata){
	 save_data(textb[0]);
	 save_data(textb[1]);
      }
   }
   if (lineL<=56) /*7 bytes max to fit in box*/
     print_current_bitstring_hexbytes(0,bitseed,0,Maxx,white,printhex);
   else if (lineL<=160) /*printer or file only*/
     print_current_bitstring_hexbytes(0,bitseed,0,Maxx,white,3);
   moveto(xbox,gety+CHeight);
   sprintf(textb[0],"\ng=%lu gd=%.3g ml=%d mp=%lu\n",
			totsubtreegofE,totsubgofEdensity,
						maxtreelevel,maxtreefan);
   outtext(textb[0]);
   if (pdata){
      print_out(textb[0]);
      print_out("\n");
   }
   if (filedata){
      save_data(textb[0]);
      save_data("\n");
   }

#  if (__BORC__||__WATCOM__)
      endtime = clock();  /*start time*/
#  elif (__UNIX__)   
      gettimeofday(&tp,&tzp);
      endtime=(unsigned long)tp.tv_sec; /*xwindows*/
      endtime_m=(unsigned long)tp.tv_usec;
#  endif   

   if (earlyexitfield==0){
#     if (__BORC__||__WATCOM__)      
         elapsedtime=(unsigned long)(endtime-starttime);
         timesec=(float)elapsedtime/(unsigned long)CLK_TCK;
         if (timesec>59){
	    timemin=(signed short)(timesec/60);
	    timesec-=timemin*60;
	    sprintf(textb[2],"%dmin %.3fsec",timemin,timesec);
         }
         else sprintf(textb[2],"%.3fsec",timesec);
         outtext(textb[2]);
#     elif (__UNIX__)   
         elapsedtime=endtime-starttime;
         elapsedtime_m=endtime_m-starttime_m;     
         if (elapsedtime_m<0){ 
            elapsedtime-=1;
            elapsedtime_m=(1000000-starttime_m)+endtime_m;
         }
         timesec=(float)
               ((elapsedtime%60)+((float)elapsedtime_m/1000000));
         if (elapsedtime>=60){
            timemin=elapsedtime/60;
            sprintf(textb[2],"  %dmin %.3fsec",timemin,timesec);
         }
         else sprintf(textb[2],"  %.3fsec",timesec);     
         outtext(textb[2]);
#    endif

   }
   /*to show average stack histogram*/
   if (see_ppstack && (nonlocal || nhood_mixed)) show_average_pp_hist();

   if (rangeL && datapause){
      if (lineL!=endL){
	 xbox=memory_box(0);
	 moveto(xbox+vgax(3),vgay(3));
	 myouttext("options-o layout-a:");
	 input_string(1,0);
	 if (is[0]=='a') amend_layout();
	 if (is[0]=='o') finish_options(1);
      }
      else finish_options(1);
   }
   free(this_firstseed);
}

/**** draw several basin fields for range of L, Oct 93 ******************/
void draw_range_field(void){
 signed short poss,zz,z,tablemax,sod,startnumber;
    /*max index of ruletable*/
    tablemax= (signed short)pow(2,(double)nhood)-1;
    zonesize=lineL;
    /*position of CA size for each field*/
    if (stp) startnumber=vgax(13+scale*endL);
    else startnumber=vgax(3);
    if (firstox<startnumber+vgax(40)){
       firstox=startnumber+vgax(40);
       ox=firstox;
    }
    if (!rulemix) show_rule_bottom(nhood,1,carule[0],0);
    for (L=startL-1;L<=endL-1;L++){
       isexception=0;
       if (is[0]=='q') break;
       fieldno+=1;
       free_mem_CA_states();
       lineL=L+1;
       bytesL=ceil((double)lineL/8);
       allocate_mem_CA_states();
       if (fieldno>1){
	  wire_rule_extra_cell(1);
	  /*start field on new line*/
	  xspacing*=xspacefact;
	  yspacing*=yspacefact;
	  ox=firstox;
	  oy+=yspacing;
       }
       if (!twod && shownumbers==3 && showbits_1d_as_2d==1){
	  for (z=(signed short)ceil(pow((double)lineL,.5));z>=1;z--){
	     if (lineL%z==0) break;
	  }
	  j2d=z;
	  i2d=(signed short)ceil((double)lineL/j2d);
       }
       /*show CA size for each field*/
       moveto(startnumber,oy-CHeight/2);
       sprintf(textb[0],"%d.",lineL);
       outtext(textb[0]);
       moveto(ox,oy);
       /*draw basin of attraction field*/
       draw_field();
       print_field_data();
       if (fieldpause==1 && !pre_fansize_freq_hist) finish_options(1);
       if (pre_fansize_freq_hist) show_pre_fansize_freq_hist();
    }
    L-=1;
    lineL=L+1;
    bytesL=ceil((double)lineL/8);
    if (mutantdontpause==0) finish_options(1);
    free_mem_CA_states();
    free_mem_wiring();
    if (rulemix){
       free_mem_rulemix();
       free_mem_tcodemix();
    }
    lineL=startL;
    L=lineL-1;
    bytesL=ceil((double)lineL/8);
    allocate_mem_CA_states();

    sprintf(textb[0],"nhoodm");
    if ((nhoodm=(char*)realloc(nhoodm,lineL*sizeof(char)))
					==NULL) outof_memory(textb[0]);
    if (nhood_mixed){
       for (poss=lineL-1;poss>=0;poss--){
	  while(!(nhoodm[poss]>=nhood_lb && nhoodm[poss]<=nhood))
						 nhoodm[poss]=myrand()%10;
       }
    }
    allocate_mem_wiring();
    if (whatwire==1) for (poss=lineL-1;poss>=0;poss--)
		  oneD_local_wire_cell(poss,lineL-1); /*rewire local*/
    else{  /*rewire random*/
       zonesize=lineL;
       for (poss=L;poss>=0;poss--) randomly_wire_cell(poss,L);
       cell_out_freq();
    }
    if (rulemix){
       allocate_mem_rulemix(nhood);
       allocate_mem_tcodemix(nhood);
       for (poss=lineL-1;poss>=0;poss--){
	  if (nhood_mixed)
	      tablemax=(signed short)pow(2,(double)nhoodm[poss])-1;
	  if (totalistic==0){
	     for (zz=tablemax;zz>=0;zz--)
				set_bit(carule[poss],zz,(myrand()%100)/50);
	  }
	  else{
	     for (zz=nhoodm[poss];zz>=0;zz--)
				set_bit(cacode[poss],zz,(myrand() % 100)/50);
	     for (zz=tablemax;zz>=0;zz--){
		sod=0;
		for (z=nhoodm[poss]-1;z>=0;z--) sod+=get_bit(nm[z],zz);
		set_bit(carule[poss],zz,get_bit(cacode[poss],sod));
	     }
	  }
       }
    }
}

/**************************** draw field, Aug 93 **********************/
void draw_field(){
 signed short timemin;
 unsigned long elapsedtime,tickoffbytes;
 float timesec;
#if (__BORC__||__WATCOM__)
 clock_t starttime, endtime;
#elif (__UNIX__)
 unsigned long starttime, starttime_m,
               endtime,endtime_m;
 long elapsedtime_m;
 struct timeval tp;
 struct timezone tzp;
#endif
 char stoprange=0;

#  if (__BORC__||__WATCOM__)
      starttime = clock();  /*start time*/
#  elif (__UNIX__)   
      sprintf(textb[0],"tp");
      sprintf(textb[0],"tzp");
      gettimeofday(&tp,&tzp);
      starttime=(unsigned long)tp.tv_sec; /*xwindows*/
      starttime_m=(unsigned long)tp.tv_usec;
#  endif   

   thisprogbar=0;

   maxfieldfan=1;
   firstox=ox;
   limitcheck=10000;
   earlyexitbasin=earlyexitfield=0;
   basintypeno=totbasinsinfield=fieldsize=fieldgofE=fieldgofEdensity=0;

   if (show_ss_matrix) show_statespace_matrix(NULL);

   if (exhaustive_testing){
		is[0]=0;
		prestate_successor_pairs();
		if (is[0]=='q'){
		earlyexitfield=1;
		mutantdontpause=0;
		return;
      }
   }
   else if (nonlocal || nhood_mixed) prepair_pre_rand();

   if (!rulemix && !rangeL) show_rule_bottom(nhood,1,carule[0],0);
   /*key to basin data*/
   if (pdata || filedata){
      sprintf(textb[0],"ty.  at  no  (p)  s  %%  g  gd  ml  mp\n");
      if (pdata) print_out(textb[0]);
      if (filedata) save_data(textb[0]);
      if (pdata==2 || filedata==2){  /*tree data*/
	 sprintf(textb[0],"   tree. root  no  s  g  gd  ml  mp\n");
	 if (pdata==2) print_out(textb[0]);
	 if (filedata==2) save_data(textb[0]);
      }
   }

   statespace=(unsigned long)(pow(2,(double)lineL)-1);
#  if (__BORC__)
      if (lineL<=19) tickspace=statespace;
      else tickspace=(unsigned long)(pow(2,(double)18)-1);
#  elif (__WATCOM__||__UNIX__)
      if (lineL<=32) tickspace=statespace;
      else tickspace=(unsigned long)(pow(2,(double)32)-1);
#  endif

   tickoffbytes=(unsigned long)ceil( (double) (tickspace+1)/8 );
   sprintf(textb[0],"tickoff"); /*state-space index set to 0*/
   if ((tickoff=(char *)calloc(tickoffbytes,sizeof(char)))
					==NULL) outof_memory(textb[0]);
   memory_box(1);
   progress_bar(); /* for progress through statespace bar*/
   progbar=segstates=totatt_states=0;;

   for (sspace=0;sspace<=tickspace;sspace++){
      /*interrupt the field*/
      if (is[0]=='q'){
	 if (rangeL){
	    startinterrupt:
	    draw_prompt_box(1);
	    myouttext("getout-q, options-o, nextfield-RET:");
	    input_string(1,0);
	    if (is[0]=='q'){
	       erase_prompt_box(1);
	       stoprange=1;
	    }
	    if (is[0]=='o'){
	       finish_options(1);
	       goto startinterrupt;
	    }
	 }
	 earlyexitfield=1;
	 mutantdontpause=0;
	 break;
      }
      if (get_bitlong(tickoff,sspace)) continue;
      basintypeno+=1;
      /*draw line in progress bar indicating pos of seed*/
      moveto(barxl+(signed short)((float)(barxr-barxl)*
		       ((float)(sspace+1)/(statespace+1))),baryt-2);
      lineto(getx,baryb+2);

      if (basintypeno>1){
	 /*show each basins in field on whole screen in succession*/
	 if (successive_basins==1){
	    clearviewport();
	    ox=firstox;
	    oy=firstoy;
	    progress_bar(); /* for progress through statespace bar*/
	 }
	 else{
	    /*move position of next basin to the right*/
	    ox+=xspacing;
	    /*if too close to right edge of screen, start new row*/
	    if ((Maxx-ox)<(signed short)((float)xspacing*rightborder)){
	       ox=firstox;
	       oy+=yspacing;
	    }
	 }
      }
      memcpy(bitseed,all_0s,bytesL); /*set seed array to null*/
      dec_to_bit_line(bitseed,sspace,lineL);
      memcpy(A,bitseed,bytesL);

      run_forward();
      if (stp){
	  moveto(0,0);
	  if (nowscrolling==1){
#            if __BORC__||__WATCOM
	        freeimage(stpimage);
#            endif
	     nowscrolling=0;
	 }
      }
   }
   if (exhaustive_testing) free(exh_pairs);
   else if (nonlocal || nhood_mixed) free_pre_rand();
   free(tickoff);
   memory_box(1);
   if (!rulemix) show_rule_bottom(nhood,0,carule[0],0);
#  if (__BORC__)/*not watcom*/
      draw_bottom_title();
     /*show various prompts*/
      if (see_ppstack==1 && (nonlocal || nhood_mixed))
				    sprintf(textb[1]," ppstack-p");
      else sprintf(textb[1],"");
      sprintf(textb[0],"%s matrix-m STP-s scroll-# exp-e contr-c",textb[1]);
      draw_hint_box(0,textb[0],385);
#  endif
#  if (__BORC__||__WATCOM__)
      endtime = clock();  /*start time*/
#  elif (__UNIX__)   
      gettimeofday(&tp,&tzp);
      endtime=(unsigned long)tp.tv_sec; /*xwindows*/
      endtime_m=(unsigned long)tp.tv_usec;
#  endif   

   sprintf(textb[2],"%s","");
   if (earlyexitfield==0){
#     if (__BORC__||__WATCOM__)
         elapsedtime=(unsigned long)(endtime-starttime);
         timesec=(float)elapsedtime/(unsigned long)CLK_TCK;
         if (timesec>59){
	    timemin=(signed short)(timesec/60);
	    timesec-=timemin*60;
	    sprintf(textb[2],"%dmin %.3fsec",timemin,timesec);
         }
         else sprintf(textb[2],"%.3fsec",timesec);
         /*sprintf(textb[0],"progbar=%lu statespace=%lu segstates=%d",
     				   progbar,statespace+1,segstates);*/
#    elif (__UNIX__)
         elapsedtime=endtime-starttime;
         elapsedtime_m=endtime_m-starttime_m;
         if (elapsedtime_m<0){ 
            elapsedtime-=1;
            elapsedtime_m=(1000000-starttime_m)+endtime_m;
         }
         timesec=(float)
               ((elapsedtime%60)+((float)elapsedtime_m/1000000));
         if (elapsedtime>=60){
            timemin=elapsedtime/60;
            sprintf(textb[2],"  %dmin %.3fsec",timemin,timesec);
         }
         else sprintf(textb[2],"  %.3fsec",timesec);
#    endif
      sprintf(textb[0],"ERROR excess states=%ld",
			(signed long)progbar-(statespace+1));
      if (progbar != statespace+1){
	 setcolor(white);
	 moveto(barxl+2,baryb+vgay(4));
	 setfillstyle(SOLID_FILL,black);
	 bar(getx,gety,barxr-2,baryb+vgay(12));
	 outtext(textb[0]);
      }
      if (fieldpause==1) stoprange=1;
   }
   if (stoprange) is[0]='q';
   else is[0]=0;
   /*to show average stack histogram*/
   if (see_ppstack && (nonlocal || nhood_mixed)) show_average_pp_hist();

}
/******** to show average partial pre-image histogram, Aug 1994 *******/
void show_average_pp_hist(void){
  signed short z/*,xbox*/;
  float pp_temp;

      pp_hist_max=pp_temp=0;
      for (z=lineL-1;z>=0;z--){
	 pp_temp=(float)pp_hist_total[z]/pp_histcount;
	 if ((float)pp_hist_max <= pp_temp)
		     pp_hist_max=(signed short)ceil(pp_temp);
      }
      /*rescale y axis*/
      pp_ymax=pp_hist_max*1.5;
      ppL=0;
      setup_ppstack_hist();
      for (z=lineL-1;z>=0;z--){
	 pp_temp=(float)pp_hist_total[z]/pp_histcount;
	 pp_heighty=(signed short)(vgax(120)*pp_temp/pp_ymax);
	 bar(pp_startx,pp_starty-pp_heighty,
				   pp_startx+pp_barwidth,pp_starty);
	 pp_startx+=pp_bartotw;
	 /*
	 xbox=draw_prompt_box(2);
	 sprintf(textb[0],"htot[%d]/hc=%lu/%lu = pp_temp=%g",
		      z,pp_hist_total[z],pp_histcount,pp_temp);
	 sprintf(textb[1],"hmax=%d,pp_ht=%d,wild=%lu",
		   pp_hist_max,pp_heighty,pp_wild_tot);
	 outtext(textb[0]);
	 moveto(xbox,gety+CHeight);
	 outtext(textb[1]);
	 getch();
	 */
      }
      if (pp_wild_tot>0){
	 pp_startx-=pp_bartotw;
	 setfillstyle(INTERLEAVE_FILL,red);
	 bar(pp_startx,pp_starty-pp_heighty-1
	    -(signed short)vgax(120)*
	       ((float)pp_wild_tot/pp_histcount)/pp_ymax,
		     pp_startx+pp_barwidth,pp_starty-pp_heighty-1);

      }
      moveto(pp_startx0+vgax(4),pp_starty0-pp_depthy+1);
      setfillstyle(SOLID_FILL,black);
      bar(getx,gety,getx+textwidth("average p-pre-image histogram"),
					       gety+CHeight);
      outtext("average p-pre-image histogram");
}

/********** for progress through state space bar, Aug 93 ***********/
void progress_bar(void){
 signed short xbox;
 unsigned char tempcolor;

   xbox=(signed short)((float)Maxx)/2;
   draw_box(-1,xbox,vgay(30),Maxx-2,vgay(30)+vgay(9)+vgay(3),1,0);
   barxl=xbox+2;
   baryt=vgay(30)+vgay(3);
   barxr=Maxx-vgax(6);
   baryb=vgay(30)+vgay(9);
   tempcolor=getcolor();
   setcolor(lightred);
   rectangle(barxl,baryt,barxr,baryb);
   setcolor(tempcolor);
}

/********************** print field data, Aug 93 ******************/
void print_field_data(void){
 signed short xbox;

    xbox=draw_prompt_box(2);
    if (earlyexitfield || earlyexitbasin)
       sprintf(textb[0],"EARLY EXIT basins types=%d total basins=%d\n",
					    basintypeno,totbasinsinfield);
    else sprintf(textb[0],"basins types=%d total basins=%d\n",
					    basintypeno,totbasinsinfield);
    outtext(textb[0]);
    if (pdata) print_out(textb[0]);
    if (filedata) save_data(textb[0]);
    moveto(xbox,gety+CHeight);
    if (fieldsize != (unsigned long)pow(2,(double)lineL))
       sprintf(textb[0],"sspace=%lu field=%lu gE=%lu density=%.3g\n",
		      (unsigned long)pow(2,(double)lineL),
				fieldsize,fieldgofE,fieldgofEdensity);
    else sprintf(textb[0],"field=%lu gE=%lu density=%.3g\n",
				fieldsize,fieldgofE,fieldgofEdensity);
    outtext(textb[0]);
    outtext(textb[2]);
    if (pdata){
       print_out(textb[0]);
       print_out("\n");
    }
    if (filedata){
       save_data(textb[0]);
       save_data("\n");
    }
}

/*** draw the attractor cycle, loop then each transient tree, 13 May 93 ***/
void draw_basin(void){
 float cyheading,stangle,cyclerad,
       pointangle,pointrad,angle;
 signed short pointx,pointy,tempx,tempy,z,xbox;
 unsigned short zu;
 char pnode,earlyexittree=0,earlyexitseg=0,hl_temp;
 unsigned long totsubtreegofE=0,basingofE=0;
 unsigned long thisbar;
 unsigned long elapsedtime;
 float timesec;
#if (__BORC__||__WATCOM__) 
   clock_t starttime, endtime;
#elif (__UNIX__)
  unsigned long starttime,starttime_m,
                endtime,endtime_m;
  long  elapsedtime_m;
  struct timeval tp;
  struct timezone tzp;
#endif 
signed short timemin;

   if (!basinfield){ 
#     if (__BORC__||__WATCOM__)
         starttime = clock();  /*start time*/
#     elif (__UNIX__)   
         sprintf(textb[0],"tp");
         sprintf(textb[0],"tzp");
         gettimeofday(&tp,&tzp);
         starttime=(unsigned long)tp.tv_sec; /*xwindows*/
         starttime_m=(unsigned long)tp.tv_usec;
#     endif  
  }
  
  if (show_ss_matrix){
     if (!basinfield || successive_basins) show_statespace_matrix(NULL);
     else{
	startmcolor:
	/*give each basin a diff color - cycle through colors in 2 steps*/
	if (matrixcolor==0) matrixcolor+=1;
	else matrixcolor+=2;
	if (matrixcolor==17) matrixcolor=2;
	if (matrixcolor==16){
	   matrixcolor=0;
	   goto startmcolor;
	}
     }
  }

  thisbar=progbar;
  earlyexit=0;
  earlyexittree=0;

  if (!basinfield){
	if (exhaustive_testing==1){ /*if ==2 done in run_forward()*/
		is[0]=0;
		prestate_successor_pairs();
		if (screensavedemo==0) mutantdontpause=0;
		
		if (is[0]=='q'){
		   return;
		}
	}
     else if (exhaustive_testing!=2 &&
	   (nonlocal || nhood_mixed)) prepair_pre_rand();
  }
  totsubtree=0;
  if (!rulemix && ((basinfield==0 && !rangeL) || (successive_basins)))
				     show_rule_bottom(nhood,1,carule[0],0);
  /*allocate mem to cycle co-ords*/
  sprintf(textb[0],"cyclex");
  if ((cyclex=(signed short *)calloc(attperiod+1,sizeof(signed short)))
				      ==NULL) outof_memory(textb[0]);
  sprintf(textb[0],"cycley");
  if ((cycley=(signed short *)calloc(attperiod+1,sizeof(signed short)))
				      ==NULL) outof_memory(textb[0]);
  tempx=getx;
  tempy=gety;
  pnode=stangle=cyheading=0;
  stangle=deg*cyheading;  /*degrees anti-clockwise from x-axis*/
  /*cyclerad asymptotically approaches rad[0] with increacing attperiod*/
  cyclerad=(rad[0]/3)+((2*rad[0]/3)*((float)attperiod-2)/(float)attperiod);
# if (__WATCOM__||__UNIX__)
     if (gd_z_graph){ /*watcom, confine graphics to rectangle*/
       if (stp) setviewport(lineL*scale+vgax(12),vgay(46),Maxx-3,vgay(157),1);
       else  setviewport(3,vgay(46),Maxx-3,vgay(157),1);
     }
# endif
  /*draw attractor cycle*/
  if (attperiod==1){
     pointangle=0;
     pointrad= pow(  ( pow( (startrad/4),2 ) *2 ), .5);
     pointangle=(deg*225)+stangle;
     pointx=(signed short) (cos(pointangle)*pointrad)+ox;
     pointy=(signed short) -(sin(pointangle)*pointrad)+oy;
     setcolor(yellow);
     circle(pointx,pointy,pow(2,.5)*startrad/4);
     setcolor(lightred);
     circle(ox,oy,startrad/20);
     cyclex[1]=ox;
     cycley[1]=oy;
  }
  if (attperiod==2){
     setcolor(cyan);
     stangle=2*PI-PI/6 + (deg* cyheading);
     circle(ox,oy,cyclerad);
     angle=2*PI/attperiod;
     setcolor(lightred);
     for (z=attperiod;z>=1;z--){
	/*co-ordinates of cycle nodes*/
	cyclex[z]=(signed short)(cos(stangle-(angle*z))*cyclerad)+ox;
	cycley[z]=-(signed short)(sin(stangle-(angle*z))*cyclerad)+oy;
	moveto(cyclex[z],cycley[z]);
	if (pnode==0) circle(cyclex[z],cycley[z],startrad/15);
     }
  }
  if (attperiod>2){
     angle=2*PI/attperiod;
     setcolor(lightred);
     for (z=attperiod;z>=1;z--){
	/*co-ordinates of cycle nodes*/
	cyclex[z]=(signed short)(cos(stangle-(angle*z))*cyclerad)+ox;
	cycley[z]=-(signed short)(sin(stangle-(angle*z))*cyclerad)+oy;
	setcolor(cyan);
	if (z==attperiod) moveto(cyclex[z],cycley[z]);
	else lineto(cyclex[z],cycley[z]);
	if (pnode==0){
	   circle (cyclex[z],cycley[z],cyclerad/(10+attperiod/2));
	   /*print_current_state(att[z], green);*/
	   moveto(cyclex[z],cycley[z]);
	}
     }
     lineto(cyclex[attperiod],cycley[attperiod]);
  }
# if (__WATCOM__||__UNIX__)
     /*watcom, release graphics from rectangle */
     if (gd_z_graph) setviewport(0, 0, Maxx, Maxy, 0);
# endif

  moveto(tempx,tempy);

  if  ((nonlocal==0  || compress_1d_local==1 || regular2d)
      && !dontcompress && !rulemix && exhaustive_testing!=2){
     if (regular2d){
	/*no of eq states in att cycle*/
	rot_cycle_equiv_2d(att[1]);
	/*    sets cyclematch_2d[0], horiz rotations
	      cyclematch_2d[1], vertical rotations
	      cyclematch_2d_diag[0], poss diagonal rotations
	      cyclematch_2d_diag[1], neg  diagonal rotations*/

	cyclematch=cyclematch_2d[0]*cyclematch_2d[1];
	if (cyclematch_2d_diag[0]>1) cyclematch=cyclematch_2d_diag[0];
	else if (cyclematch_2d_diag[1]>1) cyclematch=cyclematch_2d_diag[1];

	/*repseg_2d.. is size of segments..
	  no. of one cell translations required (vertical/horiz)
	  in toroidal bit array, to return to start
	  same for all states on att cycle,
	  overriden if vert=horiz translation*/
	attrepseg_2d_h=repseg_2d[0];
	attrepseg_2d_v=repseg_2d[1];

	basinno_2d_h=attrepseg_2d_h/cyclematch_2d[0];
	basinno_2d_v=attrepseg_2d_v/cyclematch_2d[1];

	attrepseg_2d_patch=attrepseg_2d_h*attrepseg_2d_v;
	basinno=basinno_2d_h*basinno_2d_v;

	if (cyclematch_2d_diag[0]>1)
		     basinno/=cyclematch_2d_diag[0];
	else if (cyclematch_2d_diag[1]>1)
		     basinno/=cyclematch_2d_diag[1];
	/*
	xbox=memory_box(0);
	moveto(xbox,2);
	sprintf(textb[0],"h/c=%d/%d v/c=%d/%d b=%d",
	  attrepseg_2d_h,cyclematch_2d[0],
	    attrepseg_2d_v,cyclematch_2d[1],basinno);
	outtext(textb[0]);
	input_string(1,0);
	*/
     }
     else{
	/*no of eq states in att cycle*/
	cyclematch=rot_cycle_equiv(att[1]);
	/*no of repeating segs in circular bit string,
		      same for all states on att cycle*/
	attrepseg=repeating_seg(att[1]);
	basinno=attrepseg/cyclematch;
     }
     /*number of equivalent basins of this type*/
     if (basinfield) totatt_states+=attperiod*basinno;
     else totatt_states=attperiod;
  }
  else{
     cyclematch=1; /*no of eq states in att cycle*/
     if (regular2d){
	attrepseg_2d_h=1;
	attrepseg_2d_v=1;
	attrepseg_2d_patch=1;
     }
     else attrepseg=1; /*no of repeating segs in state hoop*/

     basinno=1;/*number of equivalent basins of this type*/
     totatt_states=attperiod;
  }
  basinsize=basingofE=maxbasinfan=maxbasinlevel=0;
  if ((nonlocal==0  || compress_1d_local==1 || regular2d)
      && !dontcompress && !rulemix && exhaustive_testing!=2){
     /*allocate mem for pre-images of all 0s and 1s*/
     if (regular2d){
	sprintf(textb[0],"seg_2d_0");
	if ((seg_2d_h=(signed short*)calloc(1, sizeof(signed short)))
				 ==NULL) outof_memory(textb[0]);
	sprintf(textb[0],"seg_2d_1");
	if ((seg_2d_v=(signed short*)calloc(1, sizeof(signed short)))
				 ==NULL) outof_memory(textb[0]);
     }
     else{
	sprintf(textb[0],"seg");
	if ((seg = (signed short*)calloc(1, sizeof(signed short)))
				 ==NULL) outof_memory(textb[0]);
     }
     sprintf(textb[0],"segseed");
     if( (segseed=(char**)calloc(1,sizeof(char*)))
				     ==NULL) outof_memory(textb[0]);
     /*nominal allocation*/
     sprintf(textb[0],"segseed[%d]",0);
     if ((segseed[0]=(char*)calloc(1,sizeof(char)))
				     ==NULL) outof_memory(textb[0]);
     memory_box(1);
  }

  if (show_one_att_state==1){
	tempx=getx;
	tempy=gety;
#       if (__WATCOM__||__UNIX__)
	   if (gd_z_graph){ /*watcom, confine graphics to rectangle*/
	      if (stp) setviewport(lineL*scale+vgax(12),
				vgay(46),Maxx-3,vgay(157),1);
	      else  setviewport(3,vgay(46),Maxx-3,vgay(157),1);
	   }
#       endif

	moveto(cyclex[attperiod],cycley[attperiod]);
	hl_temp=hilight_learn;
	hilight_learn=1;
	if (twod || showbits_1d_as_2d)
	     print_current_state_twod(att[attperiod],yellow);
	else print_current_state_h(att[attperiod],yellow);
	hilight_learn=hl_temp;
#       if (__WATCOM__||__UNIX__)
	   /*watcom, release graphics from rectangle*/
	   if (gd_z_graph) setviewport(0, 0, Maxx, Maxy, 0);
#       endif
	moveto(tempx,tempy);
  }

  /*run backwards, draw transient tree, from each attractor state*/
  for (attindex=attperiod;attindex>=
		     attperiod+1-(attperiod/cyclematch);attindex--){
     memcpy(firstseed,att[attindex],bytesL);
     if (attindex==attperiod) linec=black;
     maxtreelevel=maxtreefan=justonepreimage=insegloop=0;
     run_backward();
     /*to interrupt basin field*/
     if (is[0]=='q'){
	earlyexit=1;
	if (basinfield){
	   free_basin_memory();
           return;
	}
	else break;
     }
     /*interrupt tree, continue with next tree*/
     if (is[0]=='n'){
	earlyexit=1;
	memory_box(1);
	continue;
     }
     if (earlyexit==1){
	earlyexittree=1;
	earlyexit=0;
     }
     if (segfan){  /*run back from each segfan state*/
	insegloop=1;
	segfan=totsubtree=totsubtreegofE=0;
	earlyexitseg=0;
	for (segindex=1;segindex<=segno;segindex++){
	   memcpy(firstseed,segseed[segindex],bytesL);
	   startsegfan=1;

	   run_backward();
	   /*interrupt basin or basin field*/
	   if (is[0]=='q'){
	      earlyexit=1;
	      if (basinfield){
		 free(segx);
		 free(segy);
		 free_basin_memory();
		 insegloop=0;
		 memory_box(1);

              return;
	      }
	      else break;
	   }
	   /*interrupt tree, continue with next tree*/
	   if (is[0]=='n'){
	      earlyexit=1;
	      memory_box(1);
	      continue;
	   }
	   if (earlyexit==1){
	      earlyexitseg=1;
	      earlyexit=0;
	   }
	    /*count data*/
	   if (regular2d){
	      totsubtree+=(treesize*seg_2d_h[segindex]*seg_2d_v[segindex]);
	      totsubtreegofE+=(gofEno*seg_2d_h[segindex]*seg_2d_v[segindex]);
	   }
	   else{
	      totsubtree+=treesize*seg[segindex];
	      totsubtreegofE+=gofEno*seg[segindex];
	   }
	   if (maxbasinfan<maxtreefan) maxbasinfan=maxtreefan;
	   if (maxbasinlevel<maxtreelevel) maxbasinlevel=maxtreelevel;
	}
	if (justonepreimage) totsubtree+=2;
	else totsubtree+=1;
	insegloop=0;
	treesize=gofEno=0;
	free(segx); /*free fanseg co-ords*/
	free(segy);
	if (segno>0) for (zu=1;zu<=segno;zu++) free(segseed[zu]);
	segno=0;
	memory_box(1);
     }

     basinsize+=((treesize*cyclematch)+totsubtree);
     basingofE+=((gofEno*cyclematch)+totsubtreegofE);
     if (maxbasinfan<maxtreefan) maxbasinfan=maxtreefan;
     if (maxbasinlevel<maxtreelevel) maxbasinlevel=maxtreelevel;
  } /*next attindex*/

  if (show_one_att_state==1){
	tempx=getx;
	tempy=gety;
#       if (__WATCOM__||__UNIX__)
	   if (gd_z_graph){ /*watcom, confine graphics to rectangle*/
	      if (stp) setviewport(lineL*scale+vgax(12),
				vgay(46),Maxx-3,vgay(157),1);
	      else  setviewport(3,vgay(46),Maxx-3,vgay(157),1);
	   }
#       endif

	moveto(cyclex[attperiod],cycley[attperiod]);
	hl_temp=hilight_learn;
	hilight_learn=1;
	if (twod || showbits_1d_as_2d)
	     print_current_state_twod(att[attperiod],yellow);
	else print_current_state_h(att[attperiod],yellow);
	hilight_learn=hl_temp;
#       if (__WATCOM__||__UNIX__)
	   /*watcom, release graphics from rectangle*/
	   if (gd_z_graph) setviewport(0, 0, Maxx, Maxy, 0);
#       endif
	moveto(tempx,tempy);
  }

  if (basinsize>0) basingofEdensity=(float)basingofE/(basinsize);
  if (maxfieldfan<maxbasinfan) maxfieldfan=maxbasinfan;

  /*pause to show basin data*/
  if (datapause || (!basinfield && !mutantdontpause)){
     if (earlyexitseg || earlyexittree){
	sprintf(textb[2],"EARLY EXIT ");
	earlyexitbasin=1;
     }
     else sprintf(textb[2],"%s","");
     xbox=draw_prompt_box(2);
     if (basinfield) sprintf(textb[0],"%sbasin %d, eqiv basins=%d",
					textb[2],basintypeno,basinno);
     else sprintf(textb[0],"eqiv basins=%d ",basinno);
     outtext(textb[0]);
     if (basinfield){
	if ((progbar-thisbar)/basinno!=basinsize){
	   sprintf(textb[0],"ERROR count=%lu",progbar-thisbar);
	   myouttext(textb[0]);
	}
     }
     myouttext("att(hex)=");
     print_current_bitstring_hexbytes(0,att[1],0,Maxx,white,0);
     moveto(xbox,gety+CHeight);
     sprintf(textb[0],
	  " period=%lu size=%lu %.3g%% g=%lu gd=%.3g ml=%d mp=%lu",
	    attperiod,basinsize,
	      (double)(basinsize*basinno*100)/pow(2,(double)lineL),
		     basingofE,basingofEdensity,maxbasinlevel,maxbasinfan);
     myouttext(textb[0]);
     if (!basinfield || successive_basins){
#       if (__BORC__||__WATCOM__)
           endtime = clock();  
#       elif (__UNIX__)   
           gettimeofday(&tp,&tzp);
           endtime=(unsigned long)tp.tv_sec; /*xwindows*/
           endtime_m=(unsigned long)tp.tv_usec;
#       endif   
#       if (__BORC__||__WATCOM__)    
	   elapsedtime=(unsigned long)(endtime-starttime);
	   timesec=(float)elapsedtime/(unsigned long)CLK_TCK;
	   if (timesec>59){
	      timemin=(signed short)(timesec/60);
	      timesec-=timemin*60;
	      sprintf(textb[2]," %dmin %.3fsec",timemin,timesec);
	   }
	   else sprintf(textb[2]," %.3fsec",timesec);
	   outtext(textb[2]);
     
#       elif (__UNIX__)   
           elapsedtime=endtime-starttime;
           elapsedtime_m=endtime_m-starttime_m;     
           if (elapsedtime_m<0){ 
              elapsedtime-=1;
              elapsedtime_m=(1000000-starttime_m)+endtime_m;
           }
           timesec=(float)
               ((elapsedtime%60)+((float)elapsedtime_m/1000000));
           if (elapsedtime>=60){
              timemin=elapsedtime/60;
              sprintf(textb[2],"  %dmin %.3fsec",timemin,timesec);
           }
           else sprintf(textb[2],"  %.3fsec",timesec);     
           outtext(textb[2]);
#       endif
     }

     thisbar=progbar;

     if (basinfield && !successive_basins){
	xbox=memory_box(0);
	moveto(xbox+vgax(3),vgay(3));
	myouttext("options-o layout-a:");
	input_string(1,0);
	if (is[0]=='a') amend_layout();
	if (is[0]=='o') finish_options(1);
     }

     else if (!basinfield && rangeL && datapause){
	if (lineL!=endL){
	    xbox=memory_box(0);
	    moveto(xbox+vgax(3),vgay(3));
	    myouttext("options-o layout-a:");
	    input_string(1,0);
	    if (is[0]=='a') amend_layout();
	    if (is[0]=='o') finish_options(1);
	}
	else finish_options(1);
     }
  }

  /*print and/or file basin data*/
  if (pdata || filedata){
     if (earlyexitseg || earlyexittree){
	sprintf(textb[2],"EARLY EXIT! ");
	earlyexitbasin=1;
     }
     else sprintf(textb[2],"%s","");
     if (basinfield) sprintf(textb[0],"%d. %s",basintypeno,textb[2]);
     else sprintf(textb[0],"single basin. %s",textb[2]);
     if (pdata) print_out(textb[0]);
     if (filedata) save_data(textb[0]);
     print_current_bitstring_hexbytes (0,att[1],0,Maxx,white,3);
     sprintf(textb[0]," %d (%lu) %lu %.3g%% %lu %.3g %d %lu\n",
       basinno,attperiod,basinsize,
	 (double)(basinsize*basinno*100)/pow(2,(double)lineL),
		     basingofE,basingofEdensity,maxbasinlevel,maxbasinfan);
     if (pdata){
	print_out(textb[0]);
	if (!basinfield) print_out("\n");
     }
     if (filedata){
	save_data(textb[0]);
	if (!basinfield) save_data("\n");
     }
  }
  /*data for display when field is complete*/
  if (basinfield){
     totbasinsinfield+=basinno;
     fieldsize+=basinno*basinsize;
     fieldgofE+=basinno*basingofE;
     if (fieldsize>0) fieldgofEdensity=(float)fieldgofE/fieldsize;
  }
  free_basin_memory();
  if (basinfield==0 && rangeL==0 && !rulemix)
                                 show_rule_bottom(nhood,0,carule[0],0);
  /*to show average stack histogram*/
  if (!basinfield && see_ppstack && (nonlocal || nhood_mixed))
                                         show_average_pp_hist();

}

/********* free basin memory, Aug 93 ************/
void free_basin_memory(void){
 signed short z;
 unsigned short zu;
	if (!basinfield){
	   if (exhaustive_testing){
	      free(exh_pairs);
	      free(tickoff);
	   }
	   else if (nonlocal || nhood_mixed) free_pre_rand();
	}
	if ((nonlocal==0 || compress_1d_local==1 || regular2d)
	      && !dontcompress && !rulemix && exhaustive_testing!=2){
		/*free fanseg memory*/
		if (regular2d){
		   free(seg_2d_h);
		   free(seg_2d_v);
		}
		else free(seg);
		for (zu=0;zu<=segno;zu++)free (segseed[zu]);
		free(segseed);
	}
	/*free attractor memory*/
	for (z=1;z<=attperiod;z++) free(att[z]);
	free(att);
	free(cyclex);
	free(cycley);
	memory_box(1);
}


