/****** select wiring options and wire up random Boolean network ******/
/************************** Oct 93 *******************************/
#include "edecfunc.h"
#if __UNIX__
#   include <fcntl.h>
#endif
/**********************select wiring options, Oct 93 **************/
void select_wiring_options (void){

  signed short xbox;
  unsigned short zone2d;
  char acceptallw;     /*=1, accept all wiring defaults*/
/*
char    defaultwiring,  0-no defaults, 1-regular 1-d
	acceptallw,  	1 accept wiring defaults
	twod,       	2-D  CA
	whatwire,   	type of wiring..
			hand wire=3
			regu lar 2-D=2
			regular 1-D=1
			random=0
	nonlocal,   	regular 1d CA with homogenious  nhood, nonlocal=0
			else nonlocal=1 (including regular 2d)
	fixmidwire, 	cell wired to itself =1
			not  "      "        =2
			no restriction       =0
	distinct;   	no duplicate wiring
	loc_twod_fonly  1-local 2d forward space-time patterns only, else-0
	zonesize;   size of wiring zone, if no restriction = lineL

*/

   selectw1:
    acceptallw=0;
    regular2d=0;
    defaultwiring=0;
    loc_twod_fonly=0;
    nonlocal=0;
    compress_1d_local=0;

    sprintf(textb[0],"WIRING: neural net-n special-s, load-l, random-r,");
    sprintf(textb[1],"regular 2d-2, regular 1d-default:");
    xbox=draw_prompt_box(2);
    outtext(textb[0]);
    moveto(xbox,gety+CHeight);
    myouttext(textb[1]);
    input_string(1,0);
    erase_prompt_box(2);

    if (is[0]=='q') return;

    if (is[0]=='l'){
       /*load wiring*/
       whatwire=4;
       nonlocal=1;
       compress_1d_local=0;
       return;
    }
    if (is[0]=='2'){
	defaultwiring=2;
	if (nhood!=7) regular2d=1;
	acceptallw=1;

	if (!basinfield){
	   sprintf(textb[0],"forwards only (uses less memory, slower)-y:");
	   draw_prompt_box(1);
	   myouttext(textb[0]);
	   input_string(1,0);
	   erase_prompt_box(1);
	   if (is[0]=='q') goto selectw1;
	   if (is[0]=='y') loc_twod_fonly=1;
	}
    }
    else if (is[0]=='r') acceptallw=1;
    else if (is[0]=='s'); /*do nout*/
    else {
	defaultwiring=1;
	acceptallw=1;
    }

   selectw2:
    twod=0;
    if (acceptallw==0){
	sprintf(textb[0],"for 2d-2:");
	draw_prompt_box(1);
	myouttext(textb[0]);
	input_string(1,0);
	erase_prompt_box(1);

	if (is[0]=='q') goto selectw1;
	else if (is[0]=='2') twod=2;
    }

   selectw3:
    if (defaultwiring==1) whatwire=1;
    else if (defaultwiring==2){
	whatwire=2;
	nonlocal=1;
	compress_1d_local=0;
	twod=2;
    }
    else {
	whatwire=0;
	nonlocal=1;
	compress_1d_local=0;
    }
    if (acceptallw==0){
	sprintf(textb[0],"hand wire-3,");
	if (twod==2) sprintf(textb[1],"regular 2d-2, ");
	sprintf(textb[2],"regular 1d-1, default random:");
	xbox=draw_prompt_box(2);
	outtext(textb[0]);
	moveto(xbox,gety+CHeight);
	if (twod==2) myouttext(textb[1]);
	myouttext(textb[2]);
	input_string(1,0);
	erase_prompt_box(2);

	if (is[0]=='q') goto selectw2;
	if (is[0]=='3') whatwire=3; /*hand wire*/
	if (twod==2 && is[0]=='2'){
	   whatwire=2; /*2-D local wiring*/
	   if (nhood!=7) regular2d=1;
	   if (!basinfield){
	      sprintf(textb[0],
		"forwards only (uses less memory, slower) enter-y:");
	      draw_prompt_box(1);
	      myouttext(textb[0]);
	      input_string(1,0);
	      erase_prompt_box(1);
	      if (is[0]=='q') goto selectw3;
	      else if (is[0]=='y') loc_twod_fonly=1;
	   }
	}
	if (is[0]=='1'){
		whatwire=1; /*1-D local wiring*/
		nonlocal=0;
	}
    }
    if (twod){
      start_twod:
       sprintf(textb[0],"2d, enter width (default 36):");
       xbox=draw_prompt_box(2);
       myouttext(textb[0]);
       input_string(3,0);
       if (is[0]=='q') goto selectw1;
       if (is[0]!=13 || is[0]==0) i2d=atoi(is);
       else i2d=36;
       sprintf(textb[0]," height (default %d):",i2d);
       myouttext(textb[0]);
       input_string(3,0);
       if (is[0]=='q') goto selectw3;
       if (is[0]!=13 || is[0]==0) j2d=atoi(is);
       else j2d=i2d;
       if (i2d*j2d>limit2d*limit2d){ /*borland 100^2, watcom 255^2*/
	  sprintf(textb[0],"%dx%d too big! max sixe=%dx%d cont-ret:",
				    limit2d,limit2d,i2d,j2d);
	  moveto(xbox,gety+CHeight);
	  myouttext(textb[0]);
	  input_string(1,0);
	  goto start_twod;
       }
       if (scale*i2d>Maxx/2) scale=(Maxx/2)/i2d;
       sprintf(textb[0],"run 2d space-time pattern in 3d enter y:");
       moveto(xbox,gety+CHeight);
       myouttext(textb[0]);
       input_string(1,0);
       if (is[0]=='q') goto selectw3;
       if (is[0]=='y') twod=3;

       free_mem_CA_states();
       free(nhoodm);
       free_mem_rule0();
       free_mem_tcode0();
       free_mem_all_0s_all_1s_rules();

       lineL=i2d*j2d;
       L=lineL-1;
       bytesL=(signed short)ceil((double)lineL/8);
       allocate_mem_CA_states();
       erase_prompt_box(2);
       select_nhood_size(1);

       allocate_mem_rule0(nhood);
       allocate_mem_tcode0(nhood);
       allocate_mem_all_0s_all_1s_rules(nhood);

       if (is[0]=='q') goto selectw3;

       if (lineL>31 && basinfield==1){
	  sprintf(textb[0],"size too big for basin field (max 31),");
	  sprintf(textb[1],
		 "changed to single basin or space-time patterns only");
	  sprintf(textb[2],"continue-ret:");
	  basinfield=0;
	  xbox=draw_prompt_box(3);
	  outtext(textb[0]);
	  moveto(xbox,gety+CHeight);
	  outtext(textb[1]);
	  moveto(xbox,gety+CHeight);
	  outtext(textb[2]);
	  input_string(1,0);
	  erase_prompt_box(3);
       }
    }
    if (!twod) zonesize=lineL;
    else {
	 if (i2d>=j2d) zone2d=j2d;
	 else zone2d=i2d;
	 zonesize=zone2d;
    }
    fixmidwire=0;
    if (acceptallw==0 && whatwire==0){
       xbox=draw_prompt_box(3);
      selectw4:
       sprintf(textb[0],
	     "confine to local periodic zone, enter zone size:");
       myouttext(textb[0]);
       sprintf(textb[0],"%d",lineL);
       input_string(strlen(textb[0]),0);

       if (is[0]=='q'){
	  erase_prompt_box(3);
	  goto selectw3;
       }
       else if (is[0]!=13) zonesize=atoi(is);
       if (!twod){
	  if (zonesize<1 || zonesize>lineL) zonesize=lineL;
       }
       else{
	  if (zonesize<1 || zonesize>zone2d) zonesize=zone2d;
       }
      selectw5:
       sprintf(textb[0],"exclude all selfwiring-2, selfwire centre wire-1:");
       moveto(xbox,gety+CHeight);
       myouttext(textb[0]);
       input_string(1,0);

       if (is[0]=='q'){
	  moveto(xbox,gety-CHeight);
	  goto selectw4;
       }
       if (is[0]=='1') fixmidwire=1;
       if (is[0]=='2') fixmidwire=2;

       distinct=0;
       if ((rangeL && (unsigned short)nhood<=startL) ||
	     (rangeL==0 && (unsigned short)nhood<=lineL)){
	  sprintf(textb[0],"distinct wiring (no duplication)-d:");
	  moveto(xbox,gety+CHeight);
	  myouttext(textb[0]);
	  input_string(1,0);
	  if (is[0]=='q'){
	     moveto(xbox,gety-2*CHeight);
	     goto selectw5;
	  }
	  if (is[0]=='d' && zonesize>=
			(unsigned short)nhood) distinct=1;
       }
       erase_prompt_box(3);
    }
}

/*********** wire up random Boolean network, Oct 93 *******************/
void wire_up_network(void){
 unsigned short poss,tempposs,   /*cell position L..0*/
		possreached,startindex;
 signed short
     wire,
     z,xbox,
     startx,starty,startx1,gridw,bottombox,leftbox;
 char input_with_arrow,gonewgrid,another=0,indexjump=0;

   /*
	position of cell___          __nhood index, nhood..0
		   L..0    \        /
			    \      /
		     wiring[poss][wire] = wiring position, signed short value L to 0

   */
   leftbox=Maxx/2;
   if (lineL<99){
      bottombox=vgay(40)+(lineL+6)*CHeight;
      if (bottombox>Maxy-vgay(33)) bottombox=Maxy-vgay(33);
   }
   else bottombox=Maxy-vgay(33);
   startx=vgax(435);
   if (lineL-1>999 && nhood==9) startx=vgax(410);
   if (lineL-1>9999 && nhood==8) startx=vgax(390);
   if (lineL-1>9999 && nhood==9){
      startx=vgax(365);
      leftbox=Maxx/2-vgax(20);
   }
  startwiring:
   for (poss=lineL-1;poss!=Maxu;poss--) celloutfreq[poss]=0;

   /* * * * * * * * * * * * * * * * * * * * * * * * * * * */
   /*load wiring*/
   if (whatwire==4) load_save_wrs('l',carule[0],1);/*dummy rule*/
   /* * * * * * * * * * * * * * * * * * * * * * * * * * * */
   /*random wiring*/
   if (whatwire==0){
      for (poss=lineL-1;poss!=Maxu;poss--)
			   randomly_wire_cell(poss,lineL-1);
   }
   /* * * * * * * * * * * * * * * * * * * * * * * * * * * */
   /*hand wire or revise existing wiring*/
   if (whatwire==3){
     startjump:
      sprintf(textb[0],"hand wire/revise: jump-j");
      sprintf(textb[1],
       "enter wiring positions 0-%d (return on blank/0=random)",lineL-1);
      sprintf(textb[2],
	      "move-arrows, more/complete-m, quit-q");
      xbox=draw_prompt_box(3);
      outtext(textb[0]);
      for (z=1;z<=2;z++){
	 moveto(xbox,gety+CHeight);
	 outtext(textb[z]);
      }
      if (!indexjump) startindex=lineL-1;
      indexjump=0;
      sprintf(textb[0],"%d",lineL);
      gridw=textwidth(textb[0])+vgax(3);
     startnewpart:
      possreached=print_wiring_scheme(0,1,startindex);
      moveto(startx,vgay(50));
      startx1=startx;
      starty=gety;
      starty+=(CHeight*3)/2;

      for (poss=startindex;
		    poss>=possreached && poss!=Maxu;poss--){
	 startx1=startx;
	 moveto(startx1,starty);
	 for (wire=nhood-1;wire>=0;wire--){
	   
	   if (wire>nhoodm[poss]-1){
	      startx1+=gridw;
	      moveto(startx1,starty);
	      continue;
	   }
	   newgrid:
	    setcolor(lightred);
	    moveto(startx1,starty);
	    rectangle(startx1-2,starty+1,startx1+gridw-2,
					    starty+CHeight+1);
	    if (wiring[poss][wire]!=Maxu){
	       setcolor(white);
	       sprintf(textb[0],"%d",wiring[poss][wire]);
	       outtext(textb[0]);
	       moveto(startx1,starty);
	    }
	    setcolor(yellow);
	    /*to allow arrows to end input as well as return*/
	    is[20]=input_with_arrow=gonewgrid=0;

	    sprintf(textb[0],"%d",lineL-1);
	    input_string(strlen(textb[0]),-1);

	    if (is[0]=='m') goto endwhatwire3;
	    if (is[0]=='q'){
	       possreached=0;
	       goto endwhatwire3;
	    }
	    if (is[0]=='j'){ /*jump to new cell poss*/
		  /*allocate unallocated wires to cell 0*/
		  for (poss=startindex;
			 poss>=possreached && poss!=Maxu;poss--){
		     for (wire=nhoodm[poss]-1;wire>=0;wire--){
			if (wiring[poss][wire]==Maxu)
			      wiring[poss][wire]=0;
		     }
		  }
		  sprintf(textb[0],"jump to index (%d-0):",lineL-1);
		  erase_prompt_box(3);
		  draw_prompt_box(1);
		  myouttext(textb[0]);
		  sprintf(textb[0],"%d",lineL-1);
		  input_string(strlen(textb[0]),1);


		  if (atoi(is)>=0 && atoi(is)<=lineL-1) poss=atoi(is);
		  else poss=startindex;
		  setfillstyle(SOLID_FILL,black);
		  bar(leftbox,vgay(40),Maxx-2,bottombox);
		  startindex=poss;
		  indexjump=1;
		  goto startjump;
	    }
	    setcolor(lightcyan);
	    rectangle(startx1-2,starty+1,startx1+gridw-2,
					    starty+CHeight+1);
	    tempposs=atoi(is);
	    /*arrows*/
	    if (is[20]==LeftArrow||is[20]==RightArrow||
		  is[20]==UpArrow||is[20]==DownArrow) input_with_arrow=1;
	    if (is[0]==LeftArrow||is[0]==RightArrow||
			  is[0]==UpArrow||is[0]==DownArrow) goto skip1;

	    if (is[0]!=13 || input_with_arrow==1){
	       if (tempposs!=Maxu && tempposs<=lineL-1)
				      wiring[poss][wire]=tempposs;
	    }
	    else if (input_with_arrow==0){
	       if (wiring[poss][wire]==Maxu || wiring[poss][wire]==0)
					 wiring[poss][wire]=myrand()%lineL;
	    }
	    setfillstyle(SOLID_FILL,black);
	    bar(startx1-1,starty+2,startx1+gridw-3,
					    starty+CHeight);
	    if (wiring[poss][wire]!=Maxu)
		    sprintf(textb[0],"%d",wiring[poss][wire]);
	    setcolor(yellow);
	    moveto(startx1,starty);
	    if (wiring[poss][wire]!=Maxu)
				   outtext(textb[0]);

	    if (input_with_arrow==1) is[0]=is[20];

	   skip1:
	    switch(is[0]){
	       /*arrows:128+  75=left,77=right,72=up,80=down */
	       case LeftArrow: /*left*/
		  wire+=1;
		  if (wire<=nhoodm[poss]-1){
		     startx1-=gridw;
		     moveto(startx1,starty);
		     gonewgrid=1;
		  }
		  else{
		     wire-=1;
		     poss+=1;
		     if (poss<=lineL-1 && wire<=nhoodm[poss]-1){
			starty-=(CHeight);
			moveto(startx1,starty);
			gonewgrid=1;
		     }
		     else poss-=1;
		  }
		  break;
	       case RightArrow: /*right*/
		  wire-=1;
		  if (wire>=0){
		     startx1+=gridw;
		     moveto(startx1,starty);
		     gonewgrid=1;
		  }
		  else wire+=1;
		  break;
	       case UpArrow: /*up*/
		  poss+=1;
		  if (poss<=startindex && wire<=nhoodm[poss]-1){
		     starty-=(CHeight);
		     moveto(startx1,starty);
		     gonewgrid=1;
		  }
		  else poss-=1;
		  break;
	       case DownArrow: /*down*/
		  poss-=1;
		  if (poss>=possreached && poss!=Maxu
				     && wire<=nhoodm[poss]-1){
		     starty+=(CHeight);
		     moveto(startx1,starty);
		     gonewgrid=1;
		  }
		  else poss+=1;
		  break;
	    }
	    if (gonewgrid==1) goto newgrid;
	    startx1+=gridw;

	 }
	 starty+=(CHeight);
      }
      /******/

      endwhatwire3:
      if (possreached>0){
	 /*allocate unallocated wires to cell 0*/
	 for (poss=startindex;poss>=possreached;poss--){
	    for (wire=nhoodm[poss]-1;wire>=0;wire--){
	       if (wiring[poss][wire]==Maxu)
			      wiring[poss][wire]=0;
	    }
	 }
	 startindex=possreached-1;
	 goto startnewpart;
      }
      else{
	 /*allocate unallocated wires to cell 0*/
	 for (poss=lineL-1;poss!=Maxu;poss--){
	    for (wire=nhoodm[poss]-1;wire>=0;wire--){
	       if (wiring[poss][wire]==Maxu)
			      wiring[poss][wire]=0;
	    }
	 }
      }
      cell_out_freq();

      setfillstyle(SOLID_FILL,black);
      bar(leftbox,vgay(40),Maxx-2,bottombox);
      erase_prompt_box(3);
      setcolor(white);
   }

   /* * * * * * * * * * * * * * * * * * * * * * * * * * * */
   if (whatwire==1){    /*1-D local wiring*/
	compress_1d_local=0;
	if (nhood_mixed) nonlocal=1;
	else if (defaultwiring==0){
	   sprintf(textb[0],
	     "treat regular 1d as random wiring-1, and compress-2:");
	   draw_prompt_box(1);
	   myouttext(textb[0]);
	   input_string(1,0);
	   erase_prompt_box(1);
	   if (is[0]=='q') return;
	   if (is[0]=='1' || is[0]=='2') nonlocal=1;
	   if (is[0]=='2') compress_1d_local=1;
	}
	for (poss=lineL-1;poss!=Maxu;poss--)
		    oneD_local_wire_cell(poss,lineL-1);
   }
   /* * * * * * * * * * * * * * * * * * * * * * * * * * * */
   if (whatwire==2) wireup_2d_nhood(i2d,j2d,i2d-1,j2d-1,0,0);
   /* * * * * * * * * * * * * * * * * * * * * * * * * * * */
   cell_out_freq();
   if ((defaultwiring==1 || defaultwiring==2) && !nhood_mixed) return;
  startshowing:
   if (another==0){
      if (twod) sprintf(textb[0],
	  "wiring graphic: 1d-1 2d-2, wiring matrix: view/print-v:");
      else sprintf(textb[0],
	  "wiring graphic-1, wiring matrix: view/print-v:");
      xbox=draw_prompt_box(1);
      myouttext(textb[0]);
      input_string(1,0);
      erase_prompt_box(1);
      if (is[0]=='q'){
	 for (poss=lineL-1;poss!=Maxu;poss--) celloutfreq[poss]=0;
	 setfillstyle(SOLID_FILL,black);
	 bar(leftbox,vgay(40),Maxx-1,bottombox);
	 return;
      }
      if (is[0]=='v') print_wiring_scheme(1,0,0);
      if (is[0]=='1') show_graphic_wiring_1d(0);
      if (is[0]=='2' && twod) show_graphic_wiring_2d(0);
   }
   else if (another==1) print_wiring_scheme(1,0,0);
   sprintf(textb[0],"view/print-v, randomly rewire-r");
   sprintf(textb[1],"revise by hand-h, reset wiring options-q, cont-ret:");
   xbox=draw_prompt_box(2);
   myouttext(textb[0]);
   moveto(xbox,gety+CHeight);
   myouttext(textb[1]);
   another=0;
   input_string(1,0);
   switch(is[0]){
      case 'v': erase_prompt_box(2);
		goto startshowing;
      case 'r': whatwire=0;
		nonlocal=1;
		compress_1d_local=0;
		erase_prompt_box(2);
		another=1;
		goto startwiring;
      case 'h': whatwire=3;
		nonlocal=1;
		compress_1d_local=0;
		erase_prompt_box(2);
		goto startwiring;
   }
   setfillstyle(SOLID_FILL,black);
   bar(leftbox,vgay(40),Maxx-1,bottombox);
   erase_prompt_box(2);
}

/************************ re-calculate cell output frequency *************/
void cell_out_freq(void){
 unsigned short poss;
 signed short wire;

   for (poss=lineL-1;poss!=Maxu;poss--) celloutfreq[poss]=0;
   for (poss=lineL-1;poss!=Maxu;poss--){
      for (wire=nhoodm[poss]-1;wire>=0;wire--)
	 if (wiring[poss][wire]!=Maxu)
		       celloutfreq[wiring[poss][wire]]+=1;
   }
}

/************ 1-D localy wire given cell, incl restrictions Nov 93 *********/
void oneD_local_wire_cell(unsigned short poss,unsigned short maxL){
 signed short wire,temp;

    if (maxL<nhoodm[poss]/2){ /*i.e. for nhood=9 lineL=3 to work*/
      for (wire=nhoodm[poss]-1;wire>=0;wire--){
	 temp=maxL+1+poss-(nhoodm[poss]/2)+wire;
	 if (temp<0) temp+=maxL+1;
	 wiring[poss][wire]=abs(temp)%(maxL+1);
      }
    }
    else{
       for (wire=nhoodm[poss]-1;wire>=0;wire--)
	  wiring[poss][wire]=
		   (maxL+1+poss-(nhoodm[poss]/2)+wire)%(maxL+1);
    }
}

/************ randomly wire given cell, inc restrictions Oct 93 ************/
void randomly_wire_cell(unsigned short poss,unsigned short maxL){
 long zonewiring, /*size of periodic zone within which wiring may occur*/
      thisposs;
 char fixed,z;
 signed short i,j,ii,jj,wire;
 unsigned short thiszonesize;

   thisposs=poss;
   for (wire=nhoodm[poss]-1;wire>=0;wire--){
     rewire1:
      /*confine random wiring to local periodic zone*/
      if (!twod) zonewiring= (myrand()%zonesize)+thisposs-zonesize/2;
      else{
	 i=thisposs%i2d;  /*co-ords of cell*/
	 j=thisposs/i2d;
	 ii=(myrand()%zonesize)+i-zonesize/2;
	 jj=(myrand()%zonesize)+j-zonesize/2;
	 zonewiring=i2d*jj+ii;
      }
      fixed=0;
      /*force cell to wire centre of pseudo nhood to itself*/
      if (fixmidwire==1){
	 if (wire==nhoodm[poss]/2){
	    wiring[thisposs][wire]=thisposs;
	    fixed=1;
	 }
	 if (wire!=nhoodm[poss]/2 && zonewiring==thisposs
			 && distinct==1) goto rewire1;
      }
      /*exclude cell wiring to itself*/
      if (fixmidwire==2){
	 if (zonewiring==thisposs) goto rewire1;
      }
      if (fixed==0){
	 if (zonewiring<0) zonewiring= maxL+1-abs(zonewiring);
	 if (zonewiring>maxL)  zonewiring= zonewiring-maxL-1;
	 wiring[thisposs][wire]=zonewiring;
      }
      if (distinct==1){
	 if (fixmidwire==2) thiszonesize=zonesize-1;
	    if (thiszonesize>=(unsigned short)nhood){
	    for (z=nhood-1;z>wire;z--){
	       if (wiring[thisposs][wire]==wiring[poss][z]) goto rewire1;
	    }
	 }
      }
   }
}

/***************** print wiring scheme, Oct 93 *************************/
unsigned short print_wiring_scheme(char showout,char parts,
				    unsigned short startindex){
 signed short startx,starty,startx1,bottombox,leftbox,gridw,
     wire,barlength;
 unsigned short poss;

   sprintf(textb[0],"%d",lineL);
   gridw=textwidth(textb[0])+vgax(3);

   if (lineL<99){
      bottombox=vgay(40)+(lineL+6)*CHeight;
      if (bottombox>Maxy-vgay(33)) bottombox=Maxy-vgay(33);
   }
   else bottombox=Maxy-vgay(33);
   leftbox=Maxx/2;
   cell_out_freq();
   startx=vgax(435);
   if (lineL-1>999 && nhood==9) startx=vgax(410);
   if (lineL-1>9999 && nhood==8) startx=vgax(390);
   if (lineL-1>9999 && nhood==9){
      startx=vgax(365);
      leftbox=Maxx/2-vgax(20);
   }
   setfillstyle(SOLID_FILL,black);
   bar(leftbox,vgay(40),Maxx-2,bottombox);
   setcolor(lightred);
   rectangle(leftbox,vgay(40),Maxx-2,bottombox);
   moveto(startx,vgay(50));
   startx1=startx;
   starty=gety;

   /*show nhood index*/
   setcolor(lightred);
   for (wire=nhood-1;wire>=0;wire--){
      sprintf(textb[0],"%d.",wire);
      moveto(startx1,starty);
      outtext(textb[0]);
      startx1+=gridw;
   }
   starty+=(CHeight*3)/2;
   moveto(startx1,starty);
   if (startindex==0) startindex=L;
   for (poss=startindex;poss!=Maxu;poss--){
      startx1=startx;
      if (showout){
	 /*histigram of cell output wire frequency*/
	 moveto(startx1-vgax(55),starty);
	 setfillstyle(SOLID_FILL,green);
	 barlength=celloutfreq[poss];
	 if (barlength>getx-leftbox) barlength=getx-leftbox;
	 bar(getx,gety+4,getx-barlength,gety+CHeight-1);
	 moveto(startx1-vgax(50),starty);
	 setcolor(green);
	 sprintf(textb[0],"%d",celloutfreq[poss]);
	 outtext(textb[0]);
      }
      setcolor(lightred);
      sprintf(textb[0],"%d..",poss);
      moveto(startx1-textwidth(textb[0]),starty);

      outtext(textb[0]);
      setcolor(white);
      startx1=startx;
      moveto(startx1,starty);
      for (wire=nhood-1;wire>=0;wire--){
	 if (wire>nhoodm[poss]-1){
	    startx1+=gridw;
	    moveto(startx1,starty);
	    continue;
	 }
	 if (wiring[poss][wire]==Maxu){
	    setcolor(lightcyan);
	    rectangle(startx1-2,starty+1,startx1+gridw-2,
					    starty+CHeight+1);
	    setcolor(white);
	 }
	 else{
	    sprintf(textb[0],"%d",wiring[poss][wire]);
	    outtext(textb[0]);
	 }

	 startx1+=gridw;
	 moveto(startx1,starty);
      }
      starty+=CHeight;
      if (starty>bottombox-CHeight*3 || poss==0){
	 if (parts) return(poss);
	 else{
	   startagain:
	    if (poss==0) sprintf(textb[0],
	       "print-p, quit-q, jump to index (%d-0):",lineL-1);

	    else sprintf(textb[0],
	       "MORE-ret, print-p, quit-q, jump to index (%d-0):"
	                                                        ,lineL-1);
	    draw_prompt_box(1);
	    myouttext(textb[0]);
	    sprintf(textb[0],"%d",lineL-1);
	    input_string(strlen(textb[0]),1);

	    if (is[0]=='q' || (is[0]==13 && poss==0)) return(0);
	    if (is[0]==13);
	    else if (is[0]=='p'){
#               if __BORC__||__WATCOM__		
                   printimage('P',0,0,leftbox,vgay(40),Maxx,bottombox);
#               elif __UNIX__
                   printimage();
#               endif
		goto startagain;
	    }
	    else if (atoi(is)>=0 && atoi(is)<=lineL-1) poss=atoi(is)+1;
	    setfillstyle(SOLID_FILL,black);
	    bar(leftbox,vgay(52)+CHeight,Maxx-2,bottombox);
	    setcolor(lightred);
	    rectangle(leftbox,vgay(40),Maxx-2,bottombox);
	    starty=vgay(50)+(CHeight*3)/2;;
	 }
      }
   }
   return(0);
}

/***************** print wiring scheme, Oct 93 *************************/
void print_wiring_cell(signed short startx,
		   signed short starty, unsigned short poss){
 signed short startx1,wire,tempposs;
 char gonewgrid,input_with_arrow;

   moveto(startx,starty);
   startx1=startx;
   /*show nhood index*/
   setcolor(lightred);
   for (wire=nhoodm[poss]-1;wire>=0;wire--){
      sprintf(textb[0],"%d___",wire);
      moveto(startx1,starty);
      outtext(textb[0]);
      startx1+=vgax(22);
   }
   starty+=(CHeight*3)/2;
   moveto(startx1,starty);
   startx1=startx;
   setcolor(white);
   moveto(startx1,starty);
   for (wire=nhoodm[poss]-1;wire>=0;wire--){
      sprintf(textb[0],"%d",wiring[poss][wire]);
      outtext(textb[0]);
      startx1+=vgax(22);
      moveto(startx1,starty);
   }
   startx1=startx;
   moveto(startx1,starty);
   wire=nhoodm[poss]-1;
   for (wire=nhoodm[poss]-1;wire>=0;wire--){
     newgrid:
      setcolor(lightred);
      moveto(startx1,starty);
      rectangle(startx1-1,starty+1,startx1+CWidth*3,
					    starty+CHeight+1);
      setcolor(white);
      sprintf(textb[0],"%d",wiring[poss][wire]);
      outtext(textb[0]);
      moveto(startx1,starty);
      setcolor(yellow);
      /*to allow arrows to end input as well as return*/
      is[20]=input_with_arrow=gonewgrid=0;
      sprintf(textb[0],"%d",lineL-1);
      input_string(strlen(textb[0]),-1);

      if (is[0]=='q') break;
      setcolor(lightcyan);
      rectangle(startx1-1,starty+1,startx1+CWidth*3,
					    starty+CHeight+1);
      tempposs=atoi(is);
      /*arrows*/
      if (is[20]==LeftArrow||is[20]==RightArrow) input_with_arrow=1;
      if (is[0]==LeftArrow||is[0]==RightArrow) goto skip1;
      if (is[0]==13){
	 is[0]=RightArrow;
	 goto skip1;
      }
      if (is[0]!=13 || input_with_arrow==1){
	 if (tempposs>=0 && tempposs<=lineL-1) wiring[poss][wire]=tempposs;
      }
      setfillstyle(SOLID_FILL,black);
      bar(startx1,starty+2,startx1+CWidth*3-1,
					    starty+CHeight);
      sprintf(textb[0],"%d",wiring[poss][wire]);
      setcolor(yellow);
      moveto(startx1,starty);
      outtext(textb[0]);
      if (input_with_arrow==1) is[0]=is[20];
      else is[0]=RightArrow;
     skip1:
      switch(is[0]){
	 case'q': break;
	 /*arrows:128+  75=left,77=right*/
	 case LeftArrow:
	    wire+=1;
	    if (wire<=nhoodm[poss]-1){
	       startx1-=vgax(22);
	       moveto(startx1,starty);
	    }
	    else{
	       wire=0;
	       startx1+=vgax(22)*(nhoodm[poss]-1);
	       moveto(startx1,starty);
	    }
	    gonewgrid=1;
	    break;
	 case (RightArrow):
	    wire-=1;
	    if (wire>=0){
	       startx1+=vgax(22);
	       moveto(startx1,starty);
	    }
	    else{
	       wire=nhoodm[poss]-1;
	       startx1-=vgax(22)*(nhoodm[poss]-1);
	       moveto(startx1,starty);
	    }
	    gonewgrid=1;
	    break;
      }
      if (gonewgrid==1) goto newgrid;
   }
}

/***************** show wiring layout as 1-d graphic, Dec 93 *************************/
void show_graphic_wiring_1d(char showrules){
 unsigned short zu,poss,thisposs,minL,posswas,step;
 signed short z,zz,xbox,textbx,textby,
     tablebytes,codebytes,wiredtox,thiscellsep;
 float left,top,right,bottom,nhoodlevel,
       cellscale,cellsep,cellscale1,cellsep1,cellheight,
       rightcell,tempx,tempy,tempx1,tempy1,tempx2,tempy2,cellx,
       tlratio,tzparam,wtlratio,wtzparam,weight;
 char  drawcells=0,wiring_changed=0,wr_status,pl_scape,
       rev_wiring=0,nhood_temp,wire;
 unsigned long toutwires;
#if __BORC__||__WATCOM__ 
    void *tempimage;
    unsigned long imsize;/*imsize, not xwindows*/
#elif __UNIX__
    Pixmap *tempimage;
#endif 
 unsigned short oldzonesize;
 char oldfixmidwire,old_distinct;


	if      (nonlocal==0 && rulemix==0) wr_status=0;
	else if (nonlocal==0 && rulemix)    wr_status=1;
	else if (nonlocal && rulemix==0)    wr_status=2;
	else if (nonlocal && rulemix)	    wr_status=3;

	tablebytes=(signed short)ceil(pow(2,(double)nhood)/8);
	codebytes=(signed short)ceil((double)(nhood+1)/8);

	cellscale=7;
	cellsep=3;
	bottom=vgay(390);
	top=bottom-vgay(100);
	left=vgax(60);
	minL=lineL;
	if (minL<10) minL=10;
	right=left+cellscale*minL+vgax(200);
	if (right>Maxx-vgax(60)) right=Maxx-vgax(60);
	/*whole box*/
	draw_box(6,left-vgax(40),top-vgay(50),
			       right+vgax(40),bottom+vgay(40),1,0);
	/*memory_box(1);*/
	if (right>=left+cellscale*lineL){
		cellscale1=cellscale;
		cellsep1=cellsep;
		drawcells=1;
	}
	else{
		cellscale1=(right-left)/lineL;
		cellsep1=0;
		drawcells=2;
	}
	/*draw top and bottom cells*/
	for (zz=0;zz<=1;zz++){
	   moveto(left,top+zz*vgay(100));
	   setfillstyle(SOLID_FILL,lightgray);/*darkgray to print*/
	   for (zu=lineL-1;zu!=Maxu;zu--){
	      if (zz==0){
		 if (lineL>(right-left)/2)line(getx,gety,getx,
					       gety+cellscale-cellsep);
		 else bar3d(getx,gety,getx+cellscale1-cellsep1,
					    gety+cellscale-cellsep,0,1);
	      }
	      else{
		 if (nonlocal){
		    cellheight=celloutfreq[zu];
		    if (cellheight>vgay(25)) cellheight=25;
		 }
		 else cellheight=cellscale-cellsep;
		 if (lineL>(right-left)/2) line(getx,gety,getx,
						    gety+cellheight);
		 else bar3d(getx,gety,getx+cellscale1-cellsep1,
						gety+cellheight,0,1);
	      }
	      if (drawcells==1) moverel(cellscale,0);
	      else moveto(left+cellscale1*(lineL-zu),gety);
	   }
	}
	/*add labels to diagram*/
	if (drawcells==1) rightcell=getx;
	else rightcell=right;
	moveto(rightcell+vgax(7),top-cellscale/2);
	outtext("---");
	moverel(1,-CHeight/3.5);
	outtext("t0");
	moveto(rightcell+vgax(7),bottom-cellscale/2);
	outtext("---");
	moverel(1,CHeight/3.5);
	outtext("t1");
	moveto(left+cellscale1/2-textwidth("|")/2,
			   top-cellscale-CHeight);
	outtext("|");
	moverel(-textwidth("cell |"),-CHeight);
	sprintf(textb[0],"cell %d",L);
	outtext(textb[0]);
	moveto(rightcell-cellscale1/2-textwidth("|")/2,
			     top-cellscale-CHeight);
	outtext("|");
	moverel(-textwidth("cell |"),-CHeight);
	if (lineL>8) outtext("cell 0");
	else         outtext("     0");

	nhoodlevel=bottom-vgay(20);
	moveto(left+(cellscale1-cellsep1)/2,nhoodlevel);
	step=lineL/10; /*for up and down arrows*/
	if (lineL<20) step=2;
	tempx=getx;
	tempy=gety;

	get_prompt_box(3,4);
	sprintf(textb[0],
	  "show cell wiring/rule, move-arrows, jump-j");
	sprintf(textb[1],
	  "one cell: right/left arrows, %d cells: up/down arrows",step);

	if (wr_status<2) sprintf(textb[2],
	   "options-o, print box-p, revise/transform rule-r/t");
	else if (wr_status==2 || wr_status==3) sprintf(textb[2],
	"options-o, printbox-p, rev wiring-w, rev/transform rule-r/t");
	if ((wr_status==1 || wr_status==3)
	   && memcmp(rule_all_0s,carule[0],tablebytes)!=0)
	   sprintf(textb[3],"show avZ-z, learn/highlight-l, cont-ret:");
	else sprintf(textb[3],"learn/highlight-l, cont-ret:");
	xbox=draw_prompt_box(4);
	outtext(textb[0]);
	moveto(xbox,gety+CHeight);
	outtext(textb[1]);
	moveto(xbox,gety+CHeight);
	myouttext(textb[2]);
	moveto(xbox,gety+CHeight);
	myouttext(textb[3]);
	get_prompt_box(4,4);

	/*memory_box(1);*/
	textbx=getx;
	textby=gety;
	moveto(tempx,tempy); /*nhoodlevel*/
	poss=L;
	cellx=getx; /*left+(cellscale1-cellsep1)/2*/
	while(1){
	   if (nhood_mixed){
	      tablebytes=(signed short)ceil(pow(2,(double)nhoodm[poss])/8);
	      codebytes=(signed short)ceil((double)(nhoodm[poss]+1)/8);
	   }
	   if (showrules && rulemix){
	      z_parameter_all(nhoodm[poss],0,carule[poss]);
	      show_rule_bottom(nhoodm[poss],0,carule[poss],poss);
	   }
	   draw_box(-1,left-vgax(40),bottom+vgay(40)-vgay(15),
			       right+vgax(40),bottom+vgay(40),1,0);
	   if (!nhood_mixed) sprintf(textb[0]," cell=%d wiring=",poss);
	   else sprintf(textb[0]," cell=%d nhood=%d wiring=",
						      poss,nhoodm[poss]);
	   outtext(textb[0]);
#          if __BORC__
	      moverel(-CWidth,0);
#          endif
	   for (z=nhoodm[poss]-1;z>=0;z--){
	      sprintf(textb[0],"%d ",wiring[poss][z]);
	      outtext(textb[0]);
	   }
	   sprintf(textb[0],"outwires=%d ",celloutfreq[poss]);
	   outtext(textb[0]);
	   if (nhoodm[poss]<6 && rules_set){
	      if (rulemix) thisposs=poss;
	      else thisposs=0;

	      sprintf(textb[0],"%d-rule=(hex)",nhoodm[poss]);
	      outtext(textb[0]);
	      print_current_bitstring_hexbytes(1,carule[thisposs],
			   nhoodm[thisposs],Maxx,white,0);
	   }
	   erase_box(left-vgax(35),top+(cellscale-cellsep)+1,
					     right+vgax(35),bottom-1);
	   thiscellsep=0;
	   if ((signed short)cellsep>0)
		    thiscellsep=(signed short)cellsep-1;
	   if (nhoodm[poss]%2==1)
	      moveto(cellx+thiscellsep
                 -((cellscale)*nhoodm[poss])/2,nhoodlevel);
	   else
	      moveto(cellx+thiscellsep
                 -((cellscale)*(nhoodm[poss]-1))/2,nhoodlevel);
	   if (bground=='w') setfillstyle(SOLID_FILL,blue);
           if (bground=='b') setfillstyle(SOLID_FILL,yellow);

	   for (z=nhoodm[poss]-1;z>=0;z--){
	      /*draw pseudo-cells*/
	      bar3d(getx,gety,getx+cellscale-cellsep,
				gety+cellscale-cellsep,0,1);
	      tempx1=getx;
	      tempy1=gety;
	      /*line from bottom cell to pseudo-cell*/
	      line(cellx,bottom,getx+(cellscale-cellsep)/2,
					     nhoodlevel+cellscale-cellsep);
	      wiredtox=(signed short)cellx+
		 ((signed long)poss-(signed long)wiring[poss][z])*cellscale1;
	      /*line from pseudo-cell to top cell*/
	      line(getx+(cellscale-cellsep)/2,nhoodlevel,wiredtox,
						  top+(cellscale-cellsep));
	      moveto(tempx1,tempy1);
	      moverel(cellscale,0);
	   }
	   moveto(textbx,textby);
	   if (rev_wiring==1) is[0]='w';
	   else input_string(1,-1);
	   switch(is[0]){
	      case'o':
		 finish_options(0);
		 break;
	      case'p':
		 /*print wiring box*/
		 if (right+vgax(40)<vgax(300)) pl_scape='P';
		 else pl_scape='L';
#                   if __BORC__||__WATCOM__		
                       printimage(pl_scape,
		         lightgray,blue,left-vgax(40),top-vgay(50),
                            right+vgax(40)+1,bottom+vgay(40));
#                   elif __UNIX__
                       printimage();
#                   endif			      
		 continue;
	      case'r':
		 /*revise rule*/
		 if (rulemix) thisposs=poss;
		 else thisposs=0;
		 tempx2=getx;
		 tempy2=gety;
		 revise_rule_or_code(thisposs,tablebytes,codebytes);
		 if (!rulemix){
		    z_parameter_all(nhoodm[thisposs],0,carule[thisposs]);
		    show_rule_bottom(nhoodm[thisposs],
				       0,carule[thisposs],thisposs);
		 }
		 was_changed=1;
		 moveto(tempx2,tempy2);
		 putimage((signed short)((float)Maxx)/2,2,
				   boximage_prompt[4],COPY_PUT);
		 break;
	      case't':
		 /*transform_rule*/
		 if (rulemix) thisposs=poss;
		 else thisposs=0;
		 tempx2=getx;
		 tempy2=gety;
		 transform_rule(thisposs);
		 was_changed=1;
		 moveto(tempx2,tempy2);
		 putimage((signed short)((float)Maxx)/2,2,
				     boximage_prompt[4],COPY_PUT);
		 is[0]=0;
		 break;
	      case'z':
		 /*calculate av. and weighted av. ldz,Z*/
		 if ((wr_status==1 || wr_status==3) /*&& !nhood_mixed*/
		      && memcmp(rule_all_0s,carule[0],tablebytes)!=0){
		    tempx=getx;
		    tempy=gety;
		    if (lineL*nhood>100){
		       draw_box(-1,left-vgax(40),top-vgay(50),
			  right+vgax(40),
			     top-vgay(50)+2*CHeight+4,1,0);
		       moveto(left-vgax(37),top-vgay(49));
		       outtext("computing wt.av:lda  ...WAIT");
		    }
		    cell_out_freq();
		    toutwires=0;
		    if (nhood_mixed){
		       for (zu=lineL-1;zu!=Maxu;zu--) toutwires+=nhoodm[zu];
		    }
		    else toutwires+=lineL*nhood;
		    tlratio=tzparam=wtlratio=wtzparam=0;
		    for (zu=lineL-1;zu!=Maxu;zu--){
		       z_parameter_all(nhoodm[zu],0,carule[zu]);
		       tlratio+=lratio;
		       tzparam+=zparam[0];
		       weight=(float)celloutfreq[zu]/toutwires;
		       wtlratio+=lratio*weight;
		       wtzparam+=zparam[0]*weight;
		    }
		    tlratio=tlratio/lineL;
		    tzparam=tzparam/lineL;
		    if (tzparam>0){
		       draw_box(-1,left-vgax(40),top-vgay(50),
			  right+vgax(40),
			     top-vgay(50)+2*CHeight+4,1,0);
		       moveto(left-vgax(37),top-vgay(49));
		       sprintf(textb[0],"av:lda-r=%g Z=%g",tlratio,tzparam);
		       outtext(textb[0]);
		       moveto(left-vgax(37),gety+CHeight);
		       sprintf(textb[0],"wt.av:lda-r=%g Z=%g",wtlratio,wtzparam);
		       outtext(textb[0]);
		    }
		    moveto(tempx,tempy);
		 }
		 break;
	      case'w':
		 if (!nonlocal) break;
		 tempx2=getx;
		 tempy2=gety;
		 draw_box(5,vgax(330),vgay(343),Maxx-2,vgay(400),1,0);
		 rev_wiring=1;
		 /*memory_box(1);*/
		 moveto(vgax(340),vgay(345));
		 sprintf(textb[0],
		    "REWIRE cell=%d move-arrows jump-j cont-ret",poss);
		 if (nhood_mixed)
		    sprintf(textb[1],"change k=%d nhood-n",nhoodm[poss]);
		 sprintf(textb[2],
		    "hand-h random-r random-special-s reg-1d-1:");
		 outtext(textb[0]);
		 if (nhood_mixed){
		    moveto(vgax(340),gety+CHeight);
		    outtext(textb[1]);
		 }
		 moveto(vgax(340),gety+CHeight);
		 myouttext(textb[2]);
		 input_string(1,-1);
		 switch(is[0]){
		    case'n':
		       if (!nhood_mixed) break;
		       nhood_temp=nhoodm[poss];
		       moveto(vgax(340),gety+CHeight);
		       sprintf(textb[0],
			 "set nhood size (1-%d):",nhood);
		       myouttext(textb[0]);
		       input_string(1,0);
		       if (atoi(is)>=1 && atoi(is)<=nhood)
					       nhoodm[poss]=atoi(is);
		       /*wire extra pseudo-nhood cells localy*/
		       if (nhoodm[poss]>nhood_temp){
			  for (wire=nhoodm[poss]-1;wire>=nhood_temp;wire--)
			    wiring[poss][wire]=
			      (lineL+poss-(nhoodm[poss]/2)+wire)%(lineL-1+1);
		       }
		       break;
		    case'h':
		       draw_box(-1,vgax(330),vgay(343),
						Maxx-2,vgay(400),1,0);
		       moveto(vgax(340),vgay(345));
		       sprintf(textb[0],"hand rewire");
		       sprintf(textb[1],
			"use return or arrows to move");
		       sprintf(textb[2],
			"enter wiring positions 0-%d, q to complete",lineL-1);
		       outtext(textb[0]);
		       for (z=1;z<=2;z++){
			  moveto(vgax(340),gety+CHeight);
			  outtext(textb[z]);
		       }
		       moveto(vgax(340),gety+CHeight);
		       print_wiring_cell(getx,gety,poss);
		       break;
		    case'r':
		       randomly_wire_cell(poss,lineL-1);
		       break;
		    case's':
		       draw_box(-1,vgax(330),vgay(343),
						Maxx-2,vgay(400),1,0);
		       moveto(vgax(340),vgay(345));
		       oldzonesize=zonesize;
		       oldfixmidwire=fixmidwire;
		       old_distinct=distinct;
		       zonesize=lineL;

		       fixmidwire=0;
		       sprintf(textb[0],
			"confine to local periodic zone, enter zone size:");
		       myouttext(textb[0]);
		       sprintf(textb[0],"%d",lineL);
		       input_string(strlen(textb[0]),0);
		       if (is[0]=='q') goto endcase_s;
		       else if (is[0]!=13) zonesize=atoi(is);

		       if (zonesize<1 || zonesize>lineL) zonesize=lineL;
		       sprintf(textb[0],
			  "exclude all selfwiring-2, selfwire centre wire-1:");
		       moveto(vgax(340),gety+CHeight);
		       myouttext(textb[0]);
		       input_string(1,0);
		       if (is[0]=='q') goto endcase_s;
		       if (is[0]=='1') fixmidwire=1;
		       if (is[0]=='2') fixmidwire=2;

		       distinct=0;
		       if ((rangeL && (unsigned short)nhoodm[poss]<=startL)
		       ||(rangeL==0 && (unsigned short)nhoodm[poss]<=lineL)){
			  sprintf(textb[0],
			     "distinct wiring (no duplication)-d:");
			  moveto(vgax(340),gety+CHeight);
			  myouttext(textb[0]);
			  input_string(1,0);
			  if (is[0]=='q') break;
			  if (is[0]=='d' && zonesize>=
			         (unsigned short)nhood) distinct=1;
		       }
		       randomly_wire_cell(poss,lineL-1);
		      endcase_s:;
		       zonesize=oldzonesize;
		       fixmidwire=oldfixmidwire;
		       distinct=old_distinct;
		       break;
		    case'1':
		       oneD_local_wire_cell(poss,lineL-1);
		       break;
		    default:
		       rev_wiring=0;
		 }
		 putimage((signed short)((float)Maxx)/2,2,
				      boximage_prompt[4],COPY_PUT);
		 putimage(vgax(330),vgay(343),boximage[5],COPY_PUT);
		 freeimage(boximage[5]);
		 /*memory_box(1);*/
		 was_changed=1;
		 wiring_changed=1;
		 nonlocal=1;
		 regular2d=compress_1d_local=dontcompress=0;
		 moveto(tempx2,tempy2);
		 if (is[0]=='j' || is[0]==LeftArrow || is[0]==RightArrow ||
				is[0]==UpArrow || is[0]==DownArrow){
		    switch(is[0]){
			 case LeftArrow:    
			 poss+=1;           
			 if (poss>L){       
			    poss=0;         
			    cellx=left+((cellscale1-cellsep1)/2)+cellscale1*L;
			 }                                                    
			 else{                                                
			    if (drawcells==1) cellx-=cellscale1;              
			    else cellx=left+(cellscale1-cellsep1)/3+          
				  (right-left-cellscale1)*(float)(L-poss)/L;  
			 }                                                    
			 break;                                               
		      case RightArrow:                                        
			 poss-=1;                                             
			 if (poss==Maxu){                                     
			    poss=L;                                           
			    cellx=left+(cellscale1-cellsep1)/2;               
			 }                                                    
			 else{                                                
			    if (drawcells==1) cellx+=cellscale1;              
			    else cellx=left+(cellscale1-cellsep1)/3+          
				  (right-left-cellscale1)*(float)(L-poss)/L;  
			 }                                                    
			 break;                                               
		      case UpArrow:                                           
			 poss+=step;                                          
			 if (poss>L){                                         
			    poss=0;                                           
			    cellx=left+((cellscale1-cellsep1)/2)+cellscale1*L;
			 }                                                    
			 else{                                                
			    if (drawcells==1) cellx-=cellscale1*step;         
			    else cellx=left+(cellscale1-cellsep1)/3+          
				  (right-left-cellscale1)*(float)(L-poss)/L;  
									      
			 }                                                    
			 break;                                               
		      case DownArrow:                                         
			 posswas=poss;                                        
			 posswas-=step;                                       
			 if (posswas>poss){                                   
			    poss=L;                                           
			    cellx=left+(cellscale1-cellsep1)/2;               
			 }                                                    
			 else{                                                
			    poss-=step;                                       
			    if (drawcells==1) cellx+=cellscale1*step;         
			    else cellx=left+(cellscale1-cellsep1)/3+          
				  (right-left-cellscale1)*(float)(L-poss)/L;  
			 }                                                    
			 break;                                               
		      case'j':                                                
			 moveto(getx-CWidth,gety);                            
			 setfillstyle(SOLID_FILL,black);                          
			 bar(getx,gety+2,                                     
			   getx+CWidth,gety+CHeight+2);                       
			 get_prompt_box(7,4);                                 
			 sprintf(textb[0],"jump index (%d-0):",lineL-1);      
			 erase_prompt_box(4);                                 
			 draw_prompt_box(1);                                  
			 myouttext(textb[0]);                                 
			 sprintf(textb[0],"%d",lineL-1);                      
			 input_string(strlen(textb[0]),1);                    
			 if (atoi(is)>=0 && atoi(is)<=lineL-1) poss=atoi(is); 
			 if (right>=left+cellscale*lineL)                     
			   cellx=left+(cellscale1-cellsep1)/2+                
						cellscale1*(float)(L-poss);   
			 else                                                 
			   cellx=left+cellscale1/3+                           
				 (right-left-cellscale1)*(float)(L-poss)/L;   
			 is[0]=0;                                             
			 putimage((signed short)((float)Maxx)/2,2,            
					      boximage_prompt[7],COPY_PUT);   
			 freeimage(boximage_prompt[7]);                            
		    }
		    wiring_changed=0;
		    rev_wiring=1;
		 }
		 is[0]=0;
		 break;
	      case'l':
#                if __BORC__||__WATCOM__		 
                    imsize=imagesize(left-vgax(40),top-vgay(50),
				   right+vgax(40),bottom+vgay(40));
		    if ((tempimage=malloc(imsize))==NULL){
		       draw_prompt_box(1);
		       sprintf(textb[0],
		       "out of memory! boximage[6], return-abort");
		       getch();
		       final_quit();
		    }
#                elif __UNIX__
                    /*allocate mem for pixmap pointer (long)*/
                    if ((tempimage = 
                    (Pixmap *)malloc(sizeof(Pixmap *))) == NULL)
		                 outof_memory("Pixmap pointer");
                    *tempimage = 0;
#                endif	 
		 getimage(left-vgax(40),top-vgay(50),
			    right+vgax(40),bottom+vgay(40),tempimage);
		 putimage(left-vgax(40),top-vgay(50),boximage[6],COPY_PUT);

		 sculpt_basin_field();
		 was_changed=1;
		 if (wr_status>=2) wiring_changed=1;
		 putimage(left-vgax(40),top-vgay(50),tempimage,COPY_PUT);
		 freeimage(tempimage);
#                if __UNIX__
                    free(tempimage);
#                endif	 

		 /*memory_box(1);*/
		 is[0]=0;
		 break;
	      case'q': break;
			 case LeftArrow:    
			 poss+=1;           
			 if (poss>L){       
			    poss=0;         
			    cellx=left+((cellscale1-cellsep1)/2)+cellscale1*L;
			 }                                                    
			 else{                                                
			    if (drawcells==1) cellx-=cellscale1;              
			    else cellx=left+(cellscale1-cellsep1)/3+          
				  (right-left-cellscale1)*(float)(L-poss)/L;  
			 }                                                    
			 break;                                               
		      case RightArrow:                                        
			 poss-=1;                                             
			 if (poss==Maxu){                                     
			    poss=L;                                           
			    cellx=left+(cellscale1-cellsep1)/2;               
			 }                                                    
			 else{                                                
			    if (drawcells==1) cellx+=cellscale1;              
			    else cellx=left+(cellscale1-cellsep1)/3+          
				  (right-left-cellscale1)*(float)(L-poss)/L;  
			 }                                                    
			 break;                                               
		      case UpArrow:                                           
			 poss+=step;                                          
			 if (poss>L){                                         
			    poss=0;                                           
			    cellx=left+((cellscale1-cellsep1)/2)+cellscale1*L;
			 }                                                    
			 else{                                                
			    if (drawcells==1) cellx-=cellscale1*step;         
			    else cellx=left+(cellscale1-cellsep1)/3+          
				  (right-left-cellscale1)*(float)(L-poss)/L;  
									      
			 }                                                    
			 break;                                               
		      case DownArrow:                                         
			 posswas=poss;                                        
			 posswas-=step;                                       
			 if (posswas>poss){                                   
			    poss=L;                                           
			    cellx=left+(cellscale1-cellsep1)/2;               
			 }                                                    
			 else{                                                
			    poss-=step;                                       
			    if (drawcells==1) cellx+=cellscale1*step;         
			    else cellx=left+(cellscale1-cellsep1)/3+          
				  (right-left-cellscale1)*(float)(L-poss)/L;  
			 }                                                    
			 break;                                               
		      case'j':                                                
			 moveto(getx-CWidth,gety);                            
			 setfillstyle(SOLID_FILL,black);                          
			 bar(getx,gety+2,                                     
			   getx+CWidth,gety+CHeight+2);                       
			 get_prompt_box(7,4);                                 
			 sprintf(textb[0],"jump index (%d-0):",lineL-1);      
			 erase_prompt_box(4);                                 
			 draw_prompt_box(1);                                  
			 myouttext(textb[0]);                                 
			 sprintf(textb[0],"%d",lineL-1);                      
			 input_string(strlen(textb[0]),1);                    
			 if (atoi(is)>=0 && atoi(is)<=lineL-1) poss=atoi(is); 
			 if (right>=left+cellscale*lineL)                     
			   cellx=left+(cellscale1-cellsep1)/2+                
						cellscale1*(float)(L-poss);   
			 else                                                 
			   cellx=left+cellscale1/3+                           
				 (right-left-cellscale1)*(float)(L-poss)/L;   
			 is[0]=0;                                             
			 putimage((signed short)((float)Maxx)/2,2,            
					      boximage_prompt[7],COPY_PUT);   
			 freeimage(boximage_prompt[7]);                            
	   }
	   if (wiring_changed==1){  /*redraw output frequency cells*/
	      cell_out_freq();
	      moveto(left,top+vgay(100));
	      setfillstyle(SOLID_FILL,black);
	      bar(getx,gety,rightcell,gety+vgax(25));
	      setfillstyle(SOLID_FILL,lightgray);
	      for (zu=lineL-1;zu!=Maxu;zu--){
		 cellheight=celloutfreq[zu];
		 if (cellheight>vgay(25)) cellheight=25;
		 if (lineL>(right-left)/2)
				line(getx,gety,getx,gety+cellheight);

		 else bar3d(getx,gety,getx+cellscale1-cellsep1,
						  gety+cellheight,0,1);
		 if (drawcells==1) moverel(cellscale,0);
		 else moveto(left+cellscale1*(lineL-zu),gety);
	      }
	   }	   
	   wiring_changed=0;
	   if (is[0]=='q' || is[0]==13) break;
	}
	putimage(left-vgax(40),top-vgay(50),boximage[6],COPY_PUT);
	freeimage(boximage[6]);
	putimage((signed short)((float)Maxx)/2,2,boximage_prompt[3],COPY_PUT);
	freeimage(boximage_prompt[3]);
	freeimage(boximage_prompt[4]);
	/*memory_box(1);*/
}

/***************** show wiring layout as 2-d graphic, Dec 93 *************************/
void show_graphic_wiring_2d(char showrules){
 unsigned short poss,zu;
 signed short z,zz,xbox,tempx,tempy,textbx,textby,pixcolor,
     wire,ii,jj,iz,jz,in,jn;
 float left=0,top=0,right=0,bottom=0,
       cellscale=0,cellsep=0,
       cellx=0,celly=0,maxside=0;
 char ccel;
 unsigned short thisposs;
 signed short tablebytes,codebytes;
 float tempx2,tempy2,
       tlratio,tzparam,wtlratio,wtzparam,weight;
 char  wr_status; 
 unsigned long toutwires;
#if __BORC__||__WATCOM__
 void *tempimage;
 unsigned long imsize;/*imsize, not xwindows*/
#elif __UNIX__
 Pixmap *tempimage;
#endif 
 unsigned short* tempwiring;
 char rev_wiring=0,nhood_temp;
 unsigned short oldzonesize;
 unsigned short zone2d;
 char oldfixmidwire,old_distinct;

     /*arrows:128+  75=left,77=right,72=up,80=down*/

	if      (nonlocal==0 && rulemix==0)	wr_status=0;
	else if (nonlocal==0 && rulemix)	wr_status=1;
	else if (nonlocal && rulemix==0)	wr_status=2;
	else if (nonlocal && rulemix)	wr_status=3;

	tablebytes=(signed short)ceil(pow(2,(double)nhood)/8);
	codebytes=(signed short)ceil((double)(nhood+1)/8);

	if (i2d>=j2d)  maxside=i2d;
	else maxside=j2d;

	if (i2d<=30 && j2d<=30){
	   cellscale=vgax(7);
	   cellsep=vgax(3);
	}
	else {
	   cellscale=floor((float)vgax(250)/maxside);
	   if (cellscale>=3) cellsep=2;
	   else cellsep=1;

	}
	if (cellscale<1){
	   cellscale=1;
	   cellsep=1;
	}
	bottom=vgay(390);
	top=bottom-(j2d+1)*cellscale;
	left=vgax(42);
	right=left+(i2d+1)*cellscale;
	/*get area under data box, no outline or background*/
	draw_box(3,left-vgax(40)+2,bottom+vgay(40)-vgay(17),
			       vgax(620),bottom+vgay(40)-2,0,0);
	/*whole box*/
	draw_box(7,left-vgax(40),top-vgay(50),
			       right+vgax(18),bottom+vgay(40),1,0);

	/*2-d grid*/
	for (zz=j2d-1;zz>=0;zz--){
	   for (z=i2d-1;z>=0;z--){

	      if (zz==j2d-1 || zz==0 || z==i2d-1 || z==0) pixcolor=white;
	      else pixcolor=lightcyan;
	      moveto(right-(z+1)*cellscale+((cellscale-cellsep)/2),
		     bottom-(zz+1)*cellscale+((cellscale-cellsep)/2));
	      if (cellscale>=3) putpixel(getx,gety,pixcolor);
	      else if (pixcolor==white) putpixel(getx,gety,pixcolor);
	   }
	}
	/*add co-ords to grid*/
	moveto(right-i2d*cellscale+(cellscale-cellsep)/2,
		     bottom-j2d*cellscale+(cellscale-cellsep)/2);
	line(getx,gety-vgay(10),getx,gety-vgay(5));
	sprintf(textb[0],"%d",i2d-1);
	moveto(getx-textwidth(textb[0])/2,gety-vgay(12)-CHeight);
	outtext(textb[0]);

	moveto(right-i2d*cellscale+(cellscale-cellsep)/2,
		     bottom-j2d*cellscale+(cellscale-cellsep)/2);
	line(getx-vgax(10),gety,getx-vgax(5),gety);
	sprintf(textb[0],"%d",j2d-1);
	moveto(getx-textwidth(textb[0])-vgax(11),
				     gety-(float)CHeight*.7);
	outtext(textb[0]);

	moveto(right-cellscale+((cellscale-cellsep)/2),
		     bottom-cellscale+((cellscale-cellsep)/2));
	line(getx+vgax(5),gety,getx+vgax(10),gety);
	moveto(getx+vgax(12),gety-(float)CHeight*.7);
	outtext("0");

	moveto(right-cellscale+((cellscale-cellsep)/2),
		     bottom-cellscale+((cellscale-cellsep)/2));
	line(getx,gety+vgax(5),getx,gety+vgax(10));
	moveto(getx-CHeight/2,gety+vgay(9));
	outtext("0");

	/*grid area*/
	draw_box(6,left,top,right,bottom,1,0);

	if (j2d%2==0) poss=lineL/2+i2d/2; /*start in centre*/
	else poss=lineL/2;

	ii=poss%i2d;
	jj=poss/i2d;

	get_prompt_box(3,3);
	sprintf(textb[0],
	  "show cell wiring/rule, move-arrows, jump-j");

	if (wr_status<2) sprintf(textb[2],
	   "options-o, print box-p, revise/transform rule-r/t");
	else if (wr_status==2 || wr_status==3) sprintf(textb[2],
	"options-o, printbox-p, rev wiring-w, rev/transform rule-r/t");
	if ((wr_status==1 || wr_status==3)
	   && memcmp(rule_all_0s,carule[0],tablebytes)!=0)
	   sprintf(textb[3],"show avZ-z, learn/highlight-l, cont-ret:");
	else sprintf(textb[3],"learn/highlight-l, cont-ret:");
	xbox=draw_prompt_box(3);
	outtext(textb[0]);
	moveto(xbox,gety+CHeight);
	myouttext(textb[2]);
	moveto(xbox,gety+CHeight);
	myouttext(textb[3]);
	get_prompt_box(4,3);
	/*memory_box(1);*/
	textbx=getx;
	textby=gety;

	while(1){
	    cellx=right-(ii+1)*cellscale;
	    celly=bottom-(jj+1)*cellscale;
	    moveto(cellx,celly);
	    poss=i2d*jj+ii;
	    if (showrules && rulemix){
	       z_parameter_all(nhoodm[poss],0,carule[poss]);
	       show_rule_bottom(nhoodm[poss],0,carule[poss],poss);
	    }
	    if (nhood_mixed){
		tablebytes=(signed short)ceil(pow(2,(double)nhoodm[poss])/8);
		codebytes=(signed short)ceil((double)(nhoodm[poss]+1)/8);
	    }

	    draw_box(-1,left-vgax(40)+2,bottom+vgay(40)-vgay(17),
			       vgax(620),bottom+vgay(40)-2,1,0);
	    if (!nhood_mixed)
		   sprintf(textb[0]," cell=%d (%d,%d) wiring=",poss,ii,jj);
	    else sprintf(textb[0]," cell=%d (%d,%d) nhood=%d wiring=",
					 poss,ii,jj,nhoodm[poss]);
	    outtext(textb[0]);

	    putimage(left,top,boximage[6],COPY_PUT);
#           if __BORC__
	       moverel(-CWidth,0);
#           endif

	    for (z=nhoodm[poss]-1;z>=0;z--){
	       sprintf(textb[0],"%d ",wiring[poss][z]);
	       outtext(textb[0]);
	    }
	    sprintf(textb[0],"outwires=%d ",celloutfreq[poss]);
	    outtext(textb[0]);
	    if (nhoodm[poss]<6 && rules_set){
	      if (rulemix) thisposs=poss;
	      else thisposs=0;

	      sprintf(textb[0],"%d-rule=(hex)",nhoodm[poss]);
	      outtext(textb[0]);
	      print_current_bitstring_hexbytes(1,carule[thisposs],
			   nhoodm[thisposs],Maxx,white,0);
	    }
	    for (wire=nhoodm[poss]-1;wire>=0;wire--){
		    ccel=0;
		    /*  * 0 *  ..the nhood */
		    if (nhoodm[poss]==1){
			centre;
			ccel=1;
		    }
		    /*  1
			0 *  ..the nhood */
		    else if (nhoodm[poss]==2){
			switch(wire){
				case 1:  north    ; break;
				case 0:  centre   ;
					 ccel=1   ;
			}
		    }
		    /*  2 1 0   ..the nhood */
		    else if (nhoodm[poss]==3){
			switch(wire){
				case 2:  west     ; break;
				case 1:  centre   ;
					 ccel=1   ; break;
				case 0:  east     ;
			}
		    }
		    /*    3
			2 1 0   ..the nhood */
		    else if (nhoodm[poss]==4){
			switch(wire){
				case 3:  north    ; break;
				case 2:  west     ; break;
				case 1:  centre   ;
					 ccel=1   ; break;
				case 0:  east     ;
			}
		    }
		    /*  3
		      4 2 0   ..the nhood
			1   */
		    else if (nhoodm[poss]==5){
			switch(wire){
				case 4:  west     ; break;
				case 3:  north    ; break;
				case 2:  centre   ;
					 ccel=1   ; break;
				case 1:  south    ; break;
				case 0:  east     ;
			}
		    }
		    /* 5 4 3
		       2 1 0   ..the nhood */
		    else if (nhoodm[poss]==6){
			switch(wire){
				case 5:  northwest; break;
				case 4:  north    ; break;
				case 3:  northeast; break;
				case 2:  west     ; break;
				case 1:  centre   ;
					 ccel=1   ; break;
				case 0:  east     ;
			}
		    }

		    /* triangular grid
			      odd rows
		    6 5	      from top     6 5     even rows     6 5
		    4 3 2   ..the nhood  4 3 2   ..the nhood    4 3 2
		    1 0   *                1 0                   1 0   */
		    else if (nhoodm[poss]==7){
		      if ((jj+1)%2==0){
			switch(wire){
				case 6:  northwest; break;
				case 5:  north    ; break;
				case 4:  west     ; break;
				case 3:  centre   ;
					 ccel=1   ; break;
				case 2:  east     ; break;
				case 1:  southwest; break;
				case 0:  south    ;
			}
		      }
		      else{
			switch(wire){
				case 6:  north    ; break;
				case 5:  northeast; break;
				case 4:  west     ; break;
				case 3:  centre   ;
					 ccel=1   ; break;
				case 2:  east     ; break;
				case 1:  south    ; break;
				case 0:  southeast;
			}
		      }
		    }
		    /* 7 6 5
		       4 3 2   ..the nhood
		       1   0    */
		    else if (nhoodm[poss]==8){
			switch(wire){
				case 7:  northwest; break;
				case 6:  north    ; break;
				case 5:  northeast; break;
				case 4:  west     ; break;
				case 3:  centre   ;
					 ccel=1   ; break;
				case 2:  east     ; break;
				case 1:  southwest; break;
				case 0:  southeast;
			}
		    }
		    /* 8 7 6
		       5 4 3   ..the nhood
		       2 1 0   */

		    else if (nhoodm[poss]==9){
			switch(wire){
				case 8:  northwest; break;
				case 7:  north    ; break;
				case 6:  northeast; break;
				case 5:  west     ; break;
				case 4:  centre   ;
					 ccel=1   ; break;
				case 3:  east     ; break;
				case 2:  southwest; break;
				case 1:  south    ; break;
				case 0:  southeast;
			}
		    }
		    iz=wiring[poss][wire]%i2d;
		    jz=wiring[poss][wire]/i2d;

		    if (ccel==1) setfillstyle(SOLID_FILL,red);
		    else{
                       if (bground=='w') setfillstyle(SOLID_FILL,blue);
                       if (bground=='b') setfillstyle(SOLID_FILL,yellow);
                    }
		    moveto(right-(in+1)*cellscale,bottom-(jn+1)*cellscale);
		    bar3d(getx,gety,getx+cellscale-cellsep,
					gety+cellscale-cellsep,0,1);

		    if (in!=iz && jn!=jz){
		       /*show couplings from 2-d nhood*/
		       moverel((cellscale-cellsep)/2,(cellscale-cellsep)/2);

		       lineto(right-(iz+1)*cellscale+(cellscale-cellsep)/2,
			    bottom-(jz+1)*cellscale+(cellscale-cellsep)/2);
		       moverel(-(cellscale-cellsep)/2,-(cellscale-cellsep)/2);
		       setfillstyle(SOLID_FILL,green);
		       bar3d(getx,gety,getx+cellscale-cellsep,
					gety+cellscale-cellsep,0,1);
		    }
		    moveto(cellx,celly);
	    }
	    moveto(textbx,textby);
	    if (rev_wiring==1) is[0]='w';
	    else input_string(1,-1);
	    switch(is[0]){
	      case'o':
		 finish_options(0);
		 break;
	      case'p':
		 /*print wiring box*/
#                if __BORC__||__WATCOM__		
                    printimage('p',green,blue,left-vgax(40),
                     top-vgay(50),right+vgax(18)+1,bottom+vgay(40));
#                elif __UNIX__
                    printimage();		 
#                endif
		 continue;
	      case'r':
		 /*revise rule*/
		 if (rulemix) thisposs=poss;
		 else thisposs=0;
		 tempx2=getx;
		 tempy2=gety;
		 revise_rule_or_code(thisposs,tablebytes,codebytes);
		 if (!rulemix){
		    z_parameter_all(nhoodm[thisposs],0,carule[thisposs]);
		    show_rule_bottom(nhoodm[thisposs],
				       0,carule[thisposs],thisposs);
		 }
		 was_changed=1;
		 moveto(tempx2,tempy2);
		 putimage((signed short)((float)Maxx)/2,2,
				     boximage_prompt[4],COPY_PUT);
		 break;
	      case't':
		 /*transform_rule*/
		 if (rulemix) thisposs=poss;
		 else thisposs=0;
		 tempx2=getx;
		 tempy2=gety;
		 transform_rule(thisposs);
		 was_changed=1;
		 moveto(tempx2,tempy2);
		 putimage((signed short)((float)Maxx)/2,2,
				     boximage_prompt[4],COPY_PUT);
		 is[0]=0;
		 break;
	      case'z':
		 /*calculate av. and weighted av. ldz,Z */
		 if ((wr_status==1 || wr_status==3) /*&& !nhood_mixed*/
		      && memcmp(rule_all_0s,carule[0],tablebytes)!=0){
		    tempx=getx;
		    tempy=gety;
		    if (lineL*nhood>100){
		       draw_box(-1,left-vgax(40),top-vgay(50),
			  right+vgax(18),top-vgay(50)+2*CHeight+4,1,0);
		       moveto(left-vgax(37),top-vgay(49));
		       outtext("computing wt.av:lda  ...WAIT");
		    }
		    cell_out_freq();
		    toutwires=0;
		    if (nhood_mixed){
		       for (zu=lineL-1;zu!=Maxu;zu--) toutwires+=nhoodm[zu];
		    }
		    else toutwires+=lineL*nhood;
		    tlratio=tzparam=wtlratio=wtzparam=0;
		    for (zu=lineL-1;zu!=Maxu;zu--){
		       z_parameter_all(nhoodm[zu],0,carule[zu]);
		       tlratio+=lratio;
		       tzparam+=zparam[0];
		       weight=(float)celloutfreq[zu]/toutwires;
		       wtlratio+=lratio*weight;
		       wtzparam+=zparam[0]*weight;
		    }
		    tlratio=tlratio/lineL;
		    tzparam=tzparam/lineL;
		    if (tzparam>0){
		       draw_box(-1,left-vgax(40),top-vgay(50),
			  right+vgax(18),top-vgay(50)+2*CHeight+4,1,0);
		       moveto(left-vgax(37),top-vgay(49));
		       sprintf(textb[0],"av:lda-r=%g Z=%g",tlratio,tzparam);
		       outtext(textb[0]);
		       moveto(left-vgax(37),gety+CHeight);
		       sprintf(textb[0],"wt.av:lda-r=%g Z=%g",wtlratio,wtzparam);
		       outtext(textb[0]);
		    }
		    moveto(tempx,tempy);
		 }
		 break;
	      case'w':
		 if (!nonlocal) break;
		 tempx2=getx;
		 tempy2=gety;
		 draw_box(5,vgax(330),vgay(343),Maxx-2,vgay(400),1,0);
		 rev_wiring=1;
		 /*memory_box(1);*/
		 moveto(vgax(340),vgay(345));
		 sprintf(textb[0],
		    "REWIRE cell=%d move-arrows jump-j cont-ret",poss);
		 if (nhood_mixed)
		    sprintf(textb[1],"change k=%d nhood-n",nhoodm[poss]);
		 sprintf(textb[2],
		    "hand-h random-r special-rand-s reg-1d-1 reg-2d-2:");
		 outtext(textb[0]);
		 if (nhood_mixed){
		    moveto(vgax(340),gety+CHeight);
		    outtext(textb[1]);
		 }
		 moveto(vgax(340),gety+CHeight);
		 myouttext(textb[2]);
		 input_string(1,-1);
		 switch(is[0]){
		    case'n':
		       if (!nhood_mixed) break;
		       nhood_temp=nhoodm[poss];
		       moveto(vgax(340),gety+CHeight);
		       sprintf(textb[0],
			 "set nhood size (1-%d):",nhood);
		       myouttext(textb[0]);
		       input_string(1,0);
		       if (atoi(is)>=1 && atoi(is)<=nhood)
					       nhoodm[poss]=atoi(is);
		       /*wire extra pseudo-nhood cells 2d-local*/
		       if (nhoodm[poss]>nhood_temp){
			  sprintf(textb[0],"tempwiring");
			  if ((tempwiring=(unsigned short*)
			     calloc(nhood_temp,sizeof(unsigned short)))
					==NULL) outof_memory(textb[0]);
			  memcpy(tempwiring,wiring[poss],
				   sizeof(unsigned short)*nhood_temp);
			  wireup_2d_nhood(i2d,j2d,ii,jj,ii,jj);
			  for (wire=nhood_temp-1;wire>=0;wire--)
				   wiring[poss][wire]=tempwiring[wire];
			  free(tempwiring);
		       }
		       break;
		    case'h':
		       draw_box(-1,vgax(330),vgay(343),
						Maxx-2,vgay(400),1,0);
		       moveto(vgax(340),vgay(345));
		       sprintf(textb[0],"hand rewire");
		       sprintf(textb[1],
			"use return or arrows to move");
		       sprintf(textb[2],
			"enter wiring positions 0-%d, q to complete",lineL-1);
		       outtext(textb[0]);
		       for (z=1;z<=2;z++){
			  moveto(vgax(340),gety+CHeight);
			  outtext(textb[z]);
		       }
		       moveto(vgax(340),gety+CHeight);
		       print_wiring_cell(getx,gety,poss);
		       break;
		    case'r':
		       randomly_wire_cell(poss,lineL-1);
		       break;
		    case's':
		       draw_box(-1,vgax(330),vgay(343),
						Maxx-2,vgay(400),1,0);
		       moveto(vgax(340),vgay(345));
		       oldzonesize=zonesize;
		       oldfixmidwire=fixmidwire;
		       old_distinct=distinct;
		       zonesize=lineL;

		       if (i2d>=j2d) zone2d=j2d;
		       else zone2d=i2d;
		       zonesize=zone2d;

		       fixmidwire=0;
		       sprintf(textb[0],
			"confine to local periodic zone, enter zone size:");
		       myouttext(textb[0]);
		       sprintf(textb[0],"%d",lineL);
		       input_string(strlen(textb[0]),0);
		       if (is[0]=='q') goto endcase_s;
		       else if (is[0]!=13) zonesize=atoi(is);
		       if (zonesize<1 || zonesize>zone2d) zonesize=zone2d;

		       sprintf(textb[0],
			  "exclude all selfwiring-2, selfwire centre wire-1:");
		       moveto(vgax(340),gety+CHeight);
		       myouttext(textb[0]);
		       input_string(1,0);
		       if (is[0]=='q') goto endcase_s;
		       if (is[0]=='1') fixmidwire=1;
		       if (is[0]=='2') fixmidwire=2;

		       distinct=0;
		       if ((rangeL && (unsigned short)nhoodm[poss]<=startL)
			||(rangeL==0 && (unsigned short)nhoodm[poss]<=lineL)){
			  sprintf(textb[0],
			     "distinct wiring (no duplication)-d:");
			  moveto(vgax(340),gety+CHeight);
			  myouttext(textb[0]);
			  input_string(1,0);
			  if (is[0]=='q') break;
			  if (is[0]=='d' && zonesize>=
			            (unsigned short)nhood) distinct=1;
		       }
		       randomly_wire_cell(poss,lineL-1);
		      endcase_s:;
		       zonesize=oldzonesize;
		       fixmidwire=oldfixmidwire;
		       distinct=old_distinct;
		       break;
		    case'1':
		       oneD_local_wire_cell(poss,lineL-1);
		       break;
		    case'2':
		       wireup_2d_nhood(i2d,j2d,ii,jj,ii,jj);
		       break;
		    default:
		       rev_wiring=0;
		 }
		 putimage((signed short)((float)Maxx)/2,2,
				      boximage_prompt[4],COPY_PUT);
		 putimage(vgax(330),vgay(343),boximage[5],COPY_PUT);
		 freeimage(boximage[5]);
		 /*memory_box(1);*/
		 was_changed=1;
		 nonlocal=1;
		 regular2d=compress_1d_local=dontcompress=0;
		 moveto(tempx2,tempy2);
		 if (is[0]=='j' || is[0]==LeftArrow || is[0]==RightArrow ||
				is[0]==UpArrow || is[0]==DownArrow){
		    switch(is[0]){         
			      case LeftArrow:{             
				       ii+=1;              
				       if (ii>i2d-1) ii=0; 
				       break;              
			      }                            
			      case RightArrow:{            
				       ii-=1;              
				       if (ii<0) ii=i2d-1; 
				       break;              
			      }                            
			      case UpArrow:{               
				       jj+=1;              
				       if (jj>j2d-1) jj=0; 
				       break;              
			      }                            
			      case DownArrow:{             
				       jj-=1;              
				       if (jj<0) jj=j2d-1; 
				       break;              
			      }                            
			      case'j':                                             
					 moveto(getx-CWidth,gety);                         
					 setfillstyle(SOLID_FILL,black);                       
					 bar(getx,gety+2,                                  
					   getx+CWidth,gety+CHeight+2);                    
					 get_prompt_box(7,3);                              
					 erase_prompt_box(3);                              
					 xbox=draw_prompt_box(2);                          
					 outtext("jump to index ixj");                     
					 moveto(xbox,gety+CHeight);                        
					 sprintf(textb[0],"enter i (%d-0):",i2d-1);        
					 outtext(textb[0]);                                
					 sprintf(textb[0],"%d",i2d-1);                     
					 input_string(strlen(textb[0]),1);                 
					 if (atoi(is)>=0 && atoi(is)<=i2d-1) ii=atoi(is);  
					 sprintf(textb[0]," enter j (%d-0):",j2d-1);       
					 outtext(textb[0]);                                
					 sprintf(textb[0],"%d",j2d-1);                     
					 input_string(strlen(textb[0]),1);                 
					 if (atoi(is)>=0 && atoi(is)<=j2d-1) jj=atoi(is);  
					 is[0]=0;                                          
					 putimage((signed short)((float)Maxx)/2,2,         
							      boximage_prompt[7],COPY_PUT);
					 freeimage(boximage_prompt[7]);
					 break;
		    }
		    rev_wiring=1;
		 }
		 is[0]=0;
		 break;
	      case'l':
#                if __BORC__||__WATCOM__
		     imsize=imagesize(left-vgax(40),top-vgay(50),
				     right+vgax(18),bottom+vgay(40));
		     if ((tempimage=malloc(imsize))==NULL){
			draw_prompt_box(1);
			sprintf(textb[0],
			"out of memory! boximage[6], return-abort");
			input_string(1,0);
			final_quit();
		     }

#                elif __UNIX__
                    /*allocate mem for pixmap pointer (long)*/
                    if ((tempimage = 
                         (Pixmap *)malloc(sizeof(Pixmap *))) == NULL)
		                 outof_memory("Pixmap pointer");
                    *tempimage = 0;
#                endif	 
		    getimage(left-vgax(40),top-vgay(50),
			right+vgax(18),bottom+vgay(40),tempimage);
		    putimage(left-vgax(40),top-vgay(50),boximage[7],COPY_PUT);
		    putimage(left-vgax(40)+2,bottom+vgay(40)-vgay(17)
						   ,boximage[3],COPY_PUT);
		    sculpt_basin_field();
		    was_changed=1;
		    putimage(left-vgax(40),top-vgay(50),tempimage,COPY_PUT);
		    freeimage(tempimage);
#                if __UNIX__
                    free(tempimage);
#                endif	 

		    /*memory_box(1);*/
		    is[0]=0;
		    break;

	      case'q':
	      	break;      
	      case LeftArrow:{             
		       ii+=1;              
		       if (ii>i2d-1) ii=0; 
		       break;              
	      }                            
	      case RightArrow:{            
		       ii-=1;              
		       if (ii<0) ii=i2d-1; 
		       break;              
	      }                            
	      case UpArrow:{               
		       jj+=1;              
		       if (jj>j2d-1) jj=0; 
		       break;              
	      }                            
	      case DownArrow:{             
		       jj-=1;              
		       if (jj<0) jj=j2d-1; 
		       break;              
	      }                            
	      case'j':                                             
			 moveto(getx-CWidth,gety);                         
			 setfillstyle(SOLID_FILL,black);                       
			 bar(getx,gety+2,                                  
			   getx+CWidth,gety+CHeight+2);                    
			 get_prompt_box(7,3);                              
			 erase_prompt_box(3);                              
			 xbox=draw_prompt_box(2);                          
			 outtext("jump to index ixj");                     
			 moveto(xbox,gety+CHeight);                        
			 sprintf(textb[0],"enter i (%d-0):",i2d-1);        
			 outtext(textb[0]);                                
			 sprintf(textb[0],"%d",i2d-1);                     
			 input_string(strlen(textb[0]),1);                 
			 if (atoi(is)>=0 && atoi(is)<=i2d-1) ii=atoi(is);  
			 sprintf(textb[0]," enter j (%d-0):",j2d-1);       
			 outtext(textb[0]);                                
			 sprintf(textb[0],"%d",j2d-1);                     
			 input_string(strlen(textb[0]),1);                 
			 if (atoi(is)>=0 && atoi(is)<=j2d-1) jj=atoi(is);  
			 is[0]=0;                                          
			 putimage((signed short)((float)Maxx)/2,2,         
					      boximage_prompt[7],COPY_PUT);
			 freeimage(boximage_prompt[7]);
			 break;

	    }
	    if (is[0]=='q' || is[0]==13) break;
	}

	putimage(left-vgax(40),top-vgay(50),boximage[7],COPY_PUT);
	putimage(left-vgax(40)+2,bottom+vgay(40)-vgay(17)
					   ,boximage[3],COPY_PUT);
	freeimage(boximage[3]);
	freeimage(boximage[7]);
	freeimage(boximage[6]);

	putimage((signed short)((float)Maxx)/2,2,
				  boximage_prompt[3],COPY_PUT);
	freeimage(boximage_prompt[3]);
	freeimage(boximage_prompt[4]);
}

/******************* 2-D regular 9-1 nhood wiring, Dec 93 **************/
void wireup_2d_nhood(signed short i, signed short j,
		   signed short itop,signed short jtop,
			    signed short ibot,signed short jbot){
 unsigned short poss,z;
 signed short wire,jj,ii;
#    define setnorthwest z=(i+1)*(jj+1)+ii+1;\
			  if (jj==j) z=ii+1;\
			  if (ii==i) z=(i+1)*(jj+1);\
			  if (jj==j && ii==i) z=0;

#    define setnorth     z=(i+1)*(jj+1)+ii;\
			  if (jj==j) z=ii;

#    define setnortheast z=(i+1)*(jj+1)+ii-1;\
			  if (jj==j) z=ii-1;\
			  if (ii==0) z=(i+1)*(jj+1)+i;\
			  if (jj==j && ii==0) z=i;

#    define setwest      z=(i+1)*jj + ii+1;\
			  if (ii==i) z=(i+1)*jj;

#    define setcentre    z=poss;

#    define seteast      z=(i+1)*jj + ii-1;\
			  if (ii==0) z=(i+1)*jj+i;

#    define setsouthwest z= (i+1)*(jj-1) + ii+1;\
			  if (jj==0) z=(i+1)*j+ii+1;\
			  if (ii==i) z=(i+1)*(jj-1);\
			  if (jj==0 && ii==i) z=(ii+1)*j;

#    define setsouth     z= (i+1)*(jj-1) + ii;\
			  if (jj==0) z=(i+1)*j+ii;

#    define setsoutheast z=(i+1)*(jj-1)+ii-1;\
			  if (jj==0) z=(i+1)*j+ii-1;\
			  if (ii==0) z=(i+1)*jj-1;\
			  if (ii==0 && jj==0) z=L;

     /*couple wire*/
#    define wireup  wiring[poss][wire]=z;

      i-=1;
      j-=1;
		     /* 1-d array   15......0

			2-d array

			15* * *  ..3
			* * 9 8  ..2 j
			7 6 5 4  ..1
			3 2 1 0  ..0

			| | | |
			3 2 1 0

			   i       */


      for (jj=jtop;jj>=jbot;jj--){
	 for (ii=itop;ii>=ibot;ii--){
	    poss=(i+1)*jj + ii;
	    /*  * 0 *  ..the nhood */
	    if (nhoodm[poss]==1){
	       wire=0;
	       setcentre;
	       wireup;
	    }
	    /*  1
	        0 *  ..the nhood */
	    if (nhoodm[poss]==2){
	       for (wire=1;wire>=0;wire--){
		  switch(wire){
		     case 1:  setnorth    ; break;
		     case 0:  setcentre   ;
		  }
		  wireup;
	       }
	    }
	    /*  2 1 0   ..the nhood */
	    else if (nhoodm[poss]==3){
	       for (wire=2;wire>=0;wire--){
		  switch(wire){
		     case 2:  setwest     ; break;
		     case 1:  setcentre   ; break;
		     case 0:  seteast     ;
		  }
		  wireup;
	       }
	    }
	    /*    3
		2 1 0   ..the nhood */
	    else if (nhoodm[poss]==4){
	       for (wire=3;wire>=0;wire--){
		  switch(wire){
		     case 3:  setnorth    ; break;
		     case 2:  setwest     ; break;
		     case 1:  setcentre   ; break;
		     case 0:  seteast     ;
		  }
		  wireup;
	       }
	    }
	    /*  3
	      4 2 0   ..the nhood
		1   */
	    if (nhoodm[poss]==5){
	       for (wire=4;wire>=0;wire--){
		  switch(wire){
		     case 4:  setwest     ; break;
		     case 3:  setnorth    ; break;
		     case 2:  setcentre   ; break;
		     case 1:  setsouth    ; break;
		     case 0:  seteast     ;
		  }
		  wireup;
	       }
	    }
	    /* 5 4 3
	       2 1 0   ..the nhood */
	    if (nhoodm[poss]==6){
	       for (wire=5;wire>=0;wire--){
		  switch(wire){
		     case 5:  setnorthwest; break;
		     case 4:  setnorth    ; break;
		     case 3:  setnortheast; break;
		     case 2:  setwest     ; break;
		     case 1:  setcentre   ; break;
		     case 0:  seteast     ;
		  }
		  wireup;
	       }
	    }
	    /* triangular grid
	              odd rows
	    6 5	      from top     6 5     even rows     6 5
	    4 3 2   ..the nhood  4 3 2   ..the nhood    4 3 2
	    1 0   *                1 0                   1 0   */
	    if (nhoodm[poss]==7){
	       for (wire=6;wire>=0;wire--){
		  if ((jj+1)%2==0){
		     switch(wire){
			case 6:  setnorthwest; break;
			case 5:  setnorth    ; break;
			case 4:  setwest     ; break;
			case 3:  setcentre   ; break;
			case 2:  seteast     ; break;
			case 1:  setsouthwest; break;
			case 0:  setsouth    ;
		     }
		  }
		  else{
		     switch(wire){
			case 6:  setnorth    ; break;
			case 5:  setnortheast; break;
			case 4:  setwest     ; break;
			case 3:  setcentre   ; break;
			case 2:  seteast     ; break;
			case 1:  setsouth    ; break;
			case 0:  setsoutheast;
		     }
		  }
		  wireup;
	       }
	    }
	    /* 7 6 5
	       4 3 2   ..the nhood
	       1   0    */
	    if (nhoodm[poss]==8){
	       for (wire=7;wire>=0;wire--){
		  switch(wire){
		     case 7:  setnorthwest; break;
		     case 6:  setnorth    ; break;
		     case 5:  setnortheast; break;
		     case 4:  setwest     ; break;
		     case 3:  setcentre   ; break;
		     case 2:  seteast     ; break;
		     case 1:  setsouthwest; break;
		     case 0:  setsoutheast;
		  }
		  wireup;
	       }
	    }
	    /* 8 7 6
	       5 4 3   ..the nhood
	       2 1 0   */
	    if (nhoodm[poss]==9){
	       for (wire=8;wire>=0;wire--){
		  switch(wire){
		     case 8:  setnorthwest; break;
		     case 7:  setnorth    ; break;
		     case 6:  setnortheast; break;
		     case 5:  setwest     ; break;
		     case 4:  setcentre   ; break;
		     case 3:  seteast     ; break;
		     case 2:  setsouthwest; break;
		     case 1:  setsouth    ; break;
		     case 0:  setsoutheast;
		  }
		  wireup;
	       }
	    }
	 }
      }
      cell_out_freq();
}

/***************** show wiring/rule scheme, Dec 1993 *********************/
void show_w_r_scheme(void){
 signed short tempx,tempy,wire,xbox;
 unsigned short poss,z;
 unsigned long toutwires;
 char was_loaded,thispdata,thisfiledata,
      wrstype;
    /*rule=0,wiring scheme=1,rule scheme=2,rule/scheme scheme=3,seed='s'*/
 float tlratio,tzparam,wtlratio,wtzparam,weight;
 signed short fid;
 char file_ret;

   tempx=getx;
   tempy=gety;
  start:
   if (rulemix==0){
      z_parameter_all(nhood,0,carule[0]); /*show Z parameter*/
      show_rule_bottom(nhood,0,carule[0],0);
   }
   if (twod) sprintf(textb[0],
		  "learn/revise/show rulemix + wiring: 1d-1 2d-2:");
   else sprintf(textb[0],
		  "learn/revise/show rulemix + wiring -1:");
   get_prompt_box(2,1);
   draw_prompt_box(1);
   myouttext(textb[0]);
   input_string(1,0);
   putimage( (signed short)((float)Maxx)/2,2,boximage_prompt[2],COPY_PUT);
   freeimage(boximage_prompt[2]);
   if (is[0]=='q'){
      erase_prompt_box(1);
      return;
   }
   if (is[0]=='1') show_graphic_wiring_1d(1);
   if (is[0]=='2') show_graphic_wiring_2d(1);

   /*
   wrstype==0 "SINGLE RULE"
   wrstype==1 "WIRING ONLY"
   wrstype==2 "RULE SCHEME ONLY"
   wrstype==3 "WIRING-RULE SCHEME"
   */
  start1:
   if (nonlocal || rulemix){
      if (nonlocal && rulemix){
	 sprintf(textb[0],"just wiring: print-pw, load-lw, save-sw,");
	 sprintf(textb[1],"just rules: print-pr, load-lr, save-sr,");
	 sprintf(textb[2],"rulemix+wiring: print-pb, load-lb, save-sb:");

	 get_prompt_box(2,3);
	 xbox=draw_prompt_box(3);
	 myouttext(textb[0]);
	 moveto(xbox,gety+CHeight);
	 myouttext(textb[1]);
	 moveto(xbox,gety+CHeight);
	 myouttext(textb[2]);
	 input_string(2,0);
      }
      else{
	 if (nonlocal && !rulemix)
	    sprintf(textb[0],"wiring: print-p, load-l, save-s:");
	 if (!nonlocal && rulemix)
	    sprintf(textb[0],"rulemix: print-p, load-l, save-s:");

	 get_prompt_box(2,1);
	 draw_prompt_box(1);
	 myouttext(textb[0]);
	 input_string(1,0);
      }

      putimage( (signed short)((float)Maxx)/2,2,boximage_prompt[2],COPY_PUT);
      freeimage(boximage_prompt[2]);
      if (is[0]=='q') goto start;
      was_loaded=0;


      if (is[0]=='p' || is[0]=='l' || is[0]=='s'){
	 if (nonlocal && rulemix){
	    wrstype=3;;
	    if (is[1]=='w') wrstype=1;
	    if (is[1]=='r') wrstype=2;
	    if (is[1]=='b') wrstype=3;
	 }
	 else{
	    if (nonlocal && !rulemix) wrstype=1;
	    if (!nonlocal && rulemix) wrstype=2;
	 }
      }
      if (is[0]=='l'){
	 was_loaded=1;
	 /*dummy rule*/
	 load_save_wrs('l',carule[0],wrstype);
	 was_changed=1;
	 cell_out_freq();
      }
      else if (is[0]=='s') load_save_wrs('s',carule[0],wrstype);
      else if (is[0]=='p'){
	start2:
	 sprintf(textb[0],
		  "print network data: to printer-p file-f both-b");
	 get_prompt_box(2,1);
	 draw_prompt_box(1);
	 myouttext(textb[0]);
	 input_string(1,0);
	 putimage( (signed short)((float)Maxx)/2,2,boximage_prompt[2],COPY_PUT);
	 freeimage(boximage_prompt[2]);
	 if (is[0]=='q') goto start1;
	 thispdata=pdata;
	 filedata=thisfiledata;
	 pdata=filedata=0;
	 if (is[0]=='p') pdata=1;
	 else if (is[0]=='f') filedata=1;
	 else if (is[0]=='b'){
	    pdata=1;
	    filedata=1;
	 }
	 if (filedata){
	    file_ret=select_filename("SAVE","DATA","*.dat","net_data");
	    if (file_ret=='q') goto start2;
	    memcpy(filename_data,filename,13);
	    
#           if __BORC__||__WATCOM__
               if ((fid=open(filename_data,
		   O_RDWR|O_CREAT|O_TRUNC|O_TEXT,
		               S_IREAD|S_IWRITE) )==-1){
	             sprintf(textb[0],"%s, RETURN-continue",
                                           sys_errlist[errno]);
#           elif __UNIX__
                if ((fid=open(filename_data,
		   O_WRONLY|O_CREAT|O_TRUNC,S_IREAD|S_IWRITE) )==1){
                      sprintf(textb[0],"file error, RETURN-continue");
#           endif
	           draw_prompt_box(1);
	           outtext(textb[0]);
	           input_string(1,0);
	           erase_prompt_box(1);
	           input_string(1,0);
	       }
	       close(fid);
	 }
	 cell_out_freq();
	 toutwires=0;
	 if (nhood_mixed){
	    for (poss=lineL-1;poss!=Maxu;poss--) toutwires+=nhoodm[poss];
	 }
	 else toutwires+=lineL*nhood;
	 tlratio=tzparam=wtlratio=wtzparam=0;
#        if __BORC__||__WATCOM__	 
            if (pdata){
	       prn_putc(ESC); /*initialise printer*/
	       prn_putc('@');
	    }
#        endif	 
         if (nhood_mixed) sprintf(textb[0],
	  "k=mixed(%d-%d), n=%d",nhood,nhood_lb,lineL);
	 else sprintf(textb[0],"k=%d, n=%d",nhood,lineL);
	 if (pdata){
	    print_out(textb[0]);
	    print_out("\n");
	 }
	 if (filedata){
	    save_data(textb[0]);
	    save_data("\n");
	 }
	 if (nhood_mixed){
	    if (wrstype==1) sprintf(textb[0],
	       "cell. k, wiring(%d-0),",nhoodm[poss]-1);
	    if (wrstype==2) sprintf(textb[0],
	       "cell. k, rule(hex) ld ld-r Z");
	    if (wrstype==3) sprintf(textb[0],
	       "cell. k, wiring rule(hex) ld ld-r Z");
	 }
	 else{
	    if (wrstype==1) sprintf(textb[0],
	       "cell. wiring(%d-0)",nhood-1);
	    if (wrstype==2) sprintf(textb[0],
	       "cell. rule(hex) ld ld-r z C");
	    if (wrstype==3) sprintf(textb[0],
	       "cell. wiring(%d-0) rule(hex) ld ld-r Z C",nhood-1);
	 }
	 if (pdata){
	    print_out(textb[0]);
	    print_out("\n");
	    print_out("---------------------------------------------");
	    print_out("\n");
	 }
	 if (filedata){
	    save_data(textb[0]);
	    save_data("\n");
	    save_data("---------------------------------------------");
	    save_data("\n");
	 }
	 for (poss=lineL-1;poss!=Maxu;poss--){
	    if( (is[0]=keycheck(0))=='q') break; /*abort printing */
	    if (nhood_mixed) sprintf(textb[0],"%d. %d, ",poss,nhoodm[poss]);
	    else sprintf(textb[0],"%d. ",poss);

	    if (pdata) print_out(textb[0]);
	    if (filedata) save_data(textb[0]);

	    /*wiring*/
	    if (wrstype==3 || wrstype==1){
	       for (wire=nhood-1;wire>=0;wire--){
		  if (wire>nhoodm[poss]-1) sprintf(textb[0],"- ");
		  else{
		     if (wire==0) sprintf(textb[0],
					   "%d, ",wiring[poss][wire]);
		     else sprintf(textb[0],"%d ",wiring[poss][wire]);
		  }
		  if (pdata) print_out(textb[0]);
		  if (filedata) save_data(textb[0]);
	       }
	       if (wrstype==1){
		  if (pdata) print_out("\n");
		  if (filedata) save_data("\n");
	       }
	    }

	    /*rule*/
	    if (wrstype==3 || wrstype==2 || nhood_mixed
				 || (!rulemix && poss==0)){
	       if (totalistic){
		  sprintf(textb[0],"code=%d,",
			     (signed short)dec_equiv(cacode[poss],nhood));
		  if (pdata) print_out(textb[0]);
		  if (filedata) save_data(textb[0]);

	       }
	       print_current_bitstring_hexbytes
		     (1,carule[poss],nhoodm[poss],Maxx,white,3);
	       z_parameter_all(nhoodm[poss],0,carule[poss]);
	       if (!rulemix && poss==0)
		   sprintf(textb[0],
		      "ld=%.3g ld-r=%.3g Z=%.3g",lambda,lratio,zparam[0]);
	       else sprintf(textb[0],
		      " %.3g %.3g %.3g ",lambda,lratio,zparam[0]);
	       if (pdata) print_out(textb[0]);
	       if (filedata) save_data(textb[0]);

	       tlratio+=lratio;
	       tzparam+=zparam[0];
	       weight=(float)celloutfreq[poss]/toutwires;
	       wtlratio+=lratio*weight;
	       wtzparam+=zparam[0]*weight;

	       /*show canalyzing inputs*/
	       canalyzing(nhoodm[poss],0,carule[poss]);
	       sprintf(textb[0],"%d/%d",canaltotal,nhoodm[poss]);
	       if (canaltotal && nhoodm[poss]>1){
		  memcpy(textb[0]+3," ",1);
		  for (z=nhoodm[poss]-1;z!=Maxu;z--){
		     if (get_bit(canal,z)==1){
			sprintf(textb[1],"%d",z);
			memcpy(textb[0]+4+nhoodm[poss]-1-z,textb[1],1);
		     }
		     else memcpy(textb[0]+4+nhoodm[poss]-1-z,"*",1);
		  }
	       }
	       memcpy(textb[0]+4+nhoodm[poss],"",1);
	       if (pdata){
		  print_out(textb[0]);
		  print_out("\n");
	       }
	       if (filedata){
		  save_data(textb[0]);
		  save_data("\n");
	       }
	    }
	 }
	 if (wrstype==3 || wrstype==2 || nhood_mixed){
	    tlratio=tlratio/lineL;
	    tzparam=tzparam/lineL;
	    sprintf(textb[0],"average:lda-r=%g Z=%g",tlratio,tzparam);
	    if (pdata){
	       print_out(textb[0]);
	       print_out("\n");
	    }
	    if (filedata){
	       save_data(textb[0]);
	       save_data("\n");
	    }
	    sprintf(textb[0],"weighted average:lda-r=%g Z=%g",
					  wtlratio,wtzparam);
	    was_loaded=1;
	    if (pdata){
	       print_out(textb[0]);
	       print_out("\n");

	    }
	    if (filedata){
	       save_data(textb[0]);
	       save_data("\n");
	    }
	 }
	 if (pdata) print_out("\n");
	 if (filedata) save_data("\n");
	 pdata=thispdata;
	 filedata=thisfiledata;
      }
      is[0]=0;
      is[1]=0;
      if (was_loaded==1) goto start;
   }
   moveto(tempx,tempy);
}
